#!/bin/sh

TNOW=$(date -u "+%Y%m%dT%H%M")
filename="backupBACSLogs-$TNOW.tar.gz"
TDIR="/tmp/backupBACSLogs"
SRCDIR="/var/log/bacs"

logDays=$1

# bacsrec.dat and bacslog.ini are already included at the beginning, e.g.
# #ls -r /var/log/bacs
# bacsrec.dat   bacslog.ini   20190322.001  20190321.001
# Because of this first bacslog starts with index 2.
logDays=$((logDays+2));

LOGLIMIT="$TDIR/logLimit.txt"

rm -rf ${TDIR}
mkdir -p ${TDIR}

touch "$LOGLIMIT"

if [ "$logDays" != "" ] && [ "$logDays" -gt 2 ]; then
    i=0
    for log in $(ls -r /var/log/bacs);do
        if [ "$i" -lt "$logDays" ]; then
            echo "bacs/$log">>"$LOGLIMIT"
        fi
        i=$((i+1))
    done
    tar -C ${SRCDIR}/.. -c -T ${LOGLIMIT} | gzip > ${TDIR}/${filename}
    rm "$LOGLIMIT"
else
    tar -C ${SRCDIR}/.. -c bacs | gzip > ${TDIR}/${filename}
fi

chown -R www-data:www-data "${TDIR}"
exit 0