#!/bin/sh

echo Content-type: application/json
echo ""
RESTORE_LOG="/var/log/configRestore.log"
STATUS=Error
CODE=-1
MSG="Cannot find file ${RESTORE_LOG}"
SUCC_LINE=""
RUNNING_LINE=""
ERROR_LINE=""
BFAIL=false
LAST_LINE=""

getLastLineStartingWith() {
   LAST_LINE="$( (grep ${RESTORE_LOG} -e "^${1}" | tail -1) 2>&1 )"
}

if [ -f ${RESTORE_LOG} ]; then
   getLastLineStartingWith "SUCCESS:: "
   SUCC_LINE="${LAST_LINE}"
   getLastLineStartingWith "ERROR:: "
   ERROR_LINE="${LAST_LINE}"
   getLastLineStartingWith "RUNNING:: "
   RUNNING_LINE="${LAST_LINE}"
else
   BFAIL=true
fi

if [ "true" != "$BFAIL" ]; then
   if [ -n "${ERROR_LINE}" ]; then
      STATUS=Error
      MSG="${ERROR_LINE}"
      CODE=-1
   elif [ -n "${SUCC_LINE}" ]; then
      STATUS=Success
      MSG="${SUCC_LINE}"
      CODE=0
   elif [ -n "${RUNNING_LINE}" ]; then
      STATUS=Running
      MSG="${RUNNING_LINE}"
      CODE=1
   else
      STATUS=Running
      MSG="Waiting for results from restore process."
      CODE=1
   fi
fi

TNOW=$(date -u "+%Y%m%dT%H%M%SZ")
/bin/cat << EOM
{
   "report" : {
      "time" : "$TNOW"
   },
   "update" : {
      "status" : "$STATUS",
      "message" : "$MSG",
      "error_code" : "${CODE}"
   }
}
EOM
