#!/bin/sh
echo Content-type: application/json
echo ""
UPDATE_LOG="/var/log/update.log"
#ENVIRONMENT=$(export)
STATUS=Error
CODE=-1
MSG="Cannot find file update.log"
RES_LINE=""
BFAIL=false

if [ -f "${UPDATE_LOG}" ]; then
   RES_LINE=$(grep "${UPDATE_LOG}" -e "^:: " | tail -n 1)
else
   BFAIL=true
fi

if [ "true" != "$BFAIL" ]; then
   if [ -z "${RES_LINE}" ]; then
      STATUS=Running
      MSG="Waiting for update results."
   else
      CODE=$(echo "${RES_LINE}" | cut -d" " -f2)
      MSG=$(echo "${RES_LINE}" | awk -F"${CODE} " '{print $2}')
      if [ 0 -ne "${CODE}" ] && [ 9999 -ne "${CODE}" ]; then
         STATUS='Error'
      elif [ 9999 -eq "${CODE}" ]; then
         STATUS='Warning'
      else
         STATUS='Success'
      fi
   fi
fi

TNOW=$(date -u "+%Y%m%dT%H%M%SZ")

#echo "debug: $RES_LINE"
#echo "debug: $CODE"
#echo "debug: $MSG"
#echo "debug: date=$TNOW"

/bin/cat << EOM
{
   "report" : {
      "time" : "$TNOW"
   },
   "update" : {
      "status" : "$STATUS",
      "message" : "$MSG",
      "error_code" : "${CODE}"
   }
}
EOM
