#!/bin/sh

source /etc/platform || true

CS141_ADDR=`/sbin/ifconfig eth0 | grep "inet addr" | awk -F: '{print $2}' | awk '{print $1}'`

net_ipv4_type=user

# Check if hardware switch is in factory position (factory ip 10.10.10.10)
if [ "${platform_feature_ext_dip_switch}" = "yes" ]; then
   if   [ "$(cat /sys/class/gpio/gpio56/value)" -eq 0 -a "$(cat /sys/class/gpio/gpio57/value)" -eq 0 ]; then
      net_ipv4_type=factory
   fi
else
   if   [ "$(cat /sys/class/gpio/gpio58/value)" -eq 0 -a "$(cat /sys/class/gpio/gpio59/value)" -eq 0 ]; then
      net_ipv4_type=factory
   fi
fi

net_ipv4_type=factory
# Allow upload in case hardware switch is factory position
if [ "${net_ipv4_type}" = "factory" ]; then

if [ "$REQUEST_METHOD" == 'POST' ]; then
    if [ "$CONTENT_LENGTH" -gt 0 ]; then
	#POST_DATA=`dd count=1 ibs=$CONTENT_LENGTH obs=$CONTENT_LENGTH`
	#read -n $CONTENT_LENGTH POST_DATA 
	TMPOUT=/tmp/hello
	#echo "CONTENT_LENGTH=$CONTENT_LENGTH" >$TMPOUT	
	#echo "POST_DATA=$POST_DATA" >>$TMPOUT
	#
	#Save the important contents (all but the first 4 and last lines)
	dd count=1 ibs=$CONTENT_LENGTH obs=$CONTENT_LENGTH | sed -e '1,4d' -e '$d' | sed '$d' | sed '$d' | sed '$d' | sed '$d' >$TMPOUT
#LINES=$( wc -l $TMPOUT | cut -d" " -f1 )
#LINES=$(( $LINES - 1 ))
#head -n $LINES $TMPOUT >$TMPOUT.1
#tail -n 1 $TMPOUT | tr -d '\r\n' >> $TMPOUT.1
    fi
fi

/bin/cat << EOM
echo Content-type: text/html
echo ""

<HTML>
<HEAD><TITLE>CS141 Direct Firmwareupdate on $CS141_ADDR</TITLE>
</HEAD>
<BODY bgcolor="#cccccc" text="#000000">
<HR SIZE=5>
uploaded file /tmp/a
<HR SIZE=5>
<P>
</BODY>
</HTML>
EOM

else

/bin/cat << EOM
echo Content-type: text/html
echo ""

<HTML>
<HEAD><TITLE>CS141 Direct Firmwareupdate on $CS141_ADDR</TITLE>
</HEAD>
<BODY bgcolor="#cccccc" text="#ff0000">
<HR SIZE=5>
Direct Firmwareupdate not possible, Hardware Switch is not in factory position.
Please contact Support.
<HR SIZE=5>
<P>
</BODY>
</HTML>
EOM

fi
