function get_url(cgi_name) /*get the server url*/ {
  var url;
  url = window.location.protocol + "//" + window.location.host;
  if (cgi_name.length > 0)
    url += "/" + cgi_name;
  return url;
}

function get_plattform() //get plattform name
{
  return "cs141";
}

function get_ng_scope() {
  var $scope = null,
    container = null;

  try {
    container = top.document.querySelector('.container-fluid');
    $scope = top.angular.element(container).scope();
  } catch (e) {
    /* out-commented, because IE 11 initializes console only if devtools (F12) are enabled
      console.log(e.message);
    */
  }
  return $scope;
}

function i18n(text) {
  var $scope = get_ng_scope();
  return ($scope) ? $scope.getTransText(text) : text;
}

function translate_text(elem_id, text) //for *.xsl
{
  var elem = document.getElementById(elem_id),
    txt_array = Array.isArray(text) ? text : [text],
    len = txt_array.length,
    index = 0,
    i18n_txt = "";

  for (; index < len; ++index) {
    i18n_txt += i18n(txt_array[index]);
  }

  if (elem != null) {
    elem.innerText = i18n_txt;
  }
}

var ups_alarms_api = (function () {
  var inp_hist_spported = 0x1, // EVENT_INP_HISTORY supported
    inp_alm_spported = 0x2, // EVENT_INP_ALARMS supported
    inp_warn_spported = 0x4, // EVENT_INP_WARNINGS supported
    outp_xml_spported = 0x1, // Output XML supported
    outp_html_spported = 0x2, // Output HTML supported
    outp_csv_spported = 0x4, // Output CSV supported
    outp_type_xml = 0x02, //EVENT_OUT_XML
    outp_type_html = 0x1, //EVENT_OUT_HTML
    outp_type_csv = 0, //EVENT_OUT_CSV
    inp_type_hist = 0x0, // EVENT_INP_HISTORY 
    inp_type_alm = 0x1, // EVENT_INP_ALARMS
    inp_type_warn = 0x2, // EVENT_INP_WARNINGS 

    ups_alarms_params = null,
    alarms_win = null,
    ups_cmd_option = {
      data: {},
      data_type: 'text',
      success: null, //send_ups_alarms_update,
      error: err_funct
    },
    ups_cmd_settings = {
      methode: "POST",
      xhttp_methode_override: 'PUT',
      req_payload_json: true
    },

    ctl_url = get_url("api/devices/ups/control"),
    get_alarms_data_url = ctl_url + ("?code=getAlarmData"),
    get_alarms_data_option = {
      data: {},
      data_type: 'json',
      success: get_ups_alarms_data,
      error: err_funct
    },

    get_alarms_data_settings = { methode: "GET" },

    _options = //defaults options.
    {
      open_window: true,
      title: "UPS Eventrecorder"
    },
    doc = null;

  /*public functions*/
  return {
    inp_hist_spported: inp_hist_spported,
    inp_alm_spported: inp_alm_spported,
    inp_warn_spported: inp_warn_spported,
    outp_xml_spported: outp_xml_spported,
    outp_html_spported: outp_html_spported,
    outp_csv_spported: outp_csv_spported,
    inp_type_hist: inp_type_hist,
    inp_type_alm: inp_type_alm,
    inp_type_warn: inp_type_warn,
    outp_type_xml: outp_type_xml,
    outp_type_html: outp_type_html,
    outp_type_csv: outp_type_csv,

    get_ups_alarms: get_ups_alarms,
    save_data: save_data
  };


  function get_ups_alarms(ups_alrm_params, options) {
    ups_alarms_params = ups_alrm_params;

    options = options || {};
    jqmodule.extend(options, _options);

    ups_cmd_option.data = {
      code: 'upsExeCommand',
      params: { cmdId: 3333, params: get_alarms_params() }
    };

    if (!_options.open_window) {
      alarms_win = window;
    } else {
      if (alarms_win != null && !alarms_win.closed) {
        alarms_win.close();
      }
      alarms_win = window.open();
    }

    doc = alarms_win.document;

    jqmodule.ajax(ctl_url, ups_cmd_option, ups_cmd_settings);
    send_ups_alarms_update(null);
  }

  function send_ups_alarms_update(data) {
    if (alarms_win == null || alarms_win.closed) {
      return false;
    }

    display_progress(1);

    if (window.focus) {
      alarms_win.focus();
    }

    get_ups_alarms_data(null);
  }

  function get_ups_alarms_data(data) {
    if (alarms_win == null || alarms_win.closed) {
      return true;
    }

    if (data == null) {
      jqmodule.ajax(get_alarms_data_url + '&outputType=' + ups_alarms_params.outputType + '&inputType=' + ups_alarms_params.inputType,
        get_alarms_data_option, get_alarms_data_settings);
      return true;
    }

    if (data.eventState == 3) //EVENT_STATE_ERROR
    {
      err_funct({ responseText: _options.title + ' Command failed!' });
      return true;
    }
    if (data.eventState == 1 || data.eventState == 0) //EVENT_STATE_PROGRESS || EVENT_STATE_IDLE
    {
      display_progress(data.eventReady);

      if (window.focus) {
        alarms_win.focus();
      }

      setTimeout(function () {
        jqmodule.ajax(get_alarms_data_url + '&outputType=' + ups_alarms_params.outputType + '&inputType=' + ups_alarms_params.inputType,
          get_alarms_data_option, get_alarms_data_settings);
      }, 1000);

      return true;
    }

    if (data.eventState == 2) //EVENT_STATE_SUCCESS
    {
      try {
        print_alarms_data(data.data);
      } catch (e) {
        err_funct({ responseText: e.message });
        return true;
      }
    }
    return false;
  }

  //Utils functions
  function err_funct(response) {
    var err_msg = null;

    if (alarms_win == null || alarms_win.closed) {
      return true;
    }

    if (response.responseText && !response.responseText.empty()) {
      err_msg = response.responseText;
    } else if (response.statusText && !response.statusText.empty())
      err_msg = response.statusText;

    else if (response.err_msg && !response.err_msg.empty())
      err_msg = response.err_msg;
    else
      err_msg = _options.title + "Command Failed!";

    doc.head.innerHTML = '';
    doc.body.innerHTML = '';

    doc.writeln("<!DOCTYPE html>");
    doc.writeln("<html><head><title>" + _options.title + " </title>");

    doc.writeln("<link type=\"text/css\" href=\"/lib/bootstrap/css/bootstrap.css\" rel=\"stylesheet\" media=\"screen\">");
    doc.writeln("<link rel=\"stylesheet\" type=\"text/css\" href=\"/lib/app/ext_bootstrap.css\" /></head>");
    doc.writeln("<body><center>");

    doc.writeln("<div class=\"alert alert-danger\" style=\"width:600px;z-index:122\">");
    doc.writeln("<button class=\"close\">&times;</button>");

    doc.writeln("<strong>Error!</strong>");
    doc.writeln("<h6>" + err_msg + "</h6>");

    doc.writeln("</div></center></body></html>");
    doc.close();
  }

  function get_alarms_params() {
    /*return {
      unitid: ups_alarms_params.unitid,
      priority: ups_alarms_params.priority,
      sortmode: ups_alarms_params.sortmode,
      outputType: ups_alarms_params.outputType,
      inputType: ups_alarms_params.inputType,
      lines: ups_alarms_params.lines
    };*/

    var params = ups_alarms_params.unitid + '|' +
      ups_alarms_params.priority + '|' +
      ups_alarms_params.sortmode + '|' +
      ups_alarms_params.outputType + '|' +
      ups_alarms_params.inputType + '|' +
      '|' + ups_alarms_params.lines;

    return params;
  }

  function string_to_xml_doc(xml_str) {
    if (window.ActiveXObject !== undefined &&
      new window.ActiveXObject("Microsoft.XMLDOM")
    ) {
      var xml_doc = new window.ActiveXObject("Microsoft.XMLDOM");
      xml_doc.async = "false";
      xml_doc.loadXML(xml_str);
      return xml_doc;
    } else if (document.implementation && document.implementation.createDocument) {
      return (new window.DOMParser()).parseFromString(xml_str, "text/xml");
    }
  }

  function get_xslt_doc(xslt_file) {
    var xslt_doc = null;

    if (window.ActiveXObject !== undefined && //Internet Explorer
      new window.ActiveXObject("MSXML2.DOMDocument")
    ) {
      xslt_doc = new window.ActiveXObject("MSXML2.DOMDocument");
      xslt_doc.async = false;
      xslt_doc.onreadystatechange = function () {
        if (xslt_doc.readyState != 4) return false;
      };

      xslt_doc.load(get_url(xslt_file));
    } else {
      jqmodule.ajax(get_url(xslt_file), {
        data: {},
        data_type: 'xml',
        success: function (xslt_data) {
          xslt_doc = xslt_data;
          return xslt_doc;
        },
        error: err_funct
      }, { methode: "GET", async: false });
    }
    return xslt_doc;
  }


  function print_alarms_data(alarms_data) {
    var transformed, link;

    if (ups_alarms_params.outputType == outp_type_xml) {
      var stylesheet, items, xslt_file,
        xslt_doc = null,
        xml_doc = string_to_xml_doc(alarms_data);

      //extract the stylesheet so we can load it manually
      for (var i = 0; i < xml_doc.childNodes.length; i++) {
        if (xml_doc.childNodes[i].nodeName == 'xml-stylesheet') {
          stylesheet = xml_doc.childNodes[i].data;
          break;
        }
      }

      items = stylesheet.split('=');

      xslt_file = items[items.length - 1];

      xslt_file = xslt_file.replace(/'/g, "");
      xslt_file = xslt_file.replace(/"/g, "");
      xslt_file = xslt_file.replace(/^(\.\.\/)*/, "");
      xslt_file = xslt_file.replace(/^\.\//, "");
      xslt_file = xslt_file.replace(/^\//, "");
      xslt_file = "lib/ups/history/" + xslt_file;

      xslt_doc = get_xslt_doc(xslt_file);

      if (!window['XSLTProcessor']) {
        // Trasformation for IE
        transformed = xml_doc.transformNode(xslt_doc);
      } else {
        // Transformation for non-IE
        var processor = new XSLTProcessor();
        processor.importStylesheet(xslt_doc);
        var xmldom = processor.transformToDocument(xml_doc);
        var serializer = new XMLSerializer();
        transformed = serializer.serializeToString(xmldom.documentElement);
      }

      transformed = transformed.replace("<head>", "<head><script type=\"text/javascript\" src=\"/lib/app/app_utils.js\"></script></br>");
      link = get_download_link(transformed, "UPS Alert History.html", "text/html;charset=utf-8,", "Save This Page");
      doc.open();
      doc.writeln(transformed + link);
      doc.close();

    } else {
      transformed = alarms_data;

      if (ups_alarms_params.outputType == outp_type_html) {
        transformed = transformed.replace('href="/cs121.css"', 'href="/lib/cs121.css"');
        transformed = transformed.replace("<head>", "<head><script type=\"text/javascript\" src=\"/lib/app/app_utils.js\"></script></br>");
        link = get_download_link(transformed, "UPS Alert History.html", "text/html;charset=utf-8,", "Save This Page");
        doc.open();
        doc.writeln(transformed + link);
        doc.close();
      } else if (ups_alarms_params.outputType == outp_type_csv) {
        link = get_download_link(transformed, "UPS Alert History.csv", "text/csv;charset=utf-8,", "Export to CSV");
        transformed = transformed.replace(/(\r\n|\n|\r)/gm, "</br>");
        doc.open();
        doc.writeln("<html><head> <script type = \"text/javascript\" src=\"/lib/app/app_utils.js\"></script></head ><body>");
        doc.writeln(transformed + link);
        doc.writeln("</body></html>");
      }
    }

  }

  function get_download_link(data, filename, mime_type, title) {
    var link = "";
    localStorage.setItem('hist_data', data);
    link = "</br></br><button onclick=\"javascript:ups_alarms_api.save_data('save_data'," + "'" + filename + "','" + mime_type + "')\">" + title + "</button>";
    return link;
  }

  function save_data(data, filename, mime_type) {
    var blob = new Blob([localStorage.getItem('hist_data')], {
        "type": mime_type
      }),
      link = document.createElement("a");

    if (link.download !== undefined) { // feature detection
      // Browsers that support HTML5 download attribute
      link.setAttribute("href", window.URL.createObjectURL(blob));
      link.setAttribute("download", filename);
    }
    if (window.navigator.msSaveBlob) { // IE 10+
      link.setAttribute("style", "color: blue;cursor: pointer;text-decoration:underline");
      link.addEventListener("click", function (event) {
        navigator.msSaveOrOpenBlob(blob, filename);
      }, false);
    }

    link.style.display = 'none';
    document.body.appendChild(link);
    link.click();
    document.body.removeChild(link);
  }

  function display_progress(line_number) {
    var center, h1, h2, div, img, div_master;

    if (line_number == 0) {
      ++line_number;
    }

    doc.body.innerHTML = "";
    center = doc.createElement("center");

    div_master = doc.createElement("div");
    div_master.setAttribute("class", "alert alert-success");

    h1 = doc.createElement("h1");
    h1.appendChild(doc.createTextNode(_options.title));

    h2 = doc.createElement("h2");
    h2.innerHTML = "Processing line " + line_number + ".<br><br>Please wait...";

    div = doc.createElement("div");
    div.setAttribute("width", "30px");
    div.setAttribute("height", "30px");

    img = doc.createElement("img");
    img.setAttribute("src", "/lib/ups/image/ups/ajax.gif");
    div.appendChild(img);

    div_master.appendChild(h1);
    div_master.appendChild(h2);
    div_master.appendChild(div);
    center.appendChild(div_master);
    doc.body.appendChild(center);

    doc.title = _options.title;
  }

})();


function get_alarm_page_from_ups(alarms_params, options) {
  return ups_alarms_api.get_ups_alarms(alarms_params, options);
}

function multi_ups_switch(ups_id, is_multi, svcoid) /*ups_id: 0=Global view,UPS ID-1,UPS ID-2...  is_multi= is multi ups.*/ {

  return false;
}

function footer_panel(oemViewName, location, attr_obj, css_obj) //create footer panel
{
  return false;
}

function get_oid_from_url() {
  return null;
}

function get_unms_obj(data) {
  return null;
}

var footer_api = (function () {
  function noop() {};
  /*public functions*/
  return {
    create: noop,
    set: noop,
    load_log_file: noop,
    load_chart_frame: noop,
    openWin: noop,
    loadAckPage: noop,
    disconnectCmd: noop,
    connectCmd: noop
  };
})();

var menu_api = (function () {
  function update(data) {
    return false;
  }
  /*public functions*/
  return {
    update: update
  };
})();

var info_head_api = (function () {
  function update(unms_obj) {
    return false;
  }
  /*public functions*/
  return {
    update: update
  };
})();