<?xml version="1.0"?>
<!--
   js_overlay.xsl - XSL-templates for Javascript creating overlay layers (UNMS-II)
   Copyright (c) 2007, Generex GmbH. All rights reserved.
   klaus
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="xml" indent="yes" omit-xml-declaration="yes" encoding="iso-8859-1"/>
  <xsl:template name="js_overlay_def">
    <xsl:param name="baseName" select="'overlay'"/>
    <script type="text/javascript">
      <xsl:comment>
        var layerBaseName = "<xsl:value-of select="$baseName"/>";
        <![CDATA[ 
	      var g_bShow = false;
	      function getCookieVal(cookie, key)
      	{
        	var nShow = 0;
     			var data = cookie.split(";");
	  			for(i = 0; i<data.length;++i){
     		  	var start = data[i].indexOf(key);
	         	if(start != -1){
	          	vals = data[i].split("=");
       	   		nShow = vals[1];
      	  	}
         	}         
         	return nShow;
      	}
				function getOverlayState()
		    {           
		    		var nShow = 0; 	   
		       	if(document.cookie){
		      	   nShow = getCookieVal(document.cookie, "overlay");
		      	}
		      	else{
		      	   document.cookie = "overlay=0";
		      	}
	        	return nShow == 1 ? true : false;
		     }
				function showOverlay()
				{
					for(i = 0; ;++i){					
						layer = document.getElementsByTagName("div")[i];
						if(!layer) break;
						id = layer.getAttribute("id"); 
							
		        if(!id || id.indexOf(layerBaseName) == -1) {
		        	continue;
		        }
	          if(g_bShow){
		        	layer.style.visibility = "visible";
		        }
					  else{
	  					layer.style.visibility = "hidden";
	  				}
					}
				}
				function toggleOverlay()
				{
					g_bShow = !g_bShow;
					document.cookie = g_bShow ? "overlay=1" : "overlay=0";
					showOverlay();
				}
	    ]]>
      </xsl:comment>
    </script>
  </xsl:template>
  <xsl:template name="js_overlay_init">
    <script type="text/javascript">
      <xsl:comment>
        <![CDATA[ 
	      g_bShow = getOverlayState();
	      showOverlay();
	    ]]>
      </xsl:comment>
    </script>

  </xsl:template>
</xsl:stylesheet>