 /**
    periodic_req.js:UPS screens priodic ajax request module.
    Copyright (c) 2011, Generex GmbH. All rights reserved.
    Last change: 03.04.2013
    Said
 **/

 var priodic_req = (function (jqm) {
   var callbacks = [],
   lang_adapter_is_rebooting = "Adapter is rebooting now !";

   var get_data = function (callback) {
     var load_img = null;
     if (callback.active)
     return true;
     callback.active = true;
     load_img = document.getElementById('loading_id');
     if (load_img != null)
     load_img.style['display'] = 'block';

     jqm.ajax(
       callback.req_params.url, {
         data: callback.req_params.data,
         data_type: callback.req_params.data_type,
         success: function (data, responseText) {
           if (load_img != null)
           load_img.style['display'] = 'none';

           callback.active = false;
           callback.update(data, responseText);
         },
         error: function (response) {
           //alert(response.message);
           callback.active = false;
           handle_error(response, callback);
         }
       }, //options
       {
         methode: callback.req_params.methode || "POST",
         xhttp_methode_override: callback.req_params.xhttp_methode_override || '',
         req_payload_json: callback.req_params.req_payload_json || false
       } //settings
     );
   }

   var handle_error = function (response, callback) {
     if (response.statusText == 'parsererror') {
       if (response.content_type == 'text/html') {
         if (callback.refreshId != -1)
         clearInterval(callback.refreshId);
         unsubscribe(callback);
         return on_parsererror(response, callback);
       }
     }

     if (response.status == 0)
     response.statusText = 'Page does not respond.Server currently not available.';
     else if (response.statusText == 'timeout')
     response.statusText = 'Request timeout.';

     if (typeof callback.error === 'function') {
       callback.error(response);
     }
   };

   var on_parsererror = function (response, callback) {
     if (response.responseText.indexOf(lang_adapter_is_rebooting) != -1) {
       document.body.innerHTML = "";
       var reboot_div = document.createElement('div');
       reboot_div.setAttribute('id', 'div_reboot_id');
       reboot_div.setAttribute('className', 'main');
       reboot_div.setAttribute('class', 'main');
       reboot_div.setAttribute('align', 'center');
       reboot_div.style['position'] = 'relative';

       reboot_div.innerHTML = "<br><span>Please wait </span><span id='ctdn' style='font-size:200%; font-weight:bold; color:#405080;'> 300 </span><span> seconds the page will refresh automatically.</span></br>";
       document.body.appendChild(reboot_div);
       window.setInterval(function () {
         var ctdn = document.getElementById('ctdn');
         var seconds = parseInt(ctdn.firstChild.nodeValue);
         --seconds;
         ctdn.firstChild.nodeValue = seconds;
         if (seconds <= 0)
         window.location.reload();
       }, 1000);
     } else if (typeof callback.error === 'function') {
       callback.error(response);
     } else {
       document.body.innerHTML = "";
       document.write(response.responseText);
     }
   }

   /**
      * @param obj: the object to bind the function to (what the "this" keyword will refer to)
      * @param funcs: the callback functions
      * @param req_params: an object literal with the following:
      *
         req_params=
         {
            url          : 'localhost'
            data         : {"cgi_name" : "data.cgi" , "type": "ups"},
            data_type     : 'json',
            refresh_tm   : refresch_tm || 10 Sec
         }
      *
   **/
   var callback = function (obj, funcs, req_params) {
     var obj = obj,
     funcs = funcs,
     req_params = req_params;

     return {
       req_params: req_params,
       refreshId: -1,
       active: false,
       update: function (data, responseText) {
         if (typeof funcs.update === 'function')
         return funcs.update.call(obj, data, responseText);
       },
       error: typeof funcs.error === 'function' ? function (response) {
         return funcs.error.call(obj, response);
       } : null
     };
   };

   //public interface
   function subscribe(obj, funcs, req_params) {
     var cb = null;
     funcs = funcs || {};
     req_params = req_params || {};
     obj = obj || window;

     cb = callback(obj, funcs, req_params);
     callbacks.push(cb);
     refresh(cb, req_params.refresh_tm);
     return cb;
   }

   function unsubscribe(callback) {
     var i;
     for (i in callbacks) {
       if (callbacks[i] === callback) {
         if (callback.refreshId != -1)
         clearInterval(callback.refreshId);
         callbacks = callbacks.remove(callback);
         return true;
       }
     }
     return false;
   }

   function refresh(callback, refresh_tm) {
     var i;
     for (i in callbacks) {
       if (callbacks[i] === callback) {
         if (callback.refreshId != -1)
         clearInterval(callback.refreshId);
         callback.req_params.refresh_tm = refresh_tm;
         callback.refreshId = setInterval(function () {
           get_data(callback);
         }, refresh_tm);
         return true;
       }
     }
     return false;
   }

   //extends jqmodule;
   jqmodule.subscribe = subscribe;
   jqmodule.unsubscribe = unsubscribe;
   jqmodule.refresh = refresh;
   return jqmodule;
 }(jqmodule));