<?xml version="1.0"?>
<!--
   aeg_cbsr_cmd_panel.xsl - CBSR commands UPS screen.
   Copyright (c) 2010, Generex GmbH. All rights reserved.
   said raqui
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!-- Methods -->
  <!--Body-->
  <xsl:template name="aeg_cbsr_cmd_panel-body">
    <script type="text/javascript">
      window.resizeTo(706,480);
    </script>
    <xsl:apply-templates />
  </xsl:template>
  <!-- Implementation -->
  <xsl:template match="values">
    <!--title-->
    <div class="XLargeBold" style="position:absolute; top:13px;left:188px;width:300px;height:100px;text-align:center;">
      <xsl:value-of select="'Test&#160;/&#160;Control&#160;Functions'"/>
    </div>
    <!-- CBSR time panel-->
    <xsl:call-template name="cbsr-time-panel">
      <xsl:with-param name="local_date" select="substring-before(//report/@time, ' ')"/>
      <xsl:with-param name="local_time" select="substring-after(//report/@time, ' ')"/>
      <xsl:with-param name="cbser_date" select="value[@name='CBSER_DATE']/@val"/>
      <xsl:with-param name="cbser_time" select="concat(concat(value[@name='CBSER_TIME']/@val, ':'),value[@name='CBSER_TIME']/@val2)"/>
      <xsl:with-param name="top" select="58"/>
      <xsl:with-param name="left" select="'40'"/>
      <xsl:with-param name="w" select="'300'"/>
      <xsl:with-param name="h" select="'130'"/>
      <xsl:with-param name="border" select="'1'"/>
      <xsl:with-param name="id" select="'cbsr-time-panel-id'"/>
    </xsl:call-template>
    <!--infos variable-->
    <xsl:variable name="status_txt">
      <xsl:choose>
        <xsl:when test="value[@name='CB_LOGSTATE']/@val=2">
          <xsl:value-of select="'In progress...'" />
        </xsl:when>
        <xsl:when test="value[@name='CB_LOGSTATE']/@val=1">
          <xsl:value-of select="'Logfile successfully retrieved'" />
        </xsl:when>
        <xsl:when test="value[@name='CB_LOGSTATE']/@val=3">
          <xsl:value-of select="'Error getting log file'" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="' '" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!-- CBSR download datalog  panel-->
    <xsl:call-template name="cbsr-download-datalog">
      <xsl:with-param name="top" select="206"/>
      <xsl:with-param name="left" select="'40'"/>
      <xsl:with-param name="w" select="'300'"/>
      <xsl:with-param name="h" select="'140'"/>
      <xsl:with-param name="border" select="'1'"/>
      <xsl:with-param name="id" select="'cbsr-download-panel-id'"/>
      <xsl:with-param name="status_txt" select="$status_txt"/>
    </xsl:call-template>


    <!--CBSR custom test time variable-->
    <xsl:variable name="custom_test_time" >
      <xsl:choose>
        <xsl:when test="string-length(value[@name='_custom_test_time']/@val) !=0">
          <xsl:value-of select="value[@name='_custom_test_time']/@val"/>
        </xsl:when>
        <xsl:when test="string-length(value[@name='POWERDOWNTIME']/@val) !=0">
          <xsl:value-of select="value[@name='POWERDOWNTIME']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'3'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!--CBSR battery test panel-->
    <xsl:call-template name="cbsr-battery-test-panel">
      <xsl:with-param name="custom_test_time" select="$custom_test_time"/>
      <xsl:with-param name="top" select="58"/>
      <xsl:with-param name="left" select="'350'"/>
      <xsl:with-param name="w" select="'310'"/>
      <xsl:with-param name="h" select="'440'"/>
      <xsl:with-param name="border" select="'1'"/>
      <xsl:with-param name="id" select="'cbsr-battery-test-panel-id'"/>
    </xsl:call-template>

    <!--infos variable-->
    <xsl:variable name="infos">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='infos']/@val)!=0">
          <xsl:value-of select="value[@name='infos']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="''" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:if test="string-length($infos)!=0">
      <xsl:call-template name="extcmd_infos">
        <xsl:with-param name="infos" select="value[@name='infos']/@val"/>
        <xsl:with-param name="color" select="value[@name='color']/@val"/>
        <xsl:with-param name="top" select="'390'"/>
        <xsl:with-param name="left" select="'40'"/>
      </xsl:call-template>
    </xsl:if>

  </xsl:template>
  <!-- EOS -->
</xsl:stylesheet>