<?xml version="1.0"?>
<!--
   aeg_gripow_cmd_panel.xsl - GRIPOW commands UPS screen.
   Copyright (c) 2010, Generex GmbH. All rights reserved.
   said raqui
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!-- Methods -->
  <!--Body-->
  <xsl:template name="aeg_gripow_cmd_panel-body">
    <xsl:apply-templates />
  </xsl:template>
  <!-- Implementation -->
  <xsl:template match="values">
    <!--title-->
    <div class="XLargeBold" style="position:absolute; top:13px;left:10px;width:300px;height:100px;text-align:center;">
      <xsl:value-of select="'Test&#160;/&#160;Control&#160;Functions&#160;of&#160;UPS'"/>
    </div>

    <!--gripow custom test time variable-->
    <xsl:variable name="custom_test_time" >
      <xsl:choose>
        <xsl:when test="string-length(value[@name='_custom_test_time']/@val) !=0">
          <xsl:value-of select="value[@name='_custom_test_time']/@val"/>
        </xsl:when>
        <xsl:when test="string-length(value[@name='POWERDOWNTIME']/@val) !=0">
          <xsl:value-of select="value[@name='POWERDOWNTIME']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'3'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <!--gripow battery test panel-->
    <xsl:call-template name="gripow-battery-test-panel">
      <xsl:with-param name="custom_test_time" select="$custom_test_time"/>
      <xsl:with-param name="top" select="46"/>
      <xsl:with-param name="left" select="'12'"/>
      <xsl:with-param name="w" select="'310'"/>
      <xsl:with-param name="h" select="'440'"/>
      <xsl:with-param name="border" select="'1'"/>
      <xsl:with-param name="id" select="'gripow-battery-test-panel-id'"/>
    </xsl:call-template>

    <!--infos variable-->
    <xsl:variable name="infos">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='infos']/@val)!=0">
          <xsl:value-of select="value[@name='infos']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="''" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:if test="string-length($infos)!=0">
      <xsl:call-template name="extcmd_infos">
        <xsl:with-param name="infos" select="value[@name='infos']/@val"/>
        <xsl:with-param name="color" select="value[@name='color']/@val"/>
        <xsl:with-param name="top" select="'370'"/>
        <xsl:with-param name="left" select="'20'"/>
      </xsl:call-template>
    </xsl:if>

  </xsl:template>
  <!-- EOS -->
</xsl:stylesheet>