<?xml version="1.0"?>
<!--
   aeg_protc_cmd_panel.xsl - AETSER commands UPS screen.
   Copyright (c) 2015, Generex GmbH. All rights reserved.
   said raqui
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!-- Methods -->
  <!--Body-->
  <xsl:template name="aeg_protc_cmd_panel-body">
    <xsl:apply-templates />
  </xsl:template>
  <!-- Implementation -->
  <xsl:template match="values">
    <!--title-->
    <div class="XLargeBold" style="position:absolute; top:13px;left:42px;width:300px;height:100px;text-align:center;">
      <xsl:value-of select="'UPS&#160;&#160;Test&#160;/&#160;Control&#160;Functions'"/>
    </div>

    <xsl:variable name="ups_protocol">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='_upsProtocol']/@val) !=0">
          <xsl:value-of select="value[@name='_upsProtocol']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="unsigner">
            <xsl:with-param name="val" select="value[@name='CONNECT']/@val"/>
            <xsl:with-param name="bits" select="16"/>
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <!--ATSER custom test time variable-->
    <xsl:variable name="custom_test_time" >
      <xsl:choose>
        <xsl:when test="string-length(value[@name='_custom_test_time']/@val) !=0 and string(number(value[@name='_custom_test_time']/@val)) != 'NaN'">
          <xsl:value-of select="value[@name='_custom_test_time']/@val"/>
        </xsl:when>
        <xsl:when test="string-length(value[@name='POWERDOWNTIME']/@val) !=0">
          <xsl:value-of select="value[@name='POWERDOWNTIME']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'3'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <!--PROTD 6000-10000 battery test panel-->
    <xsl:call-template name="protc-battery-test-fault-log-panel">
      <xsl:with-param name="custom_test_time" select="$custom_test_time"/>
      <xsl:with-param name="top" select="48"/>
      <xsl:with-param name="left" select="'40'"/>
      <xsl:with-param name="w" select="'310'"/>
      <xsl:with-param name="h" select="'440'"/>
      <xsl:with-param name="border" select="'1'"/>
      <xsl:with-param name="id" select="'protd-battery-test-panel-id'"/>
    </xsl:call-template>

    <!-- PROTC time panel-->
    <xsl:call-template name="protc-time-panel">
      <xsl:with-param name="local_date" select="substring-before(//report/@time, ' ')"/>
      <xsl:with-param name="local_time" select="substring-after(//report/@time, ' ')"/>
      <xsl:with-param name="cbser_date" select="value[@name='CBSER_DATE']/@val"/>
      <xsl:with-param name="cbser_time" select="concat(concat(value[@name='CBSER_TIME']/@val, ':'),value[@name='CBSER_TIME']/@val2)"/>
      <xsl:with-param name="top" select="322"/>
      <xsl:with-param name="left" select="'40'"/>
      <xsl:with-param name="w" select="'310'"/>
      <xsl:with-param name="h" select="'120'"/>
      <xsl:with-param name="border" select="'1'"/>
      <xsl:with-param name="id" select="'protc-time-panel-id'"/>
    </xsl:call-template>

    <!--infos variable-->
    <xsl:variable name="infos">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='infos']/@val)!=0">
          <xsl:value-of select="value[@name='infos']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="''" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:if test="string-length($infos)!=0">
      <xsl:call-template name="extcmd_infos">
        <xsl:with-param name="infos" select="value[@name='infos']/@val"/>
        <xsl:with-param name="color" select="value[@name='color']/@val"/>
        <xsl:with-param name="top" select="'450'"/>
        <xsl:with-param name="left" select="'40'"/>
      </xsl:call-template>
    </xsl:if>

  </xsl:template>
  <!-- EOS -->
</xsl:stylesheet>
