<?xml version="1.0"?>
<!--
   aeser240_panel.xsl - UPS screen for AEG.
   Copyright (c) 2010, Generex GmbH. All rights reserved.
   Said Raqui
-->
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:exsl="http://exslt.org/common"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	exclude-result-prefixes="exsl msxsl">

  <!-- Workaround for Internet Explorer (MSXML) to support exsl:node-set -->
  <msxsl:script language="JScript" implements-prefix="exsl">
    this['node-set'] = function (x) { return x; }
  </msxsl:script>

  <!-- Methods -->
  <!--Header-->
  <xsl:template name="aeser240_panel-header">
    <xsl:call-template name="app-header">
      <xsl:with-param name="top" select="13"/>
      <xsl:with-param name="left" select="36"/>
    </xsl:call-template>
  </xsl:template>

  <!--Footer-->
  <xsl:template name="aeser240_panel-footer" >
    <xsl:call-template name="app-footer" >
      <xsl:with-param name="top" select="550"/>
      <xsl:with-param name="left" select="10"/>
      <xsl:with-param name="width" select="754"/>
      <xsl:with-param name="height" select="66"/>
    </xsl:call-template>
  </xsl:template>
  <!--Menu-->
  <xsl:template name="aeser240_panel-menu">
    <xsl:call-template name="app-menu">
      <xsl:with-param name="top" select="428"/>
      <xsl:with-param name="left" select="0"/>
      <xsl:with-param name="width" select="0"/>
      <xsl:with-param name="height" select="0"/>
      <xsl:with-param name="class" select="'XBold_black'"/>
    </xsl:call-template>
  </xsl:template>

  <!--Body-->
  <xsl:template name="aeser240_panel-body">
    <xsl:call-template name="background">
      <xsl:with-param name="imagepath" select="'./lib/ups/image/aeg/backab1.png'"/>
      <xsl:with-param name="x" select="'0'"/>
      <xsl:with-param name="y" select="'0'"/>
      <xsl:with-param name="w" select="'785'"/>
      <xsl:with-param name="h" select="'546'"/>
      <xsl:with-param name="border" select="0"/>
      <xsl:with-param name="id" select="'background'"/>
    </xsl:call-template>

    <xsl:apply-templates />
    <script type="text/javascript">
      init();
    </script>
    <xsl:if test="string-length(//report/@_platform) != string-length('cs141')">
      <xsl:call-template name="js_refresh_call">
        <xsl:with-param	 name="timeout" select="1000*//report/@refresh"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>

  <xsl:template match="values">
    <!-- Implementation -->
    <!-- selected ups id -->
    <xsl:variable name="selected_ups_id">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='_selected_ups_id']/@val) != 0">
          <xsl:value-of select="value[@name='_selected_ups_id']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="0"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="active_path">
      <xsl:choose>
        <xsl:when test="//report/@_platform = 'cs141'">
          <xsl:choose>
            <xsl:when test="$selected_ups_id = 0">
              <xsl:copy-of select="//values/*"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:copy-of select="//modules/module[position()= $selected_ups_id]/*"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <xsl:otherwise>
          <xsl:copy-of select="//values/*"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="path" select="exsl:node-set($active_path)"/>


    <!-- Model -->
    <xsl:variable name="model">
      <xsl:choose>
        <xsl:when test="string-length(//upsview)&gt;0">
          <xsl:value-of select="value[@name='MODEL']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="' '"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <div style="color:black; font-weight:bold; font-size:9pt">
      <xsl:if test="string-length($model) !=0">
        <xsl:call-template name="paneText">
          <xsl:with-param name="x" select="16" />
          <xsl:with-param name="y" select="12" />
          <xsl:with-param name="w" select="200" />
          <xsl:with-param name="h" select="17" />
          <xsl:with-param name="align" select="'left'" />
          <xsl:with-param name="color" select="'white'" />
          <xsl:with-param name="value" select="concat('Identification&#160;&#160;',$model)" />
        </xsl:call-template>
      </xsl:if>
    </div>

    <!-- UPS Chart Text -->
    <div style="color:black; font-weight:bold; font-size:9pt">
      <xsl:call-template name="paneText">
        <xsl:with-param name="x" select="480" />
        <xsl:with-param name="y" select="148" />
        <xsl:with-param name="w" select="200" />
        <xsl:with-param name="h" select="17" />
        <xsl:with-param name="align" select="'left'" />
        <xsl:with-param name="color" select="'white'" />
        <xsl:with-param name="value" select="$lang-UPS-Chart" />
      </xsl:call-template>
    </div>
    <!-- UPS Events Text -->
    <div style="color:black; font-weight:bold; font-size:9pt">
      <xsl:call-template name="paneText">
        <xsl:with-param name="x" select="460" />
        <xsl:with-param name="y" select="12" />
        <xsl:with-param name="w" select="200" />
        <xsl:with-param name="h" select="17" />
        <xsl:with-param name="align" select="'left'" />
        <xsl:with-param name="color" select="'white'" />
        <xsl:with-param name="value" select="$lang-UPS-Events" />
      </xsl:call-template>
    </div>
    <!-- modules status pane -->
    <xsl:call-template name="modules-status-pane">
      <xsl:with-param name="modules_status" select="'0'" />
      <xsl:with-param name="ups_off" select="$path/value[@name='UPS_OFF']/@val" />
      <xsl:with-param name="state" select="$path/value[@name='STATUS']/@val" />
      <xsl:with-param name="in_phases" select="$path/value[@name='INPHASES']/@val" />
      <xsl:with-param name="in_volt" select="$path/value[@name='INVOLT']" />
      <xsl:with-param name="in_freq" select="$path/value[@name='INFREQ']/@val" />
      <xsl:with-param name="batt_autonomy_time" select="$path/value[@name='AUTONOMTIME']/@val" />
      <xsl:with-param name="batt_status" select="$path/value[@name='BATTERY_STATE']/@val" />
      <xsl:with-param name="batt_capacity" select="$path/value[@name='BATTCAP']/@val" />
      <xsl:with-param name="batt_volt" select="$path/value[@name='BATTVOLT']/@val" />
      <xsl:with-param name="batt_temp" select="$path/value[@name='TEMPDEG']/@val" />
      <xsl:with-param name="out_volt" select="$path/value[@name='OUTPUT_VOLT']" />
      <xsl:with-param name="out_power" select="$path/value[@name='OUTPOWER']/@val" />
      <xsl:with-param name="out_current" select="$path/value[@name='SOLAWROC']" />
      <xsl:with-param name="power" select="$path/value[@name='E_OUTPOWER']" />
      <xsl:with-param name="complex_power" select="$path/value[@name='E_OUTCPOWER']" />
    </xsl:call-template>

    <!--  oem View Name-->
    <xsl:variable name="oem_view_name" select="$path/value[@name='_oemViewName']/@val"/>
    <!-- Battery Voltage Load bar variables-->
    <xsl:variable name="batt_volt_startval">
      <xsl:choose>
        <xsl:when test="string($oem_view_name)='AESER240' or string($oem_view_name)='aeser240'">
          <xsl:value-of select="'90'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'0'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="batt_volt_endval">
      <xsl:choose>
        <xsl:when test="string($oem_view_name)='AESER240' or string($oem_view_name)='aeser240'">
          <xsl:value-of select="'150'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'0'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="batt_volt_step">
      <xsl:choose>
        <xsl:when test="string($oem_view_name)='AESER240' or string($oem_view_name)='aeser240'">
          <xsl:value-of select="'10'"/>
        </xsl:when>
        <xsl:otherwise></xsl:otherwise>
      </xsl:choose>
    </xsl:variable>


    <!-- Load bars page0-->
    <!-- Battery Voltage -->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="$path/value[@name='BATTVOLT']/@val"/>
      <xsl:with-param name="headline" select="$lang-Battery-Voltage"/>
      <xsl:with-param name="font-size" select="11"/>
      <xsl:with-param name="unit" select="'V'"/>
      <xsl:with-param name="x" select="330"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="h" select="80"/>
      <xsl:with-param name="barx" select="'49'"/>
      <xsl:with-param name="bary" select="70"/>
      <xsl:with-param name="barw" select="50"/>
      <xsl:with-param name="suby" select="240"/>
      <xsl:with-param name="startval" select="$batt_volt_startval"/>
      <xsl:with-param name="endval" select="$batt_volt_endval"/>
      <xsl:with-param name="decimal-places" select="1"/>
      <xsl:with-param name="step" select="$batt_volt_step"/>
      <xsl:with-param name="skip" select="5"/>
      <xsl:with-param name="id" select="'page0'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-hi" select="''"/>
      <xsl:with-param name="thresh-yellow-hi" select="''"/>
      <xsl:with-param name="start-visibility" select="'visible'"/>
      <xsl:with-param name="bright" select="0"/>
      <xsl:with-param name="sel_page" select="1"/>
    </xsl:call-template>
    <!-- Battery Capacity -->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="$path/value[@name='BATTCAP']/@val"/>
      <xsl:with-param name="headline" select="$lang-Battery-Capacity"/>
      <xsl:with-param name="font-size" select="11"/>
      <xsl:with-param name="unit" select="'%'"/>
      <xsl:with-param name="x" select="460"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="h" select="80"/>
      <xsl:with-param name="barx" select="'49'"/>
      <xsl:with-param name="bary" select="70"/>
      <xsl:with-param name="barw" select="50"/>
      <xsl:with-param name="suby" select="240"/>
      <xsl:with-param name="startval" select="0"/>
      <xsl:with-param name="endval" select="100"/>
      <xsl:with-param name="decimal-places" select="0"/>
      <xsl:with-param name="step" select="20"/>
      <xsl:with-param name="skip" select="20"/>
      <xsl:with-param name="id" select="'page0'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-lo" select="50"/>
      <xsl:with-param name="thresh-yellow-lo" select="80"/>
      <xsl:with-param name="start-visibility" select="'visible'"/>
      <xsl:with-param name="bright" select="0"/>
      <xsl:with-param name="sel_page" select="1"/>
    </xsl:call-template>
    <!-- Autonomy Time -->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="$path/value[@name='AUTONOMTIME']/@val"/>
      <xsl:with-param name="headline" select="$lang-Autonomy-Time"/>
      <xsl:with-param name="font-size" select="11"/>
      <xsl:with-param name="unit" select="'Min'"/>
      <xsl:with-param name="x" select="590"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="h" select="80"/>
      <xsl:with-param name="barx" select="'49'"/>
      <xsl:with-param name="bary" select="70"/>
      <xsl:with-param name="barw" select="50"/>
      <xsl:with-param name="suby" select="240"/>
      <xsl:with-param name="startval" select="0"/>
      <xsl:with-param name="endval" select="100"/>
      <xsl:with-param name="decimal-places" select="0"/>
      <xsl:with-param name="step" select="20"/>
      <xsl:with-param name="skip" select="20"/>
      <xsl:with-param name="id" select="'page0'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-lo" select="4"/>
      <xsl:with-param name="thresh-yellow-hi" select="''"/>
      <xsl:with-param name="start-visibility" select="'visible'"/>
      <xsl:with-param name="bright" select="0"/>
      <xsl:with-param name="sel_page" select="1"/>
    </xsl:call-template>

    <!-- Load bars page1-->
    <!-- Input Voltage -->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="$path/value[@name='INVOLT']/@val"/>
      <xsl:with-param name="headline" select="$lang-Input-Voltage"/>
      <xsl:with-param name="font-size" select="11"/>
      <xsl:with-param name="unit" select="'V'"/>
      <xsl:with-param name="x" select="330"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="h" select="80"/>
      <xsl:with-param name="barx" select="'48'"/>
      <xsl:with-param name="bary" select="90"/>
      <xsl:with-param name="barw" select="50"/>
      <xsl:with-param name="suby" select="240"/>
      <xsl:with-param name="startval" select="90"/>
      <xsl:with-param name="endval" select="270"/>
      <xsl:with-param name="decimal-places" select="0"/>
      <xsl:with-param name="step" select="45"/>
      <xsl:with-param name="skip" select="45"/>
      <xsl:with-param name="id" select="'page1'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-hi" select="''"/>
      <xsl:with-param name="thresh-yellow-hi" select="''"/>
      <xsl:with-param name="start-visibility" select="'visible'"/>
      <xsl:with-param name="bright" select="0"/>
      <xsl:with-param name="sel_page" select="1"/>
    </xsl:call-template>
    <!-- Input Frequency -->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="$path/value[@name='INFREQ']/@val"/>
      <xsl:with-param name="headline" select="$lang-Input-Frequency"/>
      <xsl:with-param name="font-size" select="11"/>
      <xsl:with-param name="unit" select="'Hz'"/>
      <xsl:with-param name="x" select="460"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="h" select="80"/>
      <xsl:with-param name="barx" select="'49'"/>
      <xsl:with-param name="bary" select="70"/>
      <xsl:with-param name="barw" select="50"/>
      <xsl:with-param name="suby" select="240"/>
      <xsl:with-param name="startval" select="40"/>
      <xsl:with-param name="endval" select="70"/>
      <xsl:with-param name="decimal-places" select="1"/>
      <xsl:with-param name="step" select="5"/>
      <xsl:with-param name="skip" select="5"/>
      <xsl:with-param name="id" select="'page1'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-hi" select="''"/>
      <xsl:with-param name="thresh-yellow-hi" select="''"/>
      <xsl:with-param name="start-visibility" select="'visible'"/>
      <xsl:with-param name="bright" select="0"/>
      <xsl:with-param name="sel_page" select="1"/>
    </xsl:call-template>
    <!-- Autonomy Time -->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="$path/value[@name='AUTONOMTIME']/@val"/>
      <xsl:with-param name="headline" select="$lang-Autonomy-Time"/>
      <xsl:with-param name="font-size" select="11"/>
      <xsl:with-param name="unit" select="'Min'"/>
      <xsl:with-param name="x" select="590"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="h" select="80"/>
      <xsl:with-param name="barx" select="'49'"/>
      <xsl:with-param name="bary" select="70"/>
      <xsl:with-param name="barw" select="50"/>
      <xsl:with-param name="suby" select="240"/>
      <xsl:with-param name="startval" select="0"/>
      <xsl:with-param name="endval" select="100"/>
      <xsl:with-param name="decimal-places" select="0"/>
      <xsl:with-param name="step" select="20"/>
      <xsl:with-param name="skip" select="20"/>
      <xsl:with-param name="id" select="'page1'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-lo" select="4"/>
      <xsl:with-param name="thresh-yellow-hi" select="''"/>
      <xsl:with-param name="start-visibility" select="'visible'"/>
      <xsl:with-param name="bright" select="0"/>
      <xsl:with-param name="sel_page" select="1"/>
    </xsl:call-template>
    <!-- Load bars page2-->
    <!-- Load -->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="$path/value[@name='OUTPOWER']/@val"/>
      <xsl:with-param name="headline" select="$lang-Load"/>
      <xsl:with-param name="font-size" select="11"/>
      <xsl:with-param name="unit" select="'%'"/>
      <xsl:with-param name="x" select="330"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="h" select="80"/>
      <xsl:with-param name="barx" select="'49'"/>
      <xsl:with-param name="bary" select="70"/>
      <xsl:with-param name="barw" select="50"/>
      <xsl:with-param name="suby" select="240"/>
      <xsl:with-param name="startval" select="0"/>
      <xsl:with-param name="endval" select="100"/>
      <xsl:with-param name="decimal-places" select="0"/>
      <xsl:with-param name="step" select="25"/>
      <xsl:with-param name="skip" select="25"/>
      <xsl:with-param name="id" select="'page2'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-hi" select="100"/>
      <xsl:with-param name="thresh-yellow-hi" select="80"/>
      <xsl:with-param name="start-visibility" select="'visible'"/>
      <xsl:with-param name="bright" select="0"/>
      <xsl:with-param name="sel_page" select="1"/>
    </xsl:call-template>
    <!-- Autonomy Time -->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="$path/value[@name='AUTONOMTIME']/@val"/>
      <xsl:with-param name="headline" select="$lang-Autonomy-Time"/>
      <xsl:with-param name="font-size" select="11"/>
      <xsl:with-param name="unit" select="'Min'"/>
      <xsl:with-param name="x" select="460"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="h" select="80"/>
      <xsl:with-param name="barx" select="'49'"/>
      <xsl:with-param name="bary" select="70"/>
      <xsl:with-param name="barw" select="50"/>
      <xsl:with-param name="suby" select="240"/>
      <xsl:with-param name="startval" select="0"/>
      <xsl:with-param name="endval" select="100"/>
      <xsl:with-param name="decimal-places" select="0"/>
      <xsl:with-param name="step" select="20"/>
      <xsl:with-param name="skip" select="0"/>
      <xsl:with-param name="id" select="'page2'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-lo" select="4"/>
      <xsl:with-param name="thresh-yellow-hi" select="''"/>
      <xsl:with-param name="start-visibility" select="'visible'"/>
      <xsl:with-param name="bright" select="0"/>
      <xsl:with-param name="sel_page" select="1"/>
    </xsl:call-template>
    <!-- Temperature -->
    <xsl:if test="$path/value[@name='_tempUnit']/@val=1">
      <xsl:call-template name="valuebar">
        <xsl:with-param name="value" select="($path/value[@name='TEMPDEG']/@val*1.8) + 32.0"/>
        <xsl:with-param name="headline" select="$lang-Temperature"/>
        <xsl:with-param name="font-size" select="11"/>
        <xsl:with-param name="unit" select="'&#176;F'"/>
        <xsl:with-param name="x" select="590"/>
        <xsl:with-param name="y" select="200"/>
        <xsl:with-param name="h" select="80"/>
        <xsl:with-param name="barx" select="'49'"/>
        <xsl:with-param name="bary" select="70"/>
        <xsl:with-param name="barw" select="50"/>
        <xsl:with-param name="suby" select="240"/>
        <xsl:with-param name="startval" select="32"/>
        <xsl:with-param name="endval" select="(60*1.8) + 32.0"/>
        <xsl:with-param name="decimal-places" select="1"/>
        <xsl:with-param name="step" select="(10*1.8) + 32.0"/>
        <xsl:with-param name="skip" select="(10*1.8) + 32.0"/>
        <xsl:with-param name="id" select="'page2'"/>
        <xsl:with-param name="shadowoffset" select="5"/>
        <xsl:with-param name="thresh-red-hi" select="''"/>
        <xsl:with-param name="thresh-yellow-hi" select="''"/>
        <xsl:with-param name="start-visibility" select="'visible'"/>
        <xsl:with-param name="bright" select="0"/>
        <xsl:with-param name="sel_page" select="1"/>
      </xsl:call-template>
    </xsl:if>
    <xsl:if test="$path/value[@name='_tempUnit']/@val=0 or string-length($path/value[@name='_tempUnit']/@val)=0">
      <xsl:call-template name="valuebar">
        <xsl:with-param name="value" select="$path/value[@name='TEMPDEG']/@val"/>
        <xsl:with-param name="headline" select="$lang-Temperature"/>
        <xsl:with-param name="font-size" select="11"/>
        <xsl:with-param name="unit" select="'&#176;C'"/>
        <xsl:with-param name="x" select="590"/>
        <xsl:with-param name="y" select="200"/>
        <xsl:with-param name="h" select="80"/>
        <xsl:with-param name="barx" select="'49'"/>
        <xsl:with-param name="bary" select="70"/>
        <xsl:with-param name="barw" select="50"/>
        <xsl:with-param name="suby" select="240"/>
        <xsl:with-param name="startval" select="0"/>
        <xsl:with-param name="endval" select="60"/>
        <xsl:with-param name="decimal-places" select="1"/>
        <xsl:with-param name="step" select="10"/>
        <xsl:with-param name="skip" select="10"/>
        <xsl:with-param name="id" select="'page2'"/>
        <xsl:with-param name="shadowoffset" select="5"/>
        <xsl:with-param name="thresh-red-hi" select="''"/>
        <xsl:with-param name="thresh-yellow-hi" select="''"/>
        <xsl:with-param name="start-visibility" select="'visible'"/>
        <xsl:with-param name="bright" select="0"/>
        <xsl:with-param name="sel_page" select="1"/>
      </xsl:call-template>
    </xsl:if>
    <!-- Log events pane -->
    <xsl:call-template name="events-pane">
    </xsl:call-template>
    <!--select pages -->
    <xsl:call-template name="select-page">
    </xsl:call-template>

    <!-- select modules pane-->
    <xsl:call-template name="select-modules">
      <xsl:with-param name="num_units" select="$path/value[@name='NUM_UNITS']/@val" />
      <xsl:with-param name="is_multi" select="'1'" />
      <!--$path/value[@name='IS_MULTI']/@val-->
      <xsl:with-param name="act_ups_id" select="$path/value[@name='ACT_UPSID']/@val" />
      <xsl:with-param name="module_mask" select="$path/value[@name='MODULEMASK']/@val" />
      <xsl:with-param name="selected_ups_id" select="$selected_ups_id" />

      <xsl:with-param name="ups_off" select="$path/value[@name='UPS_OFF']/@val" />
      <xsl:with-param name="faultcode_A" select="$path/value[@name='FAULTCODEA']" />
      <xsl:with-param name="faultcode_B" select="$path/value[@name='FAULTCODEB']" />
      <xsl:with-param name="faultcode_C" select="$path/value[@name='FAULTCODEC']" />
      <xsl:with-param name="faultcode_D" select="$path/value[@name='FAULTCODED']" />
      <xsl:with-param name="faultcode_E" select="$path/value[@name='FAULTCODEE']" />
      <xsl:with-param name="faultcode_F" select="$path/value[@name='FAULTCODEF']" />

      <xsl:with-param name="module_state_A" select="$path/value[@name='MODSTATEA']/@val" />
      <xsl:with-param name="module_state_B" select="$path/value[@name='MODSTATEB']/@val" />
      <xsl:with-param name="module_state_C" select="$path/value[@name='MODSTATEC']/@val" />
      <xsl:with-param name="module_state_D" select="$path/value[@name='MODSTATED']/@val" />
      <xsl:with-param name="module_state_E" select="$path/value[@name='MODSTATEE']/@val" />
      <xsl:with-param name="module_state_F" select="$path/value[@name='MODSTATEF']/@val" />

      <xsl:with-param name="module_warn_A" select="$path/value[@name='WARNINGSA']/@val" />
      <xsl:with-param name="module_warn_B" select="$path/value[@name='WARNINGSB']/@val" />
      <xsl:with-param name="module_warn_C" select="$path/value[@name='WARNINGSC']/@val" />
      <xsl:with-param name="module_warn_D" select="$path/value[@name='WARNINGSD']/@val" />
      <xsl:with-param name="module_warn_E" select="$path/value[@name='WARNINGSE']/@val" />
      <xsl:with-param name="module_warn_F" select="$path/value[@name='WARNINGSF']/@val" />

    </xsl:call-template>



  </xsl:template>

  <!-- EOS -->
</xsl:stylesheet>