<?xml version="1.0"?>
<!--
   cable_panel.xsl - dry-contact ups screen (UNMS-II).
   Copyright (c) 2008, Generex GmbH. All rights reserved.
   hr
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!-- Methods -->
  <!--Header-->
  <xsl:template name="cable_panel-header">
    <xsl:call-template name="app-header">
      <xsl:with-param name="top" select="3"/>
    </xsl:call-template>
  </xsl:template>

  <!--Footer-->
  <xsl:template name="cable_panel-footer" >
    <xsl:call-template name="app-footer" >
      <xsl:with-param name="left" select="22"/>
      <xsl:with-param name="top" select="440"/>
      <xsl:with-param name="width" select="756"/>
      <xsl:with-param name="height" select="62"/>
    </xsl:call-template>
  </xsl:template>
  <!--Menu-->
  <xsl:template name="cable_panel-menu">
    <xsl:call-template name="app-menu">
      <xsl:with-param name="top" select="428"/>
      <xsl:with-param name="left" select="0"/>
      <xsl:with-param name="width" select="0"/>
      <xsl:with-param name="height" select="0"/>
      <xsl:with-param name="class" select="'XBold_black'"/>
    </xsl:call-template>
  </xsl:template>

  <!--Body-->
  <xsl:template name="cable_panel-body">
    <xsl:param name="cable-type" select="0"/>
    <!-- BACKGROUND -->
    <xsl:call-template name="background">
      <xsl:with-param name="imagepath" select="'./lib/ups/image/ups/Standard.png'"/>
      <xsl:with-param name="x" select="'0'"/>
      <xsl:with-param name="y" select="'0'"/>
      <xsl:with-param name="w" select="'788'"/>
      <xsl:with-param name="h" select="'487'"/>
      <xsl:with-param name="border" select="0"/>
      <xsl:with-param name="id" select="'background'"/>
    </xsl:call-template>

    <xsl:apply-templates />
    <xsl:call-template name="IEpixelBugfixCall"/>
    <xsl:call-template name="js_refresh_call">
      <xsl:with-param	 name="timeout" select="1000*//report/@refresh"/>
    </xsl:call-template>
  </xsl:template>
  <!-- Implementation -->

  <xsl:template match="values">

    <!-- MODEL -->
    <div class="LargeBold" style="position: absolute; left: 60px; top: 110px; width: 163px; height: 17px; text-align:center">
      <xsl:value-of select="value[@name='MODEL']/@val" />
    </div>

    <!-- STATUS -->
    <xsl:variable name="state" select="value[@name='STATUS']/@val"/>

    <!-- Bits masked -->
    <xsl:variable name="bypass">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$state"/>
        <xsl:with-param name="bit" select="$bit0"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="shutdown">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$state"/>
        <xsl:with-param name="bit" select="$bit1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="active">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$state"/>
        <xsl:with-param name="bit" select="$bit2"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="powerfail">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$state"/>
        <xsl:with-param name="bit" select="$bit3"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="batterylow">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$state"/>
        <xsl:with-param name="bit" select="$bit4"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="overtemp">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$state"/>
        <xsl:with-param name="bit" select="$bit5"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="testact">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$state"/>
        <xsl:with-param name="bit" select="$bit6"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="inputhigh">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$state"/>
        <xsl:with-param name="bit" select="$bit7"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="outputhigh">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$state"/>
        <xsl:with-param name="bit" select="$bit8"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="inverterfail">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$state"/>
        <xsl:with-param name="bit" select="$bit9"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="batterybad">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$state"/>
        <xsl:with-param name="bit" select="$bit10"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="ecomode">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$state"/>
        <xsl:with-param name="bit" select="$bit11"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="inverterwarn">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$state"/>
        <xsl:with-param name="bit" select="$bit12"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="upsfailed">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$state"/>
        <xsl:with-param name="bit" select="$bit13"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="commlost">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$state"/>
        <xsl:with-param name="bit" select="$bit14"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="dvgalarm">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$state"/>
        <xsl:with-param name="bit" select="$bit15"/>
      </xsl:call-template>
    </xsl:variable>

    <!-- BATTERY-->
    <div style="position: absolute; left: 371Px; top: 293px; width: 50px; height: 50px">
      <xsl:choose>
        <xsl:when test="1=$powerfail">
          <img src="./lib/ups/image/ups/Batgrv.gif" />
        </xsl:when>
        <xsl:when test="1=$batterylow or 1=$batterybad">
          <img src="./lib/ups/image/ups/Batrv.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/ups/Batgev.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- RECTIFIER-->
    <div style="position: absolute; left: 277px; top: 217px; width: 50px; height: 50px">
      <xsl:choose>
        <xsl:when test="1=$powerfail">
          <img src="./lib/ups/image/ups/grw.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/ups/grgr.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- INVERTER-->
    <div style="position: absolute; left: 470px; top: 217px; width: 50px; height: 50px">
      <xsl:choose>
        <xsl:when test="1=$inverterfail or 1=$inverterwarn or 1=$outputhigh">
          <img src="./lib/ups/image/ups/wrr.gif" />
        </xsl:when>
        <xsl:when test="1=$bypass ">
          <img src="./lib/ups/image/ups/wrge.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/ups/wrgr.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- SSI-->
    <div style="position: absolute; left: 371px; top: 139px; width: 50px; height: 50px">
      <xsl:choose>
        <xsl:when test="1=$powerfail">
          <img src="./lib/ups/image/ups/ssww.gif" />
        </xsl:when>
        <xsl:when test="1=$bypass">
          <img src="./lib/ups/image/ups/sswgr.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/ups/sswge.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- IRE -->
    <div style="position: absolute; left: 205px; top: 236px; width: 22px; height: 8px">
      <xsl:choose>
        <xsl:when test="1=$powerfail or 1=$inputhigh">
          <img border="1" src="./lib/ups/image/ups/led20x4red.gif" width="22" height="8"/>
        </xsl:when>
        <xsl:otherwise>
          <img border="1" src="./lib/ups/image/ups/led20x4gr.gif" width="22" height="8"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- IBY -->
    <div style="position: absolute; left: 565px; top: 236px; width: 22px; height: 8px">
      <xsl:choose>
        <xsl:when test="1!=$active  and 1!=$commlost">
          <img border="1" src="./lib/ups/image/ups/led20x4red.gif" width="22" height="8"/>
        </xsl:when>
        <xsl:otherwise>
          <img border="1" src="./lib/ups/image/ups/led20x4gr.gif" width="22" height="8"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- COMMON ALARM -->
    <div style="position: absolute; left: 610px; top: 110px; width: 33px; height: 12px; color:#3341AA; font-weight:bold; font-size:9pt">Alarm</div>
    <div style="position: absolute; left: 610px; top: 130px; width: 33px; height: 12px">
      <xsl:choose>
        <xsl:when test="4!=$state and 1!=$testact">
          <img border="1" src="./lib/ups/image/ups/led33x12red.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img border="1" src="./lib/ups/image/ups/led33x12gr.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>

  </xsl:template>
  <!-- EOS -->
</xsl:stylesheet>