/*
   centiel_panel.js - Centielscreen.
   Copyright (c) 2013-2018, Generex GmbH. All rights reserved.
   Said/UW.
*/

var centiel_api = (function ($) {
  var oid = get_oid_from_url(),
    cb = null,
    pannes_created = false,
    err_div = null,
    check_bowser = true,
    outpower_loadbars_created = false,
    css_obj, attr_obj,
    ups_obj, valtable_obj, report_obj, unms_obj,
    inphases = null,
    outphases = null,
    bypphases = null,
    modules_exist_maske = null,
    modules_exist_maske2 = null,
    plattform = get_plattform(),
    ups_id = 0,
    ups_id_txt = '',
    bg_height, bg_width;
  x_pos = 10, y_pos = 10;

  var status_obj = [
      { bit: 0x0001, txt: "The Bypass is presently engaged on the UPS" },
      { bit: 0x0002, txt: "UPS is in shutdown mode" },
      { bit: 0x0004, txt: "UPS Output active" },
      { bit: 0x0008, txt: "The UPS is drawing power from the batteries" },
      { bit: 0x0010, txt: "The remaining battery run-time is low" },
      { bit: 0x0020, txt: "A temperature is out of tolerance" },
      { bit: 0x0040, txt: "A test is in progress" },
      { bit: 0x0080, txt: "Input high" },
      { bit: 0x0100, txt: "The output load exceeds the UPS output capacity" },
      { bit: 0x0200, txt: "Inverter error" },
      { bit: 0x0400, txt: "One or more batteries have been determined to require replacement" },
      { bit: 0x0800, txt: "UPS in ECO mode" },
      { bit: 0x1000, txt: "Inverter warning" },
      { bit: 0x2000, txt: "A general fault in the UPS has been detected" },
      { bit: 0x4000, txt: "A problem has been encountered in the communications between the agent and the UPS" }
    ],
    ext_status_obj = [
      { bit: 0x00001000, txt: "The battery is in discharging state" },
      { bit: 0x00004000, txt: "The battery is low" },
      { bit: 0x08000000, txt: "The buzzer is on" },
      { bit: 0x10000000, txt: "General alarm" },
    ],
    alarms_obj = [
      { bit: 0x00000001, txt: "Alarm: Overtemperature UPS" },
      { bit: 0x00000002, txt: "Alarm: Input bad" },
      { bit: 0x00000004, txt: "Alarm: Output bad" },
      { bit: 0x00000008, txt: "Alarm: Overload" },
      { bit: 0x00000010, txt: "Alarm: Bypass bad" },
      { bit: 0x00000020, txt: "Alarm: UPS Output off" },
      { bit: 0x00000040, txt: "Alarm: UPS shutdown" },
      { bit: 0x00000080, txt: "Alarm: Charger fail" },
      { bit: 0x00000100, txt: "Alarm: System off" },
      { bit: 0x00000200, txt: "Alarm: Fan failure" },
      { bit: 0x00000400, txt: "Alarm: Fuse failure" },
      { bit: 0x00000800, txt: "Alarm: General fault" },
      { bit: 0x00001000, txt: "Alarm: Awaiting power" },
      { bit: 0x00002000, txt: "Alarm: Shutdown pending" },
      { bit: 0x00004000, txt: "Alarm: Shutdown imminent" },
      { bit: 0x00008000, txt: "Alarm: Ambient overtemperature" },
      { bit: 0x00010000, txt: "Alarm: Inverter overtemperature" },
      { bit: 0x00020000, txt: "Alarm: Bypass overtemperature" },
      { bit: 0x00040000, txt: "Alarm: Battery overtemperature" },
      { bit: 0x00080000, txt: "Alarm: Inverter failure" },
      { bit: 0x00100000, txt: "Alarm: EPO activated" },
      { bit: 0x00200000, txt: "Alarm: Battery ground error" },
      { bit: 0x00400000, txt: "Alarm: Battery breaker open" },
      { bit: 0x00800000, txt: "Alarm: Sync error" },
      { bit: 0x01000000, txt: "Alarm: Redundancy loss" },
      { bit: 0x02000000, txt: "Alarm: Generator" },
      { bit: 0x04000000, txt: "Alarm: Battery low" },
      { bit: 0x08000000, txt: "Alarm: Battery depletet" }
    ];

  var req_params = null;

  /*public functions*/
  return {
    init: init
  };

  function init() {
    if (check_bowser && !utils_api.check_bowser()) {
      $('#loading_id').css('display', 'none');
      panes_api.create_br_check_panel(this, browser_check_ok);
      return true;
    }
    create_err_msg_panel();

    req_params = utils_api.get_req_params(utils_api.device_ups, oid);
    cb = jqmodule.subscribe(this, { update: update, error: err_funct }, req_params);
  }

  function browser_check_ok() {
    check_bowser = false;
    init();
  }

  function has_system_values() {
    if (valtable_obj.MODULEMASK == null) // single UPS ohne module haben IMMER system values
      return true;
    if (valtable_obj.HASSYSTEMVALS == null) // UPS ohne HASSYSTEMVALS variable haben IMMER system values
      return true;
    if (valtable_obj.HASSYSTEMVALS != 0)
      return true;
    return false;
  }

  function first_module() {
    var i, mod = 0;

    if (valtable_obj.MODULEMASK == null)
      return 0;
    for (i = 0; i < 30; i++)
    {
      if (valtable_obj.MODULEMASK & (1 << i))
      {
        mod = i + 1;
        break;
      }
    }
    if (mod == 0) // first module starts after module no 30
    {
       if (valtable_obj.MODULEMASK2 == null)
         return 0;
      for (i = 0; i < 30; i++)
      {
         if (valtable_obj.MODULEMASK2 & (1 << i))
         {
            mod = i + 1 + 30;
            break;
         }
      }
    }
    return mod;
  }

  function create_err_msg_panel() {
    css_obj = { position: 'absolute', top: y_pos, left: x_pos, width: 796, display: 'none', 'z-index': 62 };
    err_div = panes_api.create_err_panel({ id: 'error_div', 'class': 'alert alert-danger' }, css_obj);
  }

  function err_funct(response) {
    jqmodule.refresh(cb, 10 * 1000);
    panes_api.display_err({ response: response, oid: oid, err_div: err_div, err_msg_div_id: 'error_msg_div' });
  }

  function update(data) {
    if (data.ups == null) {
      return;
    }

    set_variable(data);
    jqmodule.refresh(cb, report_obj.refresh * 1000);
    if (err_div)
      err_div.css('display', 'none');

    if (window.menu_api != null)
      menu_api.update(data);

    unms_obj = get_unms_obj(data);
    if (unms_obj != null) {
      info_head_api.update(unms_obj);
    }

    if (!pannes_created) {
      //  wenn keine system values hier das erste modul suchen und ups_id setzen
      if (!has_system_values() && ups_id == 0) {
        ups_id = first_module();
        get_module_values(ups_id);
        return false;
      }
      pannes_created = true;
      create_panes();
      return false;
    }
    set_values();
  }

  function set_values() {
    set_input_values(); ////Input values
    set_output_values(); //Output values
    set_battery_value(); //Battery value
    set_byp_values(); //Bypass values
    set_iby_ire_ssi_inv_rec_batt(); //SET IBY, IRE, SSI, INVERTER, RECTIFIER and BATTERY pannes
    set_ups_status(); //set UPS status
    set_outpower_loadbars(); //outpower loadbars

    set_model_name();
    create_modules_panes();

    set_sys_mod_status();

    if (plattform !== "ups_view")
      panes_api.set_rom_temp_values(valtable_obj); //set rom temp values
    set_footer();
  }

  function create_footer_pane() {
    if (!oid || !unms_obj)
      return true;
    if (modules_exist_maske == null)
    {
       footer_api.create({ //Attr
           id: 'panel2'
           //'class':'unmsFooter'
         }, { //css
           position: 'absolute',
           top: '490px',
           left: '74px'
         },
         unms_obj
       );
    }
    else
    {
       footer_api.create({ //Attr
           id: 'panel2'
           //'class':'unmsFooter'
         }, { //css
           position: 'absolute',
           top: '700px',
           left: '74px'
         },
         unms_obj
       );
    }
  }

  function set_footer() {
    if (!oid || !unms_obj)
      return true;
    footer_api.set(unms_obj);
  }

  function set_variable(data) {
    ups_obj = data.ups;
    report_obj = data.report;

    if (plattform === utils_api.plattform_cs141) {
      if (ups_id == 0) {
        valtable_obj = ups_obj.valtable;
      } else {
        valtable_obj = ups_obj.modules[ups_id - 1] || data.ups.valtable;
        valtable_obj.MODEL = ups_obj.valtable.MODEL;
      }
    } else {
      valtable_obj = ups_obj.valtable;
    }

    if (plattform === utils_api.plattform_ups_view ||
      plattform === utils_api.plattform_cs121 ||
      plattform === utils_api.plattform_cs141) {
      modules_exist_maske = valtable_obj.MODULEMASK;
      modules_exist_maske2 = valtable_obj.MODULEMASK2;
    } else {
      modules_exist_maske = null;
      modules_exist_maske2 = null;
    }

    bg_height = modules_exist_maske == null ? 460 : 670;
    bg_width = 1000;

    if (valtable_obj.INPHASES != null)
      inphases = valtable_obj.INPHASES;
    else
      inphases = valtable_obj.PHASES;

    if (valtable_obj.OUTPHASES != null)
      outphases = valtable_obj.OUTPHASES;
    else
      outphases = valtable_obj.PHASES;

    if (valtable_obj.EX_BYP_NUMLINES != null && valtable_obj.EX_BYP_NUMLINES != -9999)
      bypphases = valtable_obj.EX_BYP_NUMLINES;
    else
      bypphases = inphases;

    if (valtable_obj.OUTPOWER != null) {
      if (outphases > 2) {
        if ((valtable_obj.OUTPOWER[0] > 100) || (valtable_obj.OUTPOWER[1] > 100) || (valtable_obj.OUTPOWER[2] > 100))
          overload = 1;
      } else {
        if (valtable_obj.OUTPOWER[0] > 100)
          overload = 1;
      }
    }
  }

  function create_panes() {
    utils_api.setTitle(valtable_obj._platform);
    create_bg(); //background
    create_input_pane(); //Input table
    create_output_pane(); //Outnput   panel
    create_battery_pane(); //Battery panel
    create_byp_pane(); //Bypass panel
    create_iby_ire_ssi_inv_rec_batt(); //create IBY, IRE, SSI, INVERTER, RECTIFIER and BATTERY pannes
    create_status_pane(); //UPS status
    create_model_panes();
    create_modules_panes();
    create_outpower_loadbars(); //outpower loadbars
    if (plattform !== "ups_view")
      create_rom_temp(); //rom temp
    create_footer_pane();
    create_sys_mod_status_panel();
  }

  function create_bg() {
    var fragment = document.createDocumentFragment(),
      img_div;
    css_obj = { position: 'absolute', top: y_pos, left: x_pos, width: bg_width + 2, height: bg_height + 2, border: 'solid 1px #808080' };
    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'bg_img_id', 'class': 'img-rounded', width: bg_width, height: 460, src: './image/centiel/centiel_bg.png' }).appendTo(img_div);
    fragment.appendChild(img_div[0]);
    document.body.appendChild(fragment);
  }

  function create_model_panes() {
    var model_div, a;
    css_obj = { position: 'absolute', top: y_pos, left: x_pos, align: 'center', width: bg_width + 2, 'z-index': 6 }; // 'background-color': '#3a87ad'
    attr_obj = { id: 'model_div_id', 'class': 'list-group' };
    model_div = panes_api.create_div(attr_obj, css_obj);
    a = $('<a/>', { 'class': 'list-group-item active', id: 'model_name_id' }).appendTo(model_div);
    set_model_name();
  }

  function create_input_pane() //Input table
  {
    var fragment = document.createDocumentFragment(),
      tr, table, tbody, thead, in_div;

    css_obj = { position: 'absolute', top: y_pos + 210, left: x_pos + 8, width: 216 };

    in_div = $('<div/>', { id: 'input_div_id' }).css(css_obj);
    table = $('<table />', { 'class': 'table table-condensed table-hover', 'id': 'inptable' }).appendTo(in_div); // table-hover
    table.css('display', 'none');
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);
    tr = $('<tr />').append($('<th />', { colspan: 4 }).append(i18n(lang_Input))).appendTo(thead);

    if (inphases == 1)
      table.css('margin-top', '22px');

    tr = $('<tr />', { 'id': 'inptrl1' }).append($('<td />').append("L1:")).appendTo(tbody);
    $('<td />', { id: 'input_volt1_id' }).appendTo(tr);
    $('<td />', { id: 'input_freq1_id' }).appendTo(tr);

    tr = $('<tr />', { 'id': 'inptrl2' }).append($('<td />').append("L2:")).appendTo(tbody);
    $('<td />', { id: 'input_volt2_id' }).appendTo(tr);

    tr = $('<tr />', { 'id': 'inptrl3' }).append($('<td />').append("L3:")).appendTo(tbody);
    $('<td />', { id: 'input_volt3_id' }).appendTo(tr);

    fragment.appendChild(in_div[0]);
    document.body.appendChild(fragment);
    set_input_values();
  }

  function set_input_values() {
    var input_val = get_ph_1_3_vals(valtable_obj.INVOLT, valtable_obj.INCURR, valtable_obj.INFREQ, inphases);

    if (ups_id == 0) {
      if (valtable_obj.RAWSTATEB & 0x4000000) // mixed system, dont show input values
      {
        $('#inptable').css('display', 'none');
        return true;
      }
      if (input_val.availables[0] == 0 && input_val.availables[1] == 0 && input_val.availables[2] == 0) {
        $('#inptable').css('display', 'none');
        return true;
      }
    }
    $('#inptable').css('display', 'block');

    if (input_val.availables[0] != 0) {
      $('#inptrl1').css('display', 'block');
      $('#input_volt1_id').text(input_val.val_objs[0].values[0]);
      $('#input_freq1_id').text(input_val.val_objs[2].values[0]);
    } else {
      $('#inptrl1').css('display', 'none');
    }

    if (input_val.availables[1] != 0) {
      if (valtable_obj.RAWSTATEB & 0x8) {
        if (ups_id > 0) {
          $('#inptrl2').css('display', 'none');
        }
      } else {
        $('#inptrl2').css('display', 'block');
        $('#input_volt2_id').text(input_val.val_objs[0].values[1]);
      }
    } else {
      $('#inptrl2').css('display', 'none');
    }

    if (input_val.availables[2] != 0) {
      if (valtable_obj.RAWSTATEB & 0x8) {
        if (ups_id > 0) {
          $('#inptrl3').css('display', 'none');
        }
      } else {
        $('#inptrl3').css('display', 'block');
        $('#input_volt3_id').text(input_val.val_objs[0].values[2]);
      }
    } else {
      $('#inptrl3').css('display', 'none');
    }
  }

  function create_output_pane() //Output
  {
    var output_div = null,
      tr, table, tbody, thead,
      fragment = document.createDocumentFragment();

    css_obj = { position: 'absolute', top: y_pos + 176, left: x_pos + 790, width: 216 };

    output_div = $('<div/>', { id: 'output_div_id' }).css(css_obj);
    table = $('<table />', { 'class': 'table table-condensed table-hover', 'id': 'outtable' }).appendTo(output_div);
    table.css('display', 'none');
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);
    tr = $('<tr />').append($('<th />', { colspan: 4 }).append(i18n(lang_Output))).appendTo(thead);

    if (outphases == 1)
      table.css('margin-top', '22px');

    tr = $('<tr />', { 'id': 'outtrl1' }).append($('<td />').append("L1:")).appendTo(tbody);
    $('<td />', { 'id': 'out_volt1_id' }).appendTo(tr);
    $('<td />', { id: 'out_cur1_id' }).appendTo(tr);
    $('<td />', { id: 'out_freq1_id' }).appendTo(tr);

    tr = $('<tr />', { 'id': 'outtrl2' }).append($('<td />').append("L2:")).appendTo(tbody);
    $('<td />', { id: 'out_volt2_id' }).appendTo(tr);
    $('<td />', { id: 'out_cur2_id' }).appendTo(tr);

    tr = $('<tr />', { 'id': 'outtrl3' }).append($('<td />').append("L3:")).appendTo(tbody);
    $('<td />', { id: 'out_volt3_id' }).appendTo(tr);
    $('<td />', { id: 'out_cur3_id' }).appendTo(tr);

    fragment.appendChild(output_div[0]);
    document.body.appendChild(fragment);
    set_output_values();
  }

  function set_output_values() //Output values
  {
    var output_val = get_ph_1_3_vals(valtable_obj.OUTPUT_VOLT, valtable_obj.EX_OUT_CURR, valtable_obj.OUTFREQ, outphases);

    if (ups_id == 0) {
      if (output_val.availables[0] == 0 && output_val.availables[1] == 0 && output_val.availables[2] == 0) {
        $('#outtable').css('display', 'none');
        return true;
      }
    }

    $('#outtable').css('display', 'block');
    if (output_val.availables[0] != 0) {
      $('#outtrl1').css('display', 'block');
      $('#out_volt1_id').text(output_val.val_objs[0].values[0]);
      $('#out_cur1_id').text(output_val.val_objs[1].values[0]);
      $('#out_freq1_id').text(output_val.val_objs[2].values[0]);
    } else {
      $('#outtrl1').css('display', 'none');
    }

    if (output_val.availables[1] != 0) {
      $('#outtrl2').css('display', 'block');
      $('#out_volt2_id').text(output_val.val_objs[0].values[1]);
      $('#out_cur2_id').text(output_val.val_objs[1].values[1]);
    } else {
      $('#outtrl2').css('display', 'none');
    }

    if (output_val.availables[2] != 0) {
      $('#outtrl3').css('display', 'block');
      $('#out_volt3_id').text(output_val.val_objs[0].values[2]);
      $('#out_cur3_id').text(output_val.val_objs[1].values[2]);
    } else {
      $('#outtrl3').css('display', 'none');
    }
  }

  function create_byp_pane() //Bypass
  {
    var byp_div, tr, table, tbody, thead,
      fragment = document.createDocumentFragment();

    css_obj = { position: 'absolute', top: y_pos + 100, left: x_pos + 8 };
    byp_div = $('<div/>', { id: 'bypass_div_id' }).css(css_obj);
    table = table = $('<table />', { 'class': 'table table-condensed table-hover', 'id': 'byptable' }).appendTo(byp_div);
    table.css('display', 'none');
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);
    tr = $('<tr />').append($('<th />', { colspan: 4 }).append(i18n(lang_Bypass))).appendTo(thead);

    if (bypphases == 1)
      table.css('margin-top', '50px');

    tr = $('<tr />', { 'id': 'byptrl1' }).append($('<td />').append("L1:")).appendTo(tbody);
    $('<td />', { 'id': 'byp_volt1_id' }).appendTo(tr);
    $('<td />', { id: 'byp_freq1_id' }).appendTo(tr);

    tr = $('<tr />', { 'id': 'byptrl2' }).append($('<td />').append("L2:")).appendTo(tbody);
    $('<td />', { id: 'byp_volt2_id' }).appendTo(tr);

    tr = $('<tr />', { 'id': 'byptrl3' }).append($('<td />').append("L3:")).appendTo(tbody);
    $('<td />', { id: 'byp_volt3_id' }).appendTo(tr);

    fragment.appendChild(byp_div[0]);
    document.body.appendChild(fragment);
    set_byp_values();
  }

  function set_byp_values() //Bypass values
  {
    var bypass_val = get_ph_1_3_vals(valtable_obj.EX_BYP_VOLT, valtable_obj.EX_BYP_CURR, valtable_obj.EX_BYP_FREQ, bypphases);

    if (ups_id == 0) {
      if (bypass_val.availables[0] == 0 && bypass_val.availables[1] == 0 && bypass_val.availables[2] == 0) {
        $('#byptable').css('display', 'none');
        return true;
      }
    }

    $('#byptable').css('display', 'block');
    if (bypass_val.availables[0] != 0) {
      $('#byptrl1').css('display', 'block');
      $('#byp_volt1_id').text(bypass_val.val_objs[0].values[0]);
      $('#byp_freq1_id').text(bypass_val.val_objs[2].values[0]);
    } else {
      $('#byptrl1').css('display', 'none');
    }

    if (bypass_val.availables[1] != 0) {
      $('#byptrl2').css('display', 'block');
      $('#byp_volt2_id').text(bypass_val.val_objs[0].values[1]);
    } else {
      $('#byptrl2').css('display', 'none');
    }

    if (bypass_val.availables[2] != 0) {
      $('#byptrl3').css('display', 'block');
      $('#byp_volt3_id').text(bypass_val.val_objs[0].values[2]);
    } else {
      $('#byptrl3').css('display', 'none');
    }
  }


  //Standardscreen erweitern: Wenn EX_BATT_VOLTPOS und EX_BATT_VOLTNEG vorhanden und ungleich UPS_VAL_NA (-9999) dann beide Werte anstatt BATTVOLT anzeigen.
  function create_battery_pane() //Battery panel
  {
    var val, tr, table, tbody, thead, batt_div,
      fragment = document.createDocumentFragment();

    css_obj = { position: 'absolute', top: y_pos + 306, left: x_pos + 210 }; //, width:130, height:100
    attr_obj = { id: 'battery_div_id' };
    batt_div = $('<div/>').attr(attr_obj).css(css_obj);
    table = table = $('<table />', { 'class': 'table table-condensed table-hover' }).appendTo(batt_div);
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);
    tr = $('<tr />').append($('<th />', { colspan: 2 }).append(i18n(lang_Battery))).appendTo(thead);

    if ((valtable_obj.EX_BATT_VOLTPOS != null && valtable_obj.EX_BATT_VOLTNEG != null) &&
      (valtable_obj.EX_BATT_VOLTPOS != -9999 && valtable_obj.EX_BATT_VOLTNEG != -9999)) {
      tr = $('<tr />').append($('<td />', { align: 'left' }).append('Pos.' + i18n(lang_Voltage) + ":")).appendTo(tbody);
      $('<td />', { id: 'batt_volt_pos_id', align: 'left' }).
      append(get_value({ values: [valtable_obj.EX_BATT_VOLTPOS], index: 0, unit: ' V', precision: 1 })).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append('Neg.' + i18n(lang_Voltage) + ":")).appendTo(tbody);
      $('<td />', { id: 'batt_volt_neg_id', align: 'left' }).
      append(get_value({ values: [valtable_obj.EX_BATT_VOLTNEG], index: 0, unit: ' V', precision: 1 })).appendTo(tr);
    } else {
      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n(lang_Voltage) + ":")).appendTo(tbody);
      $('<td />', { id: 'batt_volt_id', align: 'left' }).
      append(get_value({ values: [valtable_obj.BATTVOLT], index: 0, unit: ' V', precision: 0 })).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n(lang_Current) + ":")).appendTo(tbody);
      $('<td />', { id: 'batt_curr_id', align: 'left' }).
      append(get_value({ values: [valtable_obj.EX_BATT_CURRPOS], index: 0, unit: ' A', precision: 0 })).appendTo(tr);
    }

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Autonomy") + ":")).appendTo(tbody);
    $('<td />', { id: 'batt_autotime_id', align: 'left' }).
    append(get_value({ values: [valtable_obj.AUTONOMTIME], index: 0, unit: ' Min', precision: 0 })).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n(lang_Battery_Capacity_short) + ":")).appendTo(tbody);
    $('<td />', { id: 'batt_cap_id', align: 'left' }).
    append(get_value({ values: [valtable_obj.BATTCAP], index: 0, unit: ' %', precision: 0 })).appendTo(tr);

    if (valtable_obj.EX_BATT_SECONBATT != null) {
      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('On Battery') + ":")).appendTo(tbody);
      $('<td />', { id: 'batt_seconds_id', align: 'left' }).
      append(get_value({ values: [valtable_obj.EX_BATT_SECONBATT], index: 0, unit: ' Sec', precision: 0 })).appendTo(tr);
    }
    fragment.appendChild(batt_div[0]);
    document.body.appendChild(fragment);
  }

  function set_battery_value() //set Battery value
  {
    if ((valtable_obj.EX_BATT_VOLTPOS != null && valtable_obj.EX_BATT_VOLTNEG != null) &&
      (valtable_obj.EX_BATT_VOLTPOS != -9999 && valtable_obj.EX_BATT_VOLTNEG != -9999)) {
      $('#batt_volt_pos_id').text(get_value({ values: [valtable_obj.EX_BATT_VOLTPOS], index: 0, unit: ' V', precision: 1 }));
      $('#batt_volt_neg_id').text(get_value({ values: [valtable_obj.EX_BATT_VOLTNEG], index: 0, unit: ' V', precision: 1 }));
    } else {
      $('#batt_volt_id').text(get_value({ values: [valtable_obj.BATTVOLT], index: 0, unit: ' V', precision: 0 }));
      $('#batt_curr_id').text(get_value({ values: [valtable_obj.EX_BATT_CURRPOS], index: 0, unit: ' A', precision: 0 }));
    }

    $('#batt_autotime_id').text(get_value({ values: [valtable_obj.AUTONOMTIME], index: 0, unit: ' Min', precision: 0 }));
    $('#batt_cap_id').text(get_value({ values: [valtable_obj.BATTCAP], index: 0, unit: ' %', precision: 0 }));

    if (valtable_obj.EX_BATT_SECONBATT != null)
      $('#batt_seconds_id').text(get_value({ values: [valtable_obj.EX_BATT_SECONBATT], index: 0, unit: ' Sec', precision: 0 }));
  }

  function get_ph_1_3_vals(volt, cur, freq, phases) {
    var val_obj, val,
      l_1_3_vals = {
        availables: [0, 0, 0], //L1-L3
        val_objs: [
          { unit: ' V', precision: 0, values: ['', '', ''] },
          { unit: ' A', precision: 1, values: ['', '', ''] },
          { unit: ' Hz', precision: 1, values: ['', '', ''] }
        ]
      };
    volt = volt || [];
    cur = cur || [], freq = freq || [];
    $.each([volt, cur, freq], function (index, values) {
      val_obj = l_1_3_vals.val_objs[index];
      $.each(values, function (i, val) {
        if (i < phases) {
          val = values[i];
          if (val != -9999) {
            if (values === valtable_obj.INFREQ) {
              val = val / 10.0;
              if (valtable_obj.RAWSTATEB & (1 << 26)) // mixed system
              {
                if (valtable_obj.RAWSTATEB & 0x8) // 16,7 Hz module
                {
                  if (valtable_obj.RAWSTATEB & 0x1) // mains input ok
                  {
                    val = 16.7;
                  } else {
                    val = 0.0;
                  }
                }
              }
            }
            if (values === freq && (i == 1 || i == 2)) {} else
              l_1_3_vals.availables[i] = 1;

            val = val.toFixed(val_obj.precision);
            val += val_obj.unit;
            val_obj.values[i] = val;
          }
        }
      });
    });
    return l_1_3_vals;
  }

  function get_value(val_obj) {
    if (!val_obj.values || (val_obj.values.length <= val_obj.index))
      return 'N/A';
    var val = val_obj.values[val_obj.index];
    if (val == null || val_obj.values[val_obj.index] == -9999)
      return 'N/A';

    val = val.toFixed(val_obj.precision);
    val += val_obj.unit;
    return val;
  }

  function create_iby_ire_ssi_inv_rec_batt() //create IBY, IRE, SSI, INVERTER, RECTIFIER and BATTERY  pannes
  {
    var div, fragment = document.createDocumentFragment();
    css_obj = { position: 'absolute', top: y_pos + 234, left: x_pos + 724, width: 24, height: 10, overflow: 'hidden' };

    if (((valtable_obj.RAWSTATEB & 0x40) || (valtable_obj.RAWSTATEB & 0x200)) && (valtable_obj.RAWSTATEB & 0x10000))
      css_obj['background-color'] = 'rgb(40, 134, 59)'; //'#52B245';//green rgb(40, 134, 59)
    else
      css_obj['background-color'] = '#DC3632'; //red
    div = $('<div/>').attr({ id: 'iby_div_id', 'class': 'img-rounded' }).css(css_obj);
    fragment.appendChild(div[0]);

    css_obj = { position: 'absolute', top: y_pos + 234, left: x_pos + 220, width: 24, height: 10, overflow: 'hidden' };
    if (valtable_obj.RAWSTATEB & 0x1)
      css_obj['background-color'] = 'rgb(40, 134, 59)'; //#52B245';//green
    else
      css_obj['background-color'] = '#DC3632'; //red

    div = $('<div/>').attr({ id: 'ire_div_id', 'class': 'img-rounded' }).css(css_obj);
    fragment.appendChild(div[0]);


    css_obj = { position: 'absolute', top: y_pos + 155, left: x_pos + 220, width: 24, height: 10, overflow: 'hidden' };
    if (valtable_obj.RAWSTATEB & 0x10)
      css_obj['background-color'] = 'rgb(40, 134, 59)'; //#52B245';//green
    else
      css_obj['background-color'] = '#DC3632'; //red

    div = $('<div/>').attr({ id: 'bre_div_id', 'class': 'img-rounded' }).css(css_obj);
    fragment.appendChild(div[0]);

    document.body.appendChild(fragment);

    if (valtable_obj.RAWSTATEB & 0x20)
      panes_api.create_img_panel('ssi_img_id', './image/ups/sswgr.gif', x_pos + 410, y_pos + 130, 50, 50, 0);
    else
      panes_api.create_img_panel('ssi_img_id', './image/ups/sswr.gif', x_pos + 410, y_pos + 130, 50, 50, 0);

    if (valtable_obj.RAWSTATEB & 0x100) //Inverter
      panes_api.create_img_panel('inv_img_id', './image/ups/wrgr.gif', x_pos + 530, y_pos + 210, 50, 50, 0);
    else
      panes_api.create_img_panel('inv_img_id', './image/ups/wrr.gif', x_pos + 530, y_pos + 210, 50, 50, 0);

    if (valtable_obj.RAWSTATEB & 0x02) //RECTIFIER powerfail
      panes_api.create_img_panel('rec_img_id', './image/ups/grgr.gif', x_pos + 286, y_pos + 210, 50, 50, 0);
    else
      panes_api.create_img_panel('rec_img_id', './image/ups/grr.gif', x_pos + 286, y_pos + 210, 50, 50, 0);

    if ((valtable_obj.RAWSTATEB & 0x800) && (!(valtable_obj.RAWSTATEB & 0x4000))) //BATTERY
      panes_api.create_img_panel('batt_img_id', './image/ups/Batgrv.gif', x_pos + 410, y_pos + 294, 50, 50, 0);
    else if (valtable_obj.RAWSTATEB & 0x4000)
      panes_api.create_img_panel('batt_img_id', './image/ups/Batgev.gif', x_pos + 410, y_pos + 294, 50, 50, 0);
    else
      panes_api.create_img_panel('batt_img_id', './image/ups/Batrv.gif', x_pos + 410, y_pos + 294, 50, 50, 0);

    if (valtable_obj.RAWSTATEB & 0x40) //byp_direction
      panes_api.create_img_panel('byp_dir_img_id', './image/centiel/p_g.png', x_pos + 630, y_pos + 150, 16, 21, 0);
    else
      panes_api.create_img_panel('byp_dir_img_id', './image/centiel/p_n.png', x_pos + 630, y_pos + 150, 16, 21, 0);

    if (valtable_obj.RAWSTATEB & 0x200) //out_direction
      panes_api.create_img_panel('out_dir_img_id', './image/centiel/p_g.png', x_pos + 630, y_pos + 228, 16, 21, 0);
    else
      panes_api.create_img_panel('out_dir_img_id', './image/centiel/p_n.png', x_pos + 630, y_pos + 228, 16, 21, 0);

  }

  function set_iby_ire_ssi_inv_rec_batt() //SET IBY, IRE, SSI, INVERTER, RECTIFIER and BATTERY  pannes
  {
    if (((valtable_obj.RAWSTATEB & 0x40) || (valtable_obj.RAWSTATEB & 0x200)) && (valtable_obj.RAWSTATEB & 0x10000))
      $('#iby_div_id').css('background-color', 'rgb(40, 134, 59)'); //green
    else
      $('#iby_div_id').css('background-color', '#DC3632'); //red


    if (valtable_obj.RAWSTATEB & 0x1)
      $('#ire_div_id').css('background-color', 'rgb(40, 134, 59)'); //green
    else
      $('#ire_div_id').css('background-color', '#DC3632'); //red

    if (valtable_obj.RAWSTATEB & 0x10)
      $('#bre_div_id').css('background-color', 'rgb(40, 134, 59)'); //green
    else
      $('#bre_div_id').css('background-color', '#DC3632'); //red

    if (valtable_obj.RAWSTATEB & 0x20)
      $('#ssi_img_id').attr('src', './image/ups/sswgr.gif');
    else
      $('#ssi_img_id').attr('src', './image/ups/sswr.gif');


    if (valtable_obj.RAWSTATEB & 0x100) //Inverter
      $('#inv_img_id').attr('src', './image/ups/wrgr.gif');
    else
      $('#inv_img_id').attr('src', './image/ups/wrr.gif');

    if (valtable_obj.RAWSTATEB & 0x02) //RECTIFIER powerfail
      $('#rec_img_id').attr('src', './image/ups/grgr.gif');
    else
      $('#rec_img_id').attr('src', './image/ups/grr.gif');


    if ((valtable_obj.RAWSTATEB & 0x800) && (!(valtable_obj.RAWSTATEB & 0x4000))) //BATTERY
      $('#batt_img_id').attr('src', './image/ups/Batgrv.gif');
    else if (valtable_obj.RAWSTATEB & 0x4000)
      $('#batt_img_id').attr('src', './image/ups/Batgev.gif');
    else
      $('#batt_img_id').attr('src', './image/ups/Batrv.gif');


    if (valtable_obj.RAWSTATEB & 0x40) //byp_direction
      $('#byp_dir_img_id').attr('src', './image/centiel/p_g.png');
    else
      $('#byp_dir_img_id').attr('src', './image/centiel/p_n.png');


    if (valtable_obj.RAWSTATEB & 0x200) //byp_direction
      $('#out_dir_img_id').attr('src', './image/centiel/p_g.png');
    else
      $('#out_dir_img_id').attr('src', './image/centiel/p_n.png');

  }

  function create_status_pane() //UPS status
  {
    var status_div = $('<div/>'),
      status_span;
    css_obj = { position: 'absolute', top: y_pos + 44, left: x_pos + 20, align: 'center', overflow: 'hidden' };
    $(status_div).css(css_obj);
    status_span = $('<span />', { id: 'ups_status_id', 'class': get_status_class(), title: i18n('Click to see Status Text') }).append(i18n('Status'));
    status_span.css('cursor', 'pointer');
    status_span.click(function (event) //visibility: hidden
      {
        var sys_mod_status_txt_div = $('#sys_mod_status_txt_div'),
          display = sys_mod_status_txt_div.css('display') == 'none' ? 'block' : 'none';
        sys_mod_status_txt_div.css({ display: display });
      });

    $('<h4 />').append(status_span).appendTo(status_div);
    status_div.appendTo(document.body);
  }

  function set_ups_status() //set UPS status
  {
    $('#ups_status_id').attr('class', get_status_class());
  }

  function get_status_class() {
    var status = valtable_obj.STATUS;

    if (status & 0xF7BA)
      return 'label label-danger';

    if (status & 0x41)
      return 'label label-warning';

    if (valtable_obj.RAWSTATEB != null) {
      if (valtable_obj.RAWSTATEB & 0x18004000) {
        return 'label label-danger';
      }
    }

    if (valtable_obj.RAWSTATEA != null) {
      if (valtable_obj.RAWSTATEA & 0xFFFFFFF) {
        return 'label label-danger';
      }
    }

    return 'label label-success';
  }

  function create_outpower_loadbars() //outpower loadbars
  {
    var fragment = document.createDocumentFragment(),
      div;

    if (valtable_obj.OUTPOWER == null)
      return true;

    outpower_loadbars_created = true;

    panes_api.create_loadbar_pane({ value: valtable_obj.OUTPOWER[0], id: 'loadbar1_id', left: x_pos + 768, top: y_pos + 336, title: 'L1', scaler: 1 });
    if (outphases > 1)
      panes_api.create_loadbar_pane({ value: valtable_obj.OUTPOWER[1], id: 'loadbar2_id', left: x_pos + 768, top: y_pos + 366, title: 'L2', scaler: 0 });
    if (outphases > 2)
      panes_api.create_loadbar_pane({ value: valtable_obj.OUTPOWER[2], id: 'loadbar3_id', left: x_pos + 768, top: y_pos + 396, title: 'L3', scaler: 0 });

    css_obj = { position: 'absolute', top: y_pos + 310, left: x_pos + 540, width: 250, height: 120, 'background-color': $(document.body).css('background-color'), 'z-index': 20 };
    div = $('<div/>').attr({ id: 'loadbars' }).css(css_obj);
    fragment.appendChild(div[0]);

    document.body.appendChild(fragment);
    set_outpower_loadbars();
  }

  function set_outpower_loadbars() //outpower loadbars
  {
    if (valtable_obj.OUTPOWER == null)
      return true;
    if (valtable_obj.OUTPOWER[0] != -9999) {
      panes_api.set_loabar_value(valtable_obj.OUTPOWER[0], 'loadbar1_id');
    }
    if ((outphases > 1) && valtable_obj.OUTPOWER[1] != -9999) {
      panes_api.set_loabar_value(valtable_obj.OUTPOWER[1], 'loadbar2_id');
    }
    if ((outphases > 2) && valtable_obj.OUTPOWER[2] != -9999) {
      panes_api.set_loabar_value(valtable_obj.OUTPOWER[2], 'loadbar3_id');
    }

    if ((valtable_obj.OUTPOWER[0] != -9999) || (valtable_obj.OUTPOWER[1] != -9999) || (valtable_obj.OUTPOWER[2] != -9999)) {
      $('#loadbars').css('display', 'none');
    } else {
      $('#loadbars').css('display', 'block');
    }
  }

  function create_rom_temp() //rom temp
  {
    var fragment = document.createDocumentFragment(),
      rom_temp_div;
    css_obj = { position: 'absolute', top: y_pos + 306, left: x_pos + 8 };
    rom_temp_div = $('<div/>').attr({ id: 'rom_temp_div_id' }).css(css_obj);
    panes_api.create_rom_temp_pane(valtable_obj, { id: 'rom_temp_table_id', 'class': 'table table-condensed table-hover' }, 'Temperature').appendTo(rom_temp_div);
    fragment.appendChild(rom_temp_div[0]);
    document.body.appendChild(fragment);
  }

  function create_modules_panes() {
    var fragment = document.createDocumentFragment(),
      tr, tr, table, tbody, thead, button, modules_div, system_div,
      module_index, index_val, hassysvals = has_system_values(),
      stitle;

    var real_module_index = 0;

    if (modules_exist_maske == null) {
      return;
    }

    modules_div = $('#modules_div');
    if (modules_div.length != 0)
      modules_div.remove();

    css_obj = { position: 'absolute', top: y_pos + 480, left: x_pos + 8 }; //, width:300, height:26

    modules_div = $('<div/>', { id: 'modules_div' }).css(css_obj);
    table = $('<table />', { 'class': 'table table-condensed' }).appendTo(modules_div); // table-hover
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    if (hassysvals)
      stitle = i18n('System and Modules');
    else
      stitle = i18n('Modules');

    tr = $('<tr />').append($('<th />', { colspan: 32 }).append(stitle)).appendTo(thead);
    tr = $('<tr />', { id: 'tr_sys_id' }).appendTo(tbody);
    td = $('<td />', { 'align': 'left' }).append('System').appendTo(tr);
    td.css({ 'vertical-align': 'middle', width: 70 });
    if (!hassysvals)
      td.css('display', 'none');
    td = $('<td />', { 'align': 'left' }).appendTo(tr);

    if (hassysvals) {
      button = $('<button>', { id: 'module_sys', 'class': "btn btn-sm btn-default" }).append('S').appendTo(td);

      if (0 == ups_id) {
        button.css({ 'border': '2px outset black', 'box-shadow': '0 0 2px black' });
      }

      button.click(function (event) {
        ups_id = 0;
        ups_id_txt = '';
        get_module_values(0);
        event.preventDefault();
      });
      button.attr('class', get_sys_status_class());
    }

    tr = $('<tr />').appendTo(tbody);
    td = $('<td />', { 'align': 'left' }).append(i18n('Modules')).appendTo(tr);
    td.css({ 'vertical-align': 'middle', width: 70 });
    if (!hassysvals)
      td.css('display', 'none');

    for (module_index = 0; module_index < 60; ++module_index)
    {
      if (module_index >= 30)
      {
         index_val = 1 << (module_index - 30);
         if (!(modules_exist_maske2 & index_val))
           continue;
      }
      else
      {
         index_val = 1 << module_index;
         if (!(modules_exist_maske & index_val))
           continue;
      }

      td = $('<td />', { 'align': 'left' }).appendTo(tr);
      button = $('<button>', {
        id: '' + (++real_module_index),
        'class': get_module_status_class(module_index)
      }).append(module_index + 1).appendTo(td);

      if (real_module_index == 15)
      {
        tr = $('<tr />').appendTo(tbody);
        td = $('<td />', { 'align': 'left' }).append('').appendTo(tr);
        td.css({ 'vertical-align': 'middle', width: 70 });
      }
      else if (real_module_index == 30)
      {
        tr = $('<tr />').appendTo(tbody);
        td = $('<td />', { 'align': 'left' }).append('').appendTo(tr);
        td.css({ 'vertical-align': 'middle', width: 70 });
      }

      if (button.text() == ups_id_txt) {
        button.css({ 'border': '2px outset black', 'box-shadow': '0 0 2px black' });
      }

      button.click(function (event) {
        ups_id = parseInt($(this).attr('id'));
        ups_id_txt = $(this).text();
        get_module_values(ups_id);
        event.preventDefault();
      });
    }

    fragment.appendChild(modules_div[0]);
    document.body.appendChild(fragment);
  }

  function create_sys_mod_status_panel() {
    var fragment = document.createDocumentFragment(),
      tr, tr, table, tbody, a,
      title = "Status:" + valtable_obj.MODEL,
      status_txt_array = get_sys_mod_status_txt(),
      sys_mod_status_txt_div;

    css_obj = {
        position: 'absolute',
        top: y_pos + 72,
        left: x_pos + 78,
        align: 'center',
        'background-color': '#F1F1F1',
        display: 'none',
        border: 'solid 1px black'
      },

      sys_mod_status_txt_div = $('<div/>', { id: 'sys_mod_status_txt_div', 'class': 'img-rounded' }).css(css_obj);

    if (ups_id != 0)
      title += " [Module " + ups_id + "]";
    a = $('<a/>', { 'class': 'list-group-item active', id: 'status_model_name_id' }).append(title).appendTo(sys_mod_status_txt_div);
    a.css('height', 30);
    table = $('<table />', { 'class': 'table table-condensed', id: 'sys_mod_status_txt_table' }).appendTo(sys_mod_status_txt_div); // table-hover
    table.css({ 'background-color': '#F1F1F1' })
    tbody = $('<tbody />', { id: 'sys_mod_status_txt_table_body' }).appendTo(table);
    $.each(status_txt_array, function (index, status_txt) {
      tr = $('<tr />').appendTo(tbody);
      td = $('<td />', { 'align': 'left' }).append(i18n(status_txt)).appendTo(tr);
    });

    fragment.appendChild(sys_mod_status_txt_div[0]);
    document.body.appendChild(fragment);
    new utils_api.draggable('sys_mod_status_txt_div');
  }

  function set_sys_mod_status() {
    var tr, td,
      title = "Status:" + valtable_obj.MODEL,
      tbody = $('#sys_mod_status_txt_table_body'),
      status_txt_array = get_sys_mod_status_txt();

    if (ups_id != 0)
      title += " [Module " + ups_id_txt + "]";

    $('#status_model_name_id').text(title);

    tbody.empty();
    $.each(status_txt_array, function (index, status_txt) {
      tr = $('<tr />').appendTo(tbody);
      td = $('<td />', { 'align': 'left' }).append(i18n(status_txt)).appendTo(tr);
    });
  }

  function get_sys_mod_status_txt() {
    var status_txt_array = [];
    $.each(status_obj, function (index, status_obj) {
      if (status_obj.bit & valtable_obj.STATUS) {
        status_txt_array.push(status_obj.txt);
      }
    });

    if (valtable_obj.RAWSTATEB != null) {
      $.each(ext_status_obj, function (index, status_obj) {
        if (status_obj.bit & valtable_obj.RAWSTATEB) {
          status_txt_array.push(status_obj.txt);
        }
      });
    }
    if (valtable_obj.RAWSTATEA != null) {
      $.each(alarms_obj, function (index, status_obj) {
        if (status_obj.bit & valtable_obj.RAWSTATEA) {
          status_txt_array.push(status_obj.txt);
        }
      });
    }

    return status_txt_array;
  }

  function get_module_values(id) {
    if (plattform === utils_api.plattform_cs141) {
      if (ups_id == 0) {
        valtable_obj = ups_obj.valtable;
      } else {
        valtable_obj = ups_obj.modules[ups_id - 1] || ups_obj.valtable;
        valtable_obj.MODEL = ups_obj.valtable.MODEL;
      }
      return set_values();
    }

    jqmodule.unsubscribe(cb);
    req_params.refresh_tm = 0;

    if (plattform === utils_api.plattform_unms) {
      req_params.url = get_url("script/nmsView.dll?upsid&refoid=" + oid + "&ups_id=" + ups_id);
    } else {
      req_params.url = get_url("data.cgi"),
        req_params.data = { json: "ups", ups_id: ups_id };
    }

    cb = jqmodule.subscribe(this, { update: update, error: err_funct }, req_params);
  }

  function get_cs141_module_values(id) {
    var cs141_cmd_option = {
        data: {},
        data_type: 'text',
        success: cs141_cmd_update,
        error: err_funct
      },

      cs141_cmd_settings = { methode: "POST", xhttp_methode_override: 'PUT', req_payload_json: true },
      ctl_url = get_url("api/devices/ups/control");

    cs141_cmd_option.data = { code: 'actUpsId', params: { upsId: id } };
    jqmodule.ajax(ctl_url, cs141_cmd_option, cs141_cmd_settings);
  }

  function cs141_cmd_update() {
    if (err_div)
      err_div.css('display', 'none');
    cb = jqmodule.subscribe(this, { update: update, error: err_funct }, req_params);
  }

  function get_module_status_class(module_bit)
  {
    var bit_val = 0;

    if (module_bit >= 30)
    {
      bit_val = 1 << (module_bit - 30);
      if (ups_obj.valtable.RAWSTATEH & bit_val)
         return "btn btn-sm btn-danger";
      else if (ups_obj.valtable.RAWSTATEG & bit_val)
         return "btn btn-sm btn-warning";
    }
    else
    {
      bit_val = 1 << module_bit;
      if (ups_obj.valtable.RAWSTATEF & bit_val)
         return "btn btn-sm btn-danger";
      else if (ups_obj.valtable.RAWSTATEE & bit_val)
         return "btn btn-sm btn-warning";
    }
    return "btn btn-sm btn-default";
  }

  function get_sys_status_class() {
    var bit_val = 1 << 30;
    if ((ups_obj.valtable.RAWSTATEF & bit_val) || (ups_obj.valtable.RAWSTATEH != null && (ups_obj.valtable.RAWSTATEH & bit_val)))
      return "btn btn-sm btn-danger";
    else if ((ups_obj.valtable.RAWSTATEE & bit_val) || (ups_obj.valtable.RAWSTATEG != null && (ups_obj.valtable.RAWSTATEG & bit_val)))
      return "btn btn-sm btn-warning";

    return "btn btn-sm btn-default";
  }

  function set_model_name() {
    var model_name = valtable_obj.MODEL;
    if (ups_id != 0) {
      model_name += " [Module " + ups_id_txt + "]";
      if (valtable_obj.RAWSTATEB & (1 << 26)) // mixed system
      {
        if (valtable_obj.RAWSTATEB & 0x8) // 16,7 Hz module
        {
          model_name += " 16,7 Hz";
        } else {
          model_name += " 50 Hz";
        }
      }
    }
    $('#model_name_id').html(model_name);
  }
}(jQuery));