<?xml version="1.0"?>
<!--
   cetduo_panel.xsl - UPS screen for CET 2.
   Copyright (c) 2010, Generex GmbH. All rights reserved.
   Said Raqui
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!-- Methods -->
  <!--Header-->
  <xsl:template name="cetduo_panel-header">
    <xsl:call-template name="app-header">
      <xsl:with-param name="top" select="13"/>
      <xsl:with-param name="left" select="36"/>
    </xsl:call-template>
  </xsl:template>

  <!--Footer-->
  <xsl:template name="cetduo_panel-footer" >
    <xsl:call-template name="app-footer" >
      <xsl:with-param name="top" select="640"/>
      <xsl:with-param name="left" select="10"/>
      <xsl:with-param name="width" select="802"/>
      <xsl:with-param name="height" select="62"/>
    </xsl:call-template>
  </xsl:template>
  <!--Menu-->
  <xsl:template name="cetduo_panel-menu">
    <xsl:call-template name="app-menu">
      <xsl:with-param name="top" select="428"/>
      <xsl:with-param name="left" select="0"/>
      <xsl:with-param name="width" select="0"/>
      <xsl:with-param name="height" select="0"/>
      <xsl:with-param name="class" select="'XBold_black'"/>
    </xsl:call-template>
  </xsl:template>

  <!--Body-->
  <xsl:template name="cetduo_panel-body">
    <xsl:call-template name="background">
      <xsl:with-param name="imagepath" select="'./lib/ups/image/ce_t/agil.png'"/>
      <xsl:with-param name="x" select="'10'"/>
      <xsl:with-param name="y" select="'10'"/>
      <xsl:with-param name="w" select="'798'"/>
      <xsl:with-param name="h" select="'598'"/>
      <xsl:with-param name="border" select="0"/>
      <xsl:with-param name="id" select="'background'"/>
    </xsl:call-template>

    <xsl:apply-templates />
    <xsl:call-template name="js_refresh_call">
      <xsl:with-param	 name="timeout" select="1000*//report/@refresh"/>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="values">
    <!-- Implementation -->
    <!-- Alarm comm lost -->
    <xsl:variable name="alarm_com_lost">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='ALARM']/@val)=0">
          <xsl:value-of select="0"/>
        </xsl:when>
        <xsl:when test="(value[@name='ALARM']/@val mod ($bit19 * 2)) - (value[@name='ALARM']/@val mod $bit19)">
          <xsl:value-of select="'1'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'0'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!-- Site and location pane-->
    <xsl:call-template name="site-location-pane">
      <xsl:with-param name="site_name" select="value[@name='SYS_NAME']/@val" />
    </xsl:call-template>

    <!-- output power level and battery autonomy pane-->
    <xsl:if test="$alarm_com_lost=0">
      <xsl:call-template name="output-power-level-batt-autonomy-pane">
        <xsl:with-param name="ac_out_available_pow" select="value[@name='CET2_ACOUTAVAILP']" />
        <xsl:with-param name="ac_out_batt_autonomy" select="value[@name='CET2_DCINPAUTONOMY']" />
        <xsl:with-param name="ac_out_conf" select="value[@name='CET2_ACOUTCONF']/@val" />
        <xsl:with-param name="dc_batt_conf" select="value[@name='CET2_DCBATTCONF']/@val" />
      </xsl:call-template>
    </xsl:if>

    <!-- Alarm and in/out text pane-->
    <xsl:if test="$alarm_com_lost=0">
      <xsl:call-template name="alarm-in-out-txt-pane">
        <xsl:with-param name="major_alarm" select="value[@name='CET2_LEDMAJORALR']/@val" />
        <xsl:with-param name="minor_alarm" select="value[@name='CET2_LEDMINORALR']/@val" />
        <xsl:with-param name="in_outputs" select="value[@name='CET2_LEDINOUT']/@val" />
        <xsl:with-param name="major_alarm_num" select="value[@name='CET2_MAJORALR']/@val" />
        <xsl:with-param name="minor_alarm_num" select="value[@name='CET2_MINORALR']/@val" />
        <xsl:with-param name="serial_nr" select="value[@name='CET2_SERIAL']/@val" />
        <xsl:with-param name="soft_nr" select="value[@name='CET2_SOFTMAIN']/@val" />
        <xsl:with-param name="softsub_nr" select="value[@name='CET2_SOFTSUB']/@val" />
      </xsl:call-template>
    </xsl:if>
    <!-- Comercial network's LED-->
    <xsl:call-template name="cet-led-pane">
      <xsl:with-param name="x" select="94" />
      <xsl:with-param name="y" select="264" />
      <xsl:with-param name="alarm_val" select="value[@name='CET2_LEDCOMNET']/@val"/>
      <xsl:with-param name="id" select="'comercial_led_div'"/>
      <xsl:with-param name="alarm_com_lost" select="$alarm_com_lost"/>
    </xsl:call-template>
    <!-- Central Blok's ACIn LED-->
    <xsl:call-template name="cet-led-pane">
      <xsl:with-param name="x" select="324" />
      <xsl:with-param name="y" select="240" />
      <xsl:with-param name="alarm_val" select="value[@name='CET2_LEDACINP']/@val" />
      <xsl:with-param name="id" select="'central_blok_ac_in_led_div'" />
      <xsl:with-param name="alarm_com_lost" select="$alarm_com_lost"/>
    </xsl:call-template>
    <!-- Central Blok's ACOut LED-->
    <xsl:call-template name="cet-led-pane">
      <xsl:with-param name="x" select="482" />
      <xsl:with-param name="y" select="240" />
      <xsl:with-param name="alarm_val" select="value[@name='CET2_LEDACOUT']/@val" />
      <xsl:with-param name="id" select="'central_blok_ac_out_led_div'" />
      <xsl:with-param name="alarm_com_lost" select="$alarm_com_lost"/>
    </xsl:call-template>
    <!-- Central Blok's DC LED-->
    <xsl:call-template name="cet-led-pane">
      <xsl:with-param name="x" select="324" />
      <xsl:with-param name="y" select="352" />
      <xsl:with-param name="alarm_val" select="value[@name='CET2_LEDDC']/@val" />
      <xsl:with-param name="id" select="'central_blok_dc_led_div'" />
      <xsl:with-param name="alarm_com_lost" select="$alarm_com_lost"/>
    </xsl:call-template>
    <!-- Central Blok's COM LED-->
    <xsl:call-template name="cet-led-pane">
      <xsl:with-param name="x" select="482" />
      <xsl:with-param name="y" select="352" />
      <xsl:with-param name="alarm_val" select="value[@name='CET2_LEDCOM']/@val" />
      <xsl:with-param name="id" select="'central_blok_com_led_div'" />
      <xsl:with-param name="alarm_com_lost" select="$alarm_com_lost"/>
    </xsl:call-template>
    <!-- Output network's LED-->
    <xsl:call-template name="cet-led-pane">
      <xsl:with-param name="x" select="580" />
      <xsl:with-param name="y" select="266" />
      <xsl:with-param name="alarm_val" select="value[@name='CET2_LEDOUTNET']/@val" />
      <xsl:with-param name="id" select="'output_network_led_div'" />
      <xsl:with-param name="alarm_com_lost" select="$alarm_com_lost"/>
    </xsl:call-template>
    <!-- Battery LED-->
    <xsl:call-template name="cet-led-pane">
      <xsl:with-param name="x" select="340" />
      <xsl:with-param name="y" select="474" />
      <xsl:with-param name="alarm_val" select="value[@name='CET2_LEDBATT']/@val" />
      <xsl:with-param name="id" select="'battery_led_div'" />
      <xsl:with-param name="alarm_com_lost" select="$alarm_com_lost"/>
    </xsl:call-template>
    <!-- Comercial network's A arrow direction-->
    <xsl:call-template name="cet-arrow-pane">
      <xsl:with-param name="x" select="258" />
      <xsl:with-param name="y" select="272" />
      <xsl:with-param name="arrow_val" select="value[@name='CET2_ARROWCOMNETA']/@val" />
      <xsl:with-param name="direct" select="'hor_l'" />
      <xsl:with-param name="id" select="'comercial_networks_a_arrow_direction_div'" />
      <xsl:with-param name="alarm_com_lost" select="$alarm_com_lost"/>
    </xsl:call-template>
    <!-- Comercial network's B arrow direction-->
    <xsl:call-template name="cet-arrow-pane">
      <xsl:with-param name="x" select="258" />
      <xsl:with-param name="y" select="314" />
      <xsl:with-param name="arrow_val" select="value[@name='CET2_ARROWCOMNETB']/@val" />
      <xsl:with-param name="direct" select="'hor_l'" />
      <xsl:with-param name="id" select="'comercial_networks_b_arrow_direction_div'" />
      <xsl:with-param name="alarm_com_lost" select="$alarm_com_lost"/>
    </xsl:call-template>
    <!-- Output network's arrow direction-->
    <xsl:call-template name="cet-arrow-pane">
      <xsl:with-param name="x" select="516" />
      <xsl:with-param name="y" select="272" />
      <xsl:with-param name="arrow_val" select="value[@name='CET2_ARROWOUTNET']/@val" />
      <xsl:with-param name="direct" select="'hor_r'" />
      <xsl:with-param name="id" select="'output_networks_arrow_direction_div'" />
      <xsl:with-param name="alarm_com_lost" select="$alarm_com_lost"/>
    </xsl:call-template>
    <!-- Battery network's A arrow direction-->
    <xsl:call-template name="cet-arrow-pane">
      <xsl:with-param name="x" select="372" />
      <xsl:with-param name="y" select="404" />
      <xsl:with-param name="arrow_val" select="value[@name='CET2_ARROWBATTA']/@val" />
      <xsl:with-param name="direct" select="'vert'" />
      <xsl:with-param name="id" select="'batt_networks_a_arrow_direction_div'" />
      <xsl:with-param name="alarm_com_lost" select="$alarm_com_lost"/>
    </xsl:call-template>
    <!-- Battery network's B arrow direction-->
    <xsl:call-template name="cet-arrow-pane">
      <xsl:with-param name="x" select="416" />
      <xsl:with-param name="y" select="404" />
      <xsl:with-param name="arrow_val" select="value[@name='CET2_ARROWBATTB']/@val" />
      <xsl:with-param name="direct" select="'vert'" />
      <xsl:with-param name="id" select="'batt_networks_b_arrow_direction_div'" />
      <xsl:with-param name="alarm_com_lost" select="$alarm_com_lost"/>
    </xsl:call-template>

    <!-- CET Status of the MBP-->
    <xsl:call-template name="cet-mbp-pane">
      <xsl:with-param name="mbp_val" select="value[@name='CET2_MBPPOS']/@val" />
      <xsl:with-param name="alarm_com_lost" select="$alarm_com_lost"/>
    </xsl:call-template>

    <!-- CET digital inputs pane-->
    <xsl:if test="$alarm_com_lost=0">
      <xsl:call-template name="digital-inputs-pane">
        <xsl:with-param name="tsio_com_err" select="value[@name='CET2_T3SCOMERR']/@val" />
        <xsl:with-param name="t3s_state" select="value[@name='CET2_T3SSTATE']/@val" />
        <xsl:with-param name="tsio_state" select="value[@name='CET2_TSIOSTATE']" />
        <xsl:with-param name="num_tsio" select="value[@name='CET2_NUMTSIO']/@val" />
      </xsl:call-template>
    </xsl:if>

    <!-- CET digital outputs pane-->
    <xsl:if test="$alarm_com_lost=0">
      <xsl:call-template name="digital-outputs-pane">
        <xsl:with-param name="tsio_com_err" select="value[@name='CET2_T3SCOMERR']/@val" />
        <xsl:with-param name="t3s_state" select="value[@name='CET2_T3SSTATE']/@val" />
        <xsl:with-param name="tsio_state" select="value[@name='CET2_TSIOSTATE']" />
        <xsl:with-param name="num_tsio" select="value[@name='CET2_NUMTSIO']/@val" />
      </xsl:call-template>
    </xsl:if>

    <!-- Commercial network  button-->
    <xsl:if test="$alarm_com_lost=0">
      <xsl:call-template name="commercial-network-button">
      </xsl:call-template>
    </xsl:if>
    <!-- commercial-network-pane-->
    <xsl:if test="$alarm_com_lost=0">
      <xsl:call-template name="commercial-network-pane">
        <xsl:with-param name="ac_input_conf" select="value[@name='CET2_ACINPCONF']/@val" />
        <xsl:with-param name="ac_input_watt" select="value[@name='CET2_ACINPWATT']" />
        <xsl:with-param name="ac_input_volt" select="value[@name='CET2_ACINPVOLT']" />
        <xsl:with-param name="ac_input_curr" select="value[@name='CET2_ACINPCURR']" />
        <xsl:with-param name="ac_input_freq" select="value[@name='CET2_ACINPFREQ']" />
      </xsl:call-template>
    </xsl:if>

    <!-- Battery  button-->
    <xsl:if test="$alarm_com_lost=0">
      <xsl:call-template name="battery-button">
      </xsl:call-template>
    </xsl:if>
    <!-- CET Battery pane-->
    <xsl:if test="$alarm_com_lost=0">
      <xsl:call-template name="battery-pane">
        <xsl:with-param name="dc_batt_conf" select="value[@name='CET2_DCBATTCONF']/@val" />
        <xsl:with-param name="dc_in_pow" select="value[@name='CET2_DCINPWATT']" />
        <xsl:with-param name="dc_in_volt" select="value[@name='CET2_DCINPVOLT']" />
        <xsl:with-param name="dc_in_curr" select="value[@name='CET2_DCINPCURR']" />
        <xsl:with-param name="dc_in_temp" select="value[@name='CET2_DCINPTEMP']" />
        <xsl:with-param name="dc_in_cap" select="value[@name='CET2_DCINPCAP']" />
        <xsl:with-param name="dc_out_mod" select="value[@name='CET2_DCOUTMODE']" />
      </xsl:call-template>
    </xsl:if>

    <!-- Load  button-->
    <xsl:if test="$alarm_com_lost=0">
      <xsl:call-template name="load-button">
      </xsl:call-template>
    </xsl:if>
    <!-- CET Load pane-->
    <xsl:if test="$alarm_com_lost=0">
      <xsl:call-template name="load-pane">
        <xsl:with-param name="ac_out_conf" select="value[@name='CET2_ACOUTCONF']/@val" />
        <xsl:with-param name="ac_out_volt" select="value[@name='CET2_ACOUTVOLT']" />
        <xsl:with-param name="ac_out_pow" select="value[@name='CET2_ACOUTWATT']" />
        <xsl:with-param name="ac_out_curr" select="value[@name='CET2_ACOUTCURR']" />
        <xsl:with-param name="ac_out_freq" select="value[@name='CET2_ACOUTFREQ']" />
        <xsl:with-param name="ac_out_pf" select="value[@name='CET2_ACOUTPF']" />
      </xsl:call-template>
    </xsl:if>

    <!-- Modules  button-->
    <xsl:if test="$alarm_com_lost=0">
      <xsl:call-template name="modules-button">
      </xsl:call-template>
    </xsl:if>
    <!-- CET Modules pane-->
    <xsl:if test="$alarm_com_lost=0">
      <xsl:call-template name="modules-pane">
        <xsl:with-param name="mod_present" select="value[@name='CET2_MODPRESENT']/@val" />
        <xsl:with-param name="serial_nm" select="value[@name='CET2_MODINFSERIAL']" />
        <xsl:with-param name="modinfo_gr_ac_ina" select="value[@name='CET2_MODINFGRACINPA']" />
        <xsl:with-param name="modinfo_gr_ac_inb" select="value[@name='CET2_MODINFGRACINPB']" />
        <xsl:with-param name="modinfo_gr_ac_inc" select="value[@name='CET2_MODINFGRACINPC']" />
        <xsl:with-param name="modinfo_gr_ac_outa" select="value[@name='CET2_MODINFGRACOUTA']" />
        <xsl:with-param name="modinfo_gr_ac_outb" select="value[@name='CET2_MODINFGRACOUTB']" />
        <xsl:with-param name="modinfo_gr_ac_outc" select="value[@name='CET2_MODINFGRACOUTC']" />
        <xsl:with-param name="modinfo_pow_ac_ina" select="value[@name='CET2_MODPWRACINPWA']" />
        <xsl:with-param name="modinfo_pow_ac_inb" select="value[@name='CET2_MODPWRACINPWB']" />
        <xsl:with-param name="modinfo_pow_ac_inc" select="value[@name='CET2_MODPWRACINPWC']" />
        <xsl:with-param name="modinfo_pow_ac_outa" select="value[@name='CET2_MODPWRACOUTWA']" />
        <xsl:with-param name="modinfo_pow_ac_outb" select="value[@name='CET2_MODPWRACOUTWB']" />
        <xsl:with-param name="modinfo_pow_ac_outc" select="value[@name='CET2_MODPWRACOUTWC']" />
        <xsl:with-param name="modinfo_pow_va_ac_outa" select="value[@name='CET2_MODPWRACOUTVAA']" />
        <xsl:with-param name="modinfo_pow_va_ac_outb" select="value[@name='CET2_MODPWRACOUTVAB']" />
        <xsl:with-param name="modinfo_pow_va_ac_outc" select="value[@name='CET2_MODPWRACOUTVAC']" />
        <xsl:with-param name="mod_power_dc" select="value[@name='CET2_MODPWRDC']" />
        <xsl:with-param name="mod_power_temp" select="value[@name='CET2_MODPWRTEMP']" />
        <xsl:with-param name="mod_status" select="value[@name='CET2_MODSTATUSMOD']" />
        <xsl:with-param name="modinfo_gr_dc" select="value[@name='CET2_MODINFGRDC']" />
      </xsl:call-template>
    </xsl:if>

    <xsl:call-template name="alarm-comm-lost-pane">
      <xsl:with-param name="alarm_com_lost" select="$alarm_com_lost"/>
    </xsl:call-template>

  </xsl:template>
  <!-- EOS -->
</xsl:stylesheet>
