<?xml version="1.0"?>
<!--
   dcups_panel.xsl - UPS screen for AEG.
   Copyright (c) 2010, Generex GmbH. All rights reserved.
   Said Raqui
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!-- Methods -->
  <!--Header-->
  <xsl:template name="dcups_panel-header">
    <xsl:call-template name="app-header">
      <xsl:with-param name="top" select="13"/>
      <xsl:with-param name="left" select="36"/>
    </xsl:call-template>
  </xsl:template>

  <!--Footer-->
  <xsl:template name="dcups_panel-footer" >
    <xsl:call-template name="app-footer" >
      <xsl:with-param name="top" select="510"/>
      <xsl:with-param name="left" select="20"/>
      <xsl:with-param name="width" select="752"/>
      <xsl:with-param name="height" select="70"/>
    </xsl:call-template>
  </xsl:template>
  <!--Menu-->
  <xsl:template name="dcups_panel-menu">
    <xsl:call-template name="app-menu">
      <xsl:with-param name="top" select="428"/>
      <xsl:with-param name="left" select="0"/>
      <xsl:with-param name="width" select="0"/>
      <xsl:with-param name="height" select="0"/>
      <xsl:with-param name="class" select="'XBold_black'"/>
    </xsl:call-template>
  </xsl:template>


  <!--Body-->
  <xsl:template name="dcups_panel-body">
    <div id ="master" style="position:absolute;top:10px;left:10px;">
      <xsl:call-template name="background">
        <xsl:with-param name="imagepath" select="'./lib/ups/image/aeg/backab1.png'"/>
        <xsl:with-param name="x" select="'0'"/>
        <xsl:with-param name="y" select="'0'"/>
        <xsl:with-param name="w" select="'785'"/>
        <xsl:with-param name="h" select="'488'"/>
        <xsl:with-param name="border" select="0"/>
        <xsl:with-param name="id" select="'background'"/>
      </xsl:call-template>

      <xsl:apply-templates />
      <xsl:call-template name="IEpixelBugfixCall"/>
      <script type="text/javascript">
        init();
      </script>
      <xsl:call-template name="js_refresh_call">
        <xsl:with-param	 name="timeout" select="1000*//report/@refresh"/>
      </xsl:call-template>
    </div>
  </xsl:template>

  <xsl:template match="values">
    <!-- Implementation -->
    <!-- UPS Events Text -->
    <div style="color:black; font-weight:bold; font-size:9pt">
      <xsl:call-template name="paneText">
        <xsl:with-param name="x" select="420" />
        <xsl:with-param name="y" select="11" />
        <xsl:with-param name="w" select="200" />
        <xsl:with-param name="h" select="17" />
        <xsl:with-param name="align" select="'left'" />
        <xsl:with-param name="color" select="'white'" />
        <xsl:with-param name="value" select="$lang-UPS-Events" />
      </xsl:call-template>
    </div>

    <!-- Model -->
    <xsl:variable name="model">
      <xsl:choose>
        <xsl:when test="string-length(//upsview)&gt;0">
          <xsl:value-of select="value[@name='MODEL']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="' '"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <div style="color:black; font-weight:bold; font-size:9pt">
      <xsl:if test="string-length($model) !=0">
        <xsl:call-template name="paneText">
          <xsl:with-param name="x" select="16" />
          <xsl:with-param name="y" select="10" />
          <xsl:with-param name="w" select="200" />
          <xsl:with-param name="h" select="17" />
          <xsl:with-param name="align" select="'left'" />
          <xsl:with-param name="color" select="'white'" />
          <xsl:with-param name="value" select="concat('Identification&#160;&#160;',$model)" />
        </xsl:call-template>
      </xsl:if>
    </div>

    <!-- DC Power Supply State Text -->
    <div style="color:black; font-weight:bold; font-size:9pt">
      <xsl:call-template name="paneText">
        <xsl:with-param name="x" select="440" />
        <xsl:with-param name="y" select="148" />
        <xsl:with-param name="w" select="240" />
        <xsl:with-param name="h" select="17" />
        <xsl:with-param name="align" select="'left'" />
        <xsl:with-param name="color" select="'#3F5987'" />
        <xsl:with-param name="value" select="$lang-DC-Power-Supply-State" />
      </xsl:call-template>
    </div>
    <!-- Log events pane -->
    <xsl:call-template name="events-pane">
      <xsl:with-param name="x" select="240" />
      <xsl:with-param name="y" select="26" />
      <xsl:with-param name="w" select="523" />
      <xsl:with-param name="h" select="89" />
    </xsl:call-template>

    <!-- Identification text -->
    <div id="ident_id" class="XMedium_black" style="position:absolute; left:300px; top:168px;text-align:left;text-decoration: underline;">
      <xsl:value-of select="$lang-Identification"/>
    </div>
    <!-- Identification pane -->
    <xsl:call-template name="Identification-pane">
      <xsl:with-param name="x" select="300" />
      <xsl:with-param name="y" select="190" />
      <xsl:with-param name="ups_typ" select="value[@name='DEVICEID']/@val" />
      <xsl:with-param name="firmware" select="value[@name='FIRMWARE']/@val" />
      <xsl:with-param name="has_location" select="'0'" />
    </xsl:call-template>

    <!-- DC-power supply values -->
    <xsl:call-template name="dc-power-supply-values">
      <xsl:with-param name="date_time" select="//report/@time" />
      <xsl:with-param name="state" select="value[@name='STATUS']/@val" />
      <xsl:with-param name="input_volt" select="value[@name='INVOLT']" />
      <xsl:with-param name="frequency" select="value[@name='INFREQ']/@val" />
      <xsl:with-param name="batt_volt" select="value[@name='BATTVOLT']/@val" />
      <xsl:with-param name="batt_curr" select="value[@name='SOLABATTC']/@val" />
      <xsl:with-param name="out_curr" 			select="value[@name='OUTPUT_CUR']/@val"/>
      <xsl:with-param name="out_volt" select="value[@name='OUTPUT_VOLT']/@val" />
      <xsl:with-param name="out_power" select="value[@name='OUTPUT_POW']/@val" />
    </xsl:call-template>

    <!--Line 1 variable -->
    <xsl:variable name="line1_cond1">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="value[@name='FKTSTATUS']/@val"/>
        <xsl:with-param name="bit" select="$bit5"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="line1_color">
      <xsl:choose>
        <xsl:when test="$line1_cond1=1">
          <xsl:value-of select="'#BEBEBE'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'#5A5A5A'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!--Line 2 variable -->
    <xsl:variable name="line2_cond1_1">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="value[@name='FKTSTATUS']/@val"/>
        <xsl:with-param name="bit" select="$bit1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="line2_cond1_2">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="value[@name='FKTSTATUS']/@val"/>
        <xsl:with-param name="bit" select="$bit12"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="line2_color">
      <xsl:choose>
        <xsl:when test="$line2_cond1_1=1 and $line2_cond1_2=1">
          <xsl:value-of select="'#BEBEBE'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'#5A5A5A'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!--Line 3 variable -->
    <xsl:variable name="line3_cond1">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="value[@name='FKTSTATUS']/@val"/>
        <xsl:with-param name="bit" select="$bit3"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="line3_color">
      <xsl:choose>
        <xsl:when test="$line3_cond1=1 ">
          <xsl:value-of select="'#BEBEBE'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'#5A5A5A'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!--Line 4 variable -->
    <xsl:variable name="line4_cond1_1">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="value[@name='FKTSTATUS']/@val"/>
        <xsl:with-param name="bit" select="$bit3"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="line4_cond1_2">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="value[@name='FKTSTATUS']/@val"/>
        <xsl:with-param name="bit" select="$bit1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="line4_color">
      <xsl:choose>
        <xsl:when test="$line4_cond1_1=1 and $line4_cond1_2=1">
          <xsl:value-of select="'#BEBEBE'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'#5A5A5A'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!-- Battery Voltage -->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="value[@name='BATTVOLT']/@val"/>
      <xsl:with-param name="headline" select="$lang-Battery-Voltage"/>
      <xsl:with-param name="font-size" select="11"/>
      <xsl:with-param name="unit" select="'V'"/>
      <xsl:with-param name="x" select="600"/>
      <xsl:with-param name="y" select="180"/>
      <xsl:with-param name="h" select="80"/>
      <xsl:with-param name="barx" select="'49'"/>
      <xsl:with-param name="bary" select="70"/>
      <xsl:with-param name="barw" select="50"/>
      <xsl:with-param name="suby" select="240"/>
      <xsl:with-param name="startval" select="'30'"/>
      <xsl:with-param name="endval" select="'60'"/>
      <xsl:with-param name="decimal-places" select="1"/>
      <xsl:with-param name="step" select="'5'"/>
      <xsl:with-param name="skip" select="5"/>
      <xsl:with-param name="id" select="'page0'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-hi" select="''"/>
      <xsl:with-param name="thresh-yellow-hi" select="''"/>
      <xsl:with-param name="start-visibility" select="'visible'"/>
      <xsl:with-param name="bright" select="0"/>
      <xsl:with-param name="scaler_id" select="'batt_volt_scaler_id'"/>
    </xsl:call-template>

    <!-- DC-power supply panel -->
    <xsl:call-template name="dc-power-supply-pane">
      <xsl:with-param name="fkt_status" select="value[@name='FKTSTATUS']/@val" />
      <xsl:with-param name="comlost" select="value[@name='EU_COMMLOST']/@val" />
      <xsl:with-param name="line1_color" select="$line1_color" />
      <xsl:with-param name="line2_color" select="$line2_color" />
      <xsl:with-param name="line3_color" select="$line3_color" />
      <xsl:with-param name="line4_color" select="$line4_color" />
    </xsl:call-template>



  </xsl:template>

  <!-- EOS -->
</xsl:stylesheet>