<?xml version="1.0"?>
<!--
   ep_panel.xsl - UPS screen for General Electric.
   Copyright (c) 2008, Generex GmbH. All rights reserved.
   Said Raqui
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!-- Methods -->
  <!--Header-->
  <xsl:template name="ep_panel-header">
    <xsl:call-template name="app-header">
      <xsl:with-param name="top" select="13"/>
      <xsl:with-param name="left" select="20"/>
    </xsl:call-template>
  </xsl:template>

  <!--Footer-->
  <xsl:template name="ep_panel-footer" >
    <xsl:call-template name="app-footer" >
      <xsl:with-param name="top" select="430"/>
      <xsl:with-param name="left" select="10"/>
      <xsl:with-param name="width" select="752"/>
      <xsl:with-param name="height" select="62"/>
    </xsl:call-template>
  </xsl:template>
  <!--Menu-->
  <xsl:template name="ep_panel-menu">
    <xsl:call-template name="app-menu">
      <xsl:with-param name="top" select="428"/>
      <xsl:with-param name="left" select="0"/>
      <xsl:with-param name="width" select="0"/>
      <xsl:with-param name="height" select="0"/>
      <xsl:with-param name="class" select="'XBold_black'"/>
    </xsl:call-template>
  </xsl:template>

  <!--Body-->
  <xsl:template name="ep_panel-body">
    <div id="master" style="position:absolute;top:10px;left:10px;">
      <xsl:apply-templates />
    </div>

    <xsl:call-template name="IEpixelBugfixCall"/>
    <xsl:call-template name="js_refresh_call">
      <xsl:with-param	 name="timeout" select="1000*//report/@refresh"/>
    </xsl:call-template>
  </xsl:template>

  <!-- Implementation -->
  <xsl:template match="values">
    <xsl:call-template name="background">
      <xsl:with-param name="imagepath" select="'./lib/ups/image/ge/Standard_vh.png'"/>
      <xsl:with-param name="x" select="'0'"/>
      <xsl:with-param name="y" select="'0'"/>
      <xsl:with-param name="w" select="'752'"/>
      <xsl:with-param name="h" select="'399'"/>
      <xsl:with-param name="border" select="0"/>
      <xsl:with-param name="id" select="'background'"/>
    </xsl:call-template>
    <div style="color:black; font-weight:bold; font-size:9pt">
      <!-- Manufacturer -->
      <xsl:variable name="manufacturer" select="'GE'"/>
      <xsl:call-template name="paneText">
        <xsl:with-param name="x" select="60" />
        <xsl:with-param name="y" select="34" />
        <xsl:with-param name="w" select="200" />
        <xsl:with-param name="h" select="30" />
        <xsl:with-param name="align" select="'left'" />
        <xsl:with-param name="value" select="concat('Manufacturer:&#160;&#160;&#160;&#160;',$manufacturer)" />
        <xsl:with-param name="name" select="'manufacturer_id'" />
      </xsl:call-template>
      <script type="text/javascript"> translate_text('manufacturer_id', ['Manufacturer', ':&#160;&#160;&#160;&#160;', '<xsl:value-of select="$manufacturer" />']);</script>

      <!-- Model -->
      <xsl:variable name="model" select="value[@name='CP4_MODEL']/@val"/>
      <xsl:call-template name="paneText">
        <xsl:with-param name="x" select="60" />
        <xsl:with-param name="y" select="50" />
        <xsl:with-param name="w" select="200" />
        <xsl:with-param name="h" select="17" />
        <xsl:with-param name="align" select="'left'" />
        <xsl:with-param name="value" select="concat('Model:&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;',$model)" />
        <xsl:with-param name="name" select="'model_id'" />
      </xsl:call-template>
      <script type="text/javascript"> translate_text('model_id', ['Model', ':&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;', '<xsl:value-of select="$model" />']);</script>

      <!-- Power rating -->
      <xsl:variable name="power_rating" select="value[@name='CP4_NOMPOWER']/@val"/>
      <xsl:call-template name="paneText">
        <xsl:with-param name="x" select="60" />
        <xsl:with-param name="y" select="66" />
        <xsl:with-param name="w" select="200" />
        <xsl:with-param name="h" select="17" />
        <xsl:with-param name="align" select="'left'" />
        <xsl:with-param name="unit" select="'VA'" />
        <xsl:with-param name="value" select="concat('Power rating:&#160;&#160;&#160;&#160;&#160;',substring-before($power_rating,'.'))" />
        <xsl:with-param name="name" select="'power_rating_id'" />
      </xsl:call-template>
      <script type="text/javascript"> translate_text('power_rating_id', ['Power rating', ':&#160;&#160;&#160;&#160;&#160;;', '<xsl:value-of select="substring-before($power_rating,'.')" />']);</script>

      <!-- Firmware -->
      <!--
		<xsl:variable name="firmware" select="value[@name='CP4_SERIALNO']/@val"/>	
		 	<xsl:call-template name="paneText">
				<xsl:with-param name="x" select="60" />
			  <xsl:with-param name="y" select="82" />
			  <xsl:with-param name="w" select="263" />
			  <xsl:with-param name="h" select="17" />
			  <xsl:with-param name="align" select="'left'" />
			  <xsl:with-param name="value" select="concat('Serial number:&#160;&#160;&#160;',$firmware)" />
           <xsl:with-param name="name" select="'divText'" />
			</xsl:call-template>
			-->
    </div>
    <!-- STATUS -->
    <xsl:variable name="status" select="value[@name='STATUS']/@val"/>
    <!-- Alarm Condition -->
    <xsl:variable name="alarm" >
      <xsl:call-template name="get_alarm_condition"/>
    </xsl:variable>

    <!-- COMMON ALARM -->
    <div style="position: absolute; left: 534px; top: 305px; width: 33px; height: 12px; color:#3341AA; font-weight:bold; font-size:9pt">Alarm</div>
    <div style="position: absolute; left: 534px; top: 290px; width: 33px; height: 12px">
      <xsl:choose>
        <xsl:when test="0!=$alarm">
          <img border="1" src="./lib/ups/image/ups/led33x12red.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img border="1" src="./lib/ups/image/ups/led33x12gr.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>
    <!-- Output Power-->
    <xsl:variable name="outpower" select="value[@name='OUTPOWER']/@val"/>
    <!-- LOAD BAR-->
    <div style="position: absolute; left: 668px; top: 32px; width: 33px; height: 12px; color:#3341AA; font-weight:bold; font-size:9pt">
      <xsl:value-of select="$lang-Load"/>
    </div>
    <div style="color:#3341AA; font-weight:bold; font-size:9pt">
      <xsl:call-template name="Loadbar">
        <xsl:with-param name="load" select="value[@name='OUTPOWER']/@val"/>
        <xsl:with-param name="x" select="'670'"/>
        <xsl:with-param name="y" select="'52'"/>
        <xsl:with-param name="yOffset" select="'8'"/>
        <xsl:with-param name="border" select="'1'"/>
        <xsl:with-param name="scale" select="'1'"/>
        <xsl:with-param name="title" select="concat(substring-before($outpower,'.'),'%')"/>
        <xsl:with-param name="textcolor" select="'#3341AA'"/>
      </xsl:call-template>
    </div>
    <!-- OUTPUT_VOLT Output Volt -->
    <div id="output_txt" style="position: absolute; left: 545px; top: 170px; width: 33px; height: 12px; color:#3341AA; font-weight:bold; font-size:9pt">
      <script type="text/javascript"> translate_text('output_txt', 'Output');</script>
   </div>
    <div style="color:black; font-weight:bold; font-size:9pt">
      <!--  Output Volt (OUTPUT_VOLT) -->
      <xsl:variable name="output_volt" select="value[@name='OUTPUT_VOLT']/@val"/>
      <!-- OUTPUT_POW variables -->
      <!--output power values -->
      <xsl:variable name="output_pow">
        <xsl:call-template name="power_val">
          <xsl:with-param name="value" select="value[@name='OUTPUT_POW']/@val" />
        </xsl:call-template>
      </xsl:variable>
      <!--output power unit (OUTPUT_POW)-->
      <xsl:variable name="output_pow_unit">
        <xsl:call-template name="power_unit">
          <xsl:with-param name="value" select="value[@name='OUTPUT_POW']/@val" />
        </xsl:call-template>
      </xsl:variable>
      <!--Table width-->
      <xsl:variable name="t_width">
        <xsl:choose>
          <xsl:when test="value[@name='SOLAWROC']/@val &lt; 0 and $output_pow &lt;0">
            <xsl:value-of select="114"/>
          </xsl:when>
          <xsl:when test="string-length(value[@name='SOLAWROC']/@val)=0 and string-length($output_pow)=0">
            <xsl:value-of select="65"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="160"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <xsl:call-template name="paneRow1Col3_vh">
        <xsl:with-param name="x" select="540" />
        <xsl:with-param name="y" select="230" />
        <xsl:with-param name="w" select="$t_width" />
        <xsl:with-param name="h" select="40" />
        <xsl:with-param name="title" select="'L'"/>
        <xsl:with-param name="value1" select="substring-before($output_volt,'.')"/>
        <xsl:with-param name="value2" select="value[@name='SOLAWROC']/@val"/>
        <xsl:with-param name="value3" select="$output_pow"/>
        <xsl:with-param name="unit1" select="'V'"/>
        <xsl:with-param name="unit2" select="'A'"/>
        <xsl:with-param name="unit3" select="$output_pow_unit"/>
        <xsl:with-param name="precision1" select="-1"/>
        <xsl:with-param name="precision2" select="1"/>
        <xsl:with-param name="precision3" select="1"/>
      </xsl:call-template>
      <!-- OUTFREQ Out Frequence -->
      <xsl:variable name="out_freq" select="value[@name='OUTFREQ']/@val"/>
      <xsl:call-template name="paneRow1_ge">
        <xsl:with-param name="xT" select="541"/>
        <xsl:with-param name="yT" select="200"/>
        <xsl:with-param name="wT" select="20"/>
        <xsl:with-param name="hT" select="20"/>
        <xsl:with-param name="xOff" select="0"/>
        <xsl:with-param name="w" select="44"/>
        <xsl:with-param name="h" select="21"/>
        <xsl:with-param name="alignT" select="'left'"/>
        <xsl:with-param name="text" select="'f'" />
        <xsl:with-param name="value"  select="$out_freq" />
        <xsl:with-param name="unit" select="'Hz'"/>
        <xsl:with-param name="precision"  select="1"/>
        <xsl:with-param name="visibility" select="'visible'"/>
      </xsl:call-template>
      <!-- Service -->
      <xsl:variable name="service">
        <xsl:call-template name="bit">
          <xsl:with-param name="val" select="value[@name='STATUS']/@val"/>
          <xsl:with-param name="bit" select="$bit10"/>
        </xsl:call-template>
      </xsl:variable>
      <div id="service_txt" style="position: absolute; left: 589px; top: 305px; width: 33px; height: 12px; color:#3341AA; font-weight:bold; font-size:9pt">
         <script type="text/javascript"> translate_text('service_txt', 'Service');</script>   
      </div>
      <div style="position: absolute; left: 589px; top: 290px; width: 33px; height: 12px">
        <xsl:choose>
          <xsl:when test="1=$service">
            <img border="1" src="./lib/ups/image/ups/led33x12yellow.gif" />
          </xsl:when>
          <xsl:otherwise>
            <img border="1" src="./lib/ups/image/ups/led33x12gr.gif" />
          </xsl:otherwise>
        </xsl:choose>
      </div>
      <!-- CP4_OPSOURCE (Output source) -->
      <xsl:variable name="outsource" select="value[@name='CP4_OPSOURCE']/@val"/>
      <!-- Output -->
      <div id="output_txt_2" style="position: absolute; left: 644px; top: 305px; width: 33px; height: 12px; color:#3341AA; font-weight:bold; font-size:9pt">
         <script type="text/javascript"> translate_text('output_txt_2', 'Output');</script>
      </div>
      <div style="position: absolute; left: 644px; top: 290px; width: 33px; height: 12px">
        <xsl:choose>
          <xsl:when test="7=$outsource">
            <img border="1" src="./lib/ups/image/ups/led33x12red.gif" />
          </xsl:when>
          <xsl:when test="5=$outsource or 2=$outsource">
            <img border="1" src="./lib/ups/image/ups/led33x12yellow.gif" />
          </xsl:when>
          <xsl:otherwise>
            <img border="1" src="./lib/ups/image/ups/led33x12gr.gif" />
          </xsl:otherwise>
        </xsl:choose>
      </div>
      <!--output source values -->
      <xsl:variable name="op_source_val">
        <xsl:choose>
          <xsl:when test="0=$outsource">Normal </xsl:when>
          <xsl:when test="1=$outsource">Battery </xsl:when>
          <xsl:when test="2=$outsource">Bypass&#160;(Reserve) </xsl:when>
          <xsl:when test="3=$outsource">Reducer </xsl:when>
          <xsl:when test="4=$outsource">Booster </xsl:when>
          <xsl:when test="5=$outsource">Bypass </xsl:when>
          <xsl:when test="6=$outsource">Other </xsl:when>
          <xsl:when test="7=$outsource">None </xsl:when>
          <xsl:otherwise>None</xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <!--output source value text width-->
      <xsl:variable name="op_src_val_width">
        <xsl:choose>
          <xsl:when test="$op_source_val = 2 or $op_source_val = 5">
            <xsl:value-of select="60"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="20"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <!--output source  -->
      <xsl:call-template name="paneRow">
        <xsl:with-param name="xT" select="540"/>
        <xsl:with-param name="yT" select="215"/>
        <xsl:with-param name="wT" select="50"/>
        <xsl:with-param name="hT" select="20"/>
        <xsl:with-param name="xOff" select="0"/>
        <xsl:with-param name="w" select="$op_src_val_width"/>
        <xsl:with-param name="h" select="21"/>
        <xsl:with-param name="alignT" select="'left'"/>
        <xsl:with-param name="text" select="$lang-Source" />
        <xsl:with-param name="value"  select="$op_source_val" />
        <xsl:with-param name="visibility" select="'visible'"/>
        <xsl:with-param name="name" select="'op_src_1'" />
      </xsl:call-template>
      <script type="text/javascript"> translate_text('op_src_10', ['<xsl:value-of select="$lang-Source"/>',':']);</script>
      <script type="text/javascript"> translate_text('op_src_11', '<xsl:value-of select="$op_source_val"/>');</script>
    </div>
    <!-- Battery Volt-->
    <div style="position: absolute; left: 210px; top: 240px; width: 33px; height: 12px; color:#3341AA; font-weight:bold; font-size:9pt">Battery</div>
    <div style="color:black; font-weight:bold; font-size:9pt">
      <xsl:variable name="battvolt" select="value[@name='BATTVOLT']/@val"/>
      <xsl:call-template name="paneRow1_ge">
        <xsl:with-param name="xT" select="210"/>
        <xsl:with-param name="yT" select="255"/>
        <xsl:with-param name="wT" select="60"/>
        <xsl:with-param name="hT" select="20"/>
        <xsl:with-param name="xOff" select="0"/>
        <xsl:with-param name="w" select="60"/>
        <xsl:with-param name="h" select="21"/>
        <xsl:with-param name="alignT" select="'left'"/>
        <xsl:with-param name="text" select="'Ubatt'" />
        <xsl:with-param name="value"  select="$battvolt" />
        <xsl:with-param name="unit" select="'V'"/>
        <xsl:with-param name="precision"  select="1"/>
        <xsl:with-param name="visibility" select="'visible'"/>
        <xsl:with-param name="name" select="'batt_volt_1'" />
      </xsl:call-template>
      <script type="text/javascript"> translate_text('batt_volt_10', ['Ubatt',':']);</script>

      <!-- Power fail -->
      <xsl:variable name="power_fail">
        <xsl:call-template name="bit">
          <xsl:with-param name="val" select="value[@name='STATUS']/@val"/>
          <xsl:with-param name="bit" select="$bit3"/>
        </xsl:call-template>
      </xsl:variable>
      <!-- Battery current-->
      <xsl:variable name="battery_curr" select="value[@name='BATTERYCURRENT']/@val"/>
      <xsl:if test="string-length($battery_curr) != 0">
        <xsl:call-template name="paneRow1_ge">
          <xsl:with-param name="xT" select="210"/>
          <xsl:with-param name="yT" select="270"/>
          <xsl:with-param name="wT" select="60"/>
          <xsl:with-param name="hT" select="80"/>
          <xsl:with-param name="xOff" select="1"/>
          <xsl:with-param name="w" select="60"/>
          <xsl:with-param name="h" select="21"/>
          <xsl:with-param name="alignT" select="'left'"/>
          <xsl:with-param name="text" select="'Ibatt'" />
          <xsl:with-param name="value"  select="$battery_curr" />
          <xsl:with-param name="unit" select="'A'"/>
          <xsl:with-param name="precision"  select="1"/>
          <xsl:with-param name="power_fail"  select="$power_fail"/>
          <xsl:with-param name="name" select="'batt_curr_1'" />
        </xsl:call-template>
        <script type="text/javascript"> translate_text('batt_curr_10', ['Ibatt',':']);</script>
      </xsl:if>

      <!-- Temperature-->
      <xsl:variable name="temp_yT">
        <xsl:choose>
          <xsl:when test="string-length($battery_curr) = 0">
            <xsl:value-of select="270"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="285"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <xsl:variable name="temp" select="value[@name='TEMPDEG']/@val"/>
      <xsl:if test="value[@name='_tempUnit']/@val=0 or string-length(value[@name='_tempUnit']/@val)=0">
        <xsl:call-template name="paneRow1_ge">
          <xsl:with-param name="xT" select="210"/>
          <xsl:with-param name="yT" select="$temp_yT"/>
          <xsl:with-param name="wT" select="60"/>
          <xsl:with-param name="hT" select="80"/>
          <xsl:with-param name="xOff" select="1"/>
          <xsl:with-param name="w" select="60"/>
          <xsl:with-param name="h" select="21"/>
          <xsl:with-param name="alignT" select="'left'"/>
          <xsl:with-param name="text" select="$lang-Temperature-short" />
          <xsl:with-param name="value"  select="$temp" />
          <xsl:with-param name="unit" select="'&#176;C'"/>
          <xsl:with-param name="precision"  select="-1"/>
          <xsl:with-param name="name" select="'batt_temp_1'" />
        </xsl:call-template>
        <script type="text/javascript"> translate_text('batt_temp_10', ['<xsl:value-of select="$lang-Temperature-short" />',':']);</script>
      </xsl:if>

      <xsl:if test="value[@name='_tempUnit']/@val=1">
        <xsl:call-template name="paneRow1_ge">
          <xsl:with-param name="xT" select="210"/>
          <xsl:with-param name="yT" select="$temp_yT"/>
          <xsl:with-param name="wT" select="60"/>
          <xsl:with-param name="hT" select="80"/>
          <xsl:with-param name="xOff" select="1"/>
          <xsl:with-param name="w" select="60"/>
          <xsl:with-param name="h" select="21"/>
          <xsl:with-param name="alignT" select="'left'"/>
          <xsl:with-param name="text" select="$lang-Temperature-short" />
          <xsl:with-param name="value"  select="($temp*1.8) + 32.0" />
          <xsl:with-param name="unit" select="'&#176;C'"/>
          <xsl:with-param name="precision"  select="-1"/>
          <xsl:with-param name="name" select="'batt_temp_1'" />
        </xsl:call-template>
        <script type="text/javascript"> translate_text('batt_temp_10', ['<xsl:value-of select="$lang-Temperature-short" />',':']);</script>
      </xsl:if>

      <!--Battery capacity -->
      <xsl:variable name="battcap" select="value[@name='BATTCAP']/@val"/>
      <xsl:call-template name="paneRow1_ge">
        <xsl:with-param name="xT" select="210"/>
        <xsl:with-param name="yT" select="$temp_yT+15"/>
        <xsl:with-param name="wT" select="60"/>
        <xsl:with-param name="hT" select="20"/>
        <xsl:with-param name="xOff" select="0"/>
        <xsl:with-param name="w" select="60"/>
        <xsl:with-param name="h" select="60"/>
        <xsl:with-param name="alignT" select="'left'"/>
        <xsl:with-param name="text" select="'Charge'" />
        <xsl:with-param name="value"  select="$battcap" />
        <xsl:with-param name="unit" select="'&#160;%'"/>
        <xsl:with-param name="precision"  select="-1"/>
        <xsl:with-param name="name" select="'batt_charge_1'" />
      </xsl:call-template>
      <script type="text/javascript"> translate_text('batt_charge_10', ['Charge',':']);</script>

      <!--Runtime -->
      <xsl:variable name="autonomtime" select="value[@name='AUTONOMTIME']/@val"/>
      <xsl:call-template name="paneRow1_ge">
        <xsl:with-param name="xT" select="210"/>
        <xsl:with-param name="yT" select="$temp_yT+30"/>
        <xsl:with-param name="wT" select="60"/>
        <xsl:with-param name="hT" select="20"/>
        <xsl:with-param name="xOff" select="0"/>
        <xsl:with-param name="w" select="60"/>
        <xsl:with-param name="h" select="21"/>
        <xsl:with-param name="alignT" select="'left'"/>
        <xsl:with-param name="text" select="'Runtime'" />
        <xsl:with-param name="value"  select="$autonomtime" />
        <xsl:with-param name="unit" select="'Min'"/>
        <xsl:with-param name="precision"  select="-1"/>
        <xsl:with-param name="name" select="'batt_runtime_1'" />
      </xsl:call-template>
      <script type="text/javascript"> translate_text('batt_runtime_10', ['Runtime',':']);</script>
      
    </div>
    <div id="mains_txt" style="position: absolute; left: 122px; top: 175px; width: 33px; height: 12px; color:#3341AA; font-weight:bold; font-size:9pt">
      <script type="text/javascript"> translate_text('mains_txt', 'Mains');</script>
    </div>
    <!--width-->
    <xsl:variable name="width">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='INPUTCURRENT']/@val)=0 or string-length(value[@name='INVOLT']/@val)=0">
          <xsl:value-of select="70"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="110"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!-- Input Volt and INPUTCURRENT" -->
    <xsl:call-template name="paneRow1Col3_vh">
      <xsl:with-param name="x" select="120" />
      <xsl:with-param name="y" select="210" />
      <xsl:with-param name="w" select="$width" />
      <xsl:with-param name="h" select="40" />
      <xsl:with-param name="title" select="'L'"/>
      <xsl:with-param name="value1" select="substring-before(value[@name='INVOLT']/@val,'.')"/>
      <xsl:with-param name="value2" select="value[@name='INPUTCURRENT']/@val"/>
      <xsl:with-param name="value3" select="' '"/>
      <xsl:with-param name="unit1" select="'V'"/>
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision1" select="-1"/>
      <xsl:with-param name="precision2" select="1"/>
      <xsl:with-param name="precision3" select="0"/>
    </xsl:call-template>
    <div style="color:black; font-weight:bold; font-size:9pt">
      <!-- In Frequence -->
      <xsl:variable name="in_freq" select="value[@name='INFREQ']/@val"/>
      <xsl:call-template name="paneRow1_ge">
        <xsl:with-param name="xT" select="122"/>
        <xsl:with-param name="yT" select="195"/>
        <xsl:with-param name="wT" select="23"/>
        <xsl:with-param name="hT" select="20"/>
        <xsl:with-param name="xOff" select="0"/>
        <xsl:with-param name="w" select="20"/>
        <xsl:with-param name="h" select="21"/>
        <xsl:with-param name="alignT" select="'left'"/>
        <xsl:with-param name="text" select="'f'" />
        <xsl:with-param name="value"  select="$in_freq" />
        <xsl:with-param name="unit" select="'Hz'"/>
        <xsl:with-param name="precision"  select="1"/>
        <xsl:with-param name="name" select="'batt_volt_1'" />
      </xsl:call-template>
    </div>
    <!-- Alarm condition -->
    <!--OnBattery-->
    <xsl:variable name="upsAlarmOnBattery">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$status"/>
        <xsl:with-param name="bit" select="$bit3"/>
      </xsl:call-template>
    </xsl:variable>
    <!--GeneralFault  -->
    <xsl:variable name="upsAlarmGeneralFault">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$status"/>
        <xsl:with-param name="bit" select="$bit13"/>
      </xsl:call-template>
    </xsl:variable>
    <!--OutputOverload-->
    <xsl:variable name="upsAlarmOutputOverload">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$status"/>
        <xsl:with-param name="bit" select="$bit8"/>
      </xsl:call-template>
    </xsl:variable>
    <!--OutputOffAsRequested -->
    <xsl:variable name="upsAlarmOutputOffAsRequested">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$status"/>
        <xsl:with-param name="bit" select="$bit1"/>
      </xsl:call-template>
    </xsl:variable>
    <!--upsAlarmBatteryBad-->
    <xsl:variable name="upsAlarmBatteryBad">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$status"/>
        <xsl:with-param name="bit" select="$bit10"/>
      </xsl:call-template>
    </xsl:variable>
    <!--LowBattery-->
    <xsl:variable name="upsAlarmLowBattery">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$alarm"/>
        <xsl:with-param name="bit" select="$bit2"/>
      </xsl:call-template>
    </xsl:variable>
    <!--TestInProgress-->
    <xsl:variable name="upsAlarmTestInProgress">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$status"/>
        <xsl:with-param name="bit" select="$bit6"/>
      </xsl:call-template>
    </xsl:variable>
    <!--OnBypass-->
    <xsl:variable name="upsAlarmOnBypass">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$status"/>
        <xsl:with-param name="bit" select="$bit0"/>
      </xsl:call-template>
    </xsl:variable>

    <!--DiagnosticTestFailed -->
    <xsl:variable name="upsAlarmDiagnosticTestFailed">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$status"/>
        <xsl:with-param name="bit" select="$bit18"/>
      </xsl:call-template>
    </xsl:variable>

    <!--EPROMError -->
    <xsl:variable name="upsAlarmEPROMError">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$alarm"/>
        <xsl:with-param name="bit" select="$bit31"/>
      </xsl:call-template>
    </xsl:variable>



    <!--Alarm Panel -->
    <xsl:if test="$alarm &gt; 0 or 4!=$status">
      <xsl:call-template name="alarm_panel">
        <xsl:with-param name="upsAlarmBatteryBad" select="$upsAlarmBatteryBad" />
        <xsl:with-param name="upsAlarmOnBattery" select="$upsAlarmOnBattery" />
        <xsl:with-param name="upsAlarmLowBattery" select="$upsAlarmLowBattery" />
        <xsl:with-param name="upsAlarmOutputOverload" select="$upsAlarmOutputOverload" />
        <xsl:with-param name="upsAlarmOutputOffAsRequested" select="$upsAlarmOutputOffAsRequested" />
        <xsl:with-param name="upsAlarmGeneralFault" select="$upsAlarmGeneralFault" />
        <xsl:with-param name="upsAlarmDiagnosticTestFailed" select="$upsAlarmDiagnosticTestFailed" />
        <xsl:with-param name="upsAlarmEPROMError" select="$upsAlarmEPROMError" />
        <xsl:with-param name="upsAlarmOnBypass" select="$upsAlarmOnBypass" />
        <xsl:with-param name="upsAlarmTestInProgress" select="$upsAlarmTestInProgress" />
        <xsl:with-param name="top" select="'340'" />
      </xsl:call-template>
    </xsl:if>

  </xsl:template>
  <!-- EOS -->
</xsl:stylesheet>
