/*
   error_pannel.js - error for XSL screen.
   Copyright (c) 2016, Generex GmbH. All rights reserved.
   Said.
*/
var error_api = (function ($) {
  var err_div = null,
  check_bowser = true,
  css_obj = null,
  x_pos = 5,
  y_pos = 5,
  url_params = utils_api.get_url_params(),
  url = get_url('www/devices/ups/page');

  var cmd_option = {
    data: {},
    data_type: 'xml',
    success: update,
    error: err_funct
  },
  cmd_settings = { methode: "GET" };

  /*public functions*/
  return {
    init: init
  };

  function init() {
    if (check_bowser && !utils_api.check_bowser()) {
      $('#loading_id').css('display', 'none');
      panes_api.create_br_check_panel(this, browser_check_ok);
      return true;
    }
    create_err_msg_panel();

    jqmodule.ajax(url, cmd_option, cmd_settings);
  }

  function browser_check_ok() {
    check_bowser = false;
    init();
  }

  function create_err_msg_panel() {
    css_obj = { position: 'absolute', top: y_pos, left: x_pos, width: 791, display: 'none', 'z-index': 22, 'text-align': 'center' };

    if (url_params['initializing'] == 'yes')
    err_div = panes_api.create_err_panel({ id: 'error_div', 'class': 'alert alert' }, css_obj);
    else
    err_div = panes_api.create_err_panel({ id: 'error_div', 'class': 'alert alert-danger' }, css_obj);

  }

  function err_funct(response) {
    url_params = utils_api.get_url_params();
    response.statusText = '';

    if (url_params['initializing'] == 'yes') {
      response.responseText = i18n('Initializing device - This process may take a few minutes') + '.</br></br>';
      response.responseText += i18n('Please wait until your browser reconnects automatically') + '.';
    } else {
      response.responseText = i18n('Device not available yet') + '.</br></br>';
      response.responseText += i18n('Please wait until your browser reconnects automatically') + '.';

      if (url_params['isXSL'] == 'no' //HTML Page
        &&
        response.responseURL.lastIndexOf("error.html") == -1) {
        return update(null);
      }
    }

    panes_api.display_err({ response: response, oid: null, err_div: err_div, err_msg_div_id: 'error_msg_div' });
    setTimeout(function () {
      window.location = get_url('www/devices/ups/page');
    }, 5000);
  }

  function update(data) {
    window.location = url;
  }
}(jQuery));