<?xml version="1.0"?>
<!--
   geml_panel.xsl - UPS screen for General Electric (GE ML model).
   Copyright (c) 2008, Generex GmbH. All rights reserved.
   Said Raqui
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

  <!-- Methods -->
  <!--Header-->
  <xsl:template name="geml_panel-header">
    <xsl:call-template name="app-header">
      <xsl:with-param name="top" select="10"/>
    </xsl:call-template>
  </xsl:template>

  <!--Footer-->
  <xsl:template name="geml_panel-footer" >
    <xsl:call-template name="app-footer" >
      <xsl:with-param name="top" select="510"/>
      <xsl:with-param name="left" select="30"/>
      <xsl:with-param name="width" select="754"/>
      <xsl:with-param name="height" select="62"/>
    </xsl:call-template>
  </xsl:template>
  <!--Menu-->
  <xsl:template name="geml_panel-menu">
    <xsl:call-template name="app-menu">
      <xsl:with-param name="top" select="428"/>
      <xsl:with-param name="left" select="0"/>
      <xsl:with-param name="width" select="0"/>
      <xsl:with-param name="height" select="0"/>
      <xsl:with-param name="class" select="'XBold_black'"/>
    </xsl:call-template>
  </xsl:template>

  <!--Body-->
  <xsl:template name="geml_panel-body">
    <div id="master" style="position:absolute;top:10px;left:10px;">
      <xsl:apply-templates />
    </div>
    <xsl:call-template name="IEpixelBugfixCall"/>
    <!--<xsl:call-template name="js_refresh_call">
      <xsl:with-param	 name="timeout" select="1000*//report/@refresh"/>
    </xsl:call-template>-->

  </xsl:template>



  <xsl:template name="ups_panel-body">
		<xsl:call-template name="IEpixelBugfixCall"/>
		<xsl:call-template name="js_refresh_call">
			<xsl:with-param	 name="timeout" select="1000*//report/@refresh"/>
		</xsl:call-template>
      <xsl:apply-templates />
   </xsl:template>

  <!-- Implementation -->

  <xsl:template match="values">
    <xsl:call-template name="background">
      <xsl:with-param name="imagepath" select="'./lib/ups/image/ge/Standard_geml.png'"/>
      <xsl:with-param name="x" select="'0'"/>
      <xsl:with-param name="y" select="'0'"/>
      <xsl:with-param name="w" select="'791'"/>
      <xsl:with-param name="h" select="'530'"/>
      <xsl:with-param name="border" select="0"/>
      <xsl:with-param name="id" select="'background'"/>
    </xsl:call-template>
    <div style="color:black; font-weight:bold; font-size:9pt">
      <!-- Manufacturer -->
      <xsl:variable name="manufacturer" select="value[@name='CP4_MANUFACTURER']/@val"/>
      <xsl:if test="string-length($manufacturer) !=0">
        <xsl:call-template name="paneText">
          <xsl:with-param name="x" select="60" />
          <xsl:with-param name="y" select="54" />
          <xsl:with-param name="w" select="200" />
          <xsl:with-param name="h" select="30" />
          <xsl:with-param name="align" select="'left'" />
          <xsl:with-param name="value" select="concat('Manufacturer:&#160;&#160;&#160;&#160;',$manufacturer)" />
          <xsl:with-param name="name" select="'manufacturer_id'" />
        </xsl:call-template>
        <script type="text/javascript"> translate_text('manufacturer_id', ['Manufacturer', ':&#160;&#160;&#160;&#160;', '<xsl:value-of select="$manufacturer" />']);</script>
      </xsl:if>

      <!-- Power rating -->
      <xsl:variable name="power_rating" select="value[@name='CP4_NOMPOWER']/@val"/>
      <xsl:if test="string-length($power_rating) !=0 and value[@name='MODEL']/@val != 'GE ML'">
        <xsl:call-template name="paneText">
          <xsl:with-param name="x" select="60" />
          <xsl:with-param name="y" select="70" />
          <xsl:with-param name="w" select="200" />
          <xsl:with-param name="h" select="17" />
          <xsl:with-param name="align" select="'left'" />
          <xsl:with-param name="unit" select="'VA'" />
          <xsl:with-param name="value" select="concat('Power rating:&#160;&#160;&#160;&#160;&#160;',substring-before($power_rating,'.'))" />
          <xsl:with-param name="name" select="'power_rating_id'" />
        </xsl:call-template>
        <script type="text/javascript"> translate_text('power_rating_id', ['Power rating', ':&#160;&#160;&#160;&#160;&#160;', '<xsl:value-of select="substring-before($power_rating,'.')" />']);</script>
      </xsl:if>
      <!-- Model -->
      <xsl:variable name="model" select="value[@name='CP4_MODEL']/@val"/>
      <xsl:if test="string-length($model) !=0">
        <xsl:call-template name="paneText">
          <xsl:with-param name="x" select="60" />
          <xsl:with-param name="y" select="86" />
          <xsl:with-param name="w" select="200" />
          <xsl:with-param name="h" select="17" />
          <xsl:with-param name="align" select="'left'" />
          <xsl:with-param name="value" select="concat('Model:&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;',$model)" />
          <xsl:with-param name="name" select="'model_id'" />
        </xsl:call-template>
        <script type="text/javascript"> translate_text('model_id', ['Model', ':&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;', '<xsl:value-of select="$model" />']);</script>        
      </xsl:if>
      <!-- Firmware -->
      <xsl:variable name="serial_number" select="value[@name='CP4_SERIALNO']/@val"/>
      <xsl:if test="string-length($serial_number) !=0">
        <xsl:call-template name="paneText">
          <xsl:with-param name="x" select="60" />
          <xsl:with-param name="y" select="102" />
          <xsl:with-param name="w" select="260" />
          <xsl:with-param name="h" select="17" />
          <xsl:with-param name="align" select="'left'" />
          <xsl:with-param name="value" select="concat('Serial Number:&#160;&#160;',$serial_number)" />
          <xsl:with-param name="name" select="'sr_nr_id'" />
        </xsl:call-template>
        <script type="text/javascript"> translate_text('sr_nr_id', ['Serial Number', ':&#160;&#160;', '<xsl:value-of select="$serial_number" />']);</script>
      </xsl:if>
    </div>

    <xsl:variable name="oemViewName" select="value[@name='_oemViewName']/@val"/>

    <!-- (Alarm Condition) -->
    <xsl:variable name="alarm" >
      <xsl:call-template name="get_alarm_condition"/>
    </xsl:variable>
    <!-- STATUS-->
    <xsl:variable name="status" select="value[@name='STATUS']/@val"/>
    <!-- Power fail -->
    <xsl:variable name="power_fail">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$status"/>
        <xsl:with-param name="bit" select="$bit3"/>
      </xsl:call-template>
    </xsl:variable>

    <!-- COMMON ALARM -->
    <div id="alarm_txt" style="position: absolute; left: 534px; top: 385px; width: 33px; height: 12px; color:#3341AA; font-weight:bold; font-size:9pt">
      <script type="text/javascript"> translate_text('alarm_txt', 'Alarm');</script>
   </div>
    <div style="position: absolute; left: 534px; top: 370px; width: 33px; height: 12px">
      <xsl:choose>
        <xsl:when test="0!=$alarm or 0!=$power_fail">
          <img border="1" src="./lib/ups/image/ups/led33x12red.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img border="1" src="./lib/ups/image/ups/led33x12gr.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>
    <!-- Output Power-->
    <xsl:variable name="outpower" select="value[@name='OUTPOWER']/@val"/>
    <!-- LOAD BAR-->
    <div id="load_txt" style="position: absolute; left: 685px; top: 122px; width: 33px; height: 12px; color:#3341AA; font-weight:bold; font-size:9pt">
      <script type="text/javascript"> translate_text('load_txt', '<xsl:value-of select="$lang-Load"/>');</script>
    </div>
    <div style="color:#3341AA; font-weight:bold; font-size:9pt">
      <xsl:call-template name="Loadbar">
        <xsl:with-param name="load" select="value[@name='OUTPOWER']/@val"/>
        <xsl:with-param name="x" select="'690'"/>
        <xsl:with-param name="y" select="'140'"/>
        <xsl:with-param name="yOffset" select="'8'"/>
        <xsl:with-param name="border" select="'1'"/>
        <xsl:with-param name="scale" select="'1'"/>
        <xsl:with-param name="title" select="concat(substring-before($outpower,'.'),'%')"/>
        <xsl:with-param name="textcolor" select="'#3341AA'"/>
      </xsl:call-template>
    </div>
    <!-- OUTPUT_VOLT Output Volt -->
    <div id="output_txt_1" style="position: absolute; left: 570px; top: 187px; width: 33px; height: 12px; color:#3341AA; font-weight:bold; font-size:9pt">
      <script type="text/javascript"> translate_text('output_txt_1', 'Output');</script>
    </div>
    <div style="color:black; font-weight:bold; font-size:9pt">
      <!--  Output Volt (OUTPUT_VOLT) -->
      <xsl:variable name="output_volt" select="value[@name='OUTPUT_VOLT']/@val"/>
      <!-- OUTPUT_POW variables -->
      <!--output power values -->
      <xsl:variable name="output_pow">
        <xsl:call-template name="power_val">
          <xsl:with-param name="value" select="value[@name='OUTPUT_POW']/@val" />
        </xsl:call-template>
      </xsl:variable>
      <!--output power unit (OUTPUT_POW)-->
      <xsl:variable name="output_pow_unit">
        <xsl:call-template name="power_unit">
          <xsl:with-param name="value" select="value[@name='OUTPUT_POW']/@val" />
        </xsl:call-template>
      </xsl:variable>

      <!--Table width-->
      <xsl:variable name="t_width">
        <xsl:choose>
          <xsl:when test="value[@name='SOLAWROC']/@val &lt; 0 and $output_pow &lt; 0">
            <xsl:value-of select="114"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="190"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>

      <xsl:choose>
        <xsl:when test="'gematch'=$oemViewName or 'GEMATCH'=$oemViewName">
          <xsl:call-template name="paneRow1Col3_vh">
            <xsl:with-param name="x" select="500" />
            <xsl:with-param name="y" select="216" />
            <xsl:with-param name="w" select="$t_width" />
            <xsl:with-param name="h" select="40" />
            <xsl:with-param name="title" select="'L'"/>
            <xsl:with-param name="value1" select="substring-before($output_volt,'.')"/>
            <xsl:with-param name="value2" select="value[@name='SOLAWROC']/@val"/>
            <xsl:with-param name="value3" select="$output_pow"/>
            <xsl:with-param name="unit1" select="'V'"/>
            <xsl:with-param name="unit2" select="'A'"/>
            <xsl:with-param name="unit3" select="$output_pow_unit"/>
            <xsl:with-param name="precision1" select="-1"/>
            <xsl:with-param name="precision2" select="1"/>
            <xsl:with-param name="precision3" select="1"/>
          </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="paneRow1Col3_vh">
            <xsl:with-param name="x" select="500" />
            <xsl:with-param name="y" select="216" />
            <xsl:with-param name="w" select="$t_width" />
            <xsl:with-param name="h" select="40" />
            <xsl:with-param name="title" select="'L'"/>
            <xsl:with-param name="value1" select="substring-before($output_volt,'.')"/>
            <xsl:with-param name="value2" select="' '"/>
            <xsl:with-param name="value3" select="' '"/>
            <xsl:with-param name="unit1" select="'V'"/>
            <xsl:with-param name="unit2" select="' '"/>
            <xsl:with-param name="unit3" select="' '"/>
            <xsl:with-param name="precision1" select="-1"/>
            <xsl:with-param name="precision2" select="1"/>
            <xsl:with-param name="precision3" select="1"/>
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>

      <!-- OUTFREQ Out Frequence -->
      <xsl:variable name="out_freq" select="value[@name='OUTFREQ']/@val"/>
      <xsl:call-template name="paneRow1_ge">
        <xsl:with-param name="xT" select="502"/>
        <xsl:with-param name="yT" select="233"/>
        <xsl:with-param name="wT" select="20"/>
        <xsl:with-param name="hT" select="20"/>
        <xsl:with-param name="xOff" select="0"/>
        <xsl:with-param name="w" select="44"/>
        <xsl:with-param name="h" select="21"/>
        <xsl:with-param name="alignT" select="'left'"/>
        <xsl:with-param name="text" select="'f'" />
        <xsl:with-param name="value"  select="$out_freq" />
        <xsl:with-param name="unit" select="'Hz'"/>
        <xsl:with-param name="precision"  select="1"/>
      </xsl:call-template>
      <!-- CP4_OPSOURCE (Output source) -->
      <xsl:variable name="outsource" select="value[@name='CP4_OPSOURCE']/@val"/>
      <!-- Output -->
      <div id="output_txt" style="position: absolute; left: 584px; top: 385px; width: 33px; height: 12px; color:#3341AA; font-weight:bold; font-size:9pt">
         <script type="text/javascript"> translate_text('output_txt', 'Output');</script>
      </div>
      <div style="position: absolute; left: 584px; top: 370px; width: 33px; height: 12px">
        <xsl:choose>
          <xsl:when test="2=$outsource">
            <img border="1" src="./lib/ups/image/ups/led33x12red.gif" />
          </xsl:when>
          <xsl:when test="1=$outsource or 4=$outsource">
            <img border="1" src="./lib/ups/image/ups/led33x12yellow.gif" />
          </xsl:when>
          <xsl:otherwise>
            <img border="1" src="./lib/ups/image/ups/led33x12gr.gif" />
          </xsl:otherwise>
        </xsl:choose>
      </div>
      <!--output source values -->
      <xsl:variable name="op_source_val">
        <xsl:choose>
          <xsl:when test="1=$outsource">Other </xsl:when>
          <xsl:when test="2=$outsource">None </xsl:when>
          <xsl:when test="3=$outsource">Normal </xsl:when>
          <xsl:when test="4=$outsource">Bypass </xsl:when>
          <xsl:when test="5=$outsource">Battery </xsl:when>
          <xsl:when test="6=$outsource">Booster </xsl:when>
          <xsl:when test="7=$outsource">Reducer </xsl:when>
          <xsl:otherwise>None</xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <!--output source  -->
      <xsl:call-template name="paneRow">
        <xsl:with-param name="xT" select="500"/>
        <xsl:with-param name="yT" select="248"/>
        <xsl:with-param name="wT" select="50"/>
        <xsl:with-param name="hT" select="20"/>
        <xsl:with-param name="xOff" select="0"/>
        <xsl:with-param name="w" select="40"/>
        <xsl:with-param name="h" select="21"/>
        <xsl:with-param name="alignT" select="'left'"/>
        <xsl:with-param name="text" select="$lang-Source" />
        <xsl:with-param name="value"  select="$op_source_val" />
        <xsl:with-param name="name" select="'source_id'" />
      </xsl:call-template>
      <script type="text/javascript"> translate_text('source_id', ['<xsl:value-of select="$lang-Source" />', ':&#160;', '<xsl:value-of select="$op_source_val" />']);</script>
    </div>
   

    <!-- Battery Volt-->
    <div id="battery_txt" style="position: absolute; left: 360px; top: 310px; width: 33px; height: 12px; color:#3341AA; font-weight:bold; font-size:9pt">
      <script type="text/javascript"> translate_text('battery_txt', 'Battery');</script>
   </div>
    <div style="color:black; font-weight:bold; font-size:9pt">
      <xsl:variable name="battvolt" select="value[@name='BATTVOLT']/@val"/>
      <xsl:call-template name="paneRow1_ge">
        <xsl:with-param name="xT" select="360"/>
        <xsl:with-param name="yT" select="325"/>
        <xsl:with-param name="wT" select="60"/>
        <xsl:with-param name="hT" select="20"/>
        <xsl:with-param name="xOff" select="0"/>
        <xsl:with-param name="w" select="50"/>
        <xsl:with-param name="h" select="21"/>
        <xsl:with-param name="alignT" select="'left'"/>
        <xsl:with-param name="text" select="'Ubatt'" />
        <xsl:with-param name="value"  select="$battvolt" />
        <xsl:with-param name="unit" select="'V'"/>
        <xsl:with-param name="precision"  select="1"/>
        <xsl:with-param name="name" select="'batt_val'" />
      </xsl:call-template>
      <script type="text/javascript"> translate_text('batt_val0', ['Ubatt', ':']);</script>

      <xsl:variable name="batt_charge_yT">
        <xsl:choose>
          <xsl:when test="'geml'=$oemViewName or 'GEML'=$oemViewName">
            <xsl:value-of select="'340'" />
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'355'" />
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>

      <!-- Temperature-->
      <xsl:if test="'GEMATCH'=$oemViewName or 'gematch'=$oemViewName">
        <xsl:if test="value[@name='_tempUnit']/@val=0 or string-length(value[@name='_tempUnit']/@val)=0">
          <xsl:call-template name="paneRow1_ge">
            <xsl:with-param name="xT" select="360"/>
            <xsl:with-param name="yT" select="340"/>
            <xsl:with-param name="wT" select="60"/>
            <xsl:with-param name="hT" select="80"/>
            <xsl:with-param name="xOff" select="1"/>
            <xsl:with-param name="w" select="50"/>
            <xsl:with-param name="h" select="21"/>
            <xsl:with-param name="alignT" select="'left'"/>
            <xsl:with-param name="text" select="$lang-Temperature-short" />
            <xsl:with-param name="value"  select="value[@name='TEMPDEG']/@val" />
            <xsl:with-param name="unit" select="'&#176;C'"/>
            <xsl:with-param name="precision"  select="-1"/>
            <xsl:with-param name="name" select="'batt_tmp'" />
          </xsl:call-template>
          <script type="text/javascript"> translate_text('batt_tmp0', ['<xsl:value-of select="$lang-Temperature-short" />', ':']);</script>
        </xsl:if>
        <xsl:if test="value[@name='_tempUnit']/@val=1">
          <xsl:call-template name="paneRow1_ge">
            <xsl:with-param name="xT" select="360"/>
            <xsl:with-param name="yT" select="340"/>
            <xsl:with-param name="wT" select="60"/>
            <xsl:with-param name="hT" select="80"/>
            <xsl:with-param name="xOff" select="1"/>
            <xsl:with-param name="w" select="50"/>
            <xsl:with-param name="h" select="21"/>
            <xsl:with-param name="alignT" select="'left'"/>
            <xsl:with-param name="text" select="$lang-Temperature-short" />
            <xsl:with-param name="value"  select="(value[@name='TEMPDEG']/@val*1.8)+32.0" />
            <xsl:with-param name="unit" select="'&#176;F'"/>
            <xsl:with-param name="precision"  select="-1"/>
            <xsl:with-param name="name" select="'batt_tmp'" />
          </xsl:call-template>
          <script type="text/javascript"> translate_text('batt_tmp0', ['<xsl:value-of select="$lang-Temperature-short" />', ':']);</script>
        </xsl:if>
      </xsl:if>

      <!--Battery capacity -->
      <xsl:variable name="battcap" select="value[@name='BATTCAP']/@val"/>
      <xsl:call-template name="paneRow1_ge">
        <xsl:with-param name="xT" select="360"/>
        <xsl:with-param name="yT" select="$batt_charge_yT"/>
        <xsl:with-param name="wT" select="61"/>
        <xsl:with-param name="hT" select="20"/>
        <xsl:with-param name="xOff" select="0"/>
        <xsl:with-param name="w" select="50"/>
        <xsl:with-param name="h" select="60"/>
        <xsl:with-param name="alignT" select="'left'"/>
        <xsl:with-param name="text" select="'Charge'" />
        <xsl:with-param name="value"  select="$battcap" />
        <xsl:with-param name="unit" select="'&#160;%'"/>
        <xsl:with-param name="precision"  select="-1"/>
        <xsl:with-param name="name" select="'batt_charge'" />
      </xsl:call-template>
      <script type="text/javascript"> translate_text('batt_charge0', ['<xsl:value-of select="'Charge'" />', ':']);</script>

      <!--Runtime -->
      <xsl:variable name="autonomtime" select="value[@name='AUTONOMTIME']/@val"/>
      <xsl:call-template name="paneRow1_ge">
        <xsl:with-param name="xT" select="360"/>
        <xsl:with-param name="yT" select="$batt_charge_yT+15"/>
        <xsl:with-param name="wT" select="62"/>
        <xsl:with-param name="hT" select="20"/>
        <xsl:with-param name="xOff" select="0"/>
        <xsl:with-param name="w" select="50"/>
        <xsl:with-param name="h" select="21"/>
        <xsl:with-param name="alignT" select="'left'"/>
        <xsl:with-param name="text" select="'Runtime'" />
        <xsl:with-param name="value"  select="$autonomtime" />
        <xsl:with-param name="unit" select="'Min'"/>
        <xsl:with-param name="precision"  select="-1"/>
        <xsl:with-param name="name" select="'batt_runtime'" />
      </xsl:call-template>
      <script type="text/javascript"> translate_text('batt_runtime0', ['<xsl:value-of select="'Runtime'" />', ':']);</script>
    </div>
    <!-- Input Volt -->
    <div id="mains_txt" style="position: absolute; left: 114px; top: 188px; width: 33px; height: 12px; color:#3341AA; font-weight:bold; font-size:9pt">
      <script type="text/javascript"> translate_text('mains_txt', 'Mains');</script>
    </div>
    <div style="color:black; font-weight:bold; font-size:9pt">
      <xsl:variable name="input_volt" select="value[@name='INVOLT']/@val"/>
      <xsl:call-template name="paneRow1_ge">
        <xsl:with-param name="xT" select="114"/>
        <xsl:with-param name="yT" select="215"/>
        <xsl:with-param name="wT" select="20"/>
        <xsl:with-param name="hT" select="20"/>
        <xsl:with-param name="xOff" select="0"/>
        <xsl:with-param name="w" select="50"/>
        <xsl:with-param name="h" select="21"/>
        <xsl:with-param name="alignT" select="'left'"/>
        <xsl:with-param name="text" select="'L'" />
        <xsl:with-param name="value"  select="$input_volt" />
        <xsl:with-param name="unit" select="'V'"/>
        <xsl:with-param name="precision"  select="-1"/>
      </xsl:call-template>
      <!-- In Frequence -->
      <xsl:variable name="in_freq" select="value[@name='INFREQ']/@val"/>
      <xsl:call-template name="paneRow1_ge">
        <xsl:with-param name="xT" select="114"/>
        <xsl:with-param name="yT" select="230"/>
        <xsl:with-param name="wT" select="20"/>
        <xsl:with-param name="hT" select="20"/>
        <xsl:with-param name="xOff" select="0"/>
        <xsl:with-param name="w" select="50"/>
        <xsl:with-param name="h" select="21"/>
        <xsl:with-param name="alignT" select="'left'"/>
        <xsl:with-param name="text" select="'f'" />
        <xsl:with-param name="value"  select="$in_freq" />
        <xsl:with-param name="unit" select="'Hz'"/>
        <xsl:with-param name="precision"  select="1"/>
      </xsl:call-template>
    </div>
    <!-- Battery images -->
    <div style="position: absolute; left: 300Px; top: 288px; width: 50px; height: 50px">
      <img src="./lib/ups/image/ge/grw_ge.gif" />
    </div>
    <div style="position: absolute; left: 286Px; top: 336px; width: 50px; height: 50px">
      <img src="./lib/ups/image/ge/Batgev_ge.gif" />
    </div>


    <!--  oem View Name-->
    <xsl:variable name="oem_view_name" select="value[@name='_oemViewName']/@val"/>
    <!-- Alarm condition -->
    <!--OnBattery-->
    <xsl:variable name="upsAlarmOnBattery">
      <xsl:choose>
        <xsl:when test="string($oemViewName)='GEMATCH' or string($oemViewName)='gematch'">
          <!--gematch-->
          <xsl:call-template name="bit">
            <xsl:with-param name="val" select="$alarm"/>
            <xsl:with-param name="bit" select="$bit1"/>
          </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
          <!--geml-->
          <xsl:call-template name="bit">
            <xsl:with-param name="val" select="$status"/>
            <xsl:with-param name="bit" select="$bit3"/>
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!--InputBad-->
    <xsl:variable name="upsAlarmInputBad">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$alarm"/>
        <xsl:with-param name="bit" select="$bit5"/>
      </xsl:call-template>
    </xsl:variable>
    <!--TempBad-->
    <xsl:variable name="upsAlarmTempBad">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$status"/>
        <xsl:with-param name="bit" select="$bit5"/>
      </xsl:call-template>
    </xsl:variable>
    <!--OutputBad-->
    <xsl:variable name="upsAlarmOutputBad">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$alarm"/>
        <xsl:with-param name="bit" select="$bit6"/>
      </xsl:call-template>
    </xsl:variable>
    <!--DiagnosticTestFailed -->
    <xsl:variable name="upsAlarmDiagnosticTestFailed">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$alarm"/>
        <xsl:with-param name="bit" select="$bit18"/>
      </xsl:call-template>
    </xsl:variable>
    <!--GeneralFault  -->
    <xsl:variable name="upsAlarmGeneralFault">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$status"/>
        <xsl:with-param name="bit" select="$bit13"/>
      </xsl:call-template>
    </xsl:variable>
    <!--OutputOverload-->
    <xsl:variable name="upsAlarmOutputOverload">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$status"/>
        <xsl:with-param name="bit" select="$bit8"/>
      </xsl:call-template>
    </xsl:variable>
    <!--ShutdownImminent-->
    <xsl:variable name="upsAlarmShutdownImminent">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$alarm"/>
        <xsl:with-param name="bit" select="$bit22"/>
      </xsl:call-template>
    </xsl:variable>
    <!--ShutdownPending-->
    <xsl:variable name="upsAlarmShutdownPending">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$alarm"/>
        <xsl:with-param name="bit" select="$bit21"/>
      </xsl:call-template>
    </xsl:variable>
    <!--UpsOutputOff -->
    <xsl:variable name="upsAlarmUpsOutputOff">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$alarm"/>
        <xsl:with-param name="bit" select="$bit13"/>
      </xsl:call-template>
    </xsl:variable>
    <!--UpsOffAsRequested -->
    <xsl:variable name="upsAlarmUpsOffAsRequested">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$alarm"/>
        <xsl:with-param name="bit" select="$bit11"/>
      </xsl:call-template>
    </xsl:variable>
    <!--OutputOffAsRequested -->
    <xsl:variable name="upsAlarmOutputOffAsRequested">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$alarm"/>
        <xsl:with-param name="bit" select="$bit10"/>
      </xsl:call-template>
    </xsl:variable>

    <!--upsAlarmBatteryBad-->
    <xsl:variable name="upsAlarmBatteryBad">
      <xsl:choose>
        <xsl:when test="string($oemViewName)='GEMATCH' or string($oemViewName)='gematch'">
          <!--gematch-->
          <xsl:call-template name="bit">
            <xsl:with-param name="val" select="$alarm"/>
            <xsl:with-param name="bit" select="$bit0"/>
          </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
          <!--geml-->
          <xsl:call-template name="bit">
            <xsl:with-param name="val" select="$status"/>
            <xsl:with-param name="bit" select="$bit10"/>
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>


    <!--DepletedBattery-->
    <xsl:variable name="upsAlarmDepletedBattery">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$alarm"/>
        <xsl:with-param name="bit" select="$bit3"/>
      </xsl:call-template>
    </xsl:variable>
    <!--LowBattery-->
    <xsl:variable name="upsAlarmLowBattery">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$status"/>
        <xsl:with-param name="bit" select="$bit4"/>
      </xsl:call-template>
    </xsl:variable>
    <!--TestInProgress-->
    <xsl:variable name="upsAlarmTestInProgress">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$status"/>
        <xsl:with-param name="bit" select="$bit6"/>
      </xsl:call-template>
    </xsl:variable>
    <!--OnBypass-->
    <xsl:variable name="upsAlarmOnBypass">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$status"/>
        <xsl:with-param name="bit" select="$bit0"/>
      </xsl:call-template>
    </xsl:variable>

    <!--Alarm Panel -->
    <xsl:if test="$alarm &gt; 0 or 4!=$status">
      <xsl:call-template name="alarm_panel">
        <xsl:with-param name="upsAlarmBatteryBad" select="$upsAlarmBatteryBad" />
        <xsl:with-param name="upsAlarmOnBattery" select="$upsAlarmOnBattery" />
        <xsl:with-param name="upsAlarmTempBad" select="$upsAlarmTempBad" />
        <xsl:with-param name="upsAlarmInputBad" select="$upsAlarmInputBad" />
        <xsl:with-param name="upsAlarmOutputBad" select="$upsAlarmOutputBad" />
        <xsl:with-param name="upsAlarmLowBattery" select="$upsAlarmLowBattery" />
        <xsl:with-param name="upsAlarmDepletedBattery" select="$upsAlarmDepletedBattery" />
        <xsl:with-param name="upsAlarmOutputOverload" select="$upsAlarmOutputOverload" />
        <xsl:with-param name="upsAlarmOutputOffAsRequested" select="$upsAlarmOutputOffAsRequested" />
        <xsl:with-param name="upsAlarmShutdownImminent" select="$upsAlarmShutdownImminent" />
        <xsl:with-param name="upsAlarmShutdownPending" select="$upsAlarmShutdownPending" />
        <xsl:with-param name="upsAlarmUpsOutputOff" select="$upsAlarmUpsOutputOff" />
        <xsl:with-param name="upsAlarmUpsOffAsRequested" select="$upsAlarmUpsOffAsRequested" />
        <xsl:with-param name="upsAlarmGeneralFault" select="$upsAlarmGeneralFault" />
        <xsl:with-param name="upsAlarmOnBypass" select="$upsAlarmOnBypass" />
        <xsl:with-param name="upsAlarmTestInProgress" select="$upsAlarmTestInProgress" />
        <xsl:with-param name="upsAlarmDiagnosticTestFailed" select="$upsAlarmDiagnosticTestFailed" />
        <xsl:with-param name="top" select="'410'" />
      </xsl:call-template>
    </xsl:if>

  </xsl:template>
  <!-- EOS -->
</xsl:stylesheet>
