<?xml version="1.0"?>
<!--
   cet2event.xsl - CET T3S Alarm logfile stylesheet.
   Copyright (c) 2010, Generex GmbH. All rights reserved.
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" encoding="ISO-8859-1" indent="yes"/>

<!-- Root -->
<xsl:template match="/">
   <html>
      <head>
         <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"/>
         <title>Device Alarms</title>
      </head>
      <body style="font-family:Arial,helvetica,sans-serif;font-size:12pt; background-color:#EEEEEE">
         <xsl:apply-templates />
      </body>
   </html>
</xsl:template>

<!-- UpsSettings -->
<xsl:template match="UpsSettings">
   <!-- Explicit skip other nodes -->
   <div style="background-color:darkred;color:white;padding-top:4px;padding-bottom: 4px;width:800px">
      <span style="font-weight:bold;color:white">Alarm Table&#160;-&#160;</span>
      <span style="font-weight:bold;color:white"><xsl:value-of select="MinorAlr" /></span>
      <span style="font-weight:normal;color:white">&#160;Minor alarm(s)&#160;-&#160;</span>
      <span style="font-weight:bold;color:white"><xsl:value-of select="MajorAlr" /></span>
      <span style="font-weight:normal;color:white">&#160;Major alarm(s)</span>
   </div>
   <xsl:apply-templates select="UpsLog" />
</xsl:template>

<!-- UpsLog -->
<xsl:template match="UpsLog">
   <div style="font-size:10pt">
      <table border="1" cellspacing="0" cellpadding="2" width="800">
         <tr>
         	<th style="font-size:8pt">No.</th>
         	<th style="font-size:8pt">Level</th>
         	<th style="font-size:8pt">Type</th>
         	<th style="font-size:8pt">Alarm</th>
         </tr>
         <xsl:apply-templates>
         <xsl:sort data-type="number" select="@id" order="ascending" />
   		</xsl:apply-templates>
      </table>

   </div>
</xsl:template>

<!-- UpsData -->
<xsl:template match="UpsData">
   <tr>
   	<td style="font-size:8pt;text-align:center;" align="center" valign="top"><xsl:value-of select="@id" /></td>

 		<td style="font-size:8pt" align="left" valign="top">

 		<xsl:if test="MainSource != 0">
			<xsl:call-template name="MainSource">
				<xsl:with-param name="MainSource" select='MainSource'/>
			</xsl:call-template>
		</xsl:if>
		&#160;

 		<xsl:if test="MainReference != 0">
   		<xsl:value-of select="MainReference" />
		</xsl:if>
		&#160;

 		<xsl:if test="SecondarySource != 0">
			<xsl:call-template name="SecondarySource">
				<xsl:with-param name="SecondarySource" select='SecondarySource'/>
			</xsl:call-template>
		</xsl:if>
		&#160;

 		<xsl:if test="SecondaryReference != 0">
   		<xsl:value-of select="SecondaryReference" />
		</xsl:if>
		&#160;

		</td>

 		<td style="font-size:8pt" align="center" valign="top">
			<xsl:call-template name="Type">
				<xsl:with-param name="Type" select='Type'/>
			</xsl:call-template>
		</td>

   	<xsl:choose>
   		<xsl:when test="string-length(Description) != 0">
		   	<td style="font-size:8pt" align="left" valign="top"><xsl:value-of select="Description" /></td>
			</xsl:when>
			<xsl:otherwise>
		   	<td style="font-size:8pt" align="left" valign="top">&#160;</td>
			</xsl:otherwise>
		</xsl:choose>

   </tr>
</xsl:template>

<xsl:template name="MainSource">
	<xsl:param name="MainSource" select="'0'"/>
	<xsl:choose>
		<xsl:when test="$MainSource = '1'"><xsl:text>T3S</xsl:text></xsl:when>
		<xsl:when test="$MainSource = '2'"><xsl:text>SYSTEM</xsl:text></xsl:when>
		<xsl:when test="$MainSource = '3'"><xsl:text>GROUP</xsl:text></xsl:when>
		<xsl:when test="$MainSource = '4'"><xsl:text>MODULE</xsl:text></xsl:when>
		<xsl:when test="$MainSource = '5'"><xsl:text>BATTERY</xsl:text></xsl:when>
		<xsl:when test="$MainSource = '6'"><xsl:text>TSIO</xsl:text></xsl:when>
		<xsl:otherwise><xsl:text>&#160;</xsl:text></xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="SecondarySource">
	<xsl:param name="SecondarySource" select="'0'"/>
	<xsl:choose>
		<xsl:when test="$SecondarySource = '1'"><xsl:text>ACIN</xsl:text></xsl:when>
		<xsl:when test="$SecondarySource = '2'"><xsl:text>DC</xsl:text></xsl:when>
		<xsl:when test="$SecondarySource = '3'"><xsl:text>ACOUT</xsl:text></xsl:when>
		<xsl:when test="$SecondarySource = '4'"><xsl:text>INVERTER</xsl:text></xsl:when>
		<xsl:otherwise><xsl:text>&#160;</xsl:text></xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="Type">
	<xsl:param name="Type" select="'0'"/>
	<xsl:choose>
		<xsl:when test="$Type = '0'"><xsl:text>NO ALARM</xsl:text></xsl:when>
		<xsl:when test="$Type = '1'"><xsl:text>MINOR</xsl:text></xsl:when>
		<xsl:when test="$Type = '2'"><xsl:text>MAJOR</xsl:text></xsl:when>
		<xsl:otherwise><xsl:text>&#160;</xsl:text></xsl:otherwise>
	</xsl:choose>
</xsl:template>


<!-- EOS -->
</xsl:stylesheet>
