<?xml version="1.0"?>
<!--
   prot3mevent.xsl - Protect 3M V2 Event logfile stylesheet.
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" encoding="ISO-8859-1" indent="yes"/>

<!-- Root -->
<xsl:template match="/">
   <html>
      <head>
         <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"/>
         <title>Device History</title>
      </head>
      <body style="font-family:Arial,helvetica,sans-serif;font-size:12pt; background-color:#EEEEEE">
         <xsl:apply-templates />
      </body>
   </html>
</xsl:template>

<!-- UpsSettings -->
<xsl:template match="UpsSettings">
   <!-- Device History -->
   <div style="background-color:teal;color:white;padding:8px; width:800px; height:20px">
      <span style="font-weight:bold;color:white;font-size:14pt;">Device History</span>
   </div>
   <span style="font-size:8pt">generated <xsl:value-of select="FileDate"/>, <xsl:value-of select="FileTime"/></span>
   <br/><br/>
   <div style="background-color:gold;color:white;padding:4px;width:800px">
      <span style="font-weight:bold;color:white">Device Type<br/></span>
   </div>
   <br/>
   <!-- Device Type -->
   <table border="0">
   	<tr>
   		<td style="font-size:10pt">Model:</td>
   		<td style="font-size:10pt"><xsl:value-of select="Type" /></td>
   	</tr>
   	<tr>
   		<td style="font-size:10pt">Location: </td>
   		<td style="font-size:10pt"><xsl:value-of select="Location" /></td>
   	</tr>
   </table>
   <br/>
   <!-- Explicit skip other nodes -->
   <xsl:apply-templates select="UpsLog" />
</xsl:template>

<!-- UpsLog -->
<xsl:template match="UpsLog">
   <div style="background-color:gold;color:white;padding:4px;width:800px">
      <span style="font-weight:bold;color:white">Device Events<br/></span>
   </div>
   <br/>
   <div style="font-size:10pt">
      <table border="1" cellspacing="0" cellpadding="2" width="800">
         <tr>
         	<th style="font-size:8pt">No.</th>
         	<th style="font-size:8pt">Time</th>
         	<th style="font-size:8pt">Module</th>
         	<th style="font-size:8pt">Event</th>
         	<th style="font-size:8pt">Description</th>
         </tr>
         <xsl:apply-templates>
            <xsl:sort data-type="number" select="@id" order="ascending" />
   		</xsl:apply-templates>
      </table>
   </div>
</xsl:template>

<!-- UpsData -->
<xsl:template match="UpsData">
   <tr>
   	<td style="font-size:8pt;text-align:center;" align="center" valign="top"><xsl:value-of select="@id" /></td>
   	<td style="font-size:8pt;text-align:center;" align="center" valign="top"><xsl:value-of select="Time" /></td>
   	<td style="font-size:8pt" align="center" valign="top"><xsl:value-of select="ModuleId" /></td>
   	<td style="font-size:8pt" align="center" valign="top"><xsl:value-of select="EventCode" /></td>
   	<td style="font-size:8pt" align="left" valign="top">&#160;<xsl:value-of select="EventText" />
			<xsl:call-template name="EventText">
				<xsl:with-param name="EventCode" select='EventCode'/>
			</xsl:call-template>
		</td>
   </tr>  
</xsl:template>

<xsl:template name="EventText">
	<xsl:param name="EventCode" select="'0'"/>	
	<xsl:choose>
		<xsl:when test="$EventCode = '0'"><xsl:text>Mains Input Voltage Abnormal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '1'"><xsl:text>Mains Input Frequency Abnormal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '2'"><xsl:text>Mains Input Phase Sequence Abnormal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '3'"><xsl:text>Mains Input Over Current</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '4'"><xsl:text>Mains Input Current Unbalance</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '5'"><xsl:text>Rectifier (PFC) Over Temperature Warning</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '6'"><xsl:text>Rectifier (PFC) Over Temperature Shutdown</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '7'"><xsl:text>Rectifier Static Switch Fail</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '8'"><xsl:text>DC Bus Over Voltage</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '9'"><xsl:text>Battery Cabinet or Ambient Over Temperature</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '10'"><xsl:text>Battery Ground Fault</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '11'"><xsl:text>Battery Test OK</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '12'"><xsl:text>Battery Test Fail</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '13'"><xsl:text>Battery Over Charge</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '14'"><xsl:text>Battery Low Warning</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '15'"><xsl:text></xsl:text>Battery Low Shutdown</xsl:when>
		
		<xsl:when test="$EventCode = '16'"><xsl:text>Battery Replacement</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '17'"><xsl:text>Inverter Over Temperature Warning</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '18'"><xsl:text>Inverter Over Temperature Shutdown</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '19'"><xsl:text>Inverter Input Voltage Abnormal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '20'"><xsl:text>Inverter Voltage Abnormal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '21'"><xsl:text>Inverter Frequency Abnormal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '22'"><xsl:text>Inverter Overload warning</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '23'"><xsl:text>Inverter Overload Shutdown</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '24'"><xsl:text>Inverter Short Circuit</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '25'"><xsl:text>Inverter Fuse Fail (open)</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '26'"><xsl:text>Inverter fail</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '27'"><xsl:text>Bypass Voltage Abnormal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '28'"><xsl:text>Bypass Frequency Abnormal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '29'"><xsl:text>Bypass Phase Sequence Abnormal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '30'"><xsl:text>Bypass Static Switch Over Temperature</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '31'"><xsl:text>Bypass Static Switch Overload</xsl:text></xsl:when>
		
		<xsl:when test="$EventCode = '32'"><xsl:text>Bypass Static Switch Fail</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '33'"><xsl:text>EPO On</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '34'"><xsl:text>Inner Communication Abnormal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '35'"><xsl:text>Parallel Communication Abnormal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '36'"><xsl:text>Parallel Fail</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '37'"><xsl:text>Manual Bypass On</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '38'"><xsl:text>Output Transformer Over Temperature Shutdown</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '39'"><xsl:text>Input Transformer Over Temperature</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '40'"><xsl:text>Mains Input Voltage Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '41'"><xsl:text>Mains Input Frequency Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '42'"><xsl:text>Mains Input Phase Sequence Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '43'"><xsl:text>Mains Input Over Current Recovery</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '44'"><xsl:text>Mains Input Current Unbalance Recovery</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '45'"><xsl:text>Rectifier (PFC) Temperature Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '47'"><xsl:text>Rectifier Static Switch Normal</xsl:text></xsl:when>
		
		<xsl:when test="$EventCode = '48'"><xsl:text>DC Bus Voltage Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '49'"><xsl:text>Battery Cabinet Temperature Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '50'"><xsl:text>Battery Ground Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '53'"><xsl:text>Battery Charger Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '54'"><xsl:text>Battery Voltage Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '56'"><xsl:text>Battery Fully Charged</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '57'"><xsl:text>Inverter Temperature Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '59'"><xsl:text>Inverter Input Voltage Normal (DC bus?)</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '60'"><xsl:text>Inverter Voltage Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '61'"><xsl:text>Inverter Frequency Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '62'"><xsl:text>Inverter Load Normal</xsl:text></xsl:when>
		
		<xsl:when test="$EventCode = '64'"><xsl:text>Inverter Circuit Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '65'"><xsl:text>Inverter Fuse Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '66'"><xsl:text>Inverter OK</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '67'"><xsl:text>Bypass Voltage Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '68'"><xsl:text>Bypass Frequency Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '69'"><xsl:text>Bypass Phase Sequence Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '70'"><xsl:text>Bypass Static Switch Temperature Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '71'"><xsl:text>Bypass Static Switch Load Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '72'"><xsl:text>Bypass Static Switch OK</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '73'"><xsl:text>EPO Off</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '74'"><xsl:text>Inner Communication Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '75'"><xsl:text>Parallel Communication Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '76'"><xsl:text>Parallel OK</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '77'"><xsl:text>Manual Bypass Off</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '78'"><xsl:text>Output Transformer Temperature Normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '79'"><xsl:text>Input Transformer Temperature Normal</xsl:text></xsl:when>
		
		<xsl:when test="$EventCode = '80'"><xsl:text>Battery Test In Progress</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '81'"><xsl:text>PFC circuit fault shutdown</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '82'"><xsl:text>Inverter circuit fault shutdown</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '83'"><xsl:text>PFC soft start fault shutdown</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '84'"><xsl:text>Inverter soft start fault shutdown</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '85'"><xsl:text>PFC fuse open</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '86'"><xsl:text>Inverter static switch failure</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '87'"><xsl:text>DC bus over voltage warning</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '88'"><xsl:text>DC bus over voltage shutdown</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '89'"><xsl:text>DC bus normal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '90'"><xsl:text>DC bus under voltage warning</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '91'"><xsl:text>DC bus under voltage shutdown</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '92'"><xsl:text>Output voltage abnormal shutdown</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '93'"><xsl:text>Power module Fan failure</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '94'"><xsl:text>System Fan failure</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '95'"><xsl:text>Power module Charger fail</xsl:text></xsl:when>
		
		<xsl:when test="$EventCode = '96'"><xsl:text>System Charger fail</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '97'"><xsl:text>Aux Power fail</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '98'"><xsl:text>System to System Not Compatible</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '99'"><xsl:text>System to Module Not Compatible</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '100'"><xsl:text>Module to Module Not Compatible</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '101'"><xsl:text>PFC/INV  Not Compatible</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '102'"><xsl:text>PFC EEPROM error</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '103'"><xsl:text>INV EEPROM error</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '104'"><xsl:text>PFC EEPROM not calibrated</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '105'"><xsl:text>INV EEPROM not calibrated</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '106'"><xsl:text>INV fuse open</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '107'"><xsl:text>Battery bad</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '108'"><xsl:text>INV over current</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '109'"><xsl:text>System Parallel ID conflict</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '110'"><xsl:text>Redundancy loss</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '111'"><xsl:text>Output breaker off</xsl:text></xsl:when>
		
		<xsl:when test="$EventCode = '112'"><xsl:text>Bypass load over 104%</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '113'"><xsl:text>PM ID fail</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '114'"><xsl:text>IP TR overheat</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '115'"><xsl:text>OP TR overheat</xsl:text></xsl:when>
		
		<xsl:when test="$EventCode = '128'"><xsl:text>Inverter Status: Inhibit UPS Output</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '129'"><xsl:text>Load on Bypass</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '130'"><xsl:text>Load On Inverter</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '131'"><xsl:text>Backup Mode</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '132'"><xsl:text>Remote Shutdown</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '133'"><xsl:text>Inverter Status: SSOP Due to V-RMS</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '134'"><xsl:text>Inverter Status: Feedback Loss</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '135'"><xsl:text>Inverter Status: DV/DT Abnormal</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '136'"><xsl:text>Inverter Status: SDA Command</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '137'"><xsl:text>Inverter Status: Bus OVP Happen</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '138'"><xsl:text>Inverter Status: R-Inverter Fuse Open</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '139'"><xsl:text>Inverter Status: S-Inverter Fuse Open</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '140'"><xsl:text>Inverter Status: T-Inverter Fuse Open</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '141'"><xsl:text>Inverter Status: R-Inverter High Temperature</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '142'"><xsl:text>Inverter Status: S-Inverter High Temperature</xsl:text></xsl:when>
		<xsl:when test="$EventCode = '143'"><xsl:text>Inverter Status: T-Inverter High Temperature</xsl:text></xsl:when>

		<xsl:when test="$EventCode = '144'"><xsl:text>ECO mode</xsl:text></xsl:when>
		
		<xsl:otherwise><xsl:text>Unknown</xsl:text></xsl:otherwise>
	</xsl:choose>
</xsl:template>

<!-- EOS -->
</xsl:stylesheet>
