/*
  ip_panel.js - IP - Master Control and IP - Control screen.
  Copyright(c) 2020, Generex GmbH.All rights reserved.
  Said.
*/

var ip_api = (function ($) {

  var oid = get_oid_from_url(),
    cb = null,
    valtable_obj,
    report_obj, unms_obj,
    pannes_created = false,
    check_bowser = true,
    err_div = null,
    css_obj,
    req_params = null,
    x_pos = 10,
    y_pos = 10,
    bg_height = 500,
    bg_width = 870;

  function err_funct(response) {
    jqmodule.refresh(cb, 10 * 1000);
    panes_api.display_err({ response: response, oid: oid, err_div: err_div, err_msg_div_id: 'error_msg_div' });
  }

  return {
    init: init
  }

  function init() {
    if (check_bowser && !utils_api.check_bowser()) {
      $('#loading_id').css('display', 'none');
      panes_api.create_br_check_panel(this, browser_check_ok);
      return true;
    }
    create_err_msg_panel();

    req_params = utils_api.get_req_params(utils_api.device_ups, oid);
    cb = jqmodule.subscribe(this, { update: update, error: err_funct }, req_params);
  }

  function browser_check_ok() {
    check_bowser = false;
    init();
  }

  function create_err_msg_panel() {
    css_obj = { position: 'absolute', top: 30, left: 40, width: 790, display: 'none', 'z-index': 10 };
    err_div = panes_api.create_err_panel({ id: 'error_div', 'class': 'alert alert-danger' }, css_obj);
  }

  function err_funct(response) {
    jqmodule.refresh(cb, 10 * 1000);
    panes_api.display_err({ response: response, oid: oid, err_div: err_div, err_msg_div_id: 'error_msg_div' });
  }

  function update(data) {
    if (data.ups == null) {
      return;
    }

    if (err_div)
      err_div.css('display', 'none');

    valtable_obj = data.ups.valtable;
    report_obj = data.report;
    jqmodule.refresh(cb, report_obj.refresh * 1000);
    if (window.menu_api != null)
      menu_api.update(data);

    unms_obj = get_unms_obj(data);
    if (unms_obj != null) {
      info_head_api.update(unms_obj);
    }

    utils_api.setTitle(valtable_obj._platform);

    if (!pannes_created) {
      pannes_created = true;
      create_pannes(); //create screen.
      return;
    }
    set_footer();
  }

  function create_pannes() //create screen.
  {
    utils_api.setTitle(valtable_obj._platform);
    create_bg(); //background;
    create_model_panes()
    create_footer_pane();
  }

  //panels

  function create_bg() {
    var fragment = document.createDocumentFragment(),
      div, div_txt;

    css_obj = {
      position: 'absolute',
      'text-align': 'center',
      top: y_pos,
      left: x_pos,
      width: bg_width,
      height: bg_height,
      border: 'solid 1px #808080',
      'text-align': 'center',
      'align': 'center',
      'z-index': 12,
      "font-size": "18px"
    };
    div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    div_txt = $('<div/>', { 'class': 'img-rounded' }).css({
      position: 'relative',
      'text-align': 'center',
      top: y_pos + bg_height / 2
    }).append('No display available').appendTo(div);
    fragment.appendChild(div[0]);
    document.body.appendChild(fragment);
  }

  function create_model_panes() {
    var model_div, a;
    css_obj = { position: 'absolute', top: y_pos, left: x_pos, align: 'center', width: bg_width, 'z-index': 10 };
    attr_obj = { id: 'model_div_id', 'class': 'list-group' };
    model_div = panes_api.create_div(attr_obj, css_obj);
    a = $('<a/>', { 'class': 'list-group-item active', id: 'model_name_id' }).append(valtable_obj.MODEL).appendTo(model_div);
  }

  function create_footer_pane() {
    if (!oid || !unms_obj)
      return true;
    footer_api.create({ //Attr
        id: 'panel2'
      }, { //css
        position: 'absolute',
        top: '530px',
        left: '120px'
      },
      unms_obj
    );
  }

  function set_footer() {
    if (!oid || !unms_obj)
      return true;
    footer_api.set(unms_obj);
  }
}(jQuery));