/*
   menu_panel.js - screen utils.
   Copyright (c) 2012, Generex GmbH. All rights reserved.
   Said.
*/

var menu_api = (function ($) {
  var menu_div = null,
    menu_table = null,

    funct_win = null,
    t
  log_win = null,
    scheduler_win = null,
    datachart_win = null,
    config_win = null,
    abler2_win = null,
    cyber5_win = null,

    cb = null,
    pannes_created = false,
    ups_protocol = 0,
    CYBER5_hex = 0x80D9,
    CYBER5_dec = 32985,
    prexxanto_prot_id = 0x8107,
    prexzinto_prot_id = 0x8108,
    prabler2_prot_id = 0x8096,
    css_obj = {},
    valtable_obj = {};

  /*public functions*/
  return {
    update: update,
    create_dialog: create_dialog
  };

  function update(data) {
    valtable_obj = data.ups.valtable;

    if (!pannes_created) {
      if (valtable_obj._upsProtocol == null) {
        ups_protocol = valtable_obj.CONNECT;
        ups_protocol = (ups_protocol & 65535);
      } else
        ups_protocol = valtable_obj._upsProtocol;

      pannes_created = true;
      utils_api.setTitle(valtable_obj._platform);
      create_pannes(); //create menu screen.
      return false;
    }

    set_upsman_server_panel(); //set upsman server panel

    if (ups_protocol != prexxanto_prot_id || ups_protocol != prexzinto_prot_id) {
      panes_api.set_rom_temp_values(valtable_obj); //set rom temp values
    }

  }

  function create_pannes() //create menu screen
  {
    var fragment = document.createDocumentFragment();
    $(document.body).css('background', 'rgb(241,241,241)');
    css_obj = {
      position: 'absolute',
      top: 0,
      left: 10,
      width: 290
    };
    menu_div = $('<div/>').attr({
      id: 'menu_div_id'
    }).css(css_obj);

    menu_table = $('<table />', {
      'class': 'table table-condensed',
      width: '100%',
      align: 'center'
    }).appendTo(menu_div);

    menu_table.appendTo(menu_div);
    tbody = $('<tbody />').appendTo(menu_table);

    create_upsman_server_panel(tbody); //create upsman server panel

    create_ups_func_panel(tbody) //create ups functions panel

    if (ups_protocol != prexxanto_prot_id || ups_protocol != prexzinto_prot_id) {
      create_rom_temp(tbody); //rom temp
    }

    fragment.appendChild(menu_div[0]);
    document.body.appendChild(fragment);
  }

  function create_upsman_server_panel(tbody) //create upsman server panel
  {
    var tr, td, button;
    tr = $('<tr />').appendTo(tbody);
    td = $('<td />', {
      'id': 'id_img_logo',
      colspan: 2,
      'align': 'center'
    }).
    append('<img class="img-polaroid" border="0" alt="Logo" width="200" height= "54" src="../img/logo.gif">').appendTo(tr);
    td.css({
      'padding-top': '20px'
    });

    $('<hr />').appendTo($('<td/>', {
      colspan: 2
    }).appendTo($('<tr/>').appendTo(tbody)));

    tr = $('<tr />').appendTo(tbody);
    td = $('<td />', {
      align: 'left'
    }).appendTo(tr);

    button = $('<button />', {
      'class': 'btn btn-default btn-sm',
      type: 'button',
      text: 'Server',
      title: 'Select UPSMAN Server'
    }).appendTo(td);
    button.click(function (event) {
      create_dialog();
      event.preventDefault();
    });
    td = $('<td />', {
      'id': 'server_name_id',
      align: 'left'
    }).append(parent.document.location.hostname).appendTo(tr);

    tr = $('<tr />').appendTo(tbody);
    td = $('<td />', {
      align: 'left'
    }).append('Location').appendTo(tr);
    if (valtable_obj.LOCATION == "")
      td = $('<td />', {
        id: 'ups_location_id',
        title: 'Unknown',
        align: 'left'
      }).append('Unknown').appendTo(tr);
    else
      td = $('<td />', {
        id: 'ups_location_id',
        title: valtable_obj.LOCATION,
        align: 'left'
      }).append(valtable_obj.LOCATION).appendTo(tr);

    $('<hr />').appendTo($('<td/>', {
      colspan: 2
    }).appendTo($('<tr/>').appendTo(tbody)));
  }

  function set_upsman_server_panel() //set upsman server panel
  {
    $('#server_name_id').text(window.location.hostname);
    if (valtable_obj.LOCATION == "")
      $('#ups_location_id').html('Unknown');
    else
      $('#ups_location_id').html(valtable_obj.LOCATION);
  }

  function set_upsman_server(select_upsman_server) {
    var server_name_txt = $('#server_txt_id');
    var server_name = server_name_txt.val();
    server_name = $.trim(server_name);
    var id = $('#server_div_id input:radio:checked').attr('id');

    if ($('#server_local_id').attr('checked')) {
      parent.document.location.hostname = 'localhost';
      return false;
    }
    if (server_name.length == 0) {
      $('#server_dialog_div_id').dialog('open');
      return false;
    }
    parent.document.location.hostname = server_name;
  }

  function create_rom_temp(tbody) //rom temp
  {
    var table, tr, td;
    tr = $('<tr />').appendTo(tbody);
    td = $('<td />', {
      colspan: 2,
      align: 'left'
    }).appendTo(tr);

    table = panes_api.create_rom_temp_pane(valtable_obj, {
      id: 'rom_temp_table_id',
      'class': 'table table-condensed',
      width: '100%'
    });
    table.css('background', 'rgb(241,241,241)');
    table.appendTo(td);
  }

  function create_ups_func_panel(tbody) //create ups functions panel
  {
    var tr, td, button;
    //DataLog Chart button
    tr = $('<tr />').appendTo(tbody);
    td = $('<td />', {
      align: 'left'
    }).appendTo(tr);
    button = $('<button />', {
      'class': 'btn btn-default btn-sm',
      type: 'button',
      text: 'DataLog Chart',
      title: 'UPSMAN DataLog Chart'
    }).appendTo(td);
    button.click(function (event) {
      datachart_win = utils_api.openSiteWin(920, 720, "DataLog Chart", datachart_win, "script/lib/ups/datalogchart.html?ups_view=" +
        $('#id_ups_view_iframe', parent.document).attr('name'));
      event.preventDefault();
    });

    //Logfile button
    td = $('<td />', {
      align: 'left'
    }).appendTo(tr);
    button = $('<button />', {
      'class': 'btn btn-default btn-sm',
      type: 'button',
      text: 'Log file',
      title: 'UPSMAN Log Files'
    }).appendTo(td);
    button.click(function (event) {
      log_win = utils_api.openSiteWin(300, 135, "UPS Log Files", log_win, "logfile.html?ups_view=" +
        $('#id_ups_view_iframe', parent.document).attr('name'));
      event.preventDefault();
    });

    //functions button
    tr = $('<tr />').appendTo(tbody);
    td = $('<td />', {
      align: 'left'
    }).appendTo(tr);
    if (valtable_obj._oemViewName != 'atsgpser') {
      button = $('<button />', {
        'class': 'btn btn-default btn-sm',
        type: 'button',
        text: 'Functions',
        title: 'UPS Functions'
      }).appendTo(td);

      button.click(function (event) {
        if (valtable_obj._oemViewName == "prtof48" || valtable_obj._oemViewName == "prtof12" || valtable_obj._oemViewName == "prtof96")
          funct_win = utils_api.openCmdWin(400, 400, "UPS Test Functions", funct_win, "-logon aeg_prtof_test no pw 3");
        else if (valtable_obj._oemViewName == "atser36" || valtable_obj._oemViewName == "atser96" || valtable_obj._oemViewName == "atser240")
          funct_win = utils_api.openCmdWin(706, 600, "UPS Test Functions", funct_win, "-logon aeg_atser_test no pw 3");
        else if (valtable_obj._oemViewName == "prt31" || valtable_obj._oemViewName == "prt33")
          funct_win = utils_api.openCmdWin(706, 534, "UPS Test Functions", funct_win, "-logon aeg_cbsr_test no pw 3");
        else if (valtable_obj._oemViewName == "aeser240")
          funct_win = utils_api.openCmdWin(406, 434, "UPS Test Functions", funct_win, "-logon aeg_aeser_test no pw 3");
        else if (valtable_obj._oemViewName == "griser240")
          funct_win = utils_api.openCmdWin(406, 434, "UPS Test Functions", funct_win, "-logon aeg_gripow_test no pw 3");
        else if (valtable_obj._oemViewName == "protd")
          funct_win = utils_api.openCmdWin(706, 534, "UPS Test Functions", funct_win, "-logon aeg_protd_test no pw 3");

        else if (valtable_obj._oemViewName == "protc")
          funct_win = utils_api.openCmdWin(420, 534, "UPS Test Functions", funct_win, "-logon aeg_protc_test no pw 3");

        else if (valtable_obj._oemViewName == "mdelta")
          funct_win = utils_api.openCmdWin(416, 420, "UPS Test Functions", funct_win, "-logon aeg_mdelta_test no pw 3");
        else if (valtable_obj._oemViewName == "geml" || valtable_obj._oemViewName == "gematch" || valtable_obj._oemViewName == "vh" ||
          valtable_obj._oemViewName == "delta" || valtable_obj._oemViewName == "cp4" || ups_protocol == prabler2_prot_id) {
          funct_win = utils_api.openCmdWin(500, 270, "UPS Test Functions", funct_win, "-logon getUPSTest_data no pw 3");
        } else if (valtable_obj._oemViewName == 'xonl')
          funct_win = utils_api.openCmdWin(700, 700, "UPS Test Functions", funct_win, "-logon online_xonl_test_func no pw 3");
        else if (valtable_obj._oemViewName == 'xonlag')
          funct_win = utils_api.openCmdWin(700, 700, "UPS Test Functions", funct_win, "-logon xonlag_func no pw 3");
        else if (valtable_obj._oemViewName == 'zintoe')
          funct_win = utils_api.openCmdWin(840, 800, "UPS Test Functions", funct_win, "-logon online_zintoe_test_func no pw 3");

        else if (valtable_obj._oemViewName == 'sts')
          funct_win = utils_api.openCmdWin(380, 380, "STS Functions", funct_win, "-logon sts_func no pw 3");
        else if (valtable_obj._oemViewName == 'protblcd')
          funct_win = utils_api.openCmdWin(380, 480, "UPS Test Functions", funct_win, "-logon protblcd_func no pw 3");
        else if (valtable_obj._oemViewName == 'protalcd')
          funct_win = utils_api.openCmdWin(380, 230, "UPS Test Functions", funct_win, "-logon protalcd_func no pw 3");
        else if (valtable_obj._oemViewName == 'xanto')
          funct_win = utils_api.openCmdWin(980, 810, "UPS Test Functions", funct_win, "-logon xanto_func no pw 3");
        else if (valtable_obj._oemViewName == 'zinto')
          funct_win = utils_api.openCmdWin(950, 570, "UPS Test Functions", funct_win, "-logon zinto_func no pw 3");
        else if (valtable_obj._oemViewName == 'xanto6')
          funct_win = utils_api.openCmdWin(980, 700, "UPS Test Functions", funct_win, "-logon xanto6_func no pw 3");
        else if (valtable_obj._oemViewName == 'zinto6')
          funct_win = utils_api.openCmdWin(980, 810, "UPS Test Functions", funct_win, "-logon zinto6_func no pw 3");
        else if (valtable_obj._oemViewName == 'xanto10')
          funct_win = utils_api.openCmdWin(980, 810, "UPS Test Functions", funct_win, "-logon xanto10_func no pw 3");
        else if (valtable_obj._oemViewName == 'nano')
          funct_win = utils_api.openCmdWin(520, 240, "UPS Test Functions", funct_win, "-logon nano_func no pw 3");
        else if (valtable_obj._oemViewName == 'dkmt')
          funct_win = utils_api.openCmdWin(500, 420, "UPS Test Functions", funct_win, "-logon dkmt_func no pw 3");
        else if (valtable_obj._oemViewName == 'twinsourcedcci')
          funct_win = utils_api.openCmdWin(500, 420, "STS Test Functions", funct_win, "-logon twinsourcedcci_func no pw 3");
        else if (valtable_obj._oemViewName == 'twinsourcedccii-dcciii')
          funct_win = utils_api.openCmdWin(500, 420, "STS Test Functions", funct_win, "-logon twinsourcedccii-dcciii_func no pw 3");
        else
          funct_win = utils_api.openCmdWin(460, 400, "UPS Test Functions", funct_win, "-logon def_test no pw 3");
        event.preventDefault();
      });
    }

    //lang_Scheduler button
    td = $('<td />', {
      align: 'left'
    }).appendTo(tr);
    button = $('<button />', {
      'class': 'btn btn-default btn-sm',
      type: 'button',
      text: 'Scheduler',
      title: 'UPSMAN Scheduler'
    }).appendTo(td);
    button.click(function (event) {
      scheduler_win = utils_api.openCmdWin(570, 420, "UPS Scheduler", scheduler_win, '-logon copy_appointment no pw');
      event.preventDefault();
    });

    tr = $('<tr />');
    if (valtable_obj._OS != "WINDOWS") {
      td = $('<td />', {
        align: 'left'
      }).appendTo(tr);
      button = $('<button />', {
        'class': 'btn btn-default btn-sm',
        type: 'button',
        text: 'UPSMAN Configuration',
        title: 'UPSMAN Configuration'
      }).appendTo(td);
      button.click(function (event) {
        config_win = utils_api.openSiteWin(660, 720, "UPSMAN Configuration", config_win, "upscfg/upscfg.html");
        event.preventDefault();
      });
      if (valtable_obj._oemViewName != "abler2" && (ups_protocol != CYBER5_hex || ups_protocol != CYBER5_dec))
        td.attr('colspan', 2);
    }

    if (ups_protocol == prabler2_prot_id) {
      td = $('<td />', {
        align: 'left'
      }).appendTo(tr);
      button = $('<button />', {
        'class': 'btn btn-default btn-sm',
        type: 'button',
        text: 'Ext. Cmds',
        title: 'Extended Commands'
      }).appendTo(td);
      button.click(function (event) {
        abler2_win = utils_api.openCmdWin(580, 580, 'Extended Commands', abler2_win, '-logon ext_ups_cmds no pw');
        event.preventDefault();
      });
      if (valtable_obj._oemViewName == "WINDOWS")
        td.attr('colspan', 2);
    }

    if (ups_protocol == CYBER5_hex || ups_protocol == CYBER5_dec) {

      td = $('<td />', {
        align: 'left'
      }).appendTo(tr);
      button = $('<button />', {
        'class': 'btn btn-default btn-sm',
        type: 'button',
        text: 'UPS Configuration',
        title: 'UPS Configuration'
      }).appendTo(td);
      button.click(function (event) {
        cyber5_win = utils_api.openCmdWin(580, 580, 'UPS Configuration', cyber5_win, '-logon cyber5_ups_config no pw');
        event.preventDefault();
      });
      if (valtable_obj._oemViewName == "WINDOWS")
        td.attr('colspan', 2);
    }

    //if(valtable_obj._oemViewName == "abler2" || valtable_obj._OS != "WINDOWS" || ups_protocol == CYBER5_hex || ups_protocol == CYBER5_dec)
    //tr.appendTo(tbody);
    if (tr.length > 0)
      tr.appendTo(tbody);
    $('<hr />').appendTo($('<td/>', {
      colspan: 2
    }).appendTo($('<tr/>').appendTo(tbody)));
  }

  function create_dialog() {
    $('#server_dialog_div_id').css('visibility', 'visible');
    $('#server_dialog_div_id').dialog({
      autoOpen: true,
      width: 290,
      modal: true,
      closeOnEscape: false,
      buttons: {
        Connect: function () {
          $(this).dialog('close');
          if (set_upsman_server != null)
            set_upsman_server();
          return true;
        },
        Cancel: function () {
          $(this).dialog('close');
        }
      },
      overlay: {
        opacity: 0.5
      },
      show: "blind"
    });
    $("span.ui-dialog-title").css({
      "color": "white"
    });
    $('.ui-dialog-buttonpane').children('button').removeClass().addClass('bnt');
  }
}(jQuery));