<?xml version="1.0"?>
<!--
   modajs2_panel.xsl - UPS screen for Piller APOJET models @UNMS-II.
   Copyright (c) 2005, Generex GmbH. All rights reserved.
   klaus
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!-- Methods -->
  <!--Header-->
  <xsl:template name="modajs2_panel-header">
    <xsl:call-template name="app-header">
      <xsl:with-param name="top" select="10"/>
      <xsl:with-param name="left" select="20"/>
    </xsl:call-template>
  </xsl:template>

  <!--Footer-->
  <xsl:template name="modajs2_panel-footer" >
    <xsl:call-template name="app-footer" >
      <xsl:with-param name="top" select="520"/>
      <xsl:with-param name="left" select="10"/>
      <xsl:with-param name="width" select="786"/>
      <xsl:with-param name="height" select="70"/>
    </xsl:call-template>
  </xsl:template>
  <!--Menu-->
  <xsl:template name="modajs2_panel-menu">
    <xsl:call-template name="app-menu">
      <xsl:with-param name="top" select="428"/>
      <xsl:with-param name="left" select="0"/>
      <xsl:with-param name="width" select="0"/>
      <xsl:with-param name="height" select="0"/>
      <xsl:with-param name="class" select="'XBold_black'"/>
    </xsl:call-template>
  </xsl:template>

  <!--Body-->
  <xsl:template name="modajs2_panel-body">
    <div id="master" style="position:absolute; top:10px;left:10px;">
      <xsl:call-template name="background">
        <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/ajs_II.png'"/>
        <xsl:with-param name="x" select="'0'"/>
        <xsl:with-param name="y" select="'0'"/>
        <xsl:with-param name="w" select="'785'"/>
        <xsl:with-param name="h" select="'488'"/>
        <xsl:with-param name="border" select="'0'"/>
        <xsl:with-param name="id" select="'background'"/>
      </xsl:call-template>
      <div style="position: absolute; left:377px; top:375px; width:31px; height:22px; z-index:1;">
        <a href="javascript:onChangeSelectionUp()">
          <img border="0" alt="" src="./lib/ups/image/piller/selectUpAJR2.gif" width="31" height="22"/>
        </a>
      </div>
      <div style="position: absolute; left:443px; top:375px; width:31; height:22px; z-index:1;">
        <a href="javascript:onChangeSelectionDown()">
          <img border="0" alt="" src="./lib/ups/image/piller/selectDownAJR2.gif" width="31" height="22"/>
        </a>
      </div>
      <xsl:apply-templates />
    </div>
    <script type="text/javascript">
      init();
    </script>
    <xsl:call-template name="js_refresh_call">
      <xsl:with-param	 name="timeout" select="1000*//report/@refresh"/>
    </xsl:call-template>
  </xsl:template>
  <!-- Implementation -->
  <xsl:template match="values">
    <!-- LOCATION -->
    <div class="XLargeBold" align="right" style="position: absolute; left: 0px; top: 30px; width: 785px;  font-size:24px; text-align:center; ">
      <xsl:value-of select="value[@name='LOCATION']/@val" />
    </div>
    <!-- MODEL -->
    <div class="LargeBold" align="right" style="position: absolute; left: 252px; top: 300px; width: 200px; height: 17px; text-align:center; ">
      <xsl:value-of select="value[@name='MODEL']/@val" />
    </div>
    <!-- UPS HISTORY-->
    <xsl:if test="string-length(//service/@type) !=0 and //service/@type != 'upsman' and //service/@type != 'snmpups' and //service/@type != 'maildev' and //service/@type != 'CS141'">
      <xsl:call-template name="on-mouse-over"/>
      <div class="MediumBold" align="right" style="position: absolute; left: 302px; top: 440px; width: 100px; height: 32px; text-align:center;  ">
        <a class="MediumBoldLink" href="nmsView.dll?navigate&amp;url=http://{//host/@address}/mbevents.cgi" border="0"  target="_blank" onmouseover="changeImage('hist', './lib/img/button_white_over.gif')" onmouseout="restoreImage('hist')">
          <img id="hist" src="./lib/img/button_white.gif" width="100" height="32" border="0"/>
        </a>
      </div>
      <div class="MediumBold" align="right" style="position: absolute; left: 302px; top: 447px; width: 100px; height: 17px; text-align:center;  ">
        <a id="evt_rec" class="MediumBold" href="nmsView.dll?navigate&amp;url=http://{//host/@address}/mbevents.cgi" style="text-decoration:none"  target="_blank"  onmouseover="changeImage('hist', './lib/img/button_white_over.gif')" onmouseout="restoreImage('hist')">
         <script type="text/javascript"> translate_text('evt_rec', 'Eventrecorder');</script>
       </a>
      </div>
    </xsl:if>
    <xsl:variable name="adr154">
      <xsl:call-template name="getfixedbitstring">
        <xsl:with-param name="val" select="value[@name='ADR154']/@val"/>
        <xsl:with-param name="dir" select="-1"/>
        <xsl:with-param name="places" select="16"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="adr155">
      <xsl:call-template name="getfixedbitstring">
        <xsl:with-param name="val" select="value[@name='ADR155']/@val"/>
        <xsl:with-param name="dir" select="-1"/>
        <xsl:with-param name="places" select="16"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="adr156">
      <xsl:call-template name="getfixedbitstring">
        <xsl:with-param name="val" select="value[@name='ADR156']/@val"/>
        <xsl:with-param name="dir" select="-1"/>
        <xsl:with-param name="places" select="16"/>
      </xsl:call-template>
    </xsl:variable>

    <xsl:variable name="datetime" select="//report/@time"/>
    <xsl:variable name="date" select="concat('', substring-before($datetime, ' '))"/>
    <xsl:variable name="time" select="concat('', substring-after($datetime, ' '))"/>

    <!-- Line LEDs-->
    <xsl:variable name="leddim" select="14"/>
    <xsl:variable name="leddelta" select="5"/>
    <xsl:variable name="led-x" select="531"/>
    <xsl:variable name="led-y" select="106"/>
    <xsl:variable name="led-y-offset" select="53"/>
    <!-- MAINS -->
    <xsl:call-template name="modbuslednew">
      <xsl:with-param name="x" select="$led-x "/>
      <xsl:with-param name="y" select="$led-y"/>
      <xsl:with-param name="w" select="$leddim"/>
      <xsl:with-param name="h" select="$leddim"/>
      <xsl:with-param name="dw" select="$leddelta"/>
      <xsl:with-param name="dh" select="$leddelta"/>
      <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/'" />
      <xsl:with-param name="adrs" select="$adr154"/>
      <xsl:with-param name="high" select="0"/>
    </xsl:call-template>
    <!-- MOTOR -->
    <xsl:call-template name="modbuslednew">
      <xsl:with-param name="x" select="$led-x"/>
      <xsl:with-param name="y" select="$led-y + $led-y-offset"/>
      <xsl:with-param name="w" select="$leddim"/>
      <xsl:with-param name="h" select="$leddim"/>
      <xsl:with-param name="dw" select="$leddelta"/>
      <xsl:with-param name="dh" select="$leddelta"/>
      <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/'" />
      <xsl:with-param name="adrs" select="$adr154"/>
      <xsl:with-param name="high" select="1"/>
    </xsl:call-template>
    <!-- GENERATOR -->
    <xsl:call-template name="modbuslednew">
      <xsl:with-param name="x" select="$led-x"/>
      <xsl:with-param name="y" select="$led-y + 2*$led-y-offset"/>
      <xsl:with-param name="w" select="$leddim"/>
      <xsl:with-param name="h" select="$leddim"/>
      <xsl:with-param name="dw" select="$leddelta"/>
      <xsl:with-param name="dh" select="$leddelta"/>
      <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/'" />
      <xsl:with-param name="adrs" select="$adr155"/>
      <xsl:with-param name="high" select="0"/>
    </xsl:call-template>
    <!-- OUTPUT -->
    <xsl:call-template name="modbuslednew">
      <xsl:with-param name="x" select="$led-x"/>
      <xsl:with-param name="y" select="$led-y + 3* $led-y-offset"/>
      <xsl:with-param name="w" select="$leddim"/>
      <xsl:with-param name="h" select="$leddim"/>
      <xsl:with-param name="dw" select="$leddelta"/>
      <xsl:with-param name="dh" select="$leddelta"/>
      <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/'" />
      <xsl:with-param name="adrs" select="$adr155"/>
      <xsl:with-param name="high" select="1"/>
    </xsl:call-template>
    <!--WARNING -->
    <xsl:call-template name="modbuslednew">
      <xsl:with-param name="x" select="$led-x - 1"/>
      <xsl:with-param name="y" select="$led-y + 4*$led-y-offset"/>
      <xsl:with-param name="w" select="$leddim"/>
      <xsl:with-param name="h" select="$leddim"/>
      <xsl:with-param name="dw" select="$leddelta"/>
      <xsl:with-param name="dh" select="$leddelta"/>
      <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/'" />
      <xsl:with-param name="adrs" select="$adr156"/>
      <xsl:with-param name="high" select="0"/>
    </xsl:call-template>

    <xsl:variable name="switch" 	select="value[@name='ADR8F']/@val"/>

    <xsl:variable name="volt1mains1">
      <xsl:value-of select="value[@name='INVOLT']/@val"/>
    </xsl:variable>
    <xsl:variable name="volt2mains1">
      <xsl:value-of select="value[@name='INVOLT']/@val2"/>
    </xsl:variable>
    <xsl:variable name="volt3mains1">
      <xsl:value-of select="value[@name='INVOLT']/@val3"/>
    </xsl:variable>

    <xsl:variable name="volt1out">
      <xsl:value-of select="value[@name='ADR76']/@val"/>
    </xsl:variable>
    <xsl:variable name="volt2out">
      <xsl:value-of select="value[@name='ADR77']/@val"/>
    </xsl:variable>
    <xsl:variable name="volt3out">
      <xsl:value-of select="value[@name='ADR78']/@val"/>
    </xsl:variable>

    <xsl:variable name="volt1out2">
      <xsl:value-of select="value[@name='ADR7F']/@val"/>
    </xsl:variable>
    <xsl:variable name="volt2out2">
      <xsl:value-of select="value[@name='ADR80']/@val"/>
    </xsl:variable>
    <xsl:variable name="volt3out2">
      <xsl:value-of select="value[@name='ADR81']/@val"/>
    </xsl:variable>


    <xsl:variable name="volt1inverter">
      <xsl:value-of select="value[@name='ADR6E']/@val"/>
    </xsl:variable>
    <xsl:variable name="volt2inverter">
      <xsl:value-of select="value[@name='ADR6F']/@val"/>
    </xsl:variable>
    <xsl:variable name="volt3inverter">
      <xsl:value-of select="value[@name='ADR70']/@val"/>
    </xsl:variable>
    <xsl:variable name="pageX1"   select="242"/>
    <xsl:variable name="pageX2"   select="292"/>
    <xsl:variable name="pageX3"   select="382"/>
    <xsl:variable name="pageY"    select="187"/>
    <xsl:variable name="lineheight"   select="18"/>
    <xsl:variable name="columnwidth"    select="78"/>

    <!-- MAINS1_AT -->
    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="$columnwidth"/>
      <xsl:with-param name="h" select="$lineheight"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'IN1:'" />
      <xsl:with-param name="text2"  select="'L1:'" />
      <xsl:with-param name="text3" select="'L2:'" />
      <xsl:with-param name="text4" select="'L3:'" />
      <xsl:with-param name="visibility" select="'visible'"/>
      <xsl:with-param name="name" select="'page0'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX2"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="$columnwidth+15"/>
      <xsl:with-param name="h" select="$lineheight"/>
      <xsl:with-param name="value1" select="value[@name='ADR63']/@val" />
      <xsl:with-param name="unit1" select="'kVA'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2"  select="$volt1mains1" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="$volt2mains1" />
      <xsl:with-param name="unit3" select="'V'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="$volt3mains1" />
      <xsl:with-param name="unit4" select="'V'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'visible'"/>
      <xsl:with-param name="name" select="'page0'"/>
    </xsl:call-template>

    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX3"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="$columnwidth"/>
      <xsl:with-param name="h" select="$lineheight"/>
      <xsl:with-param name="value1" select="value[@name='INFREQ']/@val" />
      <xsl:with-param name="unit1" select="'Hz'"/>
      <xsl:with-param name="precision1" select="1"/>
      <xsl:with-param name="value2"  select="value[@name='ADR68']/@val" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='ADR69']/@val" />
      <xsl:with-param name="unit3" select="'A'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="value[@name='ADR6A']/@val" />
      <xsl:with-param name="unit4" select="'A'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'visible'"/>
      <xsl:with-param name="name" select="'page0'"/>
    </xsl:call-template>

    <!-- OUTPUT 1-->
    <xsl:variable name="freqout1">
      <xsl:choose>
        <xsl:when test="value[@name='ADR75']/@val &gt; 450">
          <xsl:call-template name="get-value">
            <xsl:with-param name="value" select="value[@name='ADR75']/@val div 10"/>
            <xsl:with-param name="unit" select="'Hz'" />
            <xsl:with-param name="precision" select="1"/>
          </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="get-value">
            <xsl:with-param name="value" select="value[@name='ADR75']/@val"/>
            <xsl:with-param name="unit" select="'Hz'" />
            <xsl:with-param name="precision" select="0"/>
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="$columnwidth"/>
      <xsl:with-param name="h" select="$lineheight"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'OUT:'" />
      <xsl:with-param name="text2" select="'L1:'" />
      <xsl:with-param name="text3" select="'L2:'" />
      <xsl:with-param name="text4" select="'L3:'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page1_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page1_11', ['OUT', ':']);</script>

    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX2"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="$columnwidth+15"/>
      <xsl:with-param name="h" select="$lineheight"/>
      <xsl:with-param name="value1"  select="value[@name='ADR74']/@val" />
      <xsl:with-param name="unit1" select="'kVA'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="$volt1out" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="$volt2out" />
      <xsl:with-param name="unit3" select="'V'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="$volt3out" />
      <xsl:with-param name="unit4" select="'V'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page1'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX3"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="$columnwidth"/>
      <xsl:with-param name="h" select="$lineheight"/>
      <xsl:with-param name="value1"  select="$freqout1" />
      <xsl:with-param name="unit1" select="''"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="value[@name='ADR79']/@val" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='ADR7A']/@val" />
      <xsl:with-param name="unit3" select="'A'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="value[@name='ADR7B']/@val" />
      <xsl:with-param name="unit4" select="'A'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page1'"/>
    </xsl:call-template>

    <!-- OUTPUT 2
	<xsl:call-template name="paneColumn">
		<xsl:with-param name="rows" select="4"/>
		<xsl:with-param name="x" select="$pageX1"/>
		<xsl:with-param name="y" select="$pageY"/>
		<xsl:with-param name="w" select="$columnwidth"/>
		<xsl:with-param name="h" select="$lineheight"/>
	  <xsl:with-param name="align" select="'left'" />
		<xsl:with-param name="value1"  select="'OUT2:'" />
		<xsl:with-param name="unit1" select="' '"/>
		<xsl:with-param name="precision1" select="1"/>
		<xsl:with-param name="value2" select="'L1:'" />
		<xsl:with-param name="unit2" select="' '"/>
		<xsl:with-param name="precision2" select="1"/>
		<xsl:with-param name="value3" select="'L2:'" />
		<xsl:with-param name="unit3" select="' '"/>
		<xsl:with-param name="precision3" select="1"/>
		<xsl:with-param name="value4" select="'L3:'" />
		<xsl:with-param name="unit4" select="' '"/>
		<xsl:with-param name="precision4" select="1"/>
		<xsl:with-param name="visibility" select="'hidden'"/>
    <xsl:with-param name="name" select="'page2'"/>
	</xsl:call-template>
	<xsl:call-template name="paneColumn">
		<xsl:with-param name="rows" select="4"/>
		<xsl:with-param name="x" select="$pageX2"/>
		<xsl:with-param name="y" select="$pageY"/>
		<xsl:with-param name="w" select="$columnwidth+10"/>
		<xsl:with-param name="h" select="$lineheight"/>
		<xsl:with-param name="value1"  select="value[@name='ADR7D']/@val" />
		<xsl:with-param name="unit1" select="'kVA'"/>
		<xsl:with-param name="precision1" select="1"/>
		<xsl:with-param name="value2" select="$volt1out2" />
		<xsl:with-param name="unit2" select="'V'"/>
		<xsl:with-param name="precision2" select="1"/>
		<xsl:with-param name="value3" select="$volt2out2" />
		<xsl:with-param name="unit3" select="'V'"/>
		<xsl:with-param name="precision3" select="1"/>
		<xsl:with-param name="value4" select="$volt3out2" />
		<xsl:with-param name="unit4" select="'V'"/>
		<xsl:with-param name="precision4" select="1"/>
		<xsl:with-param name="visibility" select="'hidden'"/>
    <xsl:with-param name="name" select="'page2'"/>
	</xsl:call-template>
	<xsl:call-template name="paneColumn">
		<xsl:with-param name="rows" select="4"/>
		<xsl:with-param name="x" select="$pageX3"/>
		<xsl:with-param name="y" select="$pageY"/>
		<xsl:with-param name="w" select="$columnwidth"/>
		<xsl:with-param name="h" select="$lineheight"/>
		<xsl:with-param name="value1"  select="value[@name='ADR7E']/@val div 10.0" />
		<xsl:with-param name="unit1" select="'Hz'"/>
		<xsl:with-param name="precision1" select="0"/>
		<xsl:with-param name="value2" select="value[@name='ADR82']/@val" />
		<xsl:with-param name="unit2" select="'A'"/>
		<xsl:with-param name="precision2" select="0"/>
		<xsl:with-param name="value3" select="value[@name='ADR83']/@val" />
		<xsl:with-param name="unit3" select="'A'"/>
		<xsl:with-param name="precision3" select="0"/>
		<xsl:with-param name="value4" select="value[@name='ADR84']/@val" />
		<xsl:with-param name="unit4" select="'A'"/>
		<xsl:with-param name="precision4" select="1"/>
		<xsl:with-param name="visibility" select="'hidden'"/>
    <xsl:with-param name="name" select="'page2'"/>
	</xsl:call-template>
-->
    <!-- Inverter Freq-->
    <xsl:variable name="freqinv">
      <xsl:choose>
        <xsl:when test="value[@name='ADR6D']/@val &gt; 450">
          <xsl:call-template name="get-value">
            <xsl:with-param name="value" select="value[@name='ADR6D']/@val div 10"/>
            <xsl:with-param name="unit" select="'Hz'" />
            <xsl:with-param name="precision" select="1"/>
          </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="get-value">
            <xsl:with-param name="value" select="value[@name='ADR6D']/@val"/>
            <xsl:with-param name="unit" select="'Hz'" />
            <xsl:with-param name="precision" select="0"/>
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!-- INVERTER-->
    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="$columnwidth"/>
      <xsl:with-param name="h" select="$lineheight"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'INV:'" />
      <xsl:with-param name="text2" select="'L1:'" />
      <xsl:with-param name="text3" select="'L2:'" />
      <xsl:with-param name="text4" select="'L3:'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page2_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page2_11', ['INV', ':']);</script>

    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX2"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="$columnwidth+10"/>
      <xsl:with-param name="h" select="$lineheight"/>
      <xsl:with-param name="value1"  select="value[@name='ADR6C']/@val" />
      <xsl:with-param name="unit1" select="'kVA'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="$volt1inverter" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="$volt2inverter" />
      <xsl:with-param name="unit3" select="'V'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="$volt3inverter" />
      <xsl:with-param name="unit4" select="'V'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page2'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX3"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="$columnwidth"/>
      <xsl:with-param name="h" select="$lineheight"/>
      <xsl:with-param name="value1"  select="$freqinv" />
      <xsl:with-param name="unit1" select="''"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="value[@name='ADR71']/@val" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='ADR72']/@val" />
      <xsl:with-param name="unit3" select="'A'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="value[@name='ADR73']/@val" />
      <xsl:with-param name="unit4" select="'A'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page2'"/>
    </xsl:call-template>

    <!-- DEFAULT -->
    <xsl:variable name ="output">
      <xsl:value-of select="value[@name='ADR7C']/@val"/>
      <xsl:text>kW</xsl:text>
    </xsl:variable>
    <!-- TEST -->
    <!--
	<div id="Debug" class="LargeBold" align="right" style="position: absolute; top: 50px; left: 50px; width: 163px; height: 17px; font-size:18px;">
		<xsl:value-of select="$input"  /><br/>
		<xsl:value-of select="$output" /><br/>
      <xsl:value-of select="$adrd8"  /><br/>
	</div>
-->
    <xsl:call-template name="paneText">
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="1 * $columnwidth"/>
      <xsl:with-param name="h" select="$lineheight"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="value"  select="$time" />
      <xsl:with-param name="unit" select="' '"/>
      <xsl:with-param name="name" select="'page3'"/>
    </xsl:call-template>

    <xsl:call-template name="paneText">
      <xsl:with-param name="x" select="$pageX2"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="2 * $columnwidth"/>
      <xsl:with-param name="h" select="$lineheight"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="align" select="'right'" />
      <xsl:with-param name="value"  select="$date" />
      <xsl:with-param name="unit" select="' '"/>
      <xsl:with-param name="name" select="'page3'"/>

    </xsl:call-template>
    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY+$lineheight"/>
      <xsl:with-param name="w" select="$columnwidth"/>
      <xsl:with-param name="h" select="$lineheight"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'HOURS:'" />
      <xsl:with-param name="text2" select="''" />
      <xsl:with-param name="text3" select="'OUTPUT:'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page3_3'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page3_31', ['HOURS', ':']);</script>
    <script type="text/javascript"> translate_text('page3_33', ['OUTPUT', ':']);</script>

    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="$pageX2"/>
      <xsl:with-param name="y" select="$pageY+$lineheight"/>
      <xsl:with-param name="w" select="2*$columnwidth"/>
      <xsl:with-param name="h" select="$lineheight"/>
      <xsl:with-param name="value1"  select="value[@name='ADR9B']/@val*10000 + value[@name='ADR9C']/@val" />
      <xsl:with-param name="unit1" select="'h'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="''" />
      <xsl:with-param name="unit2" select="' '"/>
      <xsl:with-param name="precision2" select="-1"/>
      <xsl:with-param name="value3"  select="$output" />
      <xsl:with-param name="unit3" select="' '"/>
      <xsl:with-param name="precision3" select="-1"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page3'"/>
    </xsl:call-template>


    <!-- EOT -->
  </xsl:template>

  <!-- EOS -->
</xsl:stylesheet>
