<?xml version="1.0"?>
<!--
   modas4_panel.xsl - UPS screen for Piller UNIBLOCK UB III models @UNMS-II.
   Copyright (c) 2018, Generex GmbH. All rights reserved.
   klaus
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!-- Methods -->
  <!--Header-->
  <xsl:template name="modas4_panel-header">
    <xsl:call-template name="app-header">
      <xsl:with-param name="top" select="10"/>
      <xsl:with-param name="left" select="20"/>
    </xsl:call-template>
  </xsl:template>
  <!--Footer-->
  <xsl:template name="modas4_panel-footer" >
    <xsl:call-template name="app-footer" >
      <xsl:with-param name="top" select="510"/>
      <xsl:with-param name="left" select="10"/>
      <xsl:with-param name="width" select="785"/>
      <xsl:with-param name="height" select="70"/>
    </xsl:call-template>
  </xsl:template>
  <!--Menu-->
  <xsl:template name="modas4_panel-menu">
    <xsl:call-template name="app-menu">
      <xsl:with-param name="top" select="428"/>
      <xsl:with-param name="left" select="0"/>
      <xsl:with-param name="width" select="0"/>
      <xsl:with-param name="height" select="0"/>
      <xsl:with-param name="class" select="'XBold_black'"/>
    </xsl:call-template>
  </xsl:template>

  <!--Body-->
  <xsl:template name="modas4_panel-body">
    <xsl:param name="imagepath" select="'./lib/ups/image/piller/backas.png'"/>
    <xsl:param name="up_img" select="'./lib/ups/image/piller/selectUpAt2.jpg'"/>
    <xsl:param name="down_img" select="'./lib/ups/image/piller/selectDownAt2.jpg'"/>
    <div id="master" style="position:absolute; top:10px;left:10px">
      <xsl:call-template name="background">
        <xsl:with-param name="imagepath" select="$imagepath"/>
        <xsl:with-param name="x" select="'0'"/>
        <xsl:with-param name="y" select="'0'"/>
        <xsl:with-param name="w" select="'785'"/>
        <xsl:with-param name="h" select="'488'"/>
        <xsl:with-param name="border" select="'0'"/>
        <xsl:with-param name="id" select="'background'"/>
      </xsl:call-template>
      <xsl:apply-templates />
      <div style="position: absolute; left:444px; top:137px; width:28px; height:28px; z-index:1;">
        <a href="javascript:onChangeSelectionUp()">
          <img border="0" alt="" src="{$up_img}" width="28" height="28"/>
        </a>
      </div>
      <div style="position: absolute; left:443px; top:180px; width:28; height:28px; z-index:1;">
        <a href="javascript:onChangeSelectionDown()">
          <img border="0" alt="" src="{$down_img}" width="28" height="29"/>
        </a>
      </div>
    </div>

    <script type="text/javascript">
      init();
    </script>

    <xsl:if test="string-length(//report/@_platform) != string-length('cs141')">
      <xsl:call-template name="js_refresh_call">
        <xsl:with-param	 name="timeout" select="1000*//report/@refresh"/>
      </xsl:call-template>
    </xsl:if>

  </xsl:template>

  <!-- Implementation -->
  <xsl:template match="values">

    <!-- UPS HISTORY-->
    <xsl:if test="string-length(//service/@type) !=0 and //service/@type != 'upsman' and //service/@type != 'snmpups' and //service/@type != 'maildev' and //service/@type != 'CS141'">
      <xsl:call-template name="on-mouse-over"/>
      <div class="MediumBold" align="right" style="position: absolute; left: 190px; top: 395px; width: 100px; height: 32px; text-align:center;  ">
        <a class="MediumBoldLink" href="nmsView.dll?navigate&amp;url=http://{//host/@address}/mbevents.cgi" border="0"  target="_blank" onmouseover="changeImage('hist', '../image/button_white_over.gif')" onmouseout="restoreImage('hist')">
          <img id="hist" src="../image/button_white.gif" width="100" height="32" border="0"/>
        </a>
      </div>
      <div class="MediumBold" align="right" style="position: absolute; left: 190px; top: 402px; width: 100px; height: 17px; text-align:center;  ">
        <a id="evt_rec" class="MediumBold" href="nmsView.dll?navigate&amp;url=http://{//host/@address}/mbevents.cgi" style="text-decoration:none"  target="_blank"  onmouseover="changeImage('hist', '../image/button_white_over.gif')" onmouseout="restoreImage('hist')">
         <script type="text/javascript"> translate_text('evt_rec', 'Eventrecorder');</script>
        </a>
      </div>
    </xsl:if>

    <xsl:variable name="adr154">
      <xsl:call-template name="getfixedbitstring">
        <xsl:with-param name="val" select="value[@name='ADR154']/@val"/>
        <xsl:with-param name="dir" select="-1"/>
        <xsl:with-param name="places" select="16"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="adr155">
      <xsl:call-template name="getfixedbitstring">
        <xsl:with-param name="val" select="value[@name='ADR155']/@val"/>
        <xsl:with-param name="dir" select="-1"/>
        <xsl:with-param name="places" select="16"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="adr156">
      <xsl:call-template name="getfixedbitstring">
        <xsl:with-param name="val" select="value[@name='ADR156']/@val"/>
        <xsl:with-param name="dir" select="-1"/>
        <xsl:with-param name="places" select="16"/>
      </xsl:call-template>
    </xsl:variable>

    <!-- BYPASS -->
    <div id="P004P004" style="position:absolute; left:515px; top:255px; width:9px; height:9px">
      <xsl:choose>
        <xsl:when test="substring($adr154,2,1) = '1' or substring($adr154,1,2) = '11' or substring($adr154,3,1) = '1'">
          <img  src="./lib/ups/image/piller/ledgruen10x10_flash_m.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>
        <xsl:when test="substring($adr154,1,1) = '1'">
          <img  src="./lib/ups/image/piller/ledgruen10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>  
        <xsl:otherwise>
          <img  src="./lib/ups/image/piller/ledgrau10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- OUTPUT -->
    <div id="P005P005" style="position:absolute; left:515px; top:341px; width:9px; height:9px">
      <xsl:choose>
        <xsl:when test="substring($adr154,6,1) = '1' or substring($adr154,5,2) = '11' or substring($adr154,7,1) = '1'">
          <img  src="./lib/ups/image/piller/ledgruen10x10_flash_m.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>
        <xsl:when test="substring($adr154,5,1) = '1'">
          <img  src="./lib/ups/image/piller/ledgruen10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>
        <xsl:otherwise>
          <img  src="./lib/ups/image/piller/ledgrau10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>    

    <!-- INVERTER -->
    <div id="P006P006" style="position:absolute; left:431px; top:354px; width:9px; height:9px">
      <xsl:choose>
        <xsl:when test="(substring($adr154,10,1) = '1' or substring($adr154,9,2) = '11' or substring($adr154,11,1) = '1')
        and (substring($adr154,14,1) = '1' or substring($adr154,13,2) = '11' or substring($adr154,15,1) = '1')">
          <img  src="./lib/ups/image/piller/ledgelb10x10_flash_m.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>

        <xsl:when test="substring($adr154,9,1) = '1' and substring($adr154,13,1) = '1'">
          <img  src="./lib/ups/image/piller/ledgelb10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when> 

        <xsl:when test="substring($adr154,10,1) = '1' or substring($adr154,9,2) = '11' or substring($adr154,11,1) = '1'">
          <img  src="./lib/ups/image/piller/ledgruen10x10_flash_m.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>
        <xsl:when test="substring($adr154,9,1) = '1'">
          <img  src="./lib/ups/image/piller/ledgruen10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>        
        <xsl:when test="substring($adr154,14,1) = '1' or substring($adr154,13,2) = '11' or substring($adr154,15,1) = '1'">
          <img  src="./lib/ups/image/piller/ledrot10x10_flash_m.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>

        <xsl:when test="substring($adr154,13,1) = '1'">
          <img  src="./lib/ups/image/piller/ledrot10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>
        <xsl:otherwise>
          <img  src="./lib/ups/image/piller/ledgrau10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- GR -->
    <div id="P002P002" style="position:absolute; left:289px; top:354px; width:10px; height:10px">
      <xsl:choose>
        <xsl:when test="(substring($adr155,10,1) = '1' or substring($adr155,9,2) = '11' or substring($adr155,11,1) = '1')
        and (substring($adr155,14,1) = '1' or substring($adr155,13,2) = '11' or substring($adr155,15,1) = '1')">
          <img  src="./lib/ups/image/piller/ledgelb10x10_flash_m.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>

        <xsl:when test="substring($adr155,9,1) = '1' and substring($adr155,13,1) = '1'">
          <img  src="./lib/ups/image/piller/ledgelb10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when> 


        <xsl:when test="substring($adr155,10,1) = '1' or substring($adr155,9,2) = '11' or substring($adr155,11,1) = '1'">
          <img  src="./lib/ups/image/piller/ledgruen10x10_flash_m.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>
        <xsl:when test="substring($adr155,9,1) = '1'">
          <img  src="./lib/ups/image/piller/ledgruen10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>        
        <xsl:when test="substring($adr155,14,1) = '1' or substring($adr155,13,2) = '11' or substring($adr155,15,1) = '1'">
          <img  src="./lib/ups/image/piller/ledrot10x10_flash_m.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>
        <xsl:when test="substring($adr155,13,1) = '1'">
          <img  src="./lib/ups/image/piller/ledrot10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>
        <xsl:otherwise>
          <img  src="./lib/ups/image/piller/ledgrau10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- STATIC SWITCH -->
    <div id="P003P003" style="position:absolute; left:360px; top:304px; width:9px; height:9px">
      <xsl:choose>
        <xsl:when test="(substring($adr156,2,1) = '1' or substring($adr156,1,2) = '11' or substring($adr156,3,1) = '1')
        and (substring($adr156,6,1) = '1' or substring($adr156,5,2) = '11' or substring($adr156,7,1) = '1')">
          <img  src="./lib/ups/image/piller/ledgelb10x10_flash_m.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>
        <xsl:when test="substring($adr156,5,1) = '1' and substring($adr156,1,1) = '1'">
          <img  src="./lib/ups/image/piller/ledgelb10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>

        <xsl:when test="substring($adr156,2,1) = '1' or substring($adr156,1,2) = '11' or substring($adr156,3,1) = '1'">
          <img  src="./lib/ups/image/piller/ledgruen10x10_flash_m.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>
        <xsl:when test="substring($adr156,1,1) = '1'">
          <img  src="./lib/ups/image/piller/ledgruen10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>        
        <xsl:when test="substring($adr156,6,1) = '1' or substring($adr156,5,2) = '11' or substring($adr156,7,1) = '1'">
          <img  src="./lib/ups/image/piller/ledrot10x10_flash_m.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>
        <xsl:when test="substring($adr156,5,1) = '1'">
          <img  src="./lib/ups/image/piller/ledrot10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>
        <xsl:otherwise>
          <img  src="./lib/ups/image/piller/ledgrau10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- BATTERY -->
    <div id="P007P007" style="position:absolute; left:360px; top:404px; width:9px; height:9px">
      <xsl:choose>
        <xsl:when test="(substring($adr155,2,1) = '1' or substring($adr155,1,2) = '11' or substring($adr155,3,1) = '1')
        and (substring($adr155,6,1) = '1' or substring($adr155,5,2) = '11' or substring($adr155,7,1) = '1')">
          <img  src="./lib/ups/image/piller/ledgelb10x10_flash_m.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>

        <xsl:when test="substring($adr155,1,1) = '1' and substring($adr155,5,1) = '1'">
          <img  src="./lib/ups/image/piller/ledgelb10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when> 

        <xsl:when test="substring($adr155,2,1) = '1' or substring($adr155,1,2) = '11' or substring($adr155,3,1) = '1'">
          <img  src="./lib/ups/image/piller/ledgruen10x10_flash_m.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>
       <xsl:when test="substring($adr155,6,1) = '1' or substring($adr155,5,2) = '11' or substring($adr155,7,1) = '1'">
          <img  src="./lib/ups/image/piller/ledrot10x10_flash_m.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>

        <xsl:when test="substring($adr155,1,1) = '1'">
          <img  src="./lib/ups/image/piller/ledgruen10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when>   

        <xsl:when test="substring($adr155,5,1) = '1'">
          <img  src="./lib/ups/image/piller/ledrot10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:when> 
    
        <xsl:otherwise>
          <img  src="./lib/ups/image/piller/ledgrau10x10.gif" width="10" height="10" alt="" border="0"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <xsl:variable name="switch" 	select="value[@name='ADRA1']/@val"/>

    <xsl:variable name="volt1mains1">
      <xsl:choose>
        <xsl:when test="$switch = 0">
          <xsl:value-of select="value[@name='INVOLT']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR68']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="volt2mains1">
      <xsl:choose>
        <xsl:when test="$switch = 0">
          <xsl:value-of select="value[@name='INVOLT']/@val2"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR69']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="volt3mains1">
      <xsl:choose>
        <xsl:when test="$switch = 0">
          <xsl:value-of select="value[@name='INVOLT']/@val3"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR6A']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="switch1" 	select="value[@name='ADRA3']/@val"/>

    <xsl:variable name="volt1mains2">
      <xsl:choose>
        <xsl:when test="$switch1 = 0">
          <xsl:value-of select="value[@name='ADR7D']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR80']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="volt2mains2">
      <xsl:choose>
        <xsl:when test="$switch1 = 0">
          <xsl:value-of select="value[@name='ADR7E']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR81']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="volt3mains2">
      <xsl:choose>
        <xsl:when test="$switch1 = 0">
          <xsl:value-of select="value[@name='ADR7F']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR82']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="switch2" 	select="value[@name='ADRA2']/@val"/>

    <xsl:variable name="volt1out">
      <xsl:choose>
        <xsl:when test="$switch2 = 0">
          <xsl:value-of select="value[@name='ADR74']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR77']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="volt2out">
      <xsl:choose>
        <xsl:when test="$switch2 = 0">
          <xsl:value-of select="value[@name='ADR75']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR78']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="volt3out">
      <xsl:choose>
        <xsl:when test="$switch2 = 0">
          <xsl:value-of select="value[@name='ADR76']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR79']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="pageX1"   select="247"/>
    <xsl:variable name="pageX2"   select="$pageX1+ 30"/>
    <xsl:variable name="pageX3"   select="$pageX2+ 55"/>
    <xsl:variable name="pageX3u"   select="645"/>
    <xsl:variable name="pageY"    select="149"/>
    <xsl:variable name="lineheight"   select="12"/>
    <xsl:variable name="columnwidth"    select="48"/>
    <xsl:variable name="smallcolumnwidth"    select="25"/>
    <xsl:variable name="bigcolumnwidth"    select="100"/>

    <!-- MAINS1_AS4-->
    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'IN1:'" />
      <xsl:with-param name="text2"  select="'L1:'" />
      <xsl:with-param name="text3" select="'L2:'" />
      <xsl:with-param name="text4" select="'L3:'" />
      <xsl:with-param name="visibility" select="'visible'"/>
      <xsl:with-param name="name" select="'page0'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX2"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value1" select="value[@name='ADR63']/@val" />
      <xsl:with-param name="unit1" select="'kVA'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2"  select="$volt1mains1" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="$volt2mains1" />
      <xsl:with-param name="unit3" select="'V'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="$volt3mains1" />
      <xsl:with-param name="unit4" select="'V'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'visible'"/>
      <xsl:with-param name="name" select="'page0'"/>
    </xsl:call-template>

    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX3"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value1" select="value[@name='INFREQ']/@val" />
      <xsl:with-param name="unit1" select="'Hz'"/>
      <xsl:with-param name="precision1" select="1"/>
      <xsl:with-param name="value2"  select="value[@name='ADR6B']/@val" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='ADR6C']/@val" />
      <xsl:with-param name="unit3" select="'A'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="value[@name='ADR6D']/@val" />
      <xsl:with-param name="unit4" select="'A'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'visible'"/>
      <xsl:with-param name="name" select="'page0'"/>
    </xsl:call-template>

    <!-- MAINS2_AS4 -->
    <xsl:variable name="in2-freq">
      <xsl:choose>
        <xsl:when test="value[@name='ADR6F']/@val = 32767">
          <xsl:value-of select="' -.-'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR6F']/@val div 10.0"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable> 

    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX1 - 5"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'IN2:'" />
      <xsl:with-param name="text2" select="'L1:'" />
      <xsl:with-param name="text3" select="'L2:'" />
      <xsl:with-param name="text4" select="'L3:'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page1'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX2 -5"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value1"  select="value[@name='ADR73']/@val" />
      <xsl:with-param name="unit1" select="'kVA'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="$volt1mains2" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="$volt2mains2" />
      <xsl:with-param name="unit3" select="'V'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="$volt3mains2" />
      <xsl:with-param name="unit4" select="'V'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page1'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX3 -5"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="60"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value1"  select="$in2-freq" />
      <xsl:with-param name="unit1" select="'Hz'"/>
      <xsl:with-param name="precision1" select="1"/>
      <xsl:with-param name="value2" select="value[@name='ADR70']/@val" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='ADR71']/@val" />
      <xsl:with-param name="unit3" select="'A'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="value[@name='ADR72']/@val" />
      <xsl:with-param name="unit4" select="'A'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page1'"/>
    </xsl:call-template>

    <!-- Inverter -->
    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'INV:'" />
      <xsl:with-param name="text2" select="'L1:'" />
      <xsl:with-param name="text3" select="'L2:'" />
      <xsl:with-param name="text4" select="'L3:'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page2'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX2"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value1"  select="value[@name='ADR87']/@val" />
      <xsl:with-param name="unit1" select="'kVA'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="$volt1out" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="$volt2out" />
      <xsl:with-param name="unit3" select="'V'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="$volt3out" />
      <xsl:with-param name="unit4" select="'V'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page2'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX3"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value1"  select="value[@name='ADR86']/@val div 10.0" />
      <xsl:with-param name="unit1" select="'Hz'"/>
      <xsl:with-param name="precision1" select="1"/>
      <xsl:with-param name="value2" select="value[@name='ADR83']/@val" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='ADR84']/@val" />
      <xsl:with-param name="unit3" select="'A'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="value[@name='ADR85']/@val" />
      <xsl:with-param name="unit4" select="'A'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page2'"/>
    </xsl:call-template>

    <!-- PHASE -->
    <xsl:variable name="phase-mains-inverter">
      <xsl:choose>
        <xsl:when test="value[@name='ADR9F']/@val=32767">
          <xsl:value-of select="'---'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR9F']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="phase-inverter-extern">
      <xsl:choose>
        <xsl:when test="value[@name='ADRB5']/@val=32767">
          <xsl:value-of select="'---'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADRB5']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>  

    <xsl:call-template name="paneText">
      <xsl:with-param name="x" select="$pageX1 + 35"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="120"/>
      <xsl:with-param name="h" select="12"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="value"  select="'*** PHASE ***'" />
      <xsl:with-param name="unit" select="' '"/>
      <xsl:with-param name="name" select="'page3_0'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page3_0', ['*** ', 'PHASE', ' ***']);</script>

    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="$pageX1 - 12"/>
      <xsl:with-param name="y" select="$pageY + 16"/>
      <xsl:with-param name="w" select="110"/>
      <xsl:with-param name="h" select="12"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'MAINS - INVERTER'" />
      <xsl:with-param name="text2" select="'INVERTER - BUS'" />
      <xsl:with-param name="text3" select="'INVERTER - EXTERN'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page3_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page3_11', 'MAINS - INVERTER');</script>
    <script type="text/javascript"> translate_text('page3_12', 'INVERTER - BUS');</script>
    <script type="text/javascript"> translate_text('page3_13', 'INVERTER - EXTERN');</script>

    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="$pageX3 + 4"/>
      <xsl:with-param name="y" select="$pageY + 16"/>
      <xsl:with-param name="w" select="60"/>
      <xsl:with-param name="h" select="12"/>
      <xsl:with-param name="align" select="'right'" />
      <xsl:with-param name="value1"  select="$phase-mains-inverter" />
      <xsl:with-param name="unit1" select="'DGR'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="value[@name='ADRA0']/@val" />
      <xsl:with-param name="unit2" select="'DGR'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="$phase-inverter-extern" />
      <xsl:with-param name="unit3" select="'DGR'"/>
      <xsl:with-param name="precision3" select="0"/>      
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page3'"/>
    </xsl:call-template>

    <!-- DC-LINK concat($name, '1') -->
    <xsl:variable name="equalize_txt">
      <xsl:choose>
        <xsl:when test="value[@name='ADRB8']/@val=1">
          <xsl:value-of select="'EQUALIZE ON'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'EQUALIZE'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="equalize_val">
      <xsl:choose>
        <xsl:when test="value[@name='ADRB8']/@val=1">
          <xsl:value-of select="value[@name='ADRB7']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'OFF'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="equalize_unit">
      <xsl:choose>
        <xsl:when test="value[@name='ADRB8']/@val=1">
          <xsl:value-of select="'MIN'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="''"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:call-template name="paneText">
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY -6"/>
      <xsl:with-param name="w" select="120"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="value"  select="'*** DC-LINK ***'" />
      <xsl:with-param name="unit" select="' '"/>
      <xsl:with-param name="name" select="'page4_0'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page4_0', ['*** ', 'DC-LINK', ' ***']);</script>

    <xsl:call-template name="paneRow">
      <xsl:with-param name="xT" select="$pageX1"/>
      <xsl:with-param name="yT" select="$pageY + 6"/>
      <xsl:with-param name="wT" select="75"/>
      <xsl:with-param name="hT" select="13"/>
      <xsl:with-param name="alignT" select="'left'" />
      <xsl:with-param name="text"  select="'U BATT:'" />
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value" select="value[@name='ADR96']/@val" />
      <xsl:with-param name="unit" select="'V'"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page4_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page4_10', ['U BATT', ':']);</script>

    <xsl:call-template name="paneRow">
      <xsl:with-param name="xT" select="$pageX1"/>
      <xsl:with-param name="yT" select="$pageY + 18"/>
      <xsl:with-param name="wT" select="75"/>
      <xsl:with-param name="hT" select="13"/>
      <xsl:with-param name="alignT" select="'left'" />
      <xsl:with-param name="text"  select="'I BATT:'" />
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value" select="value[@name='ADR95']/@val" />
      <xsl:with-param name="unit" select="'A'"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page4_2'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page4_20', ['I BATT', ':']);</script>    

    <xsl:call-template name="paneRow">
      <xsl:with-param name="xT" select="$pageX1"/>
      <xsl:with-param name="yT" select="$pageY + 30"/>
      <xsl:with-param name="wT" select="75"/>
      <xsl:with-param name="hT" select="13"/>
      <xsl:with-param name="alignT" select="'left'" />
      <xsl:with-param name="text"  select="'SWITCH OFF AT'" />
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value" select="value[@name='ADR97']/@val" />
      <xsl:with-param name="unit" select="'V'"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page4_3'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page4_30', 'SWITCH OFF AT');</script>

    <xsl:call-template name="paneRow">
      <xsl:with-param name="xT" select="$pageX1"/>
      <xsl:with-param name="yT" select="$pageY + 42"/>
      <xsl:with-param name="wT" select="75"/>
      <xsl:with-param name="hT" select="13"/>
      <xsl:with-param name="alignT" select="'left'" />
      <xsl:with-param name="text"  select="$equalize_txt" />
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value" select="$equalize_val" />
      <xsl:with-param name="unit" select="$equalize_unit"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page4_4'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page4_40', '<xsl:value-of select="$equalize_txt"/>');</script>

    <!-- HOURS -->

    <xsl:variable name="batt-temp-deg">
      <xsl:choose>
        <xsl:when test="value[@name='ADRB1']/@val &lt; 0">
          <xsl:value-of select="'-.-'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADRB1']/@val div 10.0"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="batt-temp-fahrenheit">
      <xsl:choose>
        <xsl:when test="value[@name='ADRB1']/@val &lt; 0">
          <xsl:value-of select="'-.-'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="(value[@name='ADRB1']/@val div 10.0*1.8) + 32.0"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>


    <xsl:variable name="unsigned-batt-rem-time">
      <xsl:call-template name="unsigner">
         <xsl:with-param name="val" select="value[@name='ADRB2']/@val"/>
      </xsl:call-template>
    </xsl:variable> 
    <xsl:variable name="batt-rem-time">
      <xsl:choose>
        <xsl:when test="$unsigned-batt-rem-time &gt; 1000 or $unsigned-batt-rem-time= 1000">
          <xsl:value-of select="'---'"/>
        </xsl:when>
        <xsl:otherwise>
         <xsl:value-of select="$unsigned-batt-rem-time"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>  
    
    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX1 -10"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="90"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'BATTERY'" />
      <xsl:with-param name="text2"  select="'TEMPERATURE'" />
      <xsl:with-param name="text3"  select="'REMAINING TIME'" />
      <xsl:with-param name="text4"  select="'REM. CAPACITY'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page5_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page5_11', 'BATTERY');</script>
    <script type="text/javascript"> translate_text('page5_12', 'TEMPERATURE');</script>
    <script type="text/javascript"> translate_text('page5_13', 'REMAINING TIME');</script>
    <script type="text/javascript"> translate_text('page5_14', 'REM. CAPACITY');</script>

    <xsl:if test="value[@name='_tempUnit']/@val=0 or string-length(value[@name='_tempUnit']/@val)=0">
      <xsl:call-template name="paneColumn">
        <xsl:with-param name="rows" select="4"/>
        <xsl:with-param name="x" select="$pageX3 -10"/>
        <xsl:with-param name="y" select="$pageY"/>
        <xsl:with-param name="w" select="70"/>
        <xsl:with-param name="h" select="13"/>
        <xsl:with-param name="align" select="'right'" />
        <xsl:with-param name="value1"  select="value[@name='ADR95']/@val" />
        <xsl:with-param name="unit1" select="'A'"/>
        <xsl:with-param name="precision1" select="0"/>
        <xsl:with-param name="value2"  select="$batt-temp-deg" />
        <xsl:with-param name="unit2" select="'&#176;C'"/>
        <xsl:with-param name="precision2" select="1"/>
        <xsl:with-param name="value3"  select="$batt-rem-time" />
        <xsl:with-param name="unit3" select="'MIN'"/>
        <xsl:with-param name="precision3" select="0"/>
        <xsl:with-param name="value4"  select="value[@name='ADR99']/@val div 10.0" />
        <xsl:with-param name="unit4" select="'Ah'"/>
        <xsl:with-param name="precision4" select="1"/>
        <xsl:with-param name="visibility" select="'hidden'"/>
        <xsl:with-param name="name" select="'page5'"/>
      </xsl:call-template>
    </xsl:if>
    <xsl:if test="value[@name='_tempUnit']/@val=1">
      <xsl:call-template name="paneColumn">
        <xsl:with-param name="rows" select="4"/>
        <xsl:with-param name="x" select="$pageX3"/>
        <xsl:with-param name="y" select="$pageY"/>
        <xsl:with-param name="w" select="50"/>
        <xsl:with-param name="h" select="13"/>
        <xsl:with-param name="align" select="'right'" />
        <xsl:with-param name="value1"  select="value[@name='ADR95']/@val" />
        <xsl:with-param name="unit1" select="'A'"/>
        <xsl:with-param name="precision1" select="0"/>
        <xsl:with-param name="value2"  select="$batt-temp-fahrenheit" />
        <xsl:with-param name="unit2" select="'&#176;F'"/>
        <xsl:with-param name="precision2" select="0.1"/>
        <xsl:with-param name="value3"  select="$batt-rem-time" />
        <xsl:with-param name="unit3" select="'MIN'"/>
        <xsl:with-param name="precision3" select="0"/>
        <xsl:with-param name="value4"  select="value[@name='ADR99']/@val div 10.0" />
        <xsl:with-param name="unit4" select="'Ah'"/>
        <xsl:with-param name="precision4" select="0.1"/>
        <xsl:with-param name="visibility" select="'hidden'"/>
        <xsl:with-param name="name" select="'page5'"/>
      </xsl:call-template>
    </xsl:if>

    <xsl:variable name="datetime" select="//report/@time"/>
    <xsl:variable name="date" select="concat('', substring-before($datetime, ' '))"/>
    <xsl:variable name="time" select="concat('', substring-after($datetime, ' '))"/>

    <!-- DEFAULT -->
  <xsl:variable name="high-hour">
    <xsl:call-template name="unsigner">
      <xsl:with-param name="val" select="value[@name='ADR9E']/@val"/>
    </xsl:call-template>
  </xsl:variable>
  <xsl:variable name="low-hour">
    <xsl:call-template name="unsigner">
      <xsl:with-param name="val" select="value[@name='ADR9D']/@val"/>
    </xsl:call-template>
  </xsl:variable>  

  <xsl:variable name="counter">
    <xsl:call-template name="unsigner">
      <xsl:with-param name="val" select="value[@name='ADR9A']/@val"/>
    </xsl:call-template>
  </xsl:variable>   

    <xsl:call-template name="paneText">
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="60"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="value"  select="$date" />
      <xsl:with-param name="unit" select="' '"/>
      <xsl:with-param name="name" select="'page6'"/>
    </xsl:call-template>
    <xsl:call-template name="paneText">
      <xsl:with-param name="x" select="$pageX3"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="60"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="value"  select="$time" />
      <xsl:with-param name="unit" select="' '"/>
      <xsl:with-param name="name" select="'page6'"/>
    </xsl:call-template>

    <xsl:call-template name="paneRow">
      <xsl:with-param name="xT" select="$pageX1"/>
      <xsl:with-param name="yT" select="$pageY + 15"/>
      <xsl:with-param name="wT" select="75"/>
      <xsl:with-param name="hT" select="13"/>
      <xsl:with-param name="alignT" select="'left'" />
      <xsl:with-param name="text"  select="'HOURS'" />
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value" select="$high-hour*65536 + $low-hour" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page6_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page6_10', 'HOURS');</script>

    <xsl:call-template name="paneRow">
      <xsl:with-param name="xT" select="$pageX1"/>
      <xsl:with-param name="yT" select="$pageY + 27"/>
      <xsl:with-param name="wT" select="75"/>
      <xsl:with-param name="hT" select="13"/>
      <xsl:with-param name="alignT" select="'left'" />
      <xsl:with-param name="text"  select="'COUNTER'" />
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value" select="$counter" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page6_2'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page6_20', 'COUNTER');</script>

    <xsl:call-template name="paneRow">
      <xsl:with-param name="xT" select="$pageX1"/>
      <xsl:with-param name="yT" select="$pageY + 39"/>
      <xsl:with-param name="wT" select="75"/>
      <xsl:with-param name="hT" select="13"/>
      <xsl:with-param name="alignT" select="'left'" />
      <xsl:with-param name="text"  select="'OUTPUT'" />
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value" select="value[@name='ADR7C']/@val" />
      <xsl:with-param name="unit" select="'kW'"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page6_3'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page6_30', 'OUTPUT');</script>

    <!-- EOT -->
  </xsl:template>

  <!-- EOS -->
</xsl:stylesheet>
