<?xml version="1.0"?>
<!--
   modat2_63_panel.xsl - UPS screen for Piller APOTRANS II models @UNMS-II.
   Copyright (c) 2005, Generex GmbH. All rights reserved.
   klaus
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!-- Methods -->
  <!--Header-->
  <xsl:template name="modat2_63_panel-header">
    <xsl:call-template name="app-header">
      <xsl:with-param name="top" select="10"/>
      <xsl:with-param name="left" select="20"/>
    </xsl:call-template>
  </xsl:template>

  <!--Footer-->
  <xsl:template name="modat2_63_panel-footer" >
    <xsl:call-template name="app-footer" >
      <xsl:with-param name="top" select="510"/>
      <xsl:with-param name="left" select="36"/>
      <xsl:with-param name="width" select="742"/>
      <xsl:with-param name="height" select="62"/>
    </xsl:call-template>
  </xsl:template>
  <!--Menu-->
  <xsl:template name="modat2_63_panel-menu">
    <xsl:call-template name="app-menu">
      <xsl:with-param name="top" select="428"/>
      <xsl:with-param name="left" select="0"/>
      <xsl:with-param name="width" select="0"/>
      <xsl:with-param name="height" select="0"/>
      <xsl:with-param name="class" select="'XBold_black'"/>
    </xsl:call-template>
  </xsl:template>

  <!--Body-->
  <xsl:template name="modat2_63_panel-body">

    <div id="master" style="position:absolute; top:10px;left:10px">
      <xsl:call-template name="background">
        <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/backat63.png'"/>
        <xsl:with-param name="x" select="'0'"/>
        <xsl:with-param name="y" select="'0'"/>
        <xsl:with-param name="w" select="'785'"/>
        <xsl:with-param name="h" select="'488'"/>
        <xsl:with-param name="border" select="'0'"/>
        <xsl:with-param name="id" select="'background'"/>
      </xsl:call-template>
      <div style="position: absolute; left:614px; top:277px; width:28px; height:28px; z-index:1;">
        <a href="javascript:onChangeSelectionDown()">
          <img border="0" alt="" src="./lib/ups/image/piller/app_scroll_up.gif" width="33" height="33"/>
        </a>
      </div>
      <div style="position: absolute; left:565px; top:277px; width:28px; height:28px; z-index:1;">
        <a href="javascript:onChangeSelectionUp()">
          <img border="0" alt="" src="./lib/ups/image/piller/app_scroll_down.gif" width="33" height="33"/>
        </a>
      </div>
      <xsl:apply-templates />
    </div>
   <script type="text/javascript">
      init();
   </script>
   <xsl:if test="string-length(//report/@_platform) != string-length('cs141')">
      <xsl:call-template name="js_refresh_call">
      <xsl:with-param	 name="timeout" select="1000*//report/@refresh"/>
      </xsl:call-template>
   </xsl:if>

  </xsl:template>

  <!-- Implementation -->

  <xsl:template match="values">
    <!-- MODEL -->
    <div class="LargeBold" align="right" style="position: absolute; left: 500px; top: 381px; width: 200px; height: 17px; color:#004C8B; text-align:center">
      <xsl:value-of select="value[@name='MODEL']/@val" />
    </div>
    <!-- UPS HISTORY-->
    <xsl:if test="string-length(//service/@type) !=0 and //service/@type != 'upsman' and //service/@type != 'snmpups' and //service/@type != 'maildev' and //service/@type != 'CS141'">
      <xsl:call-template name="on-mouse-over"/>
      <div class="MediumBold" align="right" style="position: absolute; left: 350px; top: 415px; width: 100px; height: 32px; text-align:center;  ">
        <a class="MediumBoldLink" href="nmsView.dll?navigate&amp;url=http://{//host/@address}/mbevents.cgi" border="0"  target="_blank" onmouseover="changeImage('hist', './lib/img/button_white_over.gif')" onmouseout="restoreImage('hist')">
          <img id="hist" src="./lib/img/button_white.gif" width="100" height="32" border="0"/>
        </a>
      </div>
      <div class="MediumBold" align="right" style="position: absolute; left: 350px; top: 422px; width: 100px; height: 17px; text-align:center;  ">
        <a id="evt_rec" class="MediumBold" href="nmsView.dll?navigate&amp;url=http://{//host/@address}/mbevents.cgi" style="text-decoration:none"  target="_blank"  onmouseover="changeImage('hist', './lib/img/button_white_over.gif')" onmouseout="restoreImage('hist')">
         <script type="text/javascript"> translate_text('evt_rec', 'Eventrecorder');</script>
       </a>
      </div>
    </xsl:if>

    <xsl:variable name="adr154">
      <xsl:call-template name="getfixedbitstring">
        <xsl:with-param name="val" select="value[@name='ADR154']/@val"/>
        <xsl:with-param name="dir" select="-1"/>
        <xsl:with-param name="places" select="16"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="adr155">
      <xsl:call-template name="getfixedbitstring">
        <xsl:with-param name="val" select="value[@name='ADR155']/@val"/>
        <xsl:with-param name="dir" select="-1"/>
        <xsl:with-param name="places" select="16"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="adr156">
      <xsl:call-template name="getfixedbitstring">
        <xsl:with-param name="val" select="value[@name='ADR156']/@val"/>
        <xsl:with-param name="dir" select="-1"/>
        <xsl:with-param name="places" select="16"/>
      </xsl:call-template>
    </xsl:variable>


    <xsl:call-template name="modbusled-flash-freq-inverse">
      <xsl:with-param name="x" select="368"/>
      <xsl:with-param name="y" select="250"/>
      <xsl:with-param name="w" select="10"/>
      <xsl:with-param name="h" select="10"/>
      <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/'" />
      <xsl:with-param name="adrs_dec" select="value[@name='ADR154']/@val"/>
      <xsl:with-param name="high" select="1"/>
      <xsl:with-param name="swap-red-green" select="1" />
    </xsl:call-template>
    <xsl:call-template name="modbusled-flash-freq-inverse"><!-- source 1-->
      <xsl:with-param name="x" select="239"/>
      <xsl:with-param name="y" select="198"/>
      <xsl:with-param name="w" select="10"/>
      <xsl:with-param name="h" select="10"/>
      <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/'" />
      <xsl:with-param name="adrs_dec" select="value[@name='ADR156']/@val"/>
      <xsl:with-param name="high" select="0"/>
      <xsl:with-param name="swap-red-green" select="1" />
    </xsl:call-template>
    <xsl:call-template name="modbusled-flash-freq-inverse"><!-- source 2-->
      <xsl:with-param name="x" select="239"/>
      <xsl:with-param name="y" select="302"/>
      <xsl:with-param name="w" select="10"/>
      <xsl:with-param name="h" select="10"/>
      <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/'" />
      <xsl:with-param name="adrs_dec" select="value[@name='ADR155']/@val"/>
      <xsl:with-param name="high" select="1"/>
      <xsl:with-param name="swap-red-green" select="1" />
    </xsl:call-template>

    <xsl:variable name="switch" 	select="value[@name='ADR8F']/@val"/>

    <xsl:variable name="volt1mains1">
      <xsl:choose>
        <xsl:when test="$switch = 1">
          <xsl:value-of select="value[@name='INVOLT']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR68']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="volt2mains1">
      <xsl:choose>
        <xsl:when test="$switch = 1">
          <xsl:value-of select="value[@name='INVOLT']/@val2"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR69']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="volt3mains1">
      <xsl:choose>
        <xsl:when test="$switch = 1">
          <xsl:value-of select="value[@name='INVOLT']/@val3"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR6A']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="volt1mains2">
      <xsl:choose>
        <xsl:when test="$switch = 1">
          <xsl:value-of select="value[@name='ADR70']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR73']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="volt2mains2">
      <xsl:choose>
        <xsl:when test="$switch = 1">
          <xsl:value-of select="value[@name='ADR71']/@val2"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR74']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="volt3mains2">
      <xsl:choose>
        <xsl:when test="$switch = 1">
          <xsl:value-of select="value[@name='ADR72']/@val3"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR75']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="volt1out">
      <xsl:choose>
        <xsl:when test="$switch = 1">
          <xsl:value-of select="value[@name='ADR7B']/@val"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR7E']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="volt2out">
      <xsl:choose>
        <xsl:when test="$switch = 1">
          <xsl:value-of select="value[@name='ADR7C']/@val2"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR7F']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="volt3out">
      <xsl:choose>
        <xsl:when test="$switch = 1">
          <xsl:value-of select="value[@name='ADR7D']/@val3"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="value[@name='ADR80']/@val"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="pageX1"   select="520"/>
    <xsl:variable name="pageX2"   select="$pageX1+ 40"/>
    <xsl:variable name="pageX3"   select="$pageX2+ 65"/>
    <xsl:variable name="pageX3u"   select="645"/>
    <xsl:variable name="pageY"    select="203"/>
    <xsl:variable name="lineheight"   select="12"/>
    <xsl:variable name="columnwidth"    select="48"/>
    <xsl:variable name="smallcolumnwidth"    select="25"/>
    <xsl:variable name="bigcolumnwidth"    select="100"/>
    <!-- MAINS1_AT-->

    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'IN1:'" />
      <xsl:with-param name="text2"  select="'L1:'" />
      <xsl:with-param name="text3" select="'L2:'" />
      <xsl:with-param name="text4" select="'L3:'" />
      <xsl:with-param name="visibility" select="'visible'"/>
      <xsl:with-param name="name" select="'page0'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX2"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="60"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value1" select="value[@name='ADR63']/@val" />
      <xsl:with-param name="unit1" select="'kVA'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2"  select="$volt1mains1" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="$volt2mains1" />
      <xsl:with-param name="unit3" select="'V'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="$volt3mains1" />
      <xsl:with-param name="unit4" select="'V'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'visible'"/>
      <xsl:with-param name="name" select="'page0'"/>
    </xsl:call-template>

    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX3"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="60"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value1" select="value[@name='INFREQ']/@val" />
      <xsl:with-param name="unit1" select="'Hz'"/>
      <xsl:with-param name="precision1" select="1"/>
      <xsl:with-param name="value2"  select="value[@name='ADR6B']/@val" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='ADR6C']/@val" />
      <xsl:with-param name="unit3" select="'A'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="value[@name='ADR6D']/@val" />
      <xsl:with-param name="unit4" select="'A'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'visible'"/>
      <xsl:with-param name="name" select="'page0'"/>
    </xsl:call-template>

    <!-- MAINS2_AT -->
    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'IN2:'" />
      <xsl:with-param name="text2" select="'L1:'" />
      <xsl:with-param name="text3" select="'L2:'" />
      <xsl:with-param name="text4" select="'L3:'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page1'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX2"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="60"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value1"  select="value[@name='ADR6E']/@val" />
      <xsl:with-param name="unit1" select="'kVA'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="$volt1mains2" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="$volt2mains2" />
      <xsl:with-param name="unit3" select="'V'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="$volt3mains2" />
      <xsl:with-param name="unit4" select="'V'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page1'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX3"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="60"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value1"  select="value[@name='ADR6F']/@val div 10.0" />
      <xsl:with-param name="unit1" select="'Hz'"/>
      <xsl:with-param name="precision1" select="1"/>
      <xsl:with-param name="value2" select="value[@name='ADR76']/@val" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='ADR77']/@val" />
      <xsl:with-param name="unit3" select="'A'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="value[@name='ADR78']/@val" />
      <xsl:with-param name="unit4" select="'A'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page1'"/>
    </xsl:call-template>

    <!-- OUTPUT -->
    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'OUT:'" />
      <xsl:with-param name="text2" select="'L1:'" />
      <xsl:with-param name="text3" select="'L2:'" />
      <xsl:with-param name="text4" select="'L3:'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page2'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text("page21", ['OUT', ':']);</script>
    
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX2"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="60"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value1"  select="value[@name='ADR79']/@val" />
      <xsl:with-param name="unit1" select="'kVA'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="$volt1out" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="$volt2out" />
      <xsl:with-param name="unit3" select="'V'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="$volt3out" />
      <xsl:with-param name="unit4" select="'V'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page2'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX3"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="60"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value1"  select="value[@name='ADR7A']/@val div 10.0" />
      <xsl:with-param name="unit1" select="'Hz'"/>
      <xsl:with-param name="precision1" select="1"/>
      <xsl:with-param name="value2" select="value[@name='ADR81']/@val" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='ADR82']/@val" />
      <xsl:with-param name="unit3" select="'A'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="value[@name='ADR83']/@val" />
      <xsl:with-param name="unit4" select="'A'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page2'"/>
    </xsl:call-template>

    <xsl:variable name="datetime" select="//report/@time"/>
    <xsl:variable name="date" select="concat('', substring-before($datetime, ' '))"/>
    <xsl:variable name="time" select="concat('', substring-after($datetime, ' '))"/>

    <!-- DEFAULT -->
    <xsl:call-template name="paneText">
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="60"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="value"  select="$date" />
      <xsl:with-param name="unit" select="' '"/>
      <xsl:with-param name="name" select="'page3'"/>
    </xsl:call-template>
    <xsl:call-template name="paneText">
      <xsl:with-param name="x" select="$pageX3"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="60"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="align" select="'right'" />
      <xsl:with-param name="value"  select="$time" />
      <xsl:with-param name="unit" select="' '"/>
      <xsl:with-param name="name" select="'page3'"/>
    </xsl:call-template>

    <!-- RETRANSFER -->
    <xsl:call-template name="paneText">
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY + 15"/>
      <xsl:with-param name="w" select="170"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="value"  select="'RETRANSFER'" />
      <xsl:with-param name="unit" select="' '"/>
      <xsl:with-param name="name" select="'page3_0'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page3_0', 'RETRANSFER');</script>

    <xsl:call-template name="paneRow">
      <xsl:with-param name="xT" select="$pageX1"/>
      <xsl:with-param name="yT" select="$pageY + 30"/>
      <xsl:with-param name="wT" select="90"/>
      <xsl:with-param name="hT" select="13"/>
      <xsl:with-param name="alignT" select="'left'" />
      <xsl:with-param name="text"  select="'ACTUALTIME'" />
      <xsl:with-param name="w" select="70"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="value" select="value[@name='ADR87']/@val" />
      <xsl:with-param name="unit" select="'S'"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page3_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page3_10', 'ACTUALTIME');</script>

    <!-- CURRENT -->
    <xsl:call-template name="paneText">
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY + 1"/>
      <xsl:with-param name="w" select="124"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="value"  select="'NEUTRAL CURRENT:'" />
      <xsl:with-param name="unit" select="' '"/>
      <xsl:with-param name="name" select="'page4_0'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page4_0', ['NEUTRAL CURRENT',':']);</script>

    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY + 14"/>
      <xsl:with-param name="w" select="124"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'MAINS1'" />
      <xsl:with-param name="text2" select="'MAINS2'" />
      <xsl:with-param name="text3" select="'PHASE'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page4_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page4_11', ['MAINS', '1']);</script>
    <script type="text/javascript"> translate_text('page4_12', ['MAINS', '2']);</script>
    <script type="text/javascript"> translate_text('page4_13', 'PHASE');</script>

    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="$pageX3"/>
      <xsl:with-param name="y" select="$pageY + 15"/>
      <xsl:with-param name="w" select="60"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="align" select="'right'" />
      <xsl:with-param name="value1"  select="value[@name='ADR84']/@val" />
      <xsl:with-param name="unit1" select="'A'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="value[@name='ADR85']/@val" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='ADR86']/@val" />
      <xsl:with-param name="unit3" select="'DGR'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page4'"/>
    </xsl:call-template>

    <!-- TRANSFER -->
    <xsl:variable name="adr90flag">
      <xsl:choose>
        <xsl:when test="value[@name='ADR90']/@val = 1">
          <xsl:value-of select="'*'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="' '"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="adr91flag">
      <xsl:choose>
        <xsl:when test="value[@name='ADR91']/@val = 1">
          <xsl:value-of select="'*'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="' '"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:call-template name="paneText">
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY + 1"/>
      <xsl:with-param name="w" select="120"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="value"  select="'TRANSFER AUTOMATIC'" />
      <xsl:with-param name="unit" select="' '"/>
      <xsl:with-param name="name" select="'page5_0'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page5_0', 'TRANSFER AUTOMATIC');</script>

    <xsl:call-template name="paneText">
      <xsl:with-param name="x" select="$pageX1 + 2"/>
      <xsl:with-param name="y" select="$pageY + 12"/>
      <xsl:with-param name="w" select="120"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="value"  select="'COUNT'" />
      <xsl:with-param name="unit" select="' '"/>
      <xsl:with-param name="name" select="'page5_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page5_1', 'COUNT ');</script>

    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="2"/>
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY + 26"/>
      <xsl:with-param name="w" select="15"/>
      <xsl:with-param name="h" select="11"/>
      <xsl:with-param name="align" select="'center'" />
      <xsl:with-param name="text1"  select="$adr90flag" />
      <xsl:with-param name="text2" select="$adr91flag" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page5'"/>
    </xsl:call-template>

    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="2"/>
      <xsl:with-param name="x" select="$pageX1 + 10"/>
      <xsl:with-param name="y" select="$pageY + 26"/>
      <xsl:with-param name="w" select="85"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="align" select="'center'" />
      <xsl:with-param name="text1"  select="'TRANSFER 1->2'" />
      <xsl:with-param name="text2" select="'TRANSFER 2->1'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page5_2'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page5_21', ['TRANSFER', ' 1->2:']);</script>
    <script type="text/javascript"> translate_text('page5_22', ['TRANSFER', ' 2->1:']);</script>

    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="2"/>
      <xsl:with-param name="x" select="$pageX3 + 26"/>
      <xsl:with-param name="y" select="$pageY + 26"/>
      <xsl:with-param name="w" select="80"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="value1"  select="value[@name='ADR88']/@val" />
      <xsl:with-param name="unit1" select="' '"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="value[@name='ADR89']/@val" />
      <xsl:with-param name="unit2" select="' '"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page5'"/>
    </xsl:call-template>

    <!-- HOURS -->
    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX1"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="100"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'SCR-STACK 1:'" />
      <xsl:with-param name="text2"  select="'SCR-STACK 2:'" />
      <xsl:with-param name="text3"  select="'FAN 1:'" />
      <xsl:with-param name="text4"  select="'FAN 2:'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page6_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page6_11', ['SCR-STACK', ' 1:']);</script>
    <script type="text/javascript"> translate_text('page6_12', ['SCR-STACK', ' 2:']);</script>
    <script type="text/javascript"> translate_text('page6_13', ['FAN', ' 1:']);</script>
    <script type="text/javascript"> translate_text('page6_14', ['FAN', ' 2:']);</script>

    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$pageX3 -30"/>
      <xsl:with-param name="y" select="$pageY"/>
      <xsl:with-param name="w" select="90"/>
      <xsl:with-param name="h" select="13"/>
      <xsl:with-param name="align" select="'right'" />
      <xsl:with-param name="value1"  select="value[@name='ADR9C']/@val*65536.0 + value[@name='ADR9B']/@val" />
      <xsl:with-param name="unit1" select="'H'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2"  select="value[@name='ADRA4']/@val*65536.0 + value[@name='ADRA3']/@val" />
      <xsl:with-param name="unit2" select="'H'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3"  select="value[@name='ADR94']/@val*65536.0 + value[@name='ADR93']/@val" />
      <xsl:with-param name="unit3" select="'H'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4"  select="value[@name='ADR98']/@val*65536.0 + value[@name='ADR97']/@val" />
      <xsl:with-param name="unit4" select="'H'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page6'"/>
    </xsl:call-template>

    <!-- EOT -->
  </xsl:template>

  <!-- EOS -->
</xsl:stylesheet>
