<?xml version="1.0"?>
<!--
   modbuscommon.xsl - XSL-templates for Piller/MODBUS@UNMS-II.
   Copyright (c) 2005, Generex GmbH. All rights reserved.
   klaus
   last update 2010 said
   changed template-funct : horizontal-bar, horizontal-bar-2, vertical-bar, vertical-bar-2
   new template-funct :	modbuslednew_apt3	, serial number.
-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="xml" indent="yes" omit-xml-declaration="yes" encoding="ISO-8859-1"/>

  <xsl:template name="get-color-from-load">
    <xsl:param name="load"/>
    <xsl:choose>
      <!--<xsl:when test="$load &lt; 1">
      <xsl:value-of select="'#c0c0c0'"/>-->
      <xsl:when test="$load &lt; 105">
        <xsl:value-of select="'#00FF00'"/>
      </xsl:when>
      <!--<xsl:when test="$load &lt; 90">
        <xsl:value-of select="'#00FF00'"/>
      </xsl:when>
      <xsl:when test="$load &lt; 110">
        <xsl:value-of select="'#f2ed41'"/>
      </xsl:when>-->
      <xsl:otherwise>
        <xsl:value-of select="'#DC3632'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="all-or-nothing-value">
    <xsl:param name="value" select="32767" />
    <xsl:param name="indicator" select="32767" />
    <xsl:param name="nothing-tag" select="'---'" />
    <xsl:param name="precision" select="0" />
    <xsl:param name="unit" select="''" />

    <xsl:variable name="real-val">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$value"/>
        <xsl:with-param name="precision" select="$precision" />
      </xsl:call-template>
    </xsl:variable>

    <xsl:choose>
      <xsl:when test="$value = $indicator">
        <xsl:value-of select="$nothing-tag"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="concat($real-val, $unit)"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="modbuslednew">
    <xsl:param name="x" select="0" />
    <xsl:param name="y" select="0" />
    <xsl:param name="w" select="0" />
    <xsl:param name="h" select="0" />
    <xsl:param name="dw" select="0" />
    <xsl:param name="dh" select="0" />
    <xsl:param name="adrs" select="'0000000000000000'" />
    <xsl:param name="high" select="0" />
    <xsl:param name="imagepath" select ="'./image/'"/>
    <xsl:param name="swap-red-green" select ="0"/>
    <xsl:param name="use_flash_freq" select="0"/>
    <xsl:param name="adrs_dec" select="0" />

    <xsl:variable name="bitgreen">
      <xsl:choose>
        <xsl:when test="$swap-red-green = 0">
          <xsl:value-of select="$high*8+1"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$high*8 + 4 +1"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="bitred">
      <xsl:choose>
        <xsl:when test="$swap-red-green = 0">
          <xsl:value-of select="$high*8 + 4 +1"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$high*8 + 1"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="flashgreen">
      <xsl:choose>
        <xsl:when test="substring($adrs, $bitgreen+1, 1)='1' or substring($adrs, $bitgreen+2, 1)='1'">1</xsl:when>
        <xsl:otherwise>0</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="flashred">
      <xsl:choose>
        <xsl:when test="substring($adrs, $bitred+1, 1)='1' or substring($adrs, $bitred+2, 1)='1'">1</xsl:when>
        <xsl:otherwise>0</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="color">
      <xsl:choose>
        <xsl:when test="substring($adrs, $bitgreen, 1)='1' and  substring($adrs, $bitred, 1)='1' or ($flashred=1 and $flashgreen=1)">gelb</xsl:when>
        <xsl:when test="substring($adrs, $bitred, 1)='1' or $flashred=1">rot</xsl:when>
        <xsl:when test="substring($adrs, $bitgreen, 1)='1' or $flashgreen=1">gruen</xsl:when>
        <xsl:otherwise>grau</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <!-- LED -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y"/>px;width:<xsl:value-of select="$w"/>px;height:<xsl:value-of select="$h"/>px
      </xsl:attribute>
      <xsl:call-template name="ledimg">
        <xsl:with-param name="w" select="$w"/>
        <xsl:with-param name="h" select="$h"/>
        <xsl:with-param name="dw" select="$dw"/>
        <xsl:with-param name="dh" select="$dh"/>
        <xsl:with-param name="imagepath" select="$imagepath"/>
        <xsl:with-param name="color" select="$color"/>
        <xsl:with-param name="flash" select="$flashred=1 or $flashgreen=1"/>
        <xsl:with-param name="use_flash_freq" select="$use_flash_freq"/>
        <xsl:with-param name="adrs_dec" select="$adrs_dec" />
      </xsl:call-template>
    </xsl:element>
    <!--debug-->
    <!--
	<xsl:element name="div">
		<xsl:attribute name="style">position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y+30"/>px;width:<xsl:value-of select="$w"/>:px;height:<xsl:value-of select="$h"/>px</xsl:attribute>
         w:<xsl:value-of select="$w"/>,h:<xsl:value-of select="$h"/><br/>
         fr:<xsl:value-of  select="$flashred"/>, fg:<xsl:value-of  select="$flashgreen"/><br/>
         frg:<xsl:value-of  select="$flashred=1 or $flashgreen=1"/><br/>
         high:<xsl:value-of  select="$high"/><br/>
         adrs:<xsl:value-of  select="$adrs"/><br/>
         bg:<xsl:value-of  select="$bitgreen"/>, br<xsl:value-of  select="$bitred"/><br/>

	</xsl:element>
	-->

  </xsl:template>

  <xsl:template name="modbusled-flash-freq">
    <xsl:param name="x" select="0" />
    <xsl:param name="y" select="0" />
    <xsl:param name="w" select="0" />
    <xsl:param name="h" select="0" />
    <xsl:param name="dw" select="0" />
    <xsl:param name="dh" select="0" />
    <xsl:param name="high" select="0" />
    <xsl:param name="imagepath" select ="'./image/'"/>
    <xsl:param name="swap-red-green" select ="0"/>
    <xsl:param name="use_flash_freq" select="0"/>
    <xsl:param name="adrs_dec" select="0" />
    <xsl:param name="img_id" select="''" />

    <xsl:variable name="low_byte">
      <xsl:choose>
        <xsl:when test="$high=1">
          <xsl:value-of  select="round($adrs_dec div 256)"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of  select="$adrs_dec mod 256"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <script type="text/javascript">
      //alert('<xsl:value-of  select="$adrs_dec"/>');
      //alert('<xsl:value-of  select="$low_byte"/>');
    </script>


    <xsl:variable name="flash">
      <xsl:choose>
        <xsl:when test="$low_byte=2 or $low_byte=3 or $low_byte=4">
          <xsl:value-of  select="1"/>
        </xsl:when>
        <xsl:when test="$low_byte=32 or $low_byte=48 or $low_byte=64">
          <xsl:value-of  select="1"/>
        </xsl:when>
        <xsl:when test="$low_byte=34 or $low_byte=51 or $low_byte=68">
          <xsl:value-of  select="1"/>
        </xsl:when>
        <xsl:when test="$low_byte=82 or $low_byte=99 or $low_byte=116">
          <xsl:value-of  select="1"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of  select="0"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>


    <xsl:variable name="color">
      <xsl:choose>
        <xsl:when test="$low_byte=1 or $low_byte=2 or $low_byte=3 or $low_byte=4">rot</xsl:when>
        <xsl:when test="$low_byte=16 or $low_byte=32 or $low_byte=48 or $low_byte=64">gruen</xsl:when>
        <xsl:when test="$low_byte=17 or $low_byte=34 or $low_byte=51 or $low_byte=68">gelb</xsl:when>
        <xsl:when test="$low_byte=82 or $low_byte=99 or $low_byte=116">rot_gruen</xsl:when>
        <xsl:otherwise>grau</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <!-- LED -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y"/>px;width:<xsl:value-of select="$w"/>:px;height:<xsl:value-of select="$h"/>px
      </xsl:attribute>
      <xsl:call-template name="ledimg">
        <xsl:with-param name="w" select="$w"/>
        <xsl:with-param name="h" select="$h"/>
        <xsl:with-param name="dw" select="$dw"/>
        <xsl:with-param name="dh" select="$dh"/>
        <xsl:with-param name="imagepath" select="$imagepath"/>
        <xsl:with-param name="color" select="$color"/>
        <xsl:with-param name="flash" select="$flash"/>
        <xsl:with-param name="use_flash_freq" select="$use_flash_freq"/>
        <xsl:with-param name="adrs_dec" select="$adrs_dec" />
        <xsl:with-param name="high" select="$high" />
        <xsl:with-param name="img_id" select="$img_id" />
      </xsl:call-template>
    </xsl:element>
    <!--debug-->
    <!--
	<xsl:element name="div">
		<xsl:attribute name="style">position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y+30"/>px;width:<xsl:value-of select="$w"/>:px;height:<xsl:value-of select="$h"/>px</xsl:attribute>
         w:<xsl:value-of select="$w"/>,h:<xsl:value-of select="$h"/><br/>
         fr:<xsl:value-of  select="$flashred"/>, fg:<xsl:value-of  select="$flashgreen"/><br/>
         frg:<xsl:value-of  select="$flashred=1 or $flashgreen=1"/><br/>
         high:<xsl:value-of  select="$high"/><br/>
         adrs:<xsl:value-of  select="$adrs"/><br/>
         bg:<xsl:value-of  select="$bitgreen"/>, br<xsl:value-of  select="$bitred"/><br/>

	</xsl:element>
	-->

  </xsl:template>


  <xsl:template name="modbusled-flash-freq-inverse">
    <xsl:param name="x" select="0" />
    <xsl:param name="y" select="0" />
    <xsl:param name="w" select="0" />
    <xsl:param name="h" select="0" />
    <xsl:param name="dw" select="0" />
    <xsl:param name="dh" select="0" />
    <xsl:param name="high" select="0" />
    <xsl:param name="imagepath" select ="'./image/'"/>
    <xsl:param name="swap-red-green" select ="0"/>
    <xsl:param name="use_flash_freq" select="0"/>
    <xsl:param name="adrs_dec" select="0" />
    <xsl:param name="img_id" select="''" />

    <xsl:variable name="low_byte">
      <xsl:choose>
        <xsl:when test="$high=1">
          <xsl:value-of  select="round($adrs_dec div 256)"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of  select="$adrs_dec mod 256"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="flash">
      <xsl:choose>
        <xsl:when test="$low_byte=2 or $low_byte=3 or $low_byte=4">
          <xsl:value-of  select="1"/>
        </xsl:when>
        <xsl:when test="$low_byte=32 or $low_byte=48 or $low_byte=64">
          <xsl:value-of  select="1"/>
        </xsl:when>
        <xsl:when test="$low_byte=34 or $low_byte=51 or $low_byte=68">
          <xsl:value-of  select="1"/>
        </xsl:when>
        <xsl:when test="$low_byte=82 or $low_byte=99 or $low_byte=116">
          <xsl:value-of  select="1"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of  select="0"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>


    <xsl:variable name="color">
      <xsl:choose>
        <xsl:when test="$low_byte=1 or $low_byte=2 or $low_byte=3 or $low_byte=4">gruen</xsl:when>
        <xsl:when test="$low_byte=16 or $low_byte=32 or $low_byte=48 or $low_byte=64">rot</xsl:when>
        <xsl:when test="$low_byte=17 or $low_byte=34 or $low_byte=51 or $low_byte=68">gelb</xsl:when>
        <xsl:when test="$low_byte=82 or $low_byte=99 or $low_byte=116">gruenrot</xsl:when>
        <xsl:otherwise>grau</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <!-- LED -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y"/>px;width:<xsl:value-of select="$w"/>:px;height:<xsl:value-of select="$h"/>px
      </xsl:attribute>
      <xsl:call-template name="ledimg">
        <xsl:with-param name="w" select="$w"/>
        <xsl:with-param name="h" select="$h"/>
        <xsl:with-param name="dw" select="$dw"/>
        <xsl:with-param name="dh" select="$dh"/>
        <xsl:with-param name="imagepath" select="$imagepath"/>
        <xsl:with-param name="color" select="$color"/>
        <xsl:with-param name="flash" select="$flash"/>
        <xsl:with-param name="use_flash_freq" select="$use_flash_freq"/>
        <xsl:with-param name="adrs_dec" select="$adrs_dec" />
        <xsl:with-param name="high" select="$high" />
        <xsl:with-param name="img_id" select="$img_id" />
      </xsl:call-template>
    </xsl:element>

  </xsl:template>

  <xsl:template name="modbuslednew_apt3">
    <xsl:param name="x" select="0" />
    <xsl:param name="y" select="0" />
    <xsl:param name="w" select="0" />
    <xsl:param name="h" select="0" />
    <xsl:param name="dw" select="0" />
    <xsl:param name="dh" select="0" />
    <xsl:param name="adrs" select="'0000000000000000'" />
    <xsl:param name="adrs_val_dec" select="'0'" />
    <xsl:param name="high" select="0" />
    <xsl:param name="imagepath" select ="'./image/'"/>
    <xsl:param name="swap-red-green" select ="0"/>

    <xsl:variable name="byte_val">
      <xsl:choose>
        <xsl:when test="$high = 0">
          <xsl:call-template name="bit-and">
            <xsl:with-param name="val1" select="255"/>
            <xsl:with-param name="val2" select="$adrs_val_dec"/>
            <xsl:with-param name="places" select="8"/>
          </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="roundDecimal">
            <xsl:with-param name="value" select="$adrs_val_dec div 256" />
            <xsl:with-param name="precision" select="0" />
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="bitgreen">
      <xsl:choose>
        <xsl:when test="$swap-red-green = 0">
          <xsl:value-of select="$high*8+1"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$high*8 + 4 +1"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="bitred">
      <xsl:choose>
        <xsl:when test="$swap-red-green = 0">
          <xsl:value-of select="$high*8 + 4 +1"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$high*8 + 1"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="flashgreen">
      <xsl:choose>
        <xsl:when test="substring($adrs, $bitgreen+1, 1)='1' or substring($adrs, $bitgreen+2, 1)='1'">1</xsl:when>
        <xsl:otherwise>0</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="flashred">
      <xsl:choose>
        <xsl:when test="substring($adrs, $bitred+1, 1)='1' or substring($adrs, $bitred+2, 1)='1'">1</xsl:when>
        <xsl:otherwise>0</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="color">
      <xsl:choose>
        <xsl:when test="$byte_val='17' or $byte_val='34' or $byte_val='51' or $byte_val='68'">gelb</xsl:when>
        <xsl:when test="$byte_val='82' or $byte_val='99' or $byte_val='116'">gruenrot</xsl:when>
        <xsl:when test="substring($adrs, $bitred, 1)='1' or $flashred='1'">rot</xsl:when>
        <xsl:when test="substring($adrs, $bitgreen, 1)='1' or $flashgreen='1'">gruen</xsl:when>
        <xsl:otherwise>grau</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <!-- LED -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;text-align:center;align:center;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y"/>px;width:<xsl:value-of select="$w"/>:px;height:<xsl:value-of select="$h"/>px
      </xsl:attribute>
      <xsl:call-template name="ledimg">
        <xsl:with-param name="w" select="$w"/>
        <xsl:with-param name="h" select="$h"/>
        <xsl:with-param name="dw" select="$dw"/>
        <xsl:with-param name="dh" select="$dh"/>
        <xsl:with-param name="imagepath" select="$imagepath"/>
        <xsl:with-param name="color" select="$color"/>
        <xsl:with-param name="flash" select="$flashred=1 or $flashgreen=1"/>
      </xsl:call-template>
    </xsl:element>

    <!--<script type="text/javascript">
  	alert("flashred:"+'<xsl:value-of select="$flashred"/>'+" byte_val:"+'<xsl:value-of select="$byte_val"/>'+" flashgreen:"+'<xsl:value-of select="$flashgreen"/>');
  </script>-->

  </xsl:template>


  <xsl:template name="modbusledold">
    <xsl:param name="x" select="0" />
    <xsl:param name="y" select="0" />
    <xsl:param name="w" select="0" />
    <xsl:param name="h" select="0" />
    <xsl:param name="adrsStatic" select="'0000000000000000'" />
    <xsl:param name="adrsFlash" select="'0000000000000000'" />
    <xsl:param name="bit" select="0" />
    <xsl:param name="imagepath" select ="'./image/'"/>

    <xsl:variable name="bitgreen" select="$bit+1"/>
    <xsl:variable name="bitred"   select="$bit"/>
    <xsl:variable name="flashgreen">
      <xsl:choose>
        <xsl:when test="substring($adrsFlash, $bitgreen, 1)='1' and substring($adrsStatic, $bitgreen, 1)='0'">1</xsl:when>
        <xsl:otherwise>0</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="flashred">
      <xsl:choose>
        <xsl:when test="substring($adrsFlash, $bitred, 1)='1' and substring($adrsStatic, $bitred, 1)='0'">1</xsl:when>
        <xsl:otherwise>0</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="color">
      <xsl:choose>
        <xsl:when test="substring($adrsStatic, $bitgreen, 1)='1' and  substring($adrsStatic, $bitred, 1)='1' or ($flashred=1 and $flashgreen=1)">gelb</xsl:when>
        <xsl:when test="substring($adrsStatic, $bitred, 1)='1' or $flashred=1">rot</xsl:when>
        <xsl:when test="substring($adrsStatic, $bitgreen, 1)='1' or $flashgreen=1">gruen</xsl:when>
        <xsl:otherwise>grau</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <!-- LED -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y"/>px;width:<xsl:value-of select="$w"/>:px;height:<xsl:value-of select="$h"/>px
      </xsl:attribute>
      <xsl:call-template name="ledimg">
        <xsl:with-param name="w" select="$w"/>
        <xsl:with-param name="h" select="$h"/>
        <xsl:with-param name="imagepath" select="$imagepath"/>
        <xsl:with-param name="color" select="$color"/>
        <xsl:with-param name="flash" select="$flashred=1 or $flashgreen=1"/>
      </xsl:call-template>
    </xsl:element>
    <!--debug-->
    <!--
	<xsl:element name="div">
		<xsl:attribute name="style">position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y+30"/>px;width:<xsl:value-of select="$w"/>:px;height:<xsl:value-of select="$h"/>px</xsl:attribute>
         w:<xsl:value-of select="$w"/>,h:<xsl:value-of select="$h"/><br/>
         fr:<xsl:value-of  select="$flashred"/>, fg:<xsl:value-of  select="$flashgreen"/><br/>
         frg:<xsl:value-of  select="$flashred=1 or $flashgreen=1"/><br/>
         high:<xsl:value-of  select="$high"/><br/>
         adrs:<xsl:value-of  select="$adrs"/><br/>
         bg:<xsl:value-of  select="$bitgreen"/>, br<xsl:value-of  select="$bitred"/><br/>

	</xsl:element>
	-->

  </xsl:template>

  <xsl:template name="ledimg">
    <xsl:param name="w" select="10"/>
    <xsl:param name="h" select="10"/>
    <xsl:param name="dw" select="0"/>
    <xsl:param name="dh" select="0"/>
    <xsl:param name="imagepath" select="'../image'"/>
    <xsl:param name="color" select="gruen"/>
    <xsl:param name="flash" select="1"/>
    <xsl:param name="use_flash_freq" select="0"/>
    <xsl:param name="adrs_dec" select="0" />
    <xsl:param name="high" select="0" />
    <xsl:param name="img_id" select="''" />

    <xsl:variable name="freq_byte">
      <xsl:choose>
        <xsl:when test="$high=1">
          <xsl:value-of  select="round($adrs_dec div 256)"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of  select="$adrs_dec mod 256"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="freq_endname">
      <xsl:choose>
        <xsl:when test="$use_flash_freq = 1">
          <xsl:choose>
            <xsl:when test="$freq_byte=2 or $freq_byte=32  or $freq_byte=34  or $freq_byte=82">
              <xsl:value-of select="'_l'"/>
            </xsl:when>
            <xsl:when test="$freq_byte=3 or $freq_byte=48  or $freq_byte=51  or $freq_byte=99">
              <xsl:value-of select="'_m'"/>
            </xsl:when>
            <xsl:when test="$freq_byte=4 or $freq_byte=64  or $freq_byte=68  or $freq_byte=116">
              <xsl:value-of select="'_h'"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="''"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="''"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="srcnameend">
      <xsl:choose>
        <xsl:when test="$flash = 1">
          <xsl:value-of select="concat(concat(concat($w, 'x'),$h),concat(concat('_flash', $freq_endname),'.gif'))"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="concat(concat(concat($w, 'x'),$h),'.gif')"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:element name="img">
      <xsl:attribute name="src">
        <xsl:value-of select="concat(concat(concat($imagepath, 'led'), $color), $srcnameend)"/>
      </xsl:attribute>
      <xsl:attribute name="alt"></xsl:attribute>
      <xsl:attribute name="border">0</xsl:attribute>
      <xsl:attribute name="width">
        <xsl:value-of select="$w + $dw"/>
      </xsl:attribute>
      <xsl:attribute name="height">
        <xsl:value-of select="$h + $dh"/>
      </xsl:attribute>
      <xsl:if test="string-length($img_id) != 0">
        <xsl:attribute name="id">
          <xsl:value-of select="$img_id"/>
        </xsl:attribute>
      </xsl:if>
    </xsl:element>
  </xsl:template>

  <xsl:template name="switch">
    <xsl:param name="x" select="0"/>
    <xsl:param name="y" select="0"/>
    <xsl:param name="w" select="35"/>
    <xsl:param name="h" select="35"/>
    <xsl:param name="adrstr" select="'00000000'"/>
    <xsl:param name="bit" select="1"/>
    <xsl:param name="path" select="'./lib/ups/image/piller/'"/>

    <xsl:variable name="img-path">
      <xsl:choose>
        <xsl:when test="substring($adrstr, $bit,1) = '1' and substring($adrstr, $bit + 1 ,1) = '1'">
          <xsl:value-of select="concat($path, 'soge.gif')"/>
        </xsl:when>
        <xsl:when test="substring($adrstr, $bit+1,1) = '1'">
          <xsl:value-of select="concat($path, 'sor.gif')"/>
        </xsl:when>
        <xsl:when test="substring($adrstr, $bit,1) = '1'">
          <xsl:value-of select="concat($path, 'sggr.gif')"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="concat($path, 'sow.gif')"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <div style="position:absolute;left:{$x}px;top:{$y}px;width:{$w}px;height:{$h}px">
      <img src="{$img-path}" alt="" border="" width="{$w}" height="{$h}"/>
    </div>
  </xsl:template>

  <xsl:template name="ub4-switch">
    <xsl:param name="x" select="0"/>
    <xsl:param name="y" select="0"/>
    <xsl:param name="w" select="35"/>
    <xsl:param name="h" select="35"/>
    <xsl:param name="adrstr" select="'00000000'"/>
    <xsl:param name="bit" select="1"/>
    <xsl:param name="prefix" select="'ub4s'"/>
    <xsl:param name="path" select="'./lib/ups/image/piller/'"/>

    <xsl:variable name="type">
      <xsl:choose>
        <xsl:when test="substring($adrstr, $bit,1) = '1' ">
          <xsl:value-of select="concat($prefix, 'g')"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="concat($prefix, 'o')"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="img-ext">
      <xsl:call-template name="get-img-ext">
        <xsl:with-param name="bitstr" select="$adrstr"/>
        <xsl:with-param name="bit" select="$bit"/>
      </xsl:call-template>
    </xsl:variable>

    <xsl:variable name="img-path">
      <xsl:value-of select="concat($path, concat($type, concat($img-ext, '.gif')))"/>
    </xsl:variable>
    <!--
	<xsl:message>Img-path: <xsl:value-of select="$img-path"/></xsl:message>
	<xsl:message>adrstr: <xsl:value-of select="$adrstr"/></xsl:message>
	-->
    <div style="position:absolute;left:{$x}px;top:{$y}px;width:{$w}px;height:{$h}px;z-index:10;">
      <img src="{$img-path}" alt="" border="" width="{$w}" height="{$h}"/>
    </div>
  </xsl:template>

  <xsl:template name="two-bits-to-color">
    <xsl:param name="bitstr" select="'00000000'"/>
    <xsl:param name="bit" select="1"/>
    <xsl:choose>
      <xsl:when test="substring($bitstr, $bit,1) = '1' and substring($bitstr, $bit + 1 ,1) = '1'">
        <xsl:value-of select="'ge'"/>
      </xsl:when>
      <xsl:when test="substring($bitstr, $bit,1) = '0' and substring($bitstr, $bit + 1 ,1) = '1'">
        <xsl:value-of select="'r'"/>
      </xsl:when>
      <xsl:when test="substring($bitstr, $bit,1) = '1' and substring($bitstr, $bit + 1 ,1) = '0'">
        <xsl:value-of select="'gr'"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="'w'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="get-img-ext">
    <xsl:param name="bitstr" select="'00000000'"/>
    <xsl:param name="bit" select="0"/>

    <xsl:variable name="back-val">
      <xsl:call-template name="two-bits-to-color">
        <xsl:with-param name="bitstr" select="$bitstr"/>
        <xsl:with-param name="bit" select="$bit+4"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="flash-val">
      <xsl:call-template name="two-bits-to-color">
        <xsl:with-param name="bitstr" select="$bitstr"/>
        <xsl:with-param name="bit" select="$bit+6"/>
      </xsl:call-template>

    </xsl:variable>

    <xsl:message>
      Bitstr: <xsl:value-of select="$bitstr"/>
    </xsl:message>
    <xsl:message>
      flash: <xsl:value-of select="$flash-val"/>
    </xsl:message>
    <xsl:message>
      back: <xsl:value-of select="$back-val"/>
    </xsl:message>

    <xsl:choose>

      <xsl:when test="$flash-val = 'w' or $flash-val = $back-val">
        <xsl:value-of select="$back-val"/>
      </xsl:when>

      <xsl:when test="$back-val = 'w'">
        <xsl:value-of select="concat($flash-val, '_w')"/>
      </xsl:when>

      <xsl:when test="$back-val = 'r'">
        <xsl:choose>
          <xsl:when test="$flash-val = 'gr'">
            <xsl:value-of select="'r_gr'"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'ge_r'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>

      <xsl:when test="$back-val = 'gr'">
        <xsl:value-of select="concat($flash-val, '_gr')"/>
      </xsl:when>

      <xsl:when test="$back-val = 'ge'">
        <xsl:value-of select="concat('ge_',$flash-val)"/>
      </xsl:when>

      <xsl:otherwise>
        <xsl:value-of select="$back-val"/>
      </xsl:otherwise>
    </xsl:choose>

  </xsl:template>

  <xsl:template name="symbols">
    <xsl:param name="x" select="0"/>
    <xsl:param name="y" select="0"/>
    <xsl:param name="w" select="50"/>
    <xsl:param name="h" select="50"/>
    <xsl:param name="adrstr" select="'00000000'"/>
    <xsl:param name="bit" select="1"/>
    <xsl:param name="type" select="'wr'"/>
    <xsl:param name="path" select="'./lib/ups/image/piller/'"/>

    <xsl:variable name="img-path">
      <xsl:choose>
        <xsl:when test="substring($adrstr, $bit,1) = '1' and substring($adrstr, $bit + 1 ,1) = '1'">
          <xsl:value-of select="concat($path, concat($type, 'ge.gif'))"/>
        </xsl:when>
        <xsl:when test="substring($adrstr, $bit+1,1) = '1'">
          <xsl:value-of select="concat($path, concat($type, 'r.gif'))"/>
        </xsl:when>
        <xsl:when test="substring($adrstr, $bit,1) = '1'">
          <xsl:value-of select="concat($path, concat($type, 'gr.gif'))"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="concat($path, concat($type, 'w.gif'))"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <div style="position:absolute;left:{$x}px;top:{$y}px;width:{$w}px;height:{$h}px">
      <img src="{$img-path}" alt="" border="" width="{$w}" height="{$h}"/>
    </div>
  </xsl:template>

  <xsl:template name="ub4-symbols">
    <xsl:param name="x" select="0"/>
    <xsl:param name="y" select="0"/>
    <xsl:param name="w" select="50"/>
    <xsl:param name="h" select="50"/>
    <xsl:param name="adrstr" select="'00000000'"/>
    <xsl:param name="bit" select="1"/>
    <xsl:param name="type" select="'wr'"/>
    <xsl:param name="path" select="'./lib/ups/image/piller/'"/>
    <xsl:variable name="img-ext">
      <xsl:call-template name="get-img-ext">
        <xsl:with-param name="bitstr" select="$adrstr"/>
        <xsl:with-param name="bit" select="$bit"/>
      </xsl:call-template>
    </xsl:variable>

    <xsl:variable name="img-path">
      <xsl:value-of select="concat($path, concat($type, concat($img-ext, '.gif')))"/>
    </xsl:variable>

    <div style="position:absolute;left:{$x}px;top:{$y}px;width:{$w}px;height:{$h}px;z-index:10">
      <img src="{$img-path}" alt="" border="" width="{$w}" height="{$h}"/>
    </div>
  </xsl:template>

  <xsl:template name="horizontal-bar">
    <xsl:param name="x" select="0"/>
    <xsl:param name="y" select="0"/>
    <xsl:param name="w" select="50"/>
    <xsl:param name="h" select="5"/>
    <xsl:param name="left-border" select="0"/>
    <xsl:param name="right-border" select="0"/>
    <xsl:param name="adrstr" select="'00000000'"/>
    <xsl:param name="bit" select="1"/>
    <xsl:param name="path" select="'./lib/ups/image/piller/'"/>
    <xsl:param name="z-index" select="1"/>

    <xsl:variable name="path-color">
      <xsl:choose>
        <xsl:when test="substring($adrstr, $bit,1) = '1'">
          <xsl:value-of select="'#00FF00'"/>
          <!--green-->
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'#CCCCCC'"/>
          <!--gray-->
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name ="border-color" select="'#000000'"/>
    <!--black-->

    <!-- Lower border-->
    <div style="position:absolute;left:{$x}px;top:{$y + 1 +$h}px;width:{$w}px;height:1px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>

    <!-- Inner area   background-color:#00FF00;-->
    <div id= "meinDiv" style="position:absolute;left:{$x}px;top:{$y + 1}px;width:{$w}px;height:{$h}px;z-index:{$z-index}; background-color:{$path-color};overflow:hidden;"/>

    <!-- Upper border -->
    <div style="position:absolute;left:{$x}px;top:{$y}px;width:{$w}px;height:1px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>

    <!-- Left border -->
    <xsl:if test="$left-border != 0">
      <div style="position:absolute;left:{$x}px;top:{$y}px;width:1px;height:{$h + 2}px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>
    </xsl:if>

    <!-- Right border -->
    <xsl:if test="$right-border != 0">
      <div style="position:absolute;left:{$x + $w - 1}px;top:{$y}px;width:1px;height:{$h + 2}px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>
    </xsl:if>

  </xsl:template>

  <xsl:template name="horizontal-bar2">
    <xsl:param name="x" select="0"/>
    <xsl:param name="y" select="0"/>
    <xsl:param name="w" select="50"/>
    <xsl:param name="h" select="5"/>
    <xsl:param name="left-border" select="0"/>
    <xsl:param name="right-border" select="0"/>
    <xsl:param name="adrstr" select="'00000000'"/>
    <xsl:param name="bit" select="1"/>
    <xsl:param name="path" select="'./lib/ups/image/piller/'"/>
    <xsl:param name="z-index" select="1"/>

    <xsl:variable name="path-color">
      <xsl:choose>
        <xsl:when test="substring($adrstr, $bit,1) = '0' and substring($adrstr, $bit+1,1) = '1'">
          <xsl:value-of select="'#00FF00'"/>
          <!--light green-->
        </xsl:when>
        <xsl:when test="substring($adrstr, $bit,1) = '1' and substring($adrstr, $bit+1,1) = '0'">
          <xsl:value-of select="'#FF0000'"/>
          <!--light red-->
        </xsl:when>
        <xsl:when test="substring($adrstr, $bit,1) = '1' and substring($adrstr, $bit+1,1) = '1'">
          <xsl:value-of select="'#FFFF00'"/>
          <!--light yellow-->
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'#FFFFFF'"/>
          <!--white-->
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name ="border-color" select="'#000000'"/>
    <!--black-->

    <!-- Lower border -->
    <div style="position:absolute;left:{$x}px;top:{$y + 1 + $h}px;width:{$w}px;height:1px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>

    <!-- Inner area-->
    <div style="position:absolute;left:{$x}px;top:{$y + 1}px;width:{$w}px;height:{$h}px;z-index:{$z-index};background-color:{$path-color};overflow:hidden;"/>

    <!-- Upper border -->
    <div style="position:absolute;left:{$x}px;top:{$y}px;width:{$w}px;height:1px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>


    <!-- Left border -->
    <xsl:if test="$left-border != 0">
      <div style="position:absolute;left:{$x}px;top:{$y}px;width:1px;height:{$h + 2}px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>
    </xsl:if>

    <!-- Right border -->
    <xsl:if test="$right-border != 0">
      <div style="position:absolute;left:{$x + $w - 1}px;top:{$y}px;width:1px;height:{$h + 2}px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>
    </xsl:if>
  </xsl:template>
  <xsl:template name="horizontal-bar3">
    <xsl:param name="x" select="0"/>
    <xsl:param name="y" select="0"/>
    <xsl:param name="w" select="50"/>
    <xsl:param name="h" select="5"/>
    <xsl:param name="left-border" select="0"/>
    <xsl:param name="right-border" select="0"/>
    <xsl:param name="Lower-border" select="1"/>
    <xsl:param name="Upper-border" select="1"/>
    <xsl:param name="adrstr" select="'00000000'"/>
    <xsl:param name="bit" select="1"/>
    <xsl:param name="path" select="'./lib/ups/image/piller/'"/>
    <xsl:param name="z-index" select="1"/>
    <xsl:param name="id" select="'inner_div_id'"/>

    <xsl:variable name="path-color">
      <xsl:choose>
        <xsl:when test="substring($adrstr, $bit,1) = '1' and substring($adrstr, $bit+1,1) = '1'">
          <xsl:value-of select="'#FFFF00'"/>
          <!--light yellow-->
        </xsl:when>
        <xsl:when test="substring($adrstr, $bit,1) = '1'">
          <xsl:value-of select="'#00FF00'"/>
          <!--light green-->
        </xsl:when>
        <xsl:when test="substring($adrstr, $bit+1,1) = '1'">
          <xsl:value-of select="'#FF0000'"/>
          <!--light red-->
        </xsl:when>

        <xsl:otherwise>
          <xsl:value-of select="'#FFFFFF'"/>
          <!--white-->
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name ="border-color" select="'#000000'"/>
    <!--black-->

    <!-- Lower border -->
    <xsl:if test="$Lower-border != 0">
      <div style="position:absolute;left:{$x}px;top:{$y + 1 + $h}px;width:{$w}px;height:1px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>
    </xsl:if>
    <!-- Inner area-->
    <div id="{$id}" style="position:absolute;left:{$x}px;top:{$y + 1}px;width:{$w}px;height:{$h}px;z-index:{$z-index};background-color:{$path-color};overflow:hidden;"/>

    <!-- Upper border -->
    <xsl:if test="$Upper-border != 0">
      <div style="position:absolute;left:{$x}px;top:{$y}px;width:{$w}px;height:1px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>
    </xsl:if>

    <!-- Left border -->
    <xsl:if test="$left-border != 0">
      <div style="position:absolute;left:{$x}px;top:{$y}px;width:1px;height:{$h + 2}px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>
    </xsl:if>

    <!-- Right border -->
    <xsl:if test="$right-border != 0">
      <div style="position:absolute;left:{$x + $w - 1}px;top:{$y}px;width:1px;height:{$h + 2}px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>
    </xsl:if>
  </xsl:template>


  <xsl:template name="vertical-bar">
    <xsl:param name="x" select="0"/>
    <xsl:param name="y" select="0"/>
    <xsl:param name="w" select="5"/>
    <xsl:param name="h" select="50"/>
    <xsl:param name="top-border" select="0"/>
    <xsl:param name="bottom-border" select="0"/>
    <xsl:param name="adrstr" select="'00000000'"/>
    <xsl:param name="bit" select="1"/>
    <xsl:param name="path" select="'./lib/ups/image/piller/'"/>
    <xsl:param name="z-index" select="1"/>

    <xsl:variable name="path-color">
      <xsl:choose>
        <xsl:when test="substring($adrstr, $bit,1) = '1'">
          <xsl:value-of select="'#00FF00'"/>
          <!--green-->
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'#CCCCCC'"/>
          <!--gray-->
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name ="border-color" select="'#000000'"/>
    <!--black-->

    <!-- left border -->
    <div style="position:absolute;left:{$x}px;top:{$y}px;width:1px;height:{$h}px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>


    <!-- Inner area-->
    <div style="position:absolute;left:{$x + 1}px;top:{$y}px;width:{$w}px;height:{$h}px;z-index:{$z-index};;background-color:{$path-color};overflow:hidden;"/>

    <!-- right border -->
    <div style="position:absolute;left:{$x + $w + 1}px;top:{$y}px;width:1px;height:{$h}px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>

    <!-- top border -->
    <xsl:if test="$top-border != 0">
      <div style="position:absolute;left:{$x}px;top:{$y}px;width:{$w + 2 }px;height:1px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>
    </xsl:if>

    <!-- bottom border -->
    <xsl:if test="$bottom-border != 0">
      <div style="position:absolute;left:{$x}px;top:{$y + $h -1}px;width:{$w + 2}px;height:1px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>
    </xsl:if>
  </xsl:template>


  <xsl:template name="vertical-bar2">
    <xsl:param name="x" select="0"/>
    <xsl:param name="y" select="0"/>
    <xsl:param name="w" select="5"/>
    <xsl:param name="h" select="50"/>
    <xsl:param name="top-border" select="0"/>
    <xsl:param name="bottom-border" select="0"/>
    <xsl:param name="adrstr" select="'00000000'"/>
    <xsl:param name="bit" select="1"/>
    <xsl:param name="path" select="'./lib/ups/image/piller/'"/>
    <xsl:param name="z-index" select="1"/>

    <xsl:variable name="path-color">
      <xsl:choose>
        <xsl:when test="substring($adrstr, $bit,1) = '0' and substring($adrstr, $bit+1,1) = '1'">
          <xsl:value-of select="'#00FF00'"/>
          <!--light green-->
        </xsl:when>
        <xsl:when test="substring($adrstr, $bit,1) = '1' and substring($adrstr, $bit+1,1) = '0'">
          <xsl:value-of select="'#FF0000'"/>
          <!--light red-->
        </xsl:when>
        <xsl:when test="substring($adrstr, $bit,1) = '1' and substring($adrstr, $bit+1,1) = '1'">
          <xsl:value-of select="'#FFFF00'"/>
          <!--light yellow-->
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'#FFFFFF'"/>
          <!--white-->
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name ="border-color" select="'#000000'"/>
    <!--black-->


    <!-- left border -->
    <div style="position:absolute;left:{$x}px;top:{$y}px;width:1px;height:{$h}px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>

    <!-- Inner area-->
    <div style="position:absolute;left:{$x + 1}px;top:{$y}px;width:{$w}px;height:{$h}px;z-index:{$z-index};background-color:{$path-color};overflow:hidden;"/>

    <!-- right border -->
    <div style="position:absolute;left:{$x + $w + 1}px;top:{$y}px;width:1px;height:{$h}px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>

    <!-- top border -->
    <xsl:if test="$top-border != 0">
      <div style="position:absolute;left:{$x}px;top:{$y}px;width:{$w + 2 }px;height:1px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>
    </xsl:if>

    <!-- bottom border -->
    <xsl:if test="$bottom-border != 0">
      <div style="position:absolute;left:{$x}px;top:{$y + $h -1}px;width:{$w + 2}px;height:1px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>
    </xsl:if>
  </xsl:template>
  <xsl:template name="vertical-bar3">
    <xsl:param name="x" select="0"/>
    <xsl:param name="y" select="0"/>
    <xsl:param name="w" select="5"/>
    <xsl:param name="h" select="50"/>
    <xsl:param name="top-border" select="0"/>
    <xsl:param name="bottom-border" select="0"/>
    <xsl:param name="adrstr" select="'00000000'"/>
    <xsl:param name="bit" select="1"/>
    <xsl:param name="path" select="'./lib/ups/image/piller/'"/>
    <xsl:param name="z-index" select="1"/>
    <xsl:param name="id" select="id"/>

    <xsl:variable name="path-color">
      <xsl:choose>
        <xsl:when test="substring($adrstr, $bit,1) = '1' and substring($adrstr, $bit+1,1) = '1'">
          <xsl:value-of select="'#FFFF00'"/>
          <!--light yellow-->
        </xsl:when>
        <xsl:when test="substring($adrstr, $bit,1) = '1'">
          <xsl:value-of select="'#00FF00'"/>
          <!--light green-->
        </xsl:when>
        <xsl:when test="substring($adrstr, $bit+1,1) = '1'">
          <xsl:value-of select="'#FF0000'"/>
          <!--light red-->
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'#FFFFFF'"/>
          <!--white-->
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name ="border-color" select="'#000000'"/>
    <!--black-->

    <!-- left border -->
    <div style="position:absolute;left:{$x}px;top:{$y}px;width:1px;height:{$h}px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>

    <!-- Inner area-->
    <div id="{$id}" style="position:absolute;left:{$x + 1}px;top:{$y}px;width:{$w}px;height:{$h}px;z-index:{$z-index};background-color:{$path-color};overflow:hidden;"/>

    <!-- right border -->
    <div style="position:absolute;left:{$x + $w + 1}px;top:{$y}px;width:1px;height:{$h}px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>

    <!-- top border -->
    <xsl:if test="$top-border != 0">
      <div style="position:absolute;left:{$x}px;top:{$y}px;width:{$w + 2 }px;height:1px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>
    </xsl:if>

    <!-- bottom border -->
    <xsl:if test="$bottom-border != 0">
      <div style="position:absolute;left:{$x}px;top:{$y + $h -1}px;width:{$w + 2}px;height:1px;z-index:{$z-index};background-color:{$border-color};overflow:hidden;"/>
    </xsl:if>
  </xsl:template>

  <xsl:template name="line-pane">
    <xsl:param name="x" select="0"/>
    <xsl:param name="y" select="0"/>
    <xsl:param name="w" select="0"/>
    <xsl:param name="h" select="0"/>
    <xsl:param name="v1" select="0"/>
    <xsl:param name="v2" select="0"/>
    <xsl:param name="v3" select="0"/>
    <xsl:param name="i1" select="0"/>
    <xsl:param name="i2" select="0"/>
    <xsl:param name="i3" select="0"/>
    <xsl:param name="p" select="0"/>
    <xsl:param name="f" select="0"/>
    <xsl:param name="title" select="''"/>
    <xsl:param name="border-width" select="1"/>
    <xsl:param name="border-color" select="'#405080'"/>
    <xsl:param name="style" select="'tdMediumSmallBoldGrey'"/>
    <xsl:param name="id" select="'line-pane'"/>
    <xsl:param name="visibility" select="'visible'"/>

    <xsl:variable name="v1r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$v1"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="v2r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$v2"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="v3r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$v3"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="i1r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$i1"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="i2r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$i2"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="i3r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$i3"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="pr">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$p"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="fr">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$f"/>
        <xsl:with-param name="precision" select="1" />
      </xsl:call-template>
    </xsl:variable>

    <div id="{$id}" style="position:absolute;left:{$x}px;top:{$y}px;border:{$border-width}px {$border-color} solid; visibility:{$visibility}">
      <table cellspacing="1" cellpadding="1" border="0" width="{$w}" height="{$h}">
        <tr>
          <td id="{concat($id, $title)}" class="{$style}" style="text-align:right">
            <script type="text/javascript"> translate_text('<xsl:value-of select="concat($id, $title)"/>', '<xsl:value-of select="$title"/>');</script>
          </td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$pr"/>&#160;kVA
          </td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$fr"/>&#160;Hz
          </td>
        </tr>
        <tr>
          <td class="{$style}" style="text-align:right">L1:</td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$v1r"/>&#160;V
          </td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$i1r"/>&#160;A
          </td>
        </tr>
        <tr>
          <td class="{$style}" style="text-align:right">L2:</td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$v2r"/>&#160;V
          </td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$i2r"/>&#160;A
          </td>
        </tr>
        <tr>
          <td class="{$style}" style="text-align:right">L3:</td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$v3r"/>&#160;V
          </td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$i3r"/>&#160;A
          </td>
        </tr>
      </table>
    </div>
  </xsl:template>

  <xsl:template name="line-pane2">
    <xsl:param name="x" select="0"/>
    <xsl:param name="y" select="0"/>
    <xsl:param name="w" select="0"/>
    <xsl:param name="h" select="0"/>
    <xsl:param name="v1" select="0"/>
    <xsl:param name="v2" select="0"/>
    <xsl:param name="v3" select="0"/>
    <xsl:param name="i1" select="0"/>
    <xsl:param name="i2" select="0"/>
    <xsl:param name="i3" select="0"/>
    <xsl:param name="p1" select="0"/>
    <xsl:param name="p2" select="0"/>
    <xsl:param name="f" select="0"/>
    <xsl:param name="pf" select="0"/>
    <xsl:param name="ph" select="0"/>
    <xsl:param name="phase-title" select="''"/>
    <xsl:param name="title" select="''"/>
    <xsl:param name="style" select="'tdMediumSmallBoldGrey'"/>
    <xsl:param name="id" select="'line-pane'"/>
    <xsl:param name="sub_id" select="'line-pane2'"/>
    <xsl:param name="visibility" select="'visible'"/>

    <xsl:variable name="v1r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$v1"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="v2r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$v2"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="v3r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$v3"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="i1r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$i1"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="i2r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$i2"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="i3r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$i3"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="p1r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$p1"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="p2r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$p2"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="pfr">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$pf"/>
        <xsl:with-param name="precision" select="2" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="fr">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$f"/>
        <xsl:with-param name="precision" select="1" />
      </xsl:call-template>
    </xsl:variable>



    <div id="{$id}" style="position:absolute;left:{$x}px;top:{$y}px;border:1px #405080 solid; visibility:{$visibility}">
      <table cellspacing="1" cellpadding="1" border="0" width="{$w}">
        <tr>
          <td id="{$sub_id}power" class="{$style}" style="text-align:right">
            <script type="text/javascript">
              translate_text('<xsl:value-of select="concat($sub_id, 'power')"/>', 'Power');
            </script>
          </td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$p1r"/>&#160;kVA
          </td>
          <xsl:choose>
            <xsl:when test="$p2 = ''">
              <td class="{$style}" style="text-align:right">&#160;</td>
            </xsl:when>
            <xsl:otherwise>
              <td class="{$style}" style="text-align:right">
                <xsl:value-of select="$p2r"/>&#160;kW
              </td>
            </xsl:otherwise>
          </xsl:choose>
        </tr>
        <tr>
          <td id="{$sub_id}freq" class="{$style}" style="text-align:right">
            <script type="text/javascript">
              translate_text('<xsl:value-of select="concat($sub_id, 'freq')"/>', 'Freq');
            </script>
          </td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$fr"/>&#160;Hz
          </td>
          <td class="{$style}" style="text-align:right">
            pf=<xsl:value-of select="$pf"/>
          </td>
        </tr>
        <tr>
          <td class="{$style}" style="text-align:right">L1-L2</td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$v1r"/>&#160;V
          </td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$i1r"/>&#160;A
          </td>
        </tr>
        <tr>
          <td class="{$style}" style="text-align:right">L2-L3</td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$v2r"/>&#160;V
          </td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$i2r"/>&#160;A
          </td>
        </tr>
        <tr>
          <td class="{$style}" style="text-align:right">L3-L1</td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$v3r"/>&#160;V
          </td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$i3r"/>&#160;A
          </td>
        </tr>
        <xsl:if test="string-length($phase-title) != 0">
          <tr>
            <td id="{$sub_id}phase" class="{$style}" style="text-align:right">
              <script type="text/javascript">
                translate_text('<xsl:value-of select="concat($sub_id, 'phase')"/>', 'Phase');
              </script>
            </td>
            <td id="{$sub_id}{$phase-title}" class="{$style}" style="text-align:center">
              <script type="text/javascript">
                translate_text('<xsl:value-of select="concat($sub_id, $phase-title)"/>', '<xsl:value-of select="$phase-title"/>');
              </script>
            </td>
            <td class="{$style}" style="text-align:right">
              <xsl:value-of select="$ph"/>
            </td>
          </tr>
        </xsl:if>
      </table>
    </div>
  </xsl:template>

  <xsl:template name="line-pane3">
    <xsl:param name="x" select="0"/>
    <xsl:param name="y" select="0"/>
    <xsl:param name="w" select="0"/>
    <xsl:param name="h" select="0"/>
    <xsl:param name="v1" select="0"/>
    <xsl:param name="v2" select="0"/>
    <xsl:param name="v3" select="0"/>
    <xsl:param name="f" select="0"/>
    <xsl:param name="title" select="''"/>
    <xsl:param name="style" select="'tdMediumSmallBoldGrey'"/>
    <xsl:param name="id" select="'line-pane3'"/>
    <xsl:param name="sub-id" select="'line-pane3'"/>
    <xsl:param name="visibility" select="'visible'"/>

    <xsl:variable name="v1r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$v1"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="v2r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$v2"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="v3r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$v3"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="fr">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$f"/>
        <xsl:with-param name="precision" select="1" />
      </xsl:call-template>
    </xsl:variable>

    <div id="{$id}" style="position:absolute;left:{$x}px;top:{$y}px;border:1px #405080 solid; visibility:{$visibility}">
      <table cellspacing="1" cellpadding="1" border="0" width="{$w}">
        <tr>
          <td id="{$sub-id}freq" class="{$style}" style="text-align:right">
            <xsl:value-of select="''"/>
            <script type="text/javascript">
              translate_text('<xsl:value-of select="concat($sub-id, 'freq')"/>', 'Freq');
            </script>
          </td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$fr"/>&#160;Hz
          </td>
        </tr>
        <tr>
          <td class="{$style}" style="text-align:right">L1-L2</td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$v1r"/>&#160;V
          </td>
        </tr>
        <tr>
          <td class="{$style}" style="text-align:right">L2-L3</td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$v2r"/>&#160;V
          </td>
        </tr>
        <tr>
          <td class="{$style}" style="text-align:right">L3-L1</td>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$v3r"/>&#160;V
          </td>
        </tr>
      </table>
    </div>
  </xsl:template>

  <xsl:template name="line-pane4">
    <xsl:param name="x" select="0"/>
    <xsl:param name="y" select="0"/>
    <xsl:param name="w" select="0"/>
    <xsl:param name="h" select="0"/>
    <xsl:param name="v1" select="0"/>
    <xsl:param name="v2" select="0"/>
    <xsl:param name="v3" select="0"/>
    <xsl:param name="i1" select="0"/>
    <xsl:param name="i2" select="0"/>
    <xsl:param name="i3" select="0"/>
    <xsl:param name="p" select="0"/>
    <xsl:param name="f" select="0"/>
    <xsl:param name="title" select="''"/>
    <xsl:param name="style" select="'tdMediumSmallBoldGrey'"/>
    <xsl:param name="id" select="'line-pane'"/>
    <xsl:param name="visibility" select="'hidden'"/>

    <xsl:variable name="v1r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$v1"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="v2r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$v2"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="v3r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$v3"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="i1r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$i1"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="i2r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$i2"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="i3r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$i3"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="pr">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$p"/>
        <xsl:with-param name="precision" select="0" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="fr">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$f"/>
        <xsl:with-param name="precision" select="1" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$x"/>
      <xsl:with-param name="y" select="$y"/>
      <xsl:with-param name="w" select="$w div 3"/>
      <xsl:with-param name="h" select="$h"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="$title" />
      <xsl:with-param name="text2"  select="'L1:'" />
      <xsl:with-param name="text3" select="'L2:'" />
      <xsl:with-param name="text4" select="'L3:'" />
      <xsl:with-param name="visibility" select="$visibility"/>
      <xsl:with-param name="name" select="$id"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$x + ($w div 3)"/>
      <xsl:with-param name="y" select="$y"/>
      <xsl:with-param name="w" select="$w div 3"/>
      <xsl:with-param name="h" select="$h"/>
      <xsl:with-param name="value1" select="$pr" />
      <xsl:with-param name="unit1" select="'kVA'"/>
      <xsl:with-param name="value2"  select="$v1r" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="value3" select="$v2r" />
      <xsl:with-param name="unit3" select="'V'"/>
      <xsl:with-param name="value4" select="$v3r" />
      <xsl:with-param name="unit4" select="'V'"/>
      <xsl:with-param name="visibility" select="$visibility"/>
      <xsl:with-param name="name" select="$id"/>

    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="$x + 2*($w div 3)"/>
      <xsl:with-param name="y" select="$y"/>
      <xsl:with-param name="w" select="$w div 3"/>
      <xsl:with-param name="h" select="$h"/>
      <xsl:with-param name="value1" select="$f" />
      <xsl:with-param name="unit1" select="'Hz'"/>
      <xsl:with-param name="value2"  select="$i1r" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="value3" select="$i2r" />
      <xsl:with-param name="unit3" select="'V'"/>
      <xsl:with-param name="value4" select="$i3r" />
      <xsl:with-param name="unit4" select="'V'"/>
      <xsl:with-param name="visibility" select="$visibility"/>
      <xsl:with-param name="name" select="$id"/>

    </xsl:call-template>

  </xsl:template>

  <xsl:template name="battery-pane">
    <xsl:param name="x" select="0"/>
    <xsl:param name="y" select="0"/>
    <xsl:param name="w" select="0"/>
    <xsl:param name="h" select="0"/>
    <xsl:param name="v1" select="0"/>
    <xsl:param name="v2" select="0"/>
    <xsl:param name="v3" select="0"/>
    <xsl:param name="v4" select="0"/>
    <xsl:param name="v5" select="0"/>

    <xsl:param name="precision_v1" select="1"/>
    <xsl:param name="precision_v2" select="1"/>
    <xsl:param name="precision_v3" select="1"/>
    <xsl:param name="precision_v4" select="1"/>
    <xsl:param name="precision_v5" select="1"/>

    <xsl:param name="style" select="'tdMediumSmallBoldGrey'"/>

    <xsl:variable name="v1r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$v1"/>
        <xsl:with-param name="precision" select="$precision_v1" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="v2r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$v2"/>
        <xsl:with-param name="precision" select="$precision_v2" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="v3r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$v3"/>
        <xsl:with-param name="precision" select="$precision_v3" />
      </xsl:call-template>
    </xsl:variable>

    <xsl:variable name="v4r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$v4"/>
        <xsl:with-param name="precision" select="$precision_v4" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="v5r">
      <xsl:call-template name="round-decimal">
        <xsl:with-param name="value" select="$v5"/>
        <xsl:with-param name="precision" select="1" />
      </xsl:call-template>
    </xsl:variable>
    <div style="position:absolute;left:{$x}px;top:{$y}px;border:1px #405080 solid">
      <table cellspacing="1" cellpadding="1" border="0" width="{$w}">
        <tr>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$v1r"/>&#160;V
          </td>
        </tr>
        <tr>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$v2r"/>&#160;A
          </td>
        </tr>
        <tr>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$v3r"/>&#160;min
          </td>
        </tr>
        <tr>
          <td class="{$style}" style="text-align:right">
            <xsl:value-of select="$v4r"/>&#160;Ah
          </td>
        </tr>
        <tr>
          <td class="{$style}" style="text-align:right">
            <xsl:call-template name="getTemperature">
              <xsl:with-param name="value" select="$v5" />
              <xsl:with-param name="precision" select="$precision_v5"/>
            </xsl:call-template>
          </td>
        </tr>
      </table>
    </div>
  </xsl:template>
  <xsl:template name="mini-load-bar">
    <xsl:param name="x" select="0" />
    <xsl:param name="y" select="0" />
    <xsl:param name="w1" select="20" />
    <xsl:param name="bar-w" select="100" />
    <xsl:param name="w2" select="20" />
    <xsl:param name="bar-h" select="100" />
    <xsl:param name="lh" select="12" />
    <xsl:param name="l1" select="0" />
    <xsl:param name="l2" select="0" />
    <xsl:param name="l3" select="0" />
    <xsl:param name="color" select="'#000000'" />
    <xsl:param name="visibility" select="'visible'" />
    <xsl:param name="style" select="''" />
    <xsl:param name="id" select="'page-xxx'" />
    <xsl:variable name="l1-width" select="$bar-w * $l1 div 150"/>
    <xsl:variable name="l2-width" select="$bar-w * $l2 div 150"/>
    <xsl:variable name="l3-width" select="$bar-w * $l3 div 150"/>
    <xsl:variable name="bar-y-offset" select="($lh - $bar-h) div 2"/>
    <xsl:variable name="l1-color">
      <xsl:call-template name="get-color-from-load">
        <xsl:with-param name="load" select="$l1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="l2-color">
      <xsl:call-template name="get-color-from-load">
        <xsl:with-param name="load" select="$l2"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="l3-color">
      <xsl:call-template name="get-color-from-load">
        <xsl:with-param name="load" select="$l3"/>
      </xsl:call-template>
    </xsl:variable>

    <div id="{$id}" style="position:absolute; left:{$x}px; top:{$y}px; visibility:$visibility;">
      <div id="{concat($id,'_1')}" style="position:absolute; left:0px; top:0px; width:{$w1}; height:{$lh}; visibility:$visibility;">L1</div>
      <div id="{concat($id,'_2')}" style="position:absolute; left:{$w1}px; top:{$bar-y-offset}px; width:{$bar-w}px; height:{$lh}px; background-color:{$l1-color}; clip:rect(0px {$l1-width}px {$bar-h}px 0);"></div>
      <div id="{concat($id,'_3')}" style="position:absolute; left:{$w1 + $bar-w}px; width:{$w2};top:0px; height:{$lh}; visibility:$visibility;text-align:right">
        <xsl:value-of select="$l1"/>
      </div>
      <div id="{concat($id,'_4')}" style="position:absolute; left:{$w1 + $bar-w + 14}px; width:{$w2};top:0px; height:{$lh}; visibility:$visibility;text-align:right">
        <xsl:value-of select="'&#160;&#160;%'"/>
      </div>
      <div id="{concat($id,'_5')}" style="position:absolute; left:0px; top:{$lh}px; width:{$w1}; height:{$lh}; visibility:$visibility;">L2</div>
      <div id="{concat($id,'_6')}" style="position:absolute; left:{$w1}px; top:{$lh + $bar-y-offset}px; width:{$bar-w}px; height:{$lh}px; background-color:{$l2-color}; clip:rect(0px {$l2-width}px {$bar-h}px 0);"></div>
      <div id="{concat($id,'_7')}" style="position:absolute; left:{$w1 + $bar-w}px; top:{$lh}px; width:{$w2}; height:{$lh}; visibility:$visibility;text-align:right">
        <xsl:value-of select="$l2"/>
      </div>
      <div id="{concat($id,'_8')}" style="position:absolute; left:{$w1 + $bar-w + 14}px; top:{$lh}px; width:{$w2}; height:{$lh}; visibility:$visibility;text-align:right">
        <xsl:value-of select="'&#160;&#160;%'"/>
      </div>
      <div id="{concat($id,'_9')}" style="position:absolute; left:0px; top:{$lh * 2}px; width:{$w1}; height:{$lh}; visibility:$visibility;">L3</div>
      <div id="{concat($id,'_10')}" style="position:absolute; left:{$w1}px; top:{$lh * 2 + $bar-y-offset}px; width:{$bar-w}px; height:{$lh}px; background-color:{$l3-color}; clip:rect(0px {$l3-width}px {$bar-h}px 0);"></div>
      <div id="{concat($id,'_11')}" style="position:absolute; left:{$w1 + $bar-w}px; top:{$lh * 2}px; width:{$w2};height:{$lh}; visibility:$visibility;text-align:right;">
        <xsl:value-of select="$l3"/>
      </div>
      <div id="{concat($id,'_12')}" style="position:absolute; left:{$w1 + $bar-w + 14}px; top:{$lh * 2}px; width:{$w2};height:{$lh}; visibility:$visibility;text-align:right;">
        <xsl:value-of select="'&#160;&#160;%'"/>
      </div>
    </div>
  </xsl:template>

  <xsl:template name="PillerLoadbar">
    <xsl:param name="x" select="'0'" />
    <xsl:param name="y" select="'0'" />
    <xsl:param name="adrstr" select="'0000000000011111'" />
    <xsl:param name="imagepath" select ="'./lib/ups/image/piller/'"/>
    <xsl:param name="scale" select ="'0'"/>
    <xsl:param name="title" select ="0"/>
    <xsl:param name="border" select ="'0'"/>
    <xsl:param name="yOffset" select ="'6'"/>
    <xsl:param name="textcolor" select="'#ffffff'"/>
    <xsl:param name="id" select="'id'"/>

    <!-- margin scales-->
    <xsl:if test="$scale=1">
      <xsl:element name="div">
        <xsl:attribute name="style">
          position:absolute;left:<xsl:value-of select="($x)+12+5"/>px;top:<xsl:value-of select="$y+0*$yOffset"/>px;width:25px;color:<xsl:value-of select="$textcolor"/>; text-align:right;
        </xsl:attribute>
        <xsl:text>150%</xsl:text>
      </xsl:element>
      <xsl:element name="div">
        <xsl:attribute name="style">
          position:absolute;left:<xsl:value-of select="($x)+12+5"/>px;top:<xsl:value-of select="$y+5*$yOffset"/>px;width:25px;color:<xsl:value-of select="$textcolor"/>; text-align:right;
        </xsl:attribute>
        <xsl:text>100%</xsl:text>
      </xsl:element>
      <xsl:element name="div">
        <xsl:attribute name="style">
          position:absolute;left:<xsl:value-of select="($x)+12+5"/>px;top:<xsl:value-of select="$y+10*$yOffset"/>px;width:25px;color:<xsl:value-of select="$textcolor"/>; text-align:right;
        </xsl:attribute>
        <xsl:text>50%</xsl:text>
      </xsl:element>
    </xsl:if>

    <!-- titel-->
    <xsl:if test="$title!=0">
      <xsl:element name="div">
        <xsl:attribute name="id">
         <xsl:value-of select="concat($id, $title)"/>
        </xsl:attribute>
        <xsl:attribute name="style">
          position:absolute;left:<xsl:value-of select="($x)-4"/>px;top:<xsl:value-of select="$y+15*$yOffset+6"/>px;width:20px;color:<xsl:value-of select="$textcolor"/>; text-align:center;font-weight:bold;
        </xsl:attribute>
        <xsl:value-of select="$title"/>
      </xsl:element>
    </xsl:if>

    <!-- LOAD1 -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y"/>px;width:20px;height:4px
      </xsl:attribute>
      <xsl:choose>
        <xsl:when test="substring($adrstr, 15,1) = '1'">
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledrot12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgrau12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>

    <!-- LOAD2 -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y+$yOffset"/>px;width:20px;height:4px
      </xsl:attribute>
      <xsl:choose>
        <xsl:when test="substring($adrstr, 14,1) = '1'">
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledrot12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgrau12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>

    <!-- LOAD3 -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y+2*$yOffset"/>px;width:20px;height:4px
      </xsl:attribute>
      <xsl:choose>
        <xsl:when test="substring($adrstr, 13,1) = '1'">
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledrot12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgrau12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>

    <!-- LOAD4 -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y+3*$yOffset"/>px;width:20px;height:4px
      </xsl:attribute>
      <xsl:choose>
        <xsl:when test="substring($adrstr, 12,1) = '1'">
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgelb12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgrau12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>

    <!-- LOAD5 -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y+4*$yOffset"/>px;width:20px;height:4px
      </xsl:attribute>
      <xsl:choose>
        <xsl:when test="substring($adrstr, 11,1) = '1'">
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgruen12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgrau12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>

    <!-- LOAD6 -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y+5*$yOffset"/>px;width:20px;height:4px
      </xsl:attribute>
      <xsl:choose>
        <xsl:when test="substring($adrstr, 10,1) = '1'">
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgruen12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgrau12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>

    <!-- LOAD7 -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y+6*$yOffset"/>px;width:20px;height:4px
      </xsl:attribute>
      <xsl:choose>
        <xsl:when test="substring($adrstr, 9,1) = '1'">
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgruen12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgrau12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>

    <!-- LOAD8 -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y+7*$yOffset"/>px;width:20px;height:4px
      </xsl:attribute>
      <xsl:choose>
        <xsl:when test="substring($adrstr, 8,1) = '1'">
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgruen12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgrau12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>

    <!-- LOAD9 -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y+8*$yOffset"/>px;width:20px;height:4px
      </xsl:attribute>
      <xsl:choose>
        <xsl:when test="substring($adrstr, 7,1) = '1'">
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgruen12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgrau12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>

    <!-- LOAD10 -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y+9*$yOffset"/>px;width:20px;height:4px
      </xsl:attribute>
      <xsl:choose>
        <xsl:when test="substring($adrstr, 6,1) = '1'">
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgruen12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgrau12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>

    <!-- LOAD11 -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y+10*$yOffset"/>px;width:20px;height:4px
      </xsl:attribute>
      <xsl:choose>
        <xsl:when test="substring($adrstr, 5,1) = '1'">
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgruen12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgrau12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>

    <!-- LOAD12 -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y+11*$yOffset"/>px;width:20px;height:4px
      </xsl:attribute>
      <xsl:choose>
        <xsl:when test="substring($adrstr, 4,1) = '1'">
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgruen12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgrau12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>

    <!-- LOAD13 -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y+12*$yOffset"/>px;width:20px;height:4px
      </xsl:attribute>
      <xsl:choose>
        <xsl:when test="substring($adrstr, 3,1) = '1'">
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgruen12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgrau12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>

    <!-- LOAD14 -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y+13*$yOffset"/>px;width:20px;height:4px
      </xsl:attribute>
      <xsl:choose>
        <xsl:when test="substring($adrstr, 2,1) = '1'">
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgruen12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgrau12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>

    <!-- LOAD15 -->
    <xsl:element name="div">
      <xsl:attribute name="style">
        position:absolute;left:<xsl:value-of select="$x"/>px;top:<xsl:value-of select="$y+14*$yOffset"/>px;width:20px;height:4px
      </xsl:attribute>
      <xsl:choose>
        <xsl:when test="substring($adrstr, 1,1) = '1'">
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgruen12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="concat($imagepath, 'ledgrau12x5.gif')"/>
            </xsl:attribute>
            <xsl:attribute name="border">
              <xsl:value-of select="$border"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>
  </xsl:template>

  <xsl:template name="mainsfail_cnt_Op_hours">
    <xsl:param name="x" select="0"/>
    <xsl:param name="y" select="0"/>
    <xsl:param name="w" select="0"/>
    <xsl:param name="h" select="0"/>
    <xsl:param name="op_hours" select="0"/>
    <xsl:param name="failure_counter" select="0"/>
    <xsl:param name="border-width" select="1"/>
    <xsl:param name="border-color" select="'#405080'"/>
    <xsl:param name="text-align" select="'left'"/>

    <xsl:param name="id" select="'Mains_fail_cnt_Op_ h-pane'"/>
    <xsl:param name="visibility" select="'visible'"/>

    <div id="{$id}" style="position:absolute;left:{$x}px;top:{$y}px;border:{$border-width}px {$border-color} solid; visibility:{$visibility}">

      <table cellspacing="1" cellpadding="1" border="0" width="{$w}" height="{$h}">
        <tr>
          <td class="tdMediumSmallWhiteBold" id="Mains_fail_counter" style="text-align:{$text-align}">
            <script type="text/javascript"> translate_text('Mains_fail_counter', ['Mains&#160;failure&#160;counter', ':&#160;']);</script>
          </td>
          <td class="tdMediumSmallWhiteBold" style="text-align:{$text-align}">
            <xsl:value-of select="$failure_counter"/>
          </td>
        </tr>
        <tr>
          <td id="op_hours" class="tdMediumSmallWhiteBold" style="text-align:{$text-align}">
            <script type="text/javascript"> translate_text('op_hours', ['Operating&#160;hours', ':&#160;']);</script>
          </td>
          <td class="tdMediumSmallWhiteBold" style="text-align:{$text-align}">
            <xsl:value-of select="$op_hours"/>
          </td>
        </tr>
      </table>
    </div>
  </xsl:template>


  <!--serial number-->
  <xsl:template name="serial_number">
    <xsl:param name="x" select="0"/>
    <xsl:param name="y" select="0"/>
    <xsl:param name="w" select="0"/>
    <xsl:param name="h" select="0"/>
    <xsl:param name="addr1" select="0"/>
    <xsl:param name="addr2" select="0"/>
    <xsl:param name="addr3" select="0"/>
    <xsl:param name="addr4" select="0"/>
    <xsl:param name="addr5" select="0"/>
    <xsl:param name="addr6" select="0"/>
    <xsl:param name="addr7" select="0"/>
    <xsl:param name="addr8" select="0"/>
    <xsl:param name="border-width" select="1"/>
    <xsl:param name="text-align" select="'left'"/>

    <div class="tdMediumSmallWhiteBold" id= "serial_number_id" style="text-align:center; align:center; position:absolute;left:{$x}px;top:{$y}px;height:{$h}px;width:{$w}px;border:{$border-width}px #405080 solid; padding-top:4px"/>

    <script type="text/javascript">
      var serial_nr_div = document.getElementById('serial_number_id'),
         serial_nr = String.fromCharCode('<xsl:value-of select="$addr1"/>','<xsl:value-of select="$addr2"/>','<xsl:value-of select="$addr3"/>','<xsl:value-of select="$addr4"/>',
         '<xsl:value-of select="$addr5"/>','<xsl:value-of select="$addr6"/>','<xsl:value-of select="$addr7"/>','<xsl:value-of select="$addr8"/>'),
         serial_nr_txt = document.createTextNode('&#160;&#160;S/N:' + serial_nr);
      
      serial_nr_div.appendChild(serial_nr_txt);
    </script>
  </xsl:template>

</xsl:stylesheet>
