<?xml version="1.0"?>
<!--
   modub2g_panel.xsl -models @UNMS-II.
   Copyright (c) 2009, Generex GmbH. All rights reserved.
   said
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!-- Methods -->
  <!--Header-->
  <xsl:template name="modub2g_panel-header">
    <xsl:call-template name="app-header">
      <xsl:with-param name="top" select="10"/>
      <xsl:with-param name="left" select="20"/>
    </xsl:call-template>
  </xsl:template>
  <!--Footer-->
  <xsl:template name="modub2g_panel-footer" >
    <xsl:call-template name="app-footer" >
      <xsl:with-param name="top" select="520"/>
      <xsl:with-param name="left" select="10"/>
      <xsl:with-param name="width" select="785"/>
      <xsl:with-param name="height" select="62"/>
    </xsl:call-template>
  </xsl:template>
  <!--Menu-->
  <xsl:template name="modub2g_panel-menu">
    <xsl:call-template name="app-menu">
      <xsl:with-param name="top" select="428"/>
      <xsl:with-param name="left" select="0"/>
      <xsl:with-param name="width" select="0"/>
      <xsl:with-param name="height" select="0"/>
      <xsl:with-param name="class" select="'XBold_black'"/>
    </xsl:call-template>
  </xsl:template>


  <!--Body-->
  <xsl:template name="modub2g_panel-body">
    <div id="master" style="position:absolute;top:10px;left:10px;">
      <xsl:call-template name="background">
        <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/backub2g.png'"/>
        <xsl:with-param name="x" select="'0'"/>
        <xsl:with-param name="y" select="'0'"/>
        <xsl:with-param name="w" select="'785'"/>
        <xsl:with-param name="h" select="'488'"/>
        <xsl:with-param name="border" select="'0'"/>
        <xsl:with-param name="id" select="'background'"/>
      </xsl:call-template>
      <xsl:apply-templates />
      <!--<div id="head" class="XLargeBold" style="position:absolute; top:74px; left:350px;font-size:24px;" >USV <xsl:value-of select="//values/value[@name='USVID']/@val"/></div>-->

      <div style="position: absolute; left:525px; top:281px; width:40px; height:40px; z-index:1;">
        <a href="javascript:onChangeSelectionDown()">
          <img border="0" alt="" src="./lib/ups/image/piller/selectUp.jpg" width="40" height="40"/>
        </a>
      </div>
      <div style="position: absolute; left:569px; top:281px; width:40px; height:40px; z-index:1;">
        <a href="javascript:onChangeSelectionUp()">
          <img border="0" alt="" src="./lib/ups/image/piller/selectDown.jpg" width="40" height="40"/>
        </a>
      </div>
    </div>
    <xsl:call-template name="IEpixelBugfixCall"/>

    <script type="text/javascript">
      init();
    </script>
    <xsl:call-template name="js_refresh_call">
      <xsl:with-param	 name="timeout" select="1000*//report/@refresh"/>
    </xsl:call-template>
  </xsl:template>


  <!-- Implementation -->
  <xsl:template match="values">
    <!-- LOCATION -->
    <div class="XLargeBold" align="right" style="position: absolute; left: 0px; top: 40px; width: 785px;  font-size:24px; text-align:center; ">
      <xsl:value-of select="value[@name='LOCATION']/@val" />
    </div>
    <!-- MODEL -->
    <div class="LargeBold" align="right" style="position: absolute; left: 460px; top: 361px; width: 214px; height: 17px; color:#ffffff; text-align:center;">
      <xsl:value-of select="value[@name='MODEL']/@val" />
    </div>

    <!-- UPS HISTORY-->
    <xsl:if test="string-length(//service/@type) !=0 and //service/@type != 'upsman' and //service/@type != 'snmpups' and //service/@type != 'maildev' and //service/@type != 'CS141'">
      <xsl:call-template name="on-mouse-over"/>
      <div class="MediumBold" align="right" style="position: absolute; left: 332px; top: 413px; width: 100px; height: 32px; text-align:center;  ">
        <a class="MediumBoldLink" href="nmsView.dll?navigate&amp;url=http://{//host/@address}/mbevents.cgi" border="0"  target="_blank" onmouseover="changeImage('hist', '../image/button_white_over.gif')" onmouseout="restoreImage('hist')">
          <img id="hist" src="../image/button_white.gif" width="100" height="32" border="0"/>
        </a>
      </div>
      <div class="MediumBold" align="right" style="position: absolute; left: 332px; top: 420px; width: 100px; height: 17px; text-align:center;  ">
        <a class="MediumBold" href="nmsView.dll?navigate&amp;url=http://{//host/@address}/mbevents.cgi" style="text-decoration:none"  target="_blank"  onmouseover="changeImage('hist', '../image/button_white_over.gif')" onmouseout="restoreImage('hist')">
        Eventrecorder</a>
      </div>
    </xsl:if>

    <xsl:variable name="adrd6">
      <xsl:call-template name="getfixedbitstring">
        <xsl:with-param name="val" select="value[@name='ADRD6']/@val"/>
        <xsl:with-param name="dir" select="-1"/>
        <xsl:with-param name="places" select="16"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="adr90">
      <xsl:call-template name="getfixedbitstring">
        <xsl:with-param name="val" select="value[@name='ADR90']/@val"/>
        <xsl:with-param name="dir" select="-1"/>
        <xsl:with-param name="places" select="16"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="adr91">
      <xsl:call-template name="getfixedbitstring">
        <xsl:with-param name="val" select="value[@name='ADR91']/@val"/>
        <xsl:with-param name="dir" select="-1"/>
        <xsl:with-param name="places" select="16"/>
      </xsl:call-template>
    </xsl:variable>

    <!-- TEXTE -->
    <div id="bypass1" class="Small" align="right" style="position: absolute; left: 237px; top: 130px; color:#ffffff;">
      <script type="text/javascript"> translate_text("bypass1", 'BYPASS');</script>
    </div>
    <div id="bypass2" class="MediumBold" align="right" style="position: absolute; left: 357px; top: 324px; color:#ffffff;">
      <script type="text/javascript"> translate_text("bypass2", 'BYPASS');</script>
    </div>
    <div id="ub" 			class="MediumBold" align="right" style="position: absolute; left: 129px; top: 324px; color:#ffffff;">
      <script type="text/javascript"> translate_text("ub", 'UB');</script>
    </div>
    <div id="res" 			class="MediumBold" align="right" style="position: absolute; left: 249px; top: 349px; color:#000000;font-size:11px">
      <script type="text/javascript"> translate_text("res", 'RES');</script>
    </div>
    <!-- LOAD BAR -->
    <xsl:call-template name="PillerLoadbar">
      <xsl:with-param name="adrstr" select="$adrd6"/>
      <xsl:with-param name="x" select="'418'"/>
      <xsl:with-param name="y" select="'183'"/>
      <xsl:with-param name="scale" select="1"/>
      <xsl:with-param name="title" select="'Load'"/>
      <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/'"/>
      <xsl:with-param name="id" select="'loadbar1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text("loadbar1Load", 'Load');</script>

    <!-- Line LEDs-->
    <xsl:variable name="leddim" select="10"/>
    <xsl:call-template name="modbusledold">
      <xsl:with-param name="x" select="252"/>
      <xsl:with-param name="y" select="140"/>
      <xsl:with-param name="w" select="$leddim"/>
      <xsl:with-param name="h" select="$leddim"/>
      <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/'" />
      <xsl:with-param name="adrsStatic" select="$adr90"/>
      <xsl:with-param name="adrsFlash" select="$adr91"/>
      <xsl:with-param name="bit" select="15"/>
    </xsl:call-template>
    <xsl:call-template name="modbusledold">
      <xsl:with-param name="x" select="158"/>
      <xsl:with-param name="y" select="172"/>
      <xsl:with-param name="w" select="$leddim"/>
      <xsl:with-param name="h" select="$leddim"/>
      <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/'" />
      <xsl:with-param name="adrsStatic" select="$adr90"/>
      <xsl:with-param name="adrsFlash" select="$adr91"/>
      <xsl:with-param name="bit" select="11"/>
    </xsl:call-template>
    <xsl:call-template name="modbusledold">
      <xsl:with-param name="x" select="264"/>
      <xsl:with-param name="y" select="183"/>
      <xsl:with-param name="w" select="$leddim"/>
      <xsl:with-param name="h" select="$leddim"/>
      <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/'" />
      <xsl:with-param name="adrsStatic" select="$adr90"/>
      <xsl:with-param name="adrsFlash" select="$adr91"/>
      <xsl:with-param name="bit" select="1"/>
    </xsl:call-template>
    <xsl:call-template name="modbusledold">
      <xsl:with-param name="x" select="120"/>
      <xsl:with-param name="y" select="237"/>
      <xsl:with-param name="w" select="$leddim"/>
      <xsl:with-param name="h" select="$leddim"/>
      <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/'" />
      <xsl:with-param name="adrsStatic" select="$adr90"/>
      <xsl:with-param name="adrsFlash" select="$adr91"/>
      <xsl:with-param name="bit" select="9"/>
    </xsl:call-template>
    <xsl:call-template name="modbusledold">
      <xsl:with-param name="x" select="362"/>
      <xsl:with-param name="y" select="237"/>
      <xsl:with-param name="w" select="$leddim"/>
      <xsl:with-param name="h" select="$leddim"/>
      <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/'" />
      <xsl:with-param name="adrsStatic" select="$adr90"/>
      <xsl:with-param name="adrsFlash" select="$adr91"/>
      <xsl:with-param name="bit" select="7"/>
    </xsl:call-template>

    <xsl:call-template name="modbusledold">
      <xsl:with-param name="x" select="166"/>
      <xsl:with-param name="y" select="247"/>
      <xsl:with-param name="w" select="$leddim"/>
      <xsl:with-param name="h" select="$leddim"/>
      <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/'" />
      <xsl:with-param name="adrsStatic" select="$adr90"/>
      <xsl:with-param name="adrsFlash" select="$adr91"/>
      <xsl:with-param name="bit" select="13"/>
    </xsl:call-template>
    <xsl:call-template name="modbusledold">
      <xsl:with-param name="x" select="264"/>
      <xsl:with-param name="y" select="247"/>
      <xsl:with-param name="w" select="$leddim"/>
      <xsl:with-param name="h" select="$leddim"/>
      <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/'" />
      <xsl:with-param name="adrsStatic" select="$adr90"/>
      <xsl:with-param name="adrsFlash" select="$adr91"/>
      <xsl:with-param name="bit" select="3"/>
    </xsl:call-template>
    <xsl:call-template name="modbusledold">
      <xsl:with-param name="x" select="329"/>
      <xsl:with-param name="y" select="247"/>
      <xsl:with-param name="w" select="$leddim"/>
      <xsl:with-param name="h" select="$leddim"/>
      <xsl:with-param name="imagepath" select="'./lib/ups/image/piller/'" />
      <xsl:with-param name="adrsStatic" select="$adr90"/>
      <xsl:with-param name="adrsFlash" select="$adr91"/>
      <xsl:with-param name="bit" select="5"/>
    </xsl:call-template>

    -->
    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="490"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'IN1:'" />
      <xsl:with-param name="text2"  select="'L1:'" />
      <xsl:with-param name="text3" select="'L2:'" />
      <xsl:with-param name="text4" select="'L3:'" />
      <xsl:with-param name="visibility" select="'visible'"/>
      <xsl:with-param name="name" select="'page0'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="515"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="value1" select="value[@name='ADR63']/@val" />
      <xsl:with-param name="unit1" select="'kVA'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2"  select="value[@name='INVOLT']/@val" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='INVOLT']/@val2" />
      <xsl:with-param name="unit3" select="'V'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="value[@name='INVOLT']/@val3" />
      <xsl:with-param name="unit4" select="'V'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'visible'"/>
      <xsl:with-param name="name" select="'page0'"/>

    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="573"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="value1" select="value[@name='INFREQ']/@val" />
      <xsl:with-param name="unit1" select="'Hz'"/>
      <xsl:with-param name="precision1" select="1"/>
      <xsl:with-param name="value2"  select="value[@name='ADR68']/@val" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='ADR69']/@val" />
      <xsl:with-param name="unit3" select="'A'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="value[@name='ADR6A']/@val" />
      <xsl:with-param name="unit4" select="'A'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'visible'"/>
      <xsl:with-param name="name" select="'page0'"/>

    </xsl:call-template>

    <!-- MAINS 2_2 -->
    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="490"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'IN2:'" />
      <xsl:with-param name="text2" select="'L1:'" />
      <xsl:with-param name="text3" select="'L2:'" />
      <xsl:with-param name="text4" select="'L3:'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page1'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="515"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="value1"  select="value[@name='ADR6B']/@val" />
      <xsl:with-param name="unit1" select="'kVA'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="value[@name='ADR6D']/@val" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='ADR6E']/@val" />
      <xsl:with-param name="unit3" select="'V'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="value[@name='ADR6F']/@val" />
      <xsl:with-param name="unit4" select="'V'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page1'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="573"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="value1"  select="value[@name='ADR6C']/@val div 10.0" />
      <xsl:with-param name="unit1" select="'Hz'"/>
      <xsl:with-param name="precision1" select="1"/>
      <xsl:with-param name="value2" select="value[@name='ADR70']/@val" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='ADR71']/@val" />
      <xsl:with-param name="unit3" select="'A'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="value[@name='ADR72']/@val" />
      <xsl:with-param name="unit4" select="'A'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page1'"/>

    </xsl:call-template>
    <!-- BATTERY_2 -->
    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="490"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="w" select="98"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'Battery:'" />
      <xsl:with-param name="text2" select="'Temperature:'" />
      <xsl:with-param name="text3" select="'Remaining time:'" />
      <xsl:with-param name="text4" select="'Remaining capacity:'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page5_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page5_11', ['Battery', ':']);</script>
    <script type="text/javascript"> translate_text('page5_12', ['Temperature', ':']);</script>
    <script type="text/javascript"> translate_text('page5_13', ['Remaining time', ':']);</script>
    <script type="text/javascript"> translate_text('page5_14', ['Remaining capacity', ':']);</script>
    

    <xsl:variable name ="remtime">
      <xsl:if test="value[@name='ADR76']/@val &gt; 99">
        <xsl:text>--</xsl:text>
      </xsl:if>
      <xsl:if test="value[@name='ADR76']/@val &lt; 100">
        <xsl:value-of select="value[@name='ADR76']/@val"/>
      </xsl:if>
    </xsl:variable>

    <xsl:if test="value[@name='_tempUnit']/@val=0 or string-length(value[@name='_tempUnit']/@val)=0">
      <xsl:call-template name="paneColumn">
        <xsl:with-param name="rows" select="4"/>
        <xsl:with-param name="x" select="590"/>
        <xsl:with-param name="y" select="200"/>
        <xsl:with-param name="w" select="48"/>
        <xsl:with-param name="h" select="14"/>
        <xsl:with-param name="value1"  select="value[@name='ADR73']/@val" />
        <xsl:with-param name="unit1" select="'A'"/>
        <xsl:with-param name="precision1" select="0"/>
        <xsl:with-param name="value2" select="value[@name='ADRA9']/@val div 10.0" />
        <xsl:with-param name="unit2" select="'&#176;C'"/>
        <xsl:with-param name="precision2" select="1"/>
        <xsl:with-param name="value3" select="$remtime" />
        <xsl:with-param name="unit3" select="'min'"/>
        <xsl:with-param name="precision3" select="0"/>
        <xsl:with-param name="value4" select="value[@name='ADR92']/@val" />
        <xsl:with-param name="unit4" select="'Ah'"/>
        <xsl:with-param name="precision4" select="0"/>
        <xsl:with-param name="visibility" select="'hidden'"/>
        <xsl:with-param name="name" select="'page5'"/>
      </xsl:call-template>
    </xsl:if>
    <xsl:if test="value[@name='_tempUnit']/@val=1">
      <xsl:call-template name="paneColumn">
        <xsl:with-param name="rows" select="4"/>
        <xsl:with-param name="x" select="590"/>
        <xsl:with-param name="y" select="200"/>
        <xsl:with-param name="w" select="48"/>
        <xsl:with-param name="h" select="14"/>
        <xsl:with-param name="value1"  select="value[@name='ADR73']/@val" />
        <xsl:with-param name="unit1" select="'A'"/>
        <xsl:with-param name="precision1" select="0"/>
        <xsl:with-param name="value2" select="(value[@name='ADRA9']/@val div 10.0*1.8) + 32.0" />
        <xsl:with-param name="unit2" select="'&#176;F'"/>
        <xsl:with-param name="precision2" select="1"/>
        <xsl:with-param name="value3" select="$remtime" />
        <xsl:with-param name="unit3" select="'min'"/>
        <xsl:with-param name="precision3" select="0"/>
        <xsl:with-param name="value4" select="value[@name='ADR92']/@val" />
        <xsl:with-param name="unit4" select="'Ah'"/>
        <xsl:with-param name="precision4" select="0"/>
        <xsl:with-param name="visibility" select="'hidden'"/>
        <xsl:with-param name="name" select="'page5'"/>
      </xsl:call-template>
    </xsl:if>

    <!-- DC_LINK_2 -->
    <xsl:call-template name="paneText">
      <xsl:with-param name="x" select="490"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="w" select="120"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="align" select="'center'" />
      <xsl:with-param name="value"  select="'*** DC LINK ***'" />
      <xsl:with-param name="unit" select="' '"/>
      <xsl:with-param name="name" select="'page4_0'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page4_0', ['*** ', 'DC LINK', ' ***']);</script>

    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="2"/>
      <xsl:with-param name="x" select="490"/>
      <xsl:with-param name="y" select="215"/>
      <xsl:with-param name="w" select="98"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'DC-Link:'" />
      <xsl:with-param name="text2" select="'Switch off at:'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page4_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page4_11', ['DC-Link', ':']);</script>
    <script type="text/javascript"> translate_text('page4_12', ['Switch off at', ':']);</script>

    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="2"/>
      <xsl:with-param name="x" select="590"/>
      <xsl:with-param name="y" select="215"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="value1"  select="value[@name='ADR74']/@val" />
      <xsl:with-param name="unit1" select="'V'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="value[@name='ADR75']/@val" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page4'"/>
    </xsl:call-template>

    <xsl:choose>
      <xsl:when test="value[@name='ADRAE']/@val &gt; 0">
        <xsl:call-template name="paneRow2">
          <xsl:with-param name="xT" select="490" />
          <xsl:with-param name="yT" select="243" />
          <xsl:with-param name="wT" select="42" />
          <xsl:with-param name="hT" select="14" />
          <xsl:with-param name="alignT" select="'left'" />
          <xsl:with-param name="text" select="'Equalize:'" />
          <xsl:with-param name="xOff" select="0" />
          <xsl:with-param name="xOff2" select="10" />
          <xsl:with-param name="w" select="48" />
          <xsl:with-param name="h" select="14" />
          <xsl:with-param name="align" select="'right'" />
          <xsl:with-param name="value" select="'ON'" />
          <xsl:with-param name="value2" select="value[@name='ADRAD']/@val" />
          <xsl:with-param name="unit" select="' '" />
          <xsl:with-param name="unit2" select="'min'" />
          <xsl:with-param name="precision" select="-1" />
          <xsl:with-param name="precision2" select="0" />
          <xsl:with-param name="visibility" select="'visible'" />
          <xsl:with-param name="name" select="'page4_2'" />
        </xsl:call-template>
        <script type="text/javascript"> translate_text('page4_20', ['Equalize', ':']);</script>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="paneRow2">
          <xsl:with-param name="xT" select="490" />
          <xsl:with-param name="yT" select="243" />
          <xsl:with-param name="wT" select="42" />
          <xsl:with-param name="hT" select="14" />
          <xsl:with-param name="alignT" select="'left'" />
          <xsl:with-param name="text" select="'Equalize:'" />
          <xsl:with-param name="xOff" select="0" />
          <xsl:with-param name="xOff2" select="10" />
          <xsl:with-param name="w" select="48" />
          <xsl:with-param name="h" select="14" />
          <xsl:with-param name="align" select="'right'" />
          <xsl:with-param name="value" select="''" />
          <xsl:with-param name="value2" select="'OFF'" />
          <xsl:with-param name="unit" select="' '" />
          <xsl:with-param name="unit2" select="' '" />
          <xsl:with-param name="precision" select="-1" />
          <xsl:with-param name="precision2" select="-1" />
          <xsl:with-param name="visibility" select="'visible'" />
          <xsl:with-param name="name" select="'page4_2'" />
        </xsl:call-template>
        <script type="text/javascript"> translate_text('page4_20', ['Equalize', ':']);</script>

      </xsl:otherwise>
    </xsl:choose>
    <!-- INVERTER_2-->
    <xsl:call-template name="paneRow2">
      <xsl:with-param name="xT" select="490" />
      <xsl:with-param name="yT" select="200" />
      <xsl:with-param name="wT" select="25" />
      <xsl:with-param name="hT" select="14" />
      <xsl:with-param name="alignT" select="'left'" />
      <xsl:with-param name="text" select="'INV'" />
      <xsl:with-param name="xOff" select="0" />
      <xsl:with-param name="xOff2" select="10" />
      <xsl:with-param name="w" select="48" />
      <xsl:with-param name="h" select="14" />
      <xsl:with-param name="align" select="'right'" />
      <xsl:with-param name="value" select="value[@name='ADR77']/@val" />
      <xsl:with-param name="value2" select="value[@name='ADR78']/@val div 10.0" />
      <xsl:with-param name="unit" select="'kVA'" />
      <xsl:with-param name="unit2" select="'Hz'" />
      <xsl:with-param name="precision" select="0" />
      <xsl:with-param name="precision2" select="1" />
      <xsl:with-param name="visibility" select="'visible'" />
      <xsl:with-param name="name" select="'page2'" />
    </xsl:call-template>

    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="490"/>
      <xsl:with-param name="y" select="214"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'L1:'" />
      <xsl:with-param name="text2" select="'L2:'" />
      <xsl:with-param name="text3" select="'L3:'" />
      <xsl:with-param name="visibility" select="'visible'"/>
      <xsl:with-param name="name" select="'page2'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="515"/>
      <xsl:with-param name="y" select="214"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="value1"  select="value[@name='ADR79']/@val" />
      <xsl:with-param name="unit1" select="'V'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="value[@name='ADR7A']/@val" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='ADR7B']/@val" />
      <xsl:with-param name="unit3" select="'V'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="visibility" select="'visible'"/>
      <xsl:with-param name="name" select="'page2'"/>

    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="573"/>
      <xsl:with-param name="y" select="214"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="value1"  select="value[@name='ADR7C']/@val" />
      <xsl:with-param name="unit1" select="'A'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="value[@name='ADR7D']/@val" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='ADR7E']/@val" />
      <xsl:with-param name="unit3" select="'A'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="visibility" select="'visible'"/>
      <xsl:with-param name="name" select="'page2'"/>
    </xsl:call-template>
    <!-- PHASE_2 -->
    <xsl:call-template name="paneText">
      <xsl:with-param name="x" select="490"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="w" select="120"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="align" select="'center'" />
      <xsl:with-param name="value"  select="'*** Phase ***'" />
      <xsl:with-param name="unit" select="' '"/>
      <xsl:with-param name="name" select="'page3_0'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page3_0', ['*** ', 'Phase', ' ***']);</script>

    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="490"/>
      <xsl:with-param name="y" select="215"/>
      <xsl:with-param name="w" select="98"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'Mains - Inverter:'" />
      <xsl:with-param name="text2" select="'Inverter - Bus:'" />
      <xsl:with-param name="text3" select="'Out - Bus:'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page3_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page3_11', ['Mains - Inverter:', ':']);</script>
    <script type="text/javascript"> translate_text('page3_12', ['Inverter - Bus', ':']);</script>
    <script type="text/javascript"> translate_text('page3_13', ['Out - Bus', ':']);</script>

    <xsl:variable name ="mainsphase">
      <xsl:if test="value[@name='ADR7F']/@val = 240">
        <xsl:text>--</xsl:text>
      </xsl:if>
      <xsl:if test="value[@name='ADR7F']/@val != 240">
        <xsl:call-template name="round-decimal">
          <xsl:with-param name="value" select="value[@name='ADR7F']/@val"/>
          <xsl:with-param name="precision" select="0"/>
        </xsl:call-template>
      </xsl:if>
    </xsl:variable>
    <xsl:variable name ="inverterphase">
      <xsl:if test="value[@name='ADR80']/@val = 240">
        <xsl:text>--</xsl:text>
      </xsl:if>
      <xsl:if test="value[@name='ADR80']/@val != 240">
        <xsl:call-template name="round-decimal">
          <xsl:with-param name="value" select="value[@name='ADR80']/@val"/>
          <xsl:with-param name="precision" select="0"/>
        </xsl:call-template>
      </xsl:if>
    </xsl:variable>
    <xsl:variable name ="outphase">
      <xsl:if test="value[@name='ADR81']/@val = 240">
        <xsl:text>--</xsl:text>
      </xsl:if>
      <xsl:if test="value[@name='ADR81']/@val != 240">
        <xsl:call-template name="round-decimal">
          <xsl:with-param name="value" select="value[@name='ADR81']/@val"/>
          <xsl:with-param name="precision" select="0"/>
        </xsl:call-template>
      </xsl:if>
    </xsl:variable>


    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="560"/>
      <xsl:with-param name="y" select="215"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="text1"  select="$mainsphase" />
      <xsl:with-param name="text2" select="$inverterphase" />
      <xsl:with-param name="text3" select="$outphase" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page3'"/>
    </xsl:call-template>

    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="590"/>
      <xsl:with-param name="y" select="215"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="value1"  select="'DGR'" />
      <xsl:with-param name="value2" select="'DGR'" />
      <xsl:with-param name="value3" select="'DGR'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page3'"/>
    </xsl:call-template>

    <!-- DEFAULT_UB -->
    <xsl:variable name ="output">
      <xsl:value-of select="value[@name='ADR8D']/@val"/>
      <xsl:text>kW/</xsl:text>
      <xsl:value-of select="value[@name='ADR8E']/@val div 100"/>
    </xsl:variable>

    <xsl:call-template name="paneText">
      <xsl:with-param name="x" select="490"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="w" select="120"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="align" select="'center'" />
      <xsl:with-param name="value"  select="'*** Default ***'" />
      <xsl:with-param name="unit" select="' '"/>
      <xsl:with-param name="name" select="'page6_0'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page6_0', ['*** ', 'Default', ' ***']);</script>

    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="490"/>
      <xsl:with-param name="y" select="215"/>
      <xsl:with-param name="w" select="98"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'Hours:'" />
      <xsl:with-param name="text2" select="'Counter:'" />
      <xsl:with-param name="text3" select="'Output:'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page6_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page6_11', ['Hours', ':']);</script>
    <script type="text/javascript"> translate_text('page6_12', ['Counter', ':']);</script>
    <script type="text/javascript"> translate_text('page6_13', ['Output', ':']);</script>

    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="565"/>
      <xsl:with-param name="y" select="215"/>
      <xsl:with-param name="w" select="54"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="value1"  select="value[@name='ADR8A']/@val*10000 + value[@name='ADR8B']/@val" />
      <xsl:with-param name="unit1" select="'h'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="value[@name='ADR8C']/@val" />
      <xsl:with-param name="unit2" select="' '"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3"  select="$output" />
      <xsl:with-param name="unit3" select="' '"/>
      <xsl:with-param name="precision3" select="-1"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page6'"/>
    </xsl:call-template>
    <!-- BUS2_2-->
    <!--
	<xsl:call-template name="paneRow2">
		<xsl:with-param name="xT" select="490" />
	  <xsl:with-param name="yT" select="200" />
	  <xsl:with-param name="wT" select="25" />
	  <xsl:with-param name="hT" select="14" />
	  <xsl:with-param name="alignT" select="'left'" />
	  <xsl:with-param name="text" select="'BUS'" />
	  <xsl:with-param name="xOff" select="0" />
	  <xsl:with-param name="xOff2" select="10" />
	  <xsl:with-param name="w" select="48" />
	  <xsl:with-param name="h" select="14" />
	  <xsl:with-param name="align" select="'right'" />
	  <xsl:with-param name="value" select="value[@name='ADR82']/@val" />
	  <xsl:with-param name="value2" select="value[@name='ADR83']/@val div 10.0" />
	  <xsl:with-param name="unit" select="'kVA'" />
	  <xsl:with-param name="unit2" select="'Hz'" />
	  <xsl:with-param name="precision" select="1" />
	  <xsl:with-param name="precision2" select="1" />
	  <xsl:with-param name="visibility" select="'hidden'" />
	  <xsl:with-param name="name" select="'page7'" />
	</xsl:call-template>
-->
    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="490"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'BUS:'" />
      <xsl:with-param name="text2"  select="'L1:'" />
      <xsl:with-param name="text3" select="'L2:'" />
      <xsl:with-param name="text4" select="'L3:'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page7_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page7_11', ['BUS', ':']);</script>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="515"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="value1" select="value[@name='ADR82']/@val" />
      <xsl:with-param name="unit1" select="'kVA'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2"  select="value[@name='ADR84']/@val" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='ADR85']/@val" />
      <xsl:with-param name="unit3" select="'V'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="value[@name='ADR86']/@val" />
      <xsl:with-param name="unit4" select="'V'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page7'"/>

    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="4"/>
      <xsl:with-param name="x" select="573"/>
      <xsl:with-param name="y" select="200"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="14"/>
      <xsl:with-param name="value1" select="value[@name='ADR83']/@val div 10.0" />
      <xsl:with-param name="unit1" select="'Hz'"/>
      <xsl:with-param name="precision1" select="1"/>
      <xsl:with-param name="value2"  select="value[@name='ADR87']/@val" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='ADR88']/@val" />
      <xsl:with-param name="unit3" select="'A'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="value4" select="value[@name='ADR89']/@val" />
      <xsl:with-param name="unit4" select="'A'"/>
      <xsl:with-param name="precision4" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page7'"/>

    </xsl:call-template>

    <!-- EOT -->
  </xsl:template>

  <!-- EOS -->
</xsl:stylesheet>
