<?xml version="1.0"?>
<!--
   outletsetting.xsl - programmable outlets settings.
   Copyright (c) 2010, Generex GmbH. All rights reserved.
   said raqui
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!-- Methods -->
  <!--Menu-->
  <xsl:template name="outletsetting_panel-menu">
    <xsl:call-template name="app-menu">
      <xsl:with-param name="temp" select="0"/>
      <xsl:with-param name="sm_h" select="0"/>
      <xsl:with-param name="sm_t" select="0"/>
      <xsl:with-param name="top" select="428"/>
      <xsl:with-param name="left" select="0"/>
      <xsl:with-param name="width" select="0"/>
      <xsl:with-param name="height" select="0"/>
      <xsl:with-param name="class" select="'XBold_black'"/>
    </xsl:call-template>
  </xsl:template>
  <!--Body-->
  <xsl:template name="outletsetting_panel-body">
    <xsl:apply-templates />
  </xsl:template>
  <!-- Implementation -->
  <xsl:template match="values">

    <!--title-->
    <div id="panel3" class="XLargeBold" style="position:absolute; top:10px;left:20px;width:486px;height:35px;background-color:#428BCA;text-align:center; line-height:35px;border: 1px solid black;color:white">
      <script type="text/javascript"> translate_text('panel3', 'Programmable Outlet Setting');</script>
    </div>
    <!--Outlet 1 variables-->
    <xsl:variable name="t1_1">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='t1_1']/@val)!=0">
          <xsl:value-of select="value[@name='t1_1']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="0" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="t1_2">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='t1_2']/@val)!=0">
          <xsl:value-of select="value[@name='t1_2']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="0" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="t1_3">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='t1_3']/@val)!=0">
          <xsl:value-of select="value[@name='t1_3']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="0" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="t1_4">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='t1_4']/@val)!=0">
          <xsl:value-of select="value[@name='t1_4']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="50" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="c1_1">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='c1_1']/@val)!=0">
          <xsl:value-of select="value[@name='c1_1']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="0" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="c1_2">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='c1_2']/@val)!=0">
          <xsl:value-of select="value[@name='c1_2']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="0" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="c1_3">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='c1_3']/@val)!=0">
          <xsl:value-of select="value[@name='c1_3']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="0" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="c1_4">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='c1_4']/@val)!=0">
          <xsl:value-of select="value[@name='c1_4']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="0" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <!--Outlet 2 variables-->
    <xsl:variable name="t2_1">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='t2_1']/@val)!=0">
          <xsl:value-of select="value[@name='t2_1']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="0" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="t2_2">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='t2_2']/@val)!=0">
          <xsl:value-of select="value[@name='t2_2']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="0" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="t2_3">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='t2_3']/@val)!=0">
          <xsl:value-of select="value[@name='t2_3']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="0" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="t2_4">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='t2_4']/@val)!=0">
          <xsl:value-of select="value[@name='t2_4']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="50" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="c2_1">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='c2_1']/@val)!=0">
          <xsl:value-of select="value[@name='c2_1']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="0" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="c2_2">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='c2_2']/@val)!=0">
          <xsl:value-of select="value[@name='c2_2']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="0" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="c2_3">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='c2_3']/@val)!=0">
          <xsl:value-of select="value[@name='c2_3']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="0" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="c2_4">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='c2_4']/@val)!=0">
          <xsl:value-of select="value[@name='c2_4']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="0" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <!--Outlet 1-->
    <xsl:call-template name="programmable_outlet">
      <xsl:with-param name="top" select="'74'"/>
      <xsl:with-param name="left" select="'40'"/>
      <xsl:with-param name="w" select="'445'"/>
      <xsl:with-param name="h" select="'200'"/>
      <xsl:with-param name="border" select="'1'"/>
      <xsl:with-param name="class" select="'XLarge'"/>
      <xsl:with-param name="id" select="'outlet1_id'"/>
      <xsl:with-param name="outlet_nr" select="'prg_outlet1'"/>
      <xsl:with-param name="t1" select="$t1_1"/>
      <xsl:with-param name="t2" select="$t1_2"/>
      <xsl:with-param name="t3" select="$t1_3"/>
      <xsl:with-param name="t4" select="$t1_4"/>
      <xsl:with-param name="c1" select="$c1_1"/>
      <xsl:with-param name="c2" select="$c1_2"/>
      <xsl:with-param name="c3" select="$c1_3"/>
      <xsl:with-param name="c4" select="$c1_4"/>
    </xsl:call-template>
    <!--Outlet 2-->
    <xsl:call-template name="programmable_outlet">
      <xsl:with-param name="top" select="'300'"/>
      <xsl:with-param name="left" select="'40'"/>
      <xsl:with-param name="w" select="'445'"/>
      <xsl:with-param name="h" select="'200'"/>
      <xsl:with-param name="border" select="'1'"/>
      <xsl:with-param name="class" select="'XLarge'"/>
      <xsl:with-param name="title" select="'Programmable&#160;Outlet&#160;2'"/>
      <xsl:with-param name="id" select="'outlet2_id'"/>
      <xsl:with-param name="outlet_nr" select="'prg_outlet2'"/>
      <xsl:with-param name="t1" select="$t2_1"/>
      <xsl:with-param name="t2" select="$t2_2"/>
      <xsl:with-param name="t3" select="$t2_3"/>
      <xsl:with-param name="t4" select="$t2_4"/>
      <xsl:with-param name="c1" select="$c2_1"/>
      <xsl:with-param name="c2" select="$c2_2"/>
      <xsl:with-param name="c3" select="$c2_3"/>
      <xsl:with-param name="c4" select="$c2_4"/>
    </xsl:call-template>

    <!--infos variable-->
    <xsl:variable name="infos">
      <xsl:choose>
        <xsl:when test="string-length(value[@name='infos']/@val)!=0">
          <xsl:value-of select="value[@name='infos']/@val" />
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="''" />
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:if test="string-length($infos)!=0">
      <xsl:call-template name="extcmd_infos">
        <xsl:with-param name="infos" select="$infos"/>
        <xsl:with-param name="top" select="'510'"/>
      </xsl:call-template>
    </xsl:if>


  </xsl:template>
  <!-- EOS -->
</xsl:stylesheet>