/*
   powernet_panel.js: Powernet DAC Screen
   Copyright (c) 2016, Generex GmbH. All rights reserved.
   said
*/
var powernet_api = (function ($) {
  var oid = get_oid_from_url(),
  cb = null, //Callback Obj
  pannes_created = false,
  err_div = null,
  check_bowser = true,
  css_obj,
  valtable_obj, report_obj, modules_obj, unms_obj,
  inphases = null,
  outphases = null,
  x_pos = 2,
  y_pos = 2;

  var req_params = null,
  powernet_strings = [
    // Faults:
    { id: 0x00, txt: "Fault: Units lost" },
    { id: 0x01, txt: "Fault: Inverter start" },
    { id: 0x02, txt: "Fault: Inverter operation" },
    { id: 0x03, txt: "Fault: TRX operation" },
    { id: 0x04, txt: "Fault: TRX start" },
    { id: 0x05, txt: "Fault: Sudden power down" },
    { id: 0x06, txt: "Fault: Sync TRX" },
    { id: 0x07, txt: "Fault: UnitOff ineffective" },
    { id: 0x08, txt: "Fault: Parameter EEPROM read" },
    { id: 0x09, txt: "Fault: Parameter EEPROM write" },
    { id: 0x0a, txt: "Fault: Reserved10" },
    { id: 0x0b, txt: "Fault: Reserved11" },
    { id: 0x0c, txt: "Fault: Parameters incompatible" },
    { id: 0x0d, txt: "Fault: On button stuck" },
    { id: 0x0e, txt: "Fault: Off button stuck" },
    { id: 0x0f, txt: "Fault: Overtemperature" },
    { id: 0x10, txt: "Fault: Firmware incompatible" },
    { id: 0x11, txt: "Fault: Not calibrated" },
    { id: 0x12, txt: "Fault: Comm. bus disconnected" },
    { id: 0x13, txt: "Fault: Inverter AC bus disconnected" },
    { id: 0x14, txt: "Fault: Unexpected voltage on AC bus" },
    { id: 0x15, txt: "Fault: AC bus earth short" },
    { id: 0x16, txt: "Fault: Temperature measurement" },
    { id: 0x17, txt: "Fault: History write" },
    { id: 0x18, txt: "Fault: EEPROM status write" },
    { id: 0x19, txt: "Fault: Inverter overload" },
    { id: 0x1a, txt: "Fault: Low input voltage" },
    { id: 0x1b, txt: "Fault: High input voltage" },
    { id: 0x1c, txt: "Fault: Fan installation" },
    { id: 0x1d, txt: "Fault: Bypass installation" },
    { id: 0x1e, txt: "Fault: Wrong inverter AC bus polarity" },
    { id: 0x1f, txt: "Fault: Load sharing" },
    { id: 0x20, txt: "Fault: Fan failure" },
    { id: 0x21, txt: "Fault: Mains failure" },
    { id: 0x22, txt: "Fault: Inverter system not OK" },
    { id: 0x23, txt: "Fault: Internal mains fuse fault" },
    { id: 0x24, txt: "Fault: Internal inverter fuse fault" },
    { id: 0x25, txt: "Fault: Internal switch drive failure" },
    { id: 0x26, txt: "Fault: Internal inverter switch failure" },
    { id: 0x27, txt: "Fault: Internal mains switch failure" },
    { id: 0x28, txt: "Fault: Input voltage measurement" },
    { id: 0x29, txt: "Fault: Bypass overload" },
    // End Faults:
    { id: 0x40, txt: "End fault: Units lost" },
    { id: 0x41, txt: "End fault: Inverter start" },
    { id: 0x42, txt: "End fault: Inverter operation" },
    { id: 0x43, txt: "End fault: TRX operation" },
    { id: 0x44, txt: "End fault: TRX start" },
    { id: 0x45, txt: "End fault: Sudden power down" },
    { id: 0x46, txt: "End fault: Sync TRX" },
    { id: 0x47, txt: "End fault: UnitOff ineffective" },
    { id: 0x48, txt: "End fault: Parameter EEPROM read" },
    { id: 0x49, txt: "End fault: Parameter EEPROM write" },
    { id: 0x4a, txt: "End fault: Reserved10" },
    { id: 0x4b, txt: "End fault: Reserved11" },
    { id: 0x4c, txt: "End fault: Parameters incompatible" },
    { id: 0x4d, txt: "End fault: On button stuck" },
    { id: 0x4e, txt: "End fault: Off button stuck" },
    { id: 0x4f, txt: "End fault: Overtemperature" },
    { id: 0x50, txt: "End fault: Firmware incompatible" },
    { id: 0x51, txt: "End fault: Not calibrated" },
    { id: 0x52, txt: "End fault: Comm. bus disconnected" },
    { id: 0x53, txt: "End fault: Inverter AC bus disconnected" },
    { id: 0x54, txt: "End fault: Unexpected voltage on AC bus" },
    { id: 0x55, txt: "End fault: AC bus earth short" },
    { id: 0x56, txt: "End fault: Temperature measurement" },
    { id: 0x57, txt: "End fault: History write" },
    { id: 0x58, txt: "End fault: EEPROM status write" },
    { id: 0x59, txt: "End fault: Inverter overload" },
    { id: 0x5a, txt: "End fault: Low input voltage" },
    { id: 0x5b, txt: "End fault: High input voltage" },
    { id: 0x5c, txt: "End fault: Fan installation" },
    { id: 0x5d, txt: "End fault: Bypass installation" },
    { id: 0x5e, txt: "End fault: Wrong inverter AC bus polarity" },
    { id: 0x5f, txt: "End fault: Load sharing" },
    { id: 0x60, txt: "End fault: Fan failure" },
    { id: 0x61, txt: "End fault: Mains failure" },
    { id: 0x62, txt: "End fault: Inverter system not OK" },
    { id: 0x63, txt: "End fault: Internal mains fuse fault" },
    { id: 0x64, txt: "End fault: Internal inverter fuse fault" },
    { id: 0x65, txt: "End fault: Internal switch drive failure" },
    { id: 0x66, txt: "End fault: Internal inverter switch failure" },
    { id: 0x67, txt: "End fault: Internal mains switch failure" },
    { id: 0x68, txt: "End fault: Input voltage measurement" },
    { id: 0x69, txt: "End fault: Bypass overload" },
    // Status
    { id: 0x80, txt: "Never heard" },
    { id: 0x81, txt: "Input disconnected" },
    { id: 0x82, txt: "Input undervoltage turn off" },
    { id: 0x83, txt: "Unknown" },
    { id: 0x84, txt: "Unknown" },
    { id: 0x85, txt: "Unknown" },
    { id: 0x86, txt: "Unknown" },
    { id: 0x87, txt: "Unknown" },
    { id: 0x88, txt: "Switched off" },
    { id: 0x89, txt: "Entering update mode" },
    { id: 0x8a, txt: "Saving calibration" },
    { id: 0x8b, txt: "Unknown" },
    { id: 0x8c, txt: "Unknown" },
    { id: 0x8d, txt: "Unknown" },
    { id: 0x8e, txt: "Unknown" },
    { id: 0x8f, txt: "Unknown" },
    { id: 0x90, txt: "Internal overvoltage" },
    { id: 0x91, txt: "RAM failure" },
    { id: 0x92, txt: "Switched on" },
    { id: 0x93, txt: "Input voltage connected" },
    { id: 0x94, txt: "Could not enter bus" },
    { id: 0x95, txt: "Stand alone system ready" },
    { id: 0x96, txt: "Parallel system ready" },
    { id: 0x97, txt: "Bus address conflict" },
    { id: 0x98, txt: "Bypass as sync master" },
    { id: 0x99, txt: "Sync master collision" },
    { id: 0x9a, txt: "Sync failure" },
    { id: 0x9b, txt: "Comm. bus collisions" },
    { id: 0x9c, txt: "History buffer overflow" },
    { id: 0x9d, txt: "History pointer error" },
    { id: 0x9e, txt: "Input voltage drop" },
    { id: 0x9f, txt: "Output switched on" },
    { id: 0xa0, txt: "Joined output on" },
    { id: 0xa1, txt: "Output switched off" },
    { id: 0xa2, txt: "Own Off button pressed" },
    { id: 0xa3, txt: "Two Off buttons pressed" },
    { id: 0xa4, txt: "Remote Off command" },
    { id: 0xa5, txt: "Own On button pressed" },
    { id: 0xa6, txt: "Two On buttons pressed" },
    { id: 0xa7, txt: "Remote On Command" },
    { id: 0xa8, txt: "Parameter updated" },
    { id: 0xa9, txt: "Parameter updated for this unit" },
    { id: 0xaa, txt: "Parameter adapted" },
    { id: 0xab, txt: "Bypass parameter updated" },
    { id: 0xac, txt: "Switched to inverters" },
    { id: 0xad, txt: "Switched to mains" },
    { id: 0xae, txt: "Inverters OK" },
    { id: 0xaf, txt: "Mains OK" },
    { id: 0xb0, txt: "Inverter waveform over limit" },
    { id: 0xb1, txt: "Inverter waveform under limit" },
    { id: 0xb2, txt: "Inverter RMS voltage high" },
    { id: 0xb3, txt: "Inverter RMS voltage low" },
    { id: 0xb4, txt: "Inverter output turned off" },
    { id: 0xb5, txt: "Inverter system failure" },
    { id: 0xb6, txt: "EEPROM initialized" },
    { id: 0xb7, txt: "Parameter rejected" },
    { id: 0xb8, txt: "Mains waveform over limit" },
    { id: 0xb9, txt: "Mains waveform under limit" },
    { id: 0xba, txt: "Mains RMS voltage high" },
    { id: 0xbb, txt: "Mains RMS voltage low" },
    { id: 0xbc, txt: "Mains frequency over limit" },
    { id: 0xbd, txt: "Mains frequency under limit" },
    { id: 0xbe, txt: "Synchronization lost" },
    { id: 0xbf, txt: "Remote command rejected" },
    { id: 0xc0, txt: "Started to send sync" },
    { id: 0xff, txt: "" }
  ],
  ac_faults = [
    "Bypass cannot synchronize to mains AC.",
    "Mains AC frequency is out of parameter limits.",
    "The instant value of mains voltage is out of the envelope waveform.",
    "Mains RMS voltage out of parameter limits.",
    "",
    "Communication between bypass and inverters is not working.",
    "The instant value of inverter AC voltage is out of the envelope waveform.",
    "Inverter RMS voltage is out of parameter limits."
  ];


  /*public functions*/
  return {
    init: init
  };

  function init() {
    if (check_bowser && !utils_api.check_bowser()) {
      $('#loading_id').css('display', 'none');
      panes_api.create_br_check_panel(this, browser_check_ok);
      return true;
    }
    create_err_msg_panel();

    req_params = utils_api.get_req_params(utils_api.device_ups, oid);
    cb = jqmodule.subscribe(this, { update: update, error: err_funct }, req_params);
  }

  function browser_check_ok() {
    check_bowser = false;
    init();
  }

  function create_err_msg_panel() {
    css_obj = { position: 'absolute', top: y_pos, left: x_pos, width: 791, display: 'none', 'z-index': 22 };
    err_div = panes_api.create_err_panel({ id: 'error_div', 'class': 'alert alert-danger' }, css_obj);
  }

  function err_funct(response) {
    jqmodule.refresh(cb, 10 * 1000);
    panes_api.display_err({ response: response, oid: oid, err_div: err_div, err_msg_div_id: 'error_msg_div' });
  }

  function update(data) {
    if (data.ups == null) {
      return;
    }

    set_variable(data);
    jqmodule.refresh(cb, report_obj.refresh * 1000);
    if (err_div)
    err_div.css('display', 'none');

    if (window.menu_api != null)
    menu_api.update(data);

    unms_obj = get_unms_obj(data);
    if (unms_obj != null) {
      info_head_api.update(unms_obj);
    }

    if (!pannes_created) {
      pannes_created = true;
      create_panes();
      return false;
    }
    set_mains();
    create_box_panes();
    set_ac_supply_faults();
    set_inverters();
    create_unit_panes();
    create_bypass_pane();
    set_footer();
    //set .....
  }

  function create_panes() {
    utils_api.setTitle(valtable_obj._platform);

    create_bg()
    create_model_panes();
    create_mains_panel();
    create_box_panes();
    create_ac_supply_faults_panes();
    create_unit_panes();
    create_inverter_panes();
    create_bypass_pane();
    create_footer_pane();
    //.....
  }

  function create_bg() {
    var fragment = document.createDocumentFragment(),
    bg_div;
    css_obj = { position: 'absolute', top: y_pos, left: x_pos, width: 752, height: 400, border: 'solid 1px #808080' };
    bg_div = $('<div/>', { id: 'bg_id', 'class': 'img-rounded' }).css(css_obj);
    fragment.appendChild(bg_div[0]);
    document.body.appendChild(fragment);
  }

  function create_model_panes() {
    var model_div, a;
    css_obj = { position: 'absolute', top: y_pos, left: x_pos, align: 'center', width: 752, 'z-index': 10 }; // 'background-color': '#3a87ad'
    attr_obj = { id: 'model_div_id', 'class': 'list-group' };
    model_div = panes_api.create_div(attr_obj, css_obj);
    a = $('<a/>', { 'class': 'list-group-item active', id: 'model_name_id' }).append(valtable_obj.MODEL).appendTo(model_div);
  }

  function create_mains_panel() {
    var fragment = document.createDocumentFragment(),
    div;
    css_obj = { position: 'absolute', top: y_pos + 40, left: x_pos + 2, align: 'center', 'z-index': 1 }; // 'background-color': '#3a87ad'
    div = $('<div/>').css(css_obj);
    $('<img />').attr({ 'id': 'main_img_id', src: './image/powernet/byp.gif' }).appendTo(div);
    fragment.appendChild(div[0]);

    css_obj = { position: 'absolute', top: y_pos + 160, left: x_pos + 17, align: 'center', 'z-index': 2 }; // 'background-color': '#3a87ad'
    div = $('<div/>').css(css_obj);
    $('<img />').attr({ 'id': 'ia_img_id', src: './image/powernet/empty.gif' }).appendTo(div);
    fragment.appendChild(div[0]);

    css_obj = { position: 'absolute', top: y_pos + 160, left: x_pos + 236, align: 'center', 'z-index': 2 }; // 'background-color': '#3a87ad'
    div = $('<div/>').css(css_obj);
    $('<img />').attr({ 'id': 'ib_img_id', src: './image/powernet/empty.gif' }).appendTo(div);
    fragment.appendChild(div[0]);

    css_obj = { position: 'absolute', top: y_pos + 95, left: x_pos + 29, align: 'center', 'z-index': 2 }; // 'background-color': '#3a87ad'
    div = $('<div/>').css(css_obj);
    $('<img />').attr({ 'id': 'ba_img_id', src: './image/powernet/empty.gif' }).appendTo(div);
    fragment.appendChild(div[0]);

    css_obj = { position: 'absolute', top: y_pos + 180, left: x_pos + 28, align: 'center', 'z-index': 2 }; // 'background-color': '#3a87ad'
    div = $('<div/>').css(css_obj);
    $('<img />').attr({ 'id': 'bb_img_id', src: './image/powernet/empty.gif' }).appendTo(div);
    fragment.appendChild(div[0]);

    css_obj = { position: 'absolute', top: y_pos + 181, left: x_pos + 250, align: 'center', 'z-index': 2 }; // 'background-color': '#3a87ad'
    div = $('<div/>').css(css_obj);
    $('<img />').attr({ 'id': 'bc_img_id', src: './image/powernet/empty.gif' }).appendTo(div);
    fragment.appendChild(div[0]);


    css_obj = { position: 'absolute', top: y_pos + 133, left: x_pos + 474, align: 'center', 'z-index': 2 }; // 'background-color': '#3a87ad'
    div = $('<div/>').css(css_obj);
    $('<img />').attr({ 'id': 'bd_img_id', src: './image/powernet/empty.gif' }).appendTo(div);
    fragment.appendChild(div[0]);

    css_obj = { position: 'absolute', top: y_pos + 161, left: x_pos + 569, align: 'center', 'z-index': 2 }; // 'background-color': '#3a87ad'
    div = $('<div/>').css(css_obj);
    $('<img />').attr({ 'id': 'be_img_id', src: './image/powernet/empty.gif' }).appendTo(div);
    fragment.appendChild(div[0]);

    document.body.appendChild(fragment);
    set_mains();

  }

  function set_mains() {
    if (valtable_obj.DAC_BYP_PRESENT) {
      $('#main_img_id').attr({ src: './image/powernet/byp.gif' });
      $('#ia_img_id').attr({ src: './image/powernet/empty.gif' });
      $('#ib_img_id').attr({ src: './image/powernet/empty.gif' });

      if (valtable_obj.DAC_BYP_ACFAULTS & 0x0F) {
        $('#ba_img_id').attr({ src: './image/powernet/byp-a1.gif' });
      } else {
        $('#ba_img_id').attr({ src: './image/powernet/byp-a0.gif' });
      }

      if (get_powernet_faultbit(26) || get_powernet_faultbit(27)) {
        $('#bb_img_id').attr({ src: './image/powernet/byp-b1.gif' });
      } else {
        $('#bb_img_id').attr({ src: './image/powernet/byp-b0.gif' });
      }

      if (get_powernet_faultbit(25)) {
        $('#bc_img_id').attr({ src: './image/powernet/byp-c1.gif' });
      } else {
        $('#bc_img_id').attr({ src: './image/powernet/byp-c0.gif' });
      }

      if (valtable_obj.DAC_GENERAL_STATE & 0x04) {
        $('#bd_img_id').attr({ src: './image/powernet/byp-d1.gif' });
      } else {
        $('#bd_img_id').attr({ src: './image/powernet/byp-d0.gif' });
      }

      if (get_powernet_faultbit(41)) {
        $('#be_img_id').attr({ src: './image/powernet/byp-e1.gif' });
      } else {
        $('#be_img_id').attr({ src: './image/powernet/byp-e0.gif' });
      }
    } else {
      $('#main_img_id').attr({ src: './image/powernet/inv.gif' });

      if (get_powernet_faultbit(26) || get_powernet_faultbit(27)) {
        $('#ia_img_id').attr({ src: './image/powernet/inv-a1.gif' });
      } else {
        $('#ia_img_id').attr({ src: './image/powernet/inv-a0.gif' });
      }

      if (((valtable_obj.DAC_GENERAL_STATE & 0x20) == 0) || get_powernet_faultbit(25)) {
        $('#ib_img_id').attr({ src: './image/powernet/inv-b1.gif' });
      } else {
        $('#ib_img_id').attr({ src: './image/powernet/inv-b0.gif' });
      }

      $('#ba_img_id').attr({ src: './image/powernet/empty.gif' });
      $('#bb_img_id').attr({ src: './image/powernet/empty.gif' });
      $('#bc_img_id').attr({ src: './image/powernet/empty.gif' });
      $('#bd_img_id').attr({ src: './image/powernet/empty.gif' });
      $('#be_img_id').attr({ src: './image/powernet/empty.gif' });
    }
  }

  function create_box_panes() {
    var fragment = document.createDocumentFragment(),
    byp_present_div, byp_not_present_div, div, table, tbody, tr;

    $('#byp_present_div_id').remove();
    $('#byp_not_present_div_id').remove();

    if (!valtable_obj.DAC_BYP_PRESENT) {
      byp_not_present_div = $('<div/>', { id: 'byp_not_present_div_id' }).css('background-color', '#transparent');

      css_obj = {
        position: 'absolute',
        top: y_pos + 184,
        left: x_pos + 68,
        'text-align': 'center',
        'z-index': 3,
        border: 'solid 1px #000000',
        'background-color': (get_powernet_faultbit(26) || get_powernet_faultbit(27) ? '#FF0000' : '#00FF00')
      };

      //ia
      div = $('<div/>').css(css_obj).appendTo(byp_not_present_div);
      table = $('<table />', { 'class': 'table table-condensed', align: 'left' })
      .css({ 'font-size': '9pt', 'font-weight': 'bold', 'font-family': 'arial', 'border-collapse': 'initial', 'margin-bottom': '0px' })
      .appendTo(div);
      tbody = $('<tbody />').appendTo(table);
      $('<tr />').append($('<td />').append(valtable_obj.DAC_UNIT_UIN.toFixed(1) + ' V')).appendTo(tbody);

      //ib
      css_obj = {
        position: 'absolute',
        top: y_pos + 184,
        left: x_pos + 264,
        'text-align': 'center',
        'z-index': 3,
        border: 'solid 1px #000000',
        'background-color': 'transparent'
      };

      div = $('<div/>').css(css_obj).appendTo(byp_not_present_div);
      table = $('<table />', { 'class': 'table table-condensed', align: 'center' })
      .css({ 'font-size': '9pt', 'font-weight': 'bold', 'font-family': 'arial', 'border-collapse': 'initial', 'margin-bottom': '0px' })
      .appendTo(div);
      tbody = $('<tbody />').appendTo(table);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(valtable_obj.DAC_UNIT_UOUT.toFixed(0) + ' V')).appendTo(tbody);
      $('<td />', { align: 'left' }).append(valtable_obj.DAC_UNIT_WOUT.toFixed(1) + ' W').appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(valtable_obj.DAC_UNIT_FREQ.toFixed(1) + ' Hz')).appendTo(tbody);
      $('<td />', { align: 'left' }).append(valtable_obj.DAC_UNIT_VAOUT.toFixed(1) + ' VA').appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(valtable_obj.DAC_UNIT_IOUT.toFixed(0) + ' A')).appendTo(tbody);
      $('<td />', { align: 'left' }).css('background-color', get_powernet_faultbit(25) ? '#FF0000' : '#00FF00').
      append(valtable_obj.DAC_UNIT_LOADING.toFixed(0) + ' %').appendTo(tr);


      //ic
      css_obj = {
        position: 'absolute',
        top: y_pos + 54,
        left: x_pos + 374,
        'text-align': 'center',
        'z-index': 3,
        border: 'solid 1px #000000',
        'background-color': 'transparent'
      };

      div = $('<div/>').css(css_obj).appendTo(byp_not_present_div);
      table = $('<table />', { 'class': 'table table-condensed', align: 'center' })
      .css({ 'font-size': '9pt', 'font-weight': 'bold', 'font-family': 'arial', 'border-collapse': 'initial', 'margin-bottom': '0px' }).
      appendTo(div);
      tbody = $('<tbody />').appendTo(table);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append('System ID')).appendTo(tbody);
      $('<td />', { align: 'left' }).append(valtable_obj.DAC_SYS_ID).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append('Status')).appendTo(tbody);
      $('<td />', { align: 'left' }).append(valtable_obj.DAC_GENERAL_STATE & 0x20 ? i18n('Output') + ' ' + i18n('On') : i18n('Standby')).appendTo(tr);

      fragment.appendChild(byp_not_present_div[0]);
    } else {
      byp_present_div = $('<div/>', { id: 'byp_present_div_id' }).css('background-color', '#transparent');

      //ba
      css_obj = {
        position: 'absolute',
        top: y_pos + 46,
        left: x_pos + 80,
        'text-align': 'center',
        'z-index': 3,
        border: 'solid 1px #000000'
      };

      div = $('<div/>').css(css_obj).appendTo(byp_present_div);
      table = $('<table />', { 'class': 'table table-condensed', align: 'center' })
      .css({ 'font-size': '9pt', 'font-weight': 'bold', 'font-family': 'arial', 'border-collapse': 'initial', 'margin-bottom': '0px' })
      .appendTo(div);

      tbody = $('<tbody />').appendTo(table);

      $('<tr />').append($('<td />').css('background-color', valtable_obj.DAC_BYP_ACFAULTS & 0x0C ? '#FF0000' : '#00FF00').append(valtable_obj.DAC_BYP_MAINSVOLT.toFixed(1) + ' V')).appendTo(tbody);

      $('<tr />').append($('<td />').css('background-color', ((valtable_obj.DAC_BYP_ACFAULTS & 0x03) || (valtable_obj.DAC_BYP_MAINSFREQ < 1.0)) ? '#FF0000' : '#00FF00').append(valtable_obj.DAC_BYP_MAINSFREQ.toFixed(1) + ' Hz')).appendTo(tbody);

      //bb
      css_obj = {
        position: 'absolute',
        top: y_pos + 200,
        left: x_pos + 80,
        'text-align': 'center',
        'z-index': 3,
        border: 'solid 1px #000000'
      };

      div = $('<div/>').css(css_obj).appendTo(byp_present_div);
      table = $('<table />', { 'class': 'table table-condensed', align: 'center' })
      .css({ 'font-size': '9pt', 'font-weight': 'bold', 'font-family': 'arial', 'border-collapse': 'initial', 'margin-bottom': '0px' })
      .appendTo(div);
      tbody = $('<tbody />').appendTo(table);

      $('<tr />').append($('<td />').css('background-color', get_powernet_faultbit(26) || get_powernet_faultbit(27) ? '#FF0000' : '#00FF00').append(valtable_obj.DAC_UNIT_UIN.toFixed(1) + ' V')).appendTo(tbody);

      //bc
      css_obj = {
        position: 'absolute',
        top: y_pos + 200,
        left: x_pos + 278,
        'text-align': 'center',
        'z-index': 3,
        border: 'solid 1px #000000',
        'background-color': 'transparent'
      };

      div = $('<div/>').css(css_obj).appendTo(byp_present_div);
      table = $('<table />', { 'class': 'table table-condensed', align: 'center' })
      .css({ 'font-size': '9pt', 'font-weight': 'bold', 'font-family': 'arial', 'border-collapse': 'initial', 'margin-bottom': '0px' })
      .appendTo(div);
      tbody = $('<tbody />').appendTo(table);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(valtable_obj.DAC_UNIT_UOUT.toFixed(0) + ' V')).appendTo(tbody);
      $('<td />', { align: 'left' }).append(valtable_obj.DAC_UNIT_WOUT.toFixed(1) + ' W').appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(valtable_obj.DAC_UNIT_FREQ.toFixed(1) + ' Hz')).appendTo(tbody);
      $('<td />', { align: 'left' }).append(valtable_obj.DAC_UNIT_VAOUT.toFixed(1) + ' VA').appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(valtable_obj.DAC_UNIT_IOUT.toFixed(0) + ' A')).appendTo(tbody);
      $('<td />', { align: 'left' }).css('background-color', get_powernet_faultbit(25) ? '#FF0000' : '#00FF00').
      append(valtable_obj.DAC_UNIT_LOADING.toFixed(0) + ' %').appendTo(tr);

      //bd
      css_obj = {
        position: 'absolute',
        top: y_pos + 190,
        left: x_pos + 578,
        'text-align': 'center',
        'z-index': 3,
        border: 'solid 1px #000000',
        'background-color': 'transparent'
      };

      div = $('<div/>').css(css_obj).appendTo(byp_present_div);
      table = $('<table />', { 'class': 'table table-condensed', align: 'center' })
      .css({ 'font-size': '9pt', 'font-weight': 'bold', 'font-family': 'arial', 'border-collapse': 'initial', 'margin-bottom': '0px' })
      .appendTo(div);
      tbody = $('<tbody />').appendTo(table);

      tr = $('<tr />').appendTo(tbody);
      $('<td />', { align: 'left' }).css('background-color', get_powernet_faultbit(41) ? '#FF0000' : '#00FF00').
      append((valtable_obj.DAC_BYP_WOUT / 1000).toFixed(1) + ' KW').appendTo(tr);
      $('<td />', { align: 'left' }).append(valtable_obj.DAC_BYP_UOUT.toFixed(0) + ' V').appendTo(tr);

      tr = $('<tr />').appendTo(tbody);
      $('<td />', { align: 'left' }).css('background-color', get_powernet_faultbit(41) ? '#FF0000' : '#00FF00').
      append((valtable_obj.DAC_BYP_VAOUT / 1000).toFixed(1) + ' KVA').appendTo(tr);

      $('<td />', { align: 'left' }).css('background-color', get_powernet_faultbit(41) ? '#FF0000' : '#00FF00').
      append(valtable_obj.DAC_BYP_IOUT.toFixed(0) + ' A').appendTo(tr);

      //be
      css_obj = {
        position: 'absolute',
        top: y_pos + 54,
        left: x_pos + 500,
        'text-align': 'center',
        'z-index': 3,
        border: 'solid 1px #000000',
        'background-color': 'transparent'
      };

      div = $('<div/>').css(css_obj).appendTo(byp_present_div);
      table = $('<table />', { 'class': 'table table-condensed', align: 'center' })
      .css({ 'font-size': '9pt', 'font-weight': 'bold', 'font-family': 'arial', 'border-collapse': 'initial', 'margin-bottom': '0px' })
      .appendTo(div);

      tbody = $('<tbody />').appendTo(table);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append('System ID')).appendTo(tbody);
      $('<td />', { align: 'left' }).append(valtable_obj.DAC_SYS_ID).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Status On supply'))).appendTo(tbody);
      $('<td />', { align: 'left' }).append(
        valtable_obj.DAC_GENERAL_STATE & 0x01 ? i18n('backup') : i18n('default')).appendTo(tr);

      tr = $('<tr />').appendTo(tbody);
      $('<td />', { align: 'left', colspan: 2 }).append(
        valtable_obj.DAC_GENERAL_STATE & 0x02 ? 'Load on mains' : valtable_obj.DAC_GENERAL_STATE & 0x04 ? i18n('Load on inverters') : i18n('off')).appendTo(tr);

      fragment.appendChild(byp_present_div[0]);
    }

    document.body.appendChild(fragment);
  }

  function create_ac_supply_faults_panes() {
    var fragment = document.createDocumentFragment(),
    ac_supply_faults_div, bypass_faults_div, div, button, table, tbody, thead, tr, td;

    ac_supply_faults_div = $('<div/>', { id: 'ac_supply_faults_div_id' }).css('background-color', '#transparent', 'display', 'none');

    //bf
    css_obj = { position: 'absolute', top: y_pos + 130, left: x_pos + 270, 'text-align': 'center', 'z-index': 4 };

    div = $('<div/>').css(css_obj).appendTo(ac_supply_faults_div);

    button = $('<button>', { 'class': "btn btn-danger btn-sm" }).
    css('background-color', '#FF0000').append(i18n('AC supply faults') + '!').appendTo(div);

    button.click(function (event) {
      var div = $('#bypass_faults_div_id'),
      display = div.css('display');

      div.css('display', display == 'none' ? 'block' : 'none');
      event.preventDefault();
    });

    //Bypass
    css_obj = {
      position: 'absolute',
      top: y_pos + 160,
      left: x_pos + 150,
      'text-align': 'center',
      border: 'solid 1px #808080',
      'z-index': 4,
      'background-color': '#E8E8F0',
      display: 'none'
    };
    bypass_faults_div = $('<div/>', { id: 'bypass_faults_div_id', 'class': 'img-rounded' }).css(css_obj);

    table = $('<table />', { 'class': 'table table-condensed table-hover' }).appendTo(bypass_faults_div);
    table.css({ 'font-size': '9pt', 'font-weight': 'bold', 'font-family': 'arial', 'margin-bottom': '0px' });

    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<td />', { align: 'center' }).css({ color: 'white', 'background-color': '#428bca', 'text-align': 'left' }).append(i18n("Bypass"))).appendTo(thead);
    td = $('<td />', { align: 'right', title: 'Close' }).append('X').appendTo(tr).
    css({ color: 'white', 'background-color': '#428bca', color: 'black', cursor: 'pointer' }).
    click(function (event) {
      $('#bypass_faults_div_id').css({ display: 'none' });
      event.preventDefault();
    })


    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Unit ID'))).appendTo(tbody);
    $('<td />', { id: 'byp_unit_id', align: 'left' }).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Status'))).appendTo(tbody);
    $('<td />', { id: 'byp_status_id', align: 'left' }).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Last event'))).appendTo(tbody);
    $('<td />', { id: 'byp_last_evt_id', align: 'left' }).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Inverter') + ' (V)')).appendTo(tbody);
    $('<td />', { id: 'byp_inv_v_id', align: 'left' }).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Inverter') + ' (Hz)')).appendTo(tbody);
    $('<td />', { id: 'byp_inv_hz_id', align: 'left' }).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Mains') + ' (V)')).appendTo(tbody);
    $('<td />', { id: 'byp_mains_v_id', align: 'left' }).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Mains') + ' (Hz)')).appendTo(tbody);
    $('<td />', { id: 'byp_mains_hz_id', align: 'left' }).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Output') + ' (V)')).appendTo(tbody);
    $('<td />', { id: 'byp_output_v_id', align: 'left' }).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Output') + ' (A)')).appendTo(tbody);
    $('<td />', { id: 'byp_output_a_id', align: 'left' }).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Output') + ' (kW)')).appendTo(tbody);
    $('<td />', { id: 'byp_output_kw_id', align: 'left' }).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Output') + ' (kVA)')).appendTo(tbody);
    $('<td />', { id: 'byp_output_kva_id', align: 'left' }).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Temperature'))).appendTo(tbody);
    $('<td />', { id: 'byp_Temp_id', align: 'left' }).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Faults'))).appendTo(tbody);
    $('<td />', { id: 'byp_faults_id', align: 'left' }).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('AC supply faults'))).appendTo(tbody);
    $('<td />', { id: 'byp_ac_supp_fault_id', align: 'left' }).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Firmware'))).appendTo(tbody);
    $('<td />', { id: 'byp_firmware_id', align: 'left' }).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Electrical Parameters'))).appendTo(tbody);
    $('<td />', { id: 'byp_elect_param_id', align: 'left' }).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Time since last boot'))).appendTo(tbody);
    $('<td />', { id: 'byp_boot_time_id', align: 'left' }).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Total uptime'))).appendTo(tbody);
    $('<td />', { id: 'byp_uptime_id', align: 'left' }).appendTo(tr);


    fragment.appendChild(ac_supply_faults_div[0]);
    fragment.appendChild(bypass_faults_div[0]);

    document.body.appendChild(fragment);
    set_ac_supply_faults();
    new utils_api.draggable('bypass_faults_div_id');
  }

  function set_ac_supply_faults() {
    if (!valtable_obj.DAC_BYP_PRESENT) {
      $('#ac_supply_faults_div_id').css('display', 'none');
    } else {
      //if(valtable_obj.DAC_BYP_ACFAULTS & 0xEF)
      if (valtable_obj.DAC_GENERAL_STATE & 0x10) //0x10 = 1: mains supply is OK
      {
        $('#ac_supply_faults_div_id').css('display', 'none');
      } else {
        $('#ac_supply_faults_div_id').css('display', 'block');
      }
    }

    $('#byp_unit_id').text(valtable_obj.DAC_BYP_ID);

    if (valtable_obj.DAC_BYP_OUTSTATE == 0) {
      $('#byp_status_id').text('Off');
    } else if (valtable_obj.DAC_BYP_OUTSTATE == 1) {
      $('#byp_status_id').text('On Mains');
    } else if (valtable_obj.DAC_BYP_OUTSTATE == 2) {
      $('#byp_status_id').text('On Inverter');
    }

    $('#byp_last_evt_id').text(get_powernet_string(valtable_obj.DAC_BYP_LASTSTATE));


    $('#byp_inv_v_id').text(valtable_obj.DAC_BYP_INVVOLT.toFixed(1) + ' V');
    $('#byp_inv_hz_id').text(valtable_obj.DAC_BYP_INVFREQ.toFixed(1) + ' Hz');
    $('#byp_mains_v_id').text(valtable_obj.DAC_BYP_MAINSVOLT.toFixed(0) + ' V');
    $('#byp_mains_hz_id').text(valtable_obj.DAC_BYP_MAINSFREQ.toFixed(1) + ' Hz');
    $('#byp_output_v_id').text(valtable_obj.DAC_BYP_UOUT.toFixed(0) + ' V');
    $('#byp_output_a_id').text(valtable_obj.DAC_BYP_IOUT.toFixed(0) + ' A');
    $('#byp_output_kw_id').text((valtable_obj.DAC_BYP_WOUT * 0.001).toFixed(3) + ' KW');
    $('#byp_output_kva_id').text((valtable_obj.DAC_BYP_VAOUT * 0.001).toFixed(3) + ' KVA');
    $('#byp_Temp_id').html(panes_api.get_temperature(valtable_obj.DAC_BYP_SI1TEMP, valtable_obj._tempUnit, 0));
    $('#byp_faults_id').html(get_faults_string(valtable_obj.DAC_BYP_FAULTS));
    $('#byp_ac_supp_fault_id').html(get_powernet_acfaults());
    $('#byp_firmware_id').text(valtable_obj.DAC_BYP_FIRMWARE);
    $('#byp_elect_param_id').text(valtable_obj.DAC_BYP_ELPARAMS);
    $('#byp_boot_time_id').text(get_powernet_timestring(valtable_obj.DAC_BYP_RUNNINGTIME));
    $('#byp_uptime_id').text(get_powernet_timestring(valtable_obj.DAC_BYP_TOTALUPTIME));
  }

  function create_unit_panes() {
    var fragment = document.createDocumentFragment(),
    units_div, div, table, tbody, thead, tr, td, j;

    $('#units_div_id').remove();
    //units_div
    css_obj = { position: 'absolute', top: y_pos + 330, left: x_pos + 74, width: 600, 'text-align': 'center', 'z-index': 3, border: 'solid 1px #808080' }; //,                       'background-color':'#E8E8F0'

    units_div = $('<div/>', { id: 'units_div_id', 'class': 'img-rounded' }).css(css_obj);

    table = $('<table />', { 'class': 'table table-condensed table-hover' }).appendTo(units_div);
    table.css({ 'font-size': '9pt', 'font-weight': 'bold', 'font-family': 'arial', 'margin-bottom': '0px' });

    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<th />', { align: 'center' }).append('Inverter')).
    css({ color: 'white', 'background-color': '#428bca', 'text-align': 'left' }).appendTo(thead);
    $('<th />', { align: 'left' }).append(i18n('Status')).appendTo(tr);
    $('<th />', { align: 'left' }).append(i18n('Faults')).appendTo(tr);
    $('<th />', { align: 'left' }).append(i18n('Loading')).appendTo(tr);
    $('<th />', { align: 'left' }).append(i18n('Input') + ' (V)').appendTo(tr);
    $('<th />', { align: 'left' }).append(i18n('Temperature')).appendTo(tr);


    $.each(modules_obj, (function (index, module) {

      tr = $('<tr />').appendTo(tbody);
      td = $('<td />', { id: '_' + index + '_id', align: 'left', 'class': 'text-info' }).css('cursor', 'pointer').append('Inverter ' + (index + 1)).appendTo(tr);

      td.click(function (event) {
        var div = $('#inverter' + this.id),
        display = div.css('display');

        div.css('display', display == 'none' ? 'block' : 'none');
        event.preventDefault();
      });

      if (module.DAC_UNIT_STATE & 1) {
        $('<td />', { align: 'left' }).append(i18n("Output") + " " + i18n("on")).appendTo(tr);
      } else {
        $('<td />', { align: 'left' }).append(i18n("Standby")).appendTo(tr);
      }

      td = $('<td />', { align: 'left' }).append('').appendTo(tr);
      for (j = 0; j < 8; j++) {
        if (module.DAC_UNIT_FAULTS[j]) {
          td.append('X');
          break;
        }
      }

      $('<td />', { align: 'left' }).append(module.DAC_UNIT_LOADING.toFixed(0) + ' %').appendTo(tr);
      $('<td />', { align: 'left' }).append(module.DAC_UNIT_UIN.toFixed(1) + ' V').appendTo(tr);
      $('<td />', { align: 'left' }).append(panes_api.get_temperature(module.DAC_UNIT_SI1TEMP, valtable_obj._tempUnit, 0)).appendTo(tr);
    }));



    fragment.appendChild(units_div[0]);
    document.body.appendChild(fragment);
  }

  function create_inverter_panes() {
    var div, button, table, tbody, thead, tr, td, index, id;

    css_obj = {
      position: 'absolute',
      top: y_pos + 360,
      left: x_pos + 310,
      'text-align': 'center',
      border: 'solid 1px #808080',
      'z-index': 4,
      'background-color': '#E8E8F0',
      display: 'none'
    };

    for (index = 0; index < 20; ++index) {
      //Inverters
      id = 'inverter_' + index + '_id';
      div = $('<div/>', { id: id, 'class': 'img-rounded' }).css(css_obj);

      table = $('<table />', { 'class': 'table table-condensed table-hover' }).appendTo(div);
      table.css({ 'font-size': '9pt', 'font-weight': 'bold', 'font-family': 'arial', 'margin-bottom': '0px' });

      tbody = $('<tbody />').appendTo(table);
      thead = $('<thead />').appendTo(table);

      tr = $('<tr />').append($('<td />', { align: 'center' }).css({ color: 'white', 'background-color': '#428bca', 'text-align': 'left' }).append(i18n('Inverter') + ' ' + (index + 1))).appendTo(thead);
      td = $('<td />', { id: index + '_id', align: 'right', title: 'Close' }).append('X').appendTo(tr).
      css({ color: 'white', 'background-color': '#428bca', color: 'black', cursor: 'pointer' }).
      click(function (event) {
        var div = $('#inverter_' + this.id),
        display = div.css('display');

        div.css('display', 'none');
        event.preventDefault();
      })


      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Unit ID'))).appendTo(tbody);
      $('<td />', { id: 'inv_unit_' + index + '_id', align: 'left' }).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Status'))).appendTo(tbody);
      $('<td />', { id: 'inv_status_' + index + '_id', align: 'left' }).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Last event'))).appendTo(tbody);
      $('<td />', { id: 'inv_last_evt_' + index + '_id', align: 'left' }).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Output') + ' (W)')).appendTo(tbody);
      $('<td />', { id: 'inv_output_w_' + index + '_id', align: 'left' }).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Output') + ' (VA)')).appendTo(tbody);
      $('<td />', { id: 'inv_output_va_' + index + '_id', align: 'left' }).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Loading'))).appendTo(tbody);
      $('<td />', { id: 'inv_loading_' + index + '_id', align: 'left' }).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Output') + ' (V)')).appendTo(tbody);
      $('<td />', { id: 'inv_output_v_' + index + '_id', align: 'left' }).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Output') + ' (Hz)')).appendTo(tbody);
      $('<td />', { id: 'inv_output_hz' + index + '_id', align: 'left' }).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Input') + ' (V)')).appendTo(tbody);
      $('<td />', { id: 'inv_input_v_' + index + '_id', align: 'left' }).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Input') + ' (A)')).appendTo(tbody);
      $('<td />', { id: 'inv_input_a' + index + '_id', align: 'left' }).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Temperature') + ' 1')).appendTo(tbody);
      $('<td />', { id: 'inv_temp_1_' + index + '_id', align: 'left' }).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Temperature') + ' 2')).appendTo(tbody);
      $('<td />', { id: 'inv_temp_2_' + index + '_id', align: 'left' }).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Faults'))).appendTo(tbody);
      $('<td />', { id: 'inv_faults_' + index + '_id', align: 'left' }).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Firmware'))).appendTo(tbody);
      $('<td />', { id: 'inv_firmware_' + index + '_id', align: 'left' }).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Electrical Parameters'))).appendTo(tbody);
      $('<td />', { id: 'inv_elect_param_' + index + '_id', align: 'left' }).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Time since last boot'))).appendTo(tbody);
      $('<td />', { id: 'inv_time_boot_' + index + '_id', align: 'left' }).appendTo(tr);

      tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n('Total uptime'))).appendTo(tbody);
      $('<td />', { id: 'inv_total_uptime_' + index + '_id', align: 'left' }).appendTo(tr);

      document.body.appendChild(div[0]);
      set_inverters();
      new utils_api.draggable('inverter_' + index + '_id');
      css_obj.top += 30;
      css_obj.left += 20;
    }

  }

  function set_inverters() {
    var index;

    for (index = modules_obj.length; index < 20; ++index) {
      $('#inverter_' + index + '_id').css("display", "none");
    }

    for (index = 0; index < 20 && index < modules_obj.length; ++index) {
      $('#inv_unit_' + index + '_id').text(modules_obj[index].DAC_UNIT_ID);

      if (modules_obj[index].DAC_UNIT_STATE & 1) {
        $('#inv_status_' + index + '_id').text("Output on");
      } else {
        $('#inv_status_' + index + '_id').text("Standby");
      }

      $('#inv_last_evt_' + index + '_id').text(get_powernet_string(modules_obj[index].DAC_UNIT_LASTSTATE));

      $('#inv_output_w_' + index + '_id').text(modules_obj[index].DAC_UNIT_WOUT.toFixed(0) + ' W');
      $('#inv_output_va_' + index + '_id').text(modules_obj[index].DAC_UNIT_VAOUT.toFixed(0) + ' VA');
      $('#inv_loading_' + index + '_id').text(modules_obj[index].DAC_UNIT_LOADING.toFixed(0) + ' %');
      $('#inv_output_v_' + index + '_id').text(modules_obj[index].DAC_UNIT_UOUT.toFixed(1) + ' V');
      $('#inv_output_hz' + index + '_id').text(modules_obj[index].DAC_UNIT_FREQ.toFixed(1) + ' Hz');
      $('#inv_input_v_' + index + '_id').text(modules_obj[index].DAC_UNIT_UIN.toFixed(1) + ' V');
      $('#inv_input_a' + index + '_id').text(modules_obj[index].DAC_UNIT_IIN.toFixed(0) + ' A');
      $('#inv_temp_1_' + index + '_id').html(panes_api.get_temperature(modules_obj[index].DAC_UNIT_SI1TEMP, valtable_obj._tempUnit, 0));
      $('#inv_temp_2_' + index + '_id').html(panes_api.get_temperature(modules_obj[index].DAC_UNIT_SI2TEMP, valtable_obj._tempUnit, 0));
      $('#inv_faults_' + index + '_id').text(get_faults_string(modules_obj[index].DAC_UNIT_FAULTS));

      $('#inv_firmware_' + index + '_id').text(modules_obj[index].DAC_UNIT_FIRMWARE);
      $('#inv_elect_param_' + index + '_id').text(modules_obj[index].DAC_UNIT_ELPARAMS);
      $('#inv_time_boot_' + index + '_id').text(get_powernet_timestring(modules_obj[index].DAC_UNIT_RUNNINGTIME));
      $('#inv_total_uptime_' + index + '_id').text(get_powernet_timestring(modules_obj[index].DAC_UNIT_TOTALUPTIME));
    }

    top = $('#bg_id').css('height', (y_pos + 430) + $('#units_div_id').height());
  }

  function create_bypass_pane() {
    var fragment = document.createDocumentFragment(),
    bypass_div, div, table, tbody, thead, tr, td, j,
    top = $('#units_div_id').height() + (y_pos + 330) + 20;

    $('#bypass_div_id').remove();

    if (!valtable_obj.DAC_BYP_PRESENT) {
      return true;
    }

    //bypass_div
    css_obj = { position: 'absolute', left: x_pos + 74, top: top, width: 600, 'text-align': 'center', 'z-index': 3, border: 'solid 1px #808080' };

    bypass_div = $('<div/>', { id: 'bypass_div_id', 'class': 'img-rounded' }).css(css_obj);

    table = $('<table />', { 'class': 'table table-condensed table-hover' }).appendTo(bypass_div);
    table.css({ 'font-size': '9pt', 'font-weight': 'bold', 'font-family': 'arial', 'margin-bottom': '0px' });

    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<th />', { align: 'center' }).append('')).
    css({ color: 'white', 'background-color': '#428bca', 'text-align': 'left' }).appendTo(thead);
    $('<th />', { align: 'left' }).append(i18n('Status')).appendTo(tr);
    $('<th />', { align: 'left' }).append(i18n('Faults')).appendTo(tr);
    $('<th />', { align: 'left' }).append(i18n('Temperature')).appendTo(tr);



    tr = $('<tr />').appendTo(tbody);
    td = $('<td />', { align: 'left', 'class': 'text-info' }).css('cursor', 'pointer').append(i18n('Bypass')).appendTo(tr);

    td.click(function (event) {
      var div = $('#bypass_faults_div_id'),
      display = div.css('display');

      div.css('display', display == 'none' ? 'block' : 'none');
      event.preventDefault();
    });

    if (valtable_obj.DAC_BYP_OUTSTATE == 0) {
      $('<td />', { align: 'left' }).append(i18n("Off")).appendTo(tr);
    } else if (valtable_obj.DAC_BYP_OUTSTATE == 1) {
      $('<td />', { align: 'left' }).append(i18n("On Mains")).appendTo(tr);
    } else if (valtable_obj.DAC_BYP_OUTSTATE == 2) {
      $('<td />', { align: 'left' }).append(i18n("On Inverter")).appendTo(tr);
    } else {
      $('<td />', { align: 'left' }).append("").appendTo(tr);
    }

    td = $('<td />', { align: 'left' }).append('').appendTo(tr);
    for (j = 0; j < 8; j++) {
      if (valtable_obj.DAC_BYP_FAULTS[j]) {
        td.append('X');
        break;
      }
    }

    $('<td />', { align: 'left' }).append(panes_api.get_temperature(valtable_obj.DAC_BYP_SI1TEMP, valtable_obj._tempUnit, 0)).appendTo(tr);


    fragment.appendChild(bypass_div[0]);
    document.body.appendChild(fragment);
  }


  function get_powernet_string(id) {
    var txt = "Unknown";

    $.each(powernet_strings, (function (index, obj) {
      if (obj.id == id) {
        txt = i18n(obj.txt);
        return false;
      }
    }));

    return txt;
  }

  function get_faults_string(faults_array) {
    var txt = "",
    i, index;

    for (i = 0; i < 64; i++) {
      index = parseInt(i / 8);
      if ((faults_array[index]) & (1 << (i % 8))) {
        if (!txt.empty()) {
          txt += ' <br />' + i18n(get_powernet_string(i));
        } else {
          txt = i18n(get_powernet_string(i));
        }
      }
    }

    return txt;
  }

  function get_powernet_acfaults() {
    var txt = "",
    i;

    for (i = 0; i < 8; i++) {
      if (valtable_obj.DAC_BYP_ACFAULTS & (1 << i)) {
        if (!txt.empty()) {
          txt += ' <br />' + i18n(ac_faults[i]);
        } else {
          txt = i18n(ac_faults[i]);
        }
      }
    }

    return txt;
  }

  function get_powernet_faultbit(ind) {
    var index = parseInt(ind / 8);
    return valtable_obj.DAC_SYS_FAULTS[index] & (1 << (ind % 8));
  }


  function get_powernet_timestring(d) {
    var rt = d,
    days, hours, mins;

    days = parseInt(rt / (60 * 60 * 24));
    rt %= (60 * 60 * 24);
    hours = parseInt(rt / (60 * 60));
    rt %= (60 * 60);
    mins = parseInt(rt / 60);
    //rt %= 60;
    //secs = rt;
    return days + 'd ' + hours + 'hr ' + mins + 'min';
  }


  function create_footer_pane() {
    if (!oid || !unms_obj)
    return true;
    footer_api.create({ //Attr
        id: 'panel2'
        //'class':'unmsFooter'
      }, { //css
        position: 'absolute',
        top: '490px',
        left: '74px'
      },
      unms_obj
    );
  }

  function set_footer() {
    if (!oid || !unms_obj)
    return true;
    footer_api.set(unms_obj);
  }

  function set_variable(data) {
    valtable_obj = data.ups.valtable;
    report_obj = data.report;
    modules_obj = data.ups.modules;

    if (valtable_obj.INPHASES != null)
    inphases = valtable_obj.INPHASES;
    else
    inphases = valtable_obj.PHASES;

    if (valtable_obj.OUTPHASES != null)
    outphases = valtable_obj.OUTPHASES;
    else
    outphases = valtable_obj.PHASES;

    valtable_obj._tempUnit = valtable_obj._tempUnit || 0; //0 = Celsius
  }

}(jQuery));