<?xml version="1.0"?>
<!--
   prto_f_o_panel.xsl - UPS screen for AEG.
   Copyright (c) 2010, Generex GmbH. All rights reserved.
   Said Raqui
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="html" indent="yes" omit-xml-declaration="yes" encoding="iso-8859-1"/>
  <!-- Methods -->
  <!--Header-->
  <xsl:template name="prto_f_o_panel-header">
    <xsl:call-template name="app-header">
      <xsl:with-param name="top" select="13"/>
      <xsl:with-param name="left" select="46"/>
    </xsl:call-template>
  </xsl:template>

  <!--Footer-->
  <xsl:template name="prto_f_o_panel-footer" >
    <xsl:call-template name="app-footer" >
      <xsl:with-param name="top" select="540"/>
      <xsl:with-param name="left" select="22"/>
      <xsl:with-param name="width" select="750"/>
      <xsl:with-param name="height" select="70"/>
    </xsl:call-template>
  </xsl:template>
  <!--Menu-->
  <xsl:template name="prto_f_o_panel-menu">
    <xsl:call-template name="app-menu">
      <xsl:with-param name="top" select="428"/>
      <xsl:with-param name="left" select="0"/>
      <xsl:with-param name="width" select="0"/>
      <xsl:with-param name="height" select="0"/>
      <xsl:with-param name="class" select="'XBold_black'"/>
    </xsl:call-template>
  </xsl:template>


  <!--Body-->
  <xsl:template name="prto_f_o_panel-body">
    <div id ="master" style="position:absolute;top:10px;left:10px;">
      <xsl:call-template name="background">
        <xsl:with-param name="imagepath" select="'./lib/ups/image/aeg/backab1.png'"/>
        <xsl:with-param name="x" select="'0'"/>
        <xsl:with-param name="y" select="'0'"/>
        <xsl:with-param name="w" select="'785'"/>
        <xsl:with-param name="h" select="'546'"/>
        <xsl:with-param name="border" select="0"/>
        <xsl:with-param name="id" select="'background'"/>
      </xsl:call-template>
      <xsl:apply-templates />
      <xsl:call-template name="IEpixelBugfixCall"/>
      <script type="text/javascript">
        init();
      </script>
      <xsl:call-template name="js_refresh_call">
        <xsl:with-param	 name="timeout" select="1000*//report/@refresh"/>
      </xsl:call-template>
    </div>
  </xsl:template>

  <xsl:template match="values">
    <!-- Implementation -->
    <div style="color:black; font-weight:bold; font-size:9pt">
      <!-- Model -->
      <xsl:variable name="model" select="value[@name='MODEL']/@val"/>
      <xsl:if test="string-length($model) !=0">
        <xsl:call-template name="paneText">
          <xsl:with-param name="x" select="16" />
          <xsl:with-param name="y" select="10" />
          <xsl:with-param name="w" select="200" />
          <xsl:with-param name="h" select="17" />
          <xsl:with-param name="align" select="'left'" />
          <xsl:with-param name="color" select="'white'" />
          <xsl:with-param name="value" select="concat('Model&#160;:&#160;',$model)" />
          <xsl:with-param name="name" select="'model_id'" />
        </xsl:call-template>
        <script type="text/javascript"> translate_text('model_id', ['Model', '<xsl:value-of select="concat('&#160;:&#160;',$model)" />']);</script>
      </xsl:if>
    </div>

    <!--Segments state -->
    <xsl:call-template name="segments-state">
      <xsl:with-param name="outlet_onmaske" select ="value[@name='OUTLET_ONOFFMASK']/@val"/>
      <xsl:with-param name="outlet_existmaske" select ="value[@name='OUTLET_EXISTMASK']/@val"/>
    </xsl:call-template>

    <!-- USV Chart Text -->
    <div style="color:black; font-weight:bold; font-size:9pt">
      <xsl:call-template name="paneText">
        <xsl:with-param name="x" select="480" />
        <xsl:with-param name="y" select="148" />
        <xsl:with-param name="w" select="200" />
        <xsl:with-param name="h" select="17" />
        <xsl:with-param name="align" select="'left'" />
        <xsl:with-param name="color" select="'white'" />
        <xsl:with-param name="value" select="$lang-UPS-Chart" />
        <xsl:with-param name="name" select="'ups_chart_id'" />
      </xsl:call-template>
      <script type="text/javascript"> translate_text('ups_chart_id', '<xsl:value-of select="$lang-UPS-Chart" />');</script>
    </div>
    <!-- UPS Events Text -->
    <div style="color:black; font-weight:bold; font-size:9pt">
      <xsl:call-template name="paneText">
        <xsl:with-param name="x" select="460" />
        <xsl:with-param name="y" select="12" />
        <xsl:with-param name="w" select="200" />
        <xsl:with-param name="h" select="17" />
        <xsl:with-param name="align" select="'left'" />
        <xsl:with-param name="color" select="'white'" />
        <xsl:with-param name="value" select="$lang-UPS-Events" />
        <xsl:with-param name="name" select="'ups_evt_id'" />
      </xsl:call-template>
      <script type="text/javascript"> translate_text('ups_evt_id', '<xsl:value-of select="$lang-UPS-Events" />');</script>
    </div>

    <!-- USV Status -->
    <xsl:call-template name="usv-status-pane">
      <xsl:with-param name="date_time" select="//report/@time" />
      <xsl:with-param name="state" select="value[@name='STATUS']/@val" />
      <xsl:with-param name="ups_off" select="value[@name='UPS_OFF']/@val" />
      <xsl:with-param name="in_volt" select="value[@name='INVOLT']/@val" />
      <xsl:with-param name="in_freq" select="value[@name='INFREQ']/@val" />
      <xsl:with-param name="batt_autonomy_time" select="value[@name='AUTONOMTIME']/@val" />
      <xsl:with-param name="batt_status" select="value[@name='BATTERY_STATE']/@val" />
      <xsl:with-param name="batt_capacity" select="value[@name='BATTCAP']/@val" />
      <xsl:with-param name="batt_volt" select="value[@name='BATTVOLT']/@val" />
      <xsl:with-param name="batt_temp" select="value[@name='TEMPDEG']/@val" />
      <xsl:with-param name="out_volt" select="value[@name='OUTPUT_VOLT']/@val" />
      <xsl:with-param name="out_power" select="value[@name='OUTPOWER']/@val" />
      <xsl:with-param name="out_freq" select="value[@name='OUTFREQ']/@val" />
    </xsl:call-template>

    <!--  oem View Name-->
    <xsl:variable name="oem_view_name" select="value[@name='_oemViewName']/@val"/>
    <!-- Battery Voltage Load bar variables-->
    <xsl:variable name="batt_volt_startval">
      <xsl:choose>
        <xsl:when test="string($oem_view_name)='PRTOF24' or string($oem_view_name)='prtof24'">
          <xsl:value-of select="'10'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='PRTOF12' or string($oem_view_name)='prtof12' or string($oem_view_name)='PROTBLCD' or string($oem_view_name)='protblcd' or string($oem_view_name)='PROTALCD' or string($oem_view_name)='protalcd'">
          <xsl:value-of select="'6'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='PRTOF48' or string($oem_view_name)='prtof48'">
          <xsl:value-of select="'30'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='PRTOF96' or string($oem_view_name)='prtof96' or string($oem_view_name)='ATSER96' or string($oem_view_name)='atser96'">
          <xsl:value-of select="'60'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='PRTON36' or string($oem_view_name)='prton36' or string($oem_view_name)='ATSER36' or string($oem_view_name)='atser36'">
          <xsl:value-of select="'20'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='PRTON72' or string($oem_view_name)='prton72'">
          <xsl:value-of select="'60'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='ATSER240' or string($oem_view_name)='atser240'">
          <xsl:value-of select="'150'"/>
        </xsl:when>
        <xsl:otherwise></xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="batt_volt_endval">
      <xsl:choose>
        <xsl:when test="string($oem_view_name)='PRTOF24' or string($oem_view_name)='prtof24'">
          <xsl:value-of select="'40'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='PRTOF12' or string($oem_view_name)='prtof12' or string($oem_view_name)='PROTBLCD' or string($oem_view_name)='protblcd' or string($oem_view_name)='PROTALCD' or string($oem_view_name)='protalcd'">
          <xsl:value-of select="'18'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='PRTOF48' or string($oem_view_name)='prtof48'">
          <xsl:value-of select="'60'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='PRTOF96' or string($oem_view_name)='prtof96' or string($oem_view_name)='ATSER96' or string($oem_view_name)='atser96'">
          <xsl:value-of select="'120'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='PRTON36' or string($oem_view_name)='prton36' or string($oem_view_name)='ATSER36' or string($oem_view_name)='atser36'">
          <xsl:value-of select="'50'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='PRTON72' or string($oem_view_name)='prton72'">
          <xsl:value-of select="'90'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='ATSER240' or string($oem_view_name)='atser240'">
          <xsl:value-of select="'300'"/>
        </xsl:when>
        <xsl:otherwise></xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="batt_volt_step">
      <xsl:choose>
        <xsl:when test="string($oem_view_name)='PRTOF24' or string($oem_view_name)='prtof24'">
          <xsl:value-of select="'5'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='PRTOF12' or string($oem_view_name)='prtof12' or string($oem_view_name)='PROTBLCD' or string($oem_view_name)='protblcd' or string($oem_view_name)='PROTALCD' or string($oem_view_name)='protalcd'">
          <xsl:value-of select="'2'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='PRTOF48' or string($oem_view_name)='prtof48'">
          <xsl:value-of select="'5'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='PRTOF96' or string($oem_view_name)='prtof96' or string($oem_view_name)='ATSER96' or string($oem_view_name)='atser96'">
          <xsl:value-of select="'10'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='PRTON36' or string($oem_view_name)='prton36' or string($oem_view_name)='ATSER36' or string($oem_view_name)='atser36'">
          <xsl:value-of select="'5'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='PRTON72' or string($oem_view_name)='prton72'">
          <xsl:value-of select="'5'"/>
        </xsl:when>
        <xsl:when test="string($oem_view_name)='ATSER240' or string($oem_view_name)='atser240'">
          <xsl:value-of select="'25'"/>
        </xsl:when>
        <xsl:otherwise></xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <!-- Load bars page0-->
    <!-- Input Voltage -->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="value[@name='INVOLT']/@val"/>
      <xsl:with-param name="headline" select="$lang-Input-Voltage"/>
      <xsl:with-param name="font-size" select="11"/>
      <xsl:with-param name="unit" select="'V'"/>
      <xsl:with-param name="x" select="330"/>
      <xsl:with-param name="y" select="180"/>
      <xsl:with-param name="h" select="80"/>
      <xsl:with-param name="barx" select="'48'"/>
      <xsl:with-param name="bary" select="90"/>
      <xsl:with-param name="barw" select="50"/>
      <xsl:with-param name="suby" select="240"/>
      <xsl:with-param name="startval" select="90"/>
      <xsl:with-param name="endval" select="270"/>
      <xsl:with-param name="decimal-places" select="0"/>
      <xsl:with-param name="step" select="45"/>
      <xsl:with-param name="skip" select="45"/>
      <xsl:with-param name="id" select="'page0'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-hi" select="''"/>
      <xsl:with-param name="thresh-yellow-hi" select="''"/>
      <xsl:with-param name="start-visibility" select="'visible'"/>
      <xsl:with-param name="bright" select="0"/>
      <xsl:with-param name="sel_page" select="1"/>
      <xsl:with-param name="scaler_id" select="'in_volt_scaler_id'"/>
    </xsl:call-template>
    <!-- Load -->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="value[@name='OUTPOWER']/@val"/>
      <xsl:with-param name="headline" select="$lang-Load"/>
      <xsl:with-param name="font-size" select="11"/>
      <xsl:with-param name="unit" select="'%'"/>
      <xsl:with-param name="x" select="460"/>
      <xsl:with-param name="y" select="180"/>
      <xsl:with-param name="h" select="80"/>
      <xsl:with-param name="barx" select="'49'"/>
      <xsl:with-param name="bary" select="70"/>
      <xsl:with-param name="barw" select="50"/>
      <xsl:with-param name="suby" select="240"/>
      <xsl:with-param name="startval" select="0"/>
      <xsl:with-param name="endval" select="100"/>
      <xsl:with-param name="decimal-places" select="0"/>
      <xsl:with-param name="step" select="25"/>
      <xsl:with-param name="skip" select="25"/>
      <xsl:with-param name="id" select="'page0'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-hi" select="100"/>
      <xsl:with-param name="thresh-yellow-hi" select="80"/>
      <xsl:with-param name="start-visibility" select="'visible'"/>
      <xsl:with-param name="bright" select="0"/>
      <xsl:with-param name="sel_page" select="1"/>
      <xsl:with-param name="scaler_id" select="'outpower_scaler_id'"/>
    </xsl:call-template>
    <!-- Autonomy Time -->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="value[@name='AUTONOMTIME']/@val"/>
      <xsl:with-param name="headline" select="$lang-Autonomy-Time"/>
      <xsl:with-param name="font-size" select="11"/>
      <xsl:with-param name="unit" select="'Min'"/>
      <xsl:with-param name="x" select="590"/>
      <xsl:with-param name="y" select="180"/>
      <xsl:with-param name="h" select="80"/>
      <xsl:with-param name="barx" select="'49'"/>
      <xsl:with-param name="bary" select="70"/>
      <xsl:with-param name="barw" select="50"/>
      <xsl:with-param name="suby" select="240"/>
      <xsl:with-param name="startval" select="0"/>
      <xsl:with-param name="endval" select="100"/>
      <xsl:with-param name="decimal-places" select="0"/>
      <xsl:with-param name="step" select="20"/>
      <xsl:with-param name="skip" select="20"/>
      <xsl:with-param name="id" select="'page0'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-lo" select="4"/>
      <xsl:with-param name="thresh-yellow-hi" select="''"/>
      <xsl:with-param name="start-visibility" select="'visible'"/>
      <xsl:with-param name="bright" select="0"/>
      <xsl:with-param name="sel_page" select="1"/>
      <xsl:with-param name="scaler_id" select="'batt_autotime_scaler_id1'"/>
    </xsl:call-template>
    <!-- Load bars page1-->
    <!-- Input Frequency -->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="value[@name='INFREQ']/@val"/>
      <xsl:with-param name="headline" select="$lang-Input-Frequency"/>
      <xsl:with-param name="font-size" select="11"/>
      <xsl:with-param name="unit" select="'Hz'"/>
      <xsl:with-param name="x" select="330"/>
      <xsl:with-param name="y" select="180"/>
      <xsl:with-param name="h" select="80"/>
      <xsl:with-param name="barx" select="'49'"/>
      <xsl:with-param name="bary" select="70"/>
      <xsl:with-param name="barw" select="50"/>
      <xsl:with-param name="suby" select="240"/>
      <xsl:with-param name="startval" select="40"/>
      <xsl:with-param name="endval" select="70"/>
      <xsl:with-param name="decimal-places" select="1"/>
      <xsl:with-param name="step" select="5"/>
      <xsl:with-param name="skip" select="5"/>
      <xsl:with-param name="id" select="'page1'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-hi" select="''"/>
      <xsl:with-param name="thresh-yellow-hi" select="''"/>
      <xsl:with-param name="start-visibility" select="'visible'"/>
      <xsl:with-param name="bright" select="0"/>
      <xsl:with-param name="sel_page" select="1"/>
      <xsl:with-param name="scaler_id" select="'in_freq_scaler_id'"/>
    </xsl:call-template>
    <!-- Battery Voltage -->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="value[@name='BATTVOLT']/@val"/>
      <!---->
      <xsl:with-param name="headline" select="$lang-Battery-Voltage"/>
      <xsl:with-param name="font-size" select="11"/>
      <xsl:with-param name="unit" select="'V'"/>
      <xsl:with-param name="x" select="460"/>
      <xsl:with-param name="y" select="180"/>
      <xsl:with-param name="h" select="80"/>
      <xsl:with-param name="barx" select="'49'"/>
      <xsl:with-param name="bary" select="'70'"/>
      <xsl:with-param name="barw" select="'50'"/>
      <xsl:with-param name="suby" select="240"/>
      <xsl:with-param name="startval" select="$batt_volt_startval"/>
      <xsl:with-param name="endval" select="$batt_volt_endval"/>
      <xsl:with-param name="decimal-places" select="1"/>
      <xsl:with-param name="step" select="$batt_volt_step"/>
      <xsl:with-param name="skip" select="0"/>
      <xsl:with-param name="id" select="'page1'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-hi" select="''"/>
      <xsl:with-param name="thresh-yellow-hi" select="''"/>
      <xsl:with-param name="start-visibility" select="'visible'"/>
      <xsl:with-param name="bright" select="0"/>
      <xsl:with-param name="sel_page" select="1"/>
      <xsl:with-param name="scaler_id" select="'batt_volt_scaler_id'"/>
    </xsl:call-template>
    <!-- Autonomy Time -->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="value[@name='AUTONOMTIME']/@val"/>
      <xsl:with-param name="headline" select="$lang-Autonomy-Time"/>
      <xsl:with-param name="font-size" select="11"/>
      <xsl:with-param name="unit" select="'Min'"/>
      <xsl:with-param name="x" select="590"/>
      <xsl:with-param name="y" select="180"/>
      <xsl:with-param name="h" select="80"/>
      <xsl:with-param name="barx" select="'49'"/>
      <xsl:with-param name="bary" select="70"/>
      <xsl:with-param name="barw" select="50"/>
      <xsl:with-param name="suby" select="240"/>
      <xsl:with-param name="startval" select="0"/>
      <xsl:with-param name="endval" select="100"/>
      <xsl:with-param name="decimal-places" select="0"/>
      <xsl:with-param name="step" select="20"/>
      <xsl:with-param name="skip" select="20"/>
      <xsl:with-param name="id" select="'page1'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-lo" select="4"/>
      <xsl:with-param name="thresh-yellow-hi" select="''"/>
      <xsl:with-param name="start-visibility" select="'visible'"/>
      <xsl:with-param name="bright" select="0"/>
      <xsl:with-param name="sel_page" select="1"/>
      <xsl:with-param name="scaler_id" select="'batt_autotime_scaler_id2'"/>
    </xsl:call-template>

    <!-- Load bars page2-->
    <!-- Battery Capacity -->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="value[@name='BATTCAP']/@val"/>
      <xsl:with-param name="headline" select="$lang-Battery-Capacity"/>
      <xsl:with-param name="font-size" select="11"/>
      <xsl:with-param name="unit" select="'%'"/>
      <xsl:with-param name="x" select="330"/>
      <xsl:with-param name="y" select="180"/>
      <xsl:with-param name="h" select="80"/>
      <xsl:with-param name="barx" select="'49'"/>
      <xsl:with-param name="bary" select="70"/>
      <xsl:with-param name="barw" select="49"/>
      <xsl:with-param name="suby" select="240"/>
      <xsl:with-param name="startval" select="0"/>
      <xsl:with-param name="endval" select="100"/>
      <xsl:with-param name="decimal-places" select="0"/>
      <xsl:with-param name="step" select="20"/>
      <xsl:with-param name="skip" select="20"/>
      <xsl:with-param name="id" select="'page2'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-lo" select="50"/>
      <xsl:with-param name="thresh-yellow-lo" select="80"/>
      <xsl:with-param name="start-visibility" select="'visible'"/>
      <xsl:with-param name="bright" select="0"/>
      <xsl:with-param name="sel_page" select="1"/>
      <xsl:with-param name="scaler_id" select="'batt_capp_scaler_id'"/>
    </xsl:call-template>
    <!-- Temperature -->
    <xsl:if test="value[@name='_tempUnit']/@val=1">
      <xsl:call-template name="valuebar">
        <xsl:with-param name="value" select="(value[@name='TEMPDEG']/@val*1.8) + 32.0"/>
        <xsl:with-param name="headline" select="$lang-Temperature"/>
        <xsl:with-param name="font-size" select="11"/>
        <xsl:with-param name="unit" select="'&#176;F'"/>
        <xsl:with-param name="x" select="460"/>
        <xsl:with-param name="y" select="180"/>
        <xsl:with-param name="h" select="80"/>
        <xsl:with-param name="barx" select="'49'"/>
        <xsl:with-param name="bary" select="70"/>
        <xsl:with-param name="barw" select="50"/>
        <xsl:with-param name="suby" select="240"/>
        <xsl:with-param name="startval" select="32"/>
        <xsl:with-param name="endval" select="(60*1.8) + 32.0"/>
        <xsl:with-param name="decimal-places" select="1"/>
        <xsl:with-param name="step" select="(10*1.8) + 32.0"/>
        <xsl:with-param name="skip" select="(10*1.8) + 32.0"/>
        <xsl:with-param name="id" select="'page2'"/>
        <xsl:with-param name="shadowoffset" select="5"/>
        <xsl:with-param name="thresh-red-hi" select="''"/>
        <xsl:with-param name="thresh-yellow-hi" select="''"/>
        <xsl:with-param name="start-visibility" select="'visible'"/>
        <xsl:with-param name="bright" select="0"/>
        <xsl:with-param name="sel_page" select="1"/>
        <xsl:with-param name="scaler_id" select="'batt_tmp_scaler_id'"/>
      </xsl:call-template>
    </xsl:if>
    <xsl:if test="value[@name='_tempUnit']/@val=0 or string-length(value[@name='_tempUnit']/@val)=0">
      <xsl:call-template name="valuebar">
        <xsl:with-param name="value" select="value[@name='TEMPDEG']/@val"/>
        <xsl:with-param name="headline" select="$lang-Temperature"/>
        <xsl:with-param name="font-size" select="11"/>
        <xsl:with-param name="unit" select="'&#176;C'"/>
        <xsl:with-param name="x" select="460"/>
        <xsl:with-param name="y" select="180"/>
        <xsl:with-param name="h" select="80"/>
        <xsl:with-param name="barx" select="'49'"/>
        <xsl:with-param name="bary" select="70"/>
        <xsl:with-param name="barw" select="50"/>
        <xsl:with-param name="suby" select="240"/>
        <xsl:with-param name="startval" select="0"/>
        <xsl:with-param name="endval" select="60"/>
        <xsl:with-param name="decimal-places" select="1"/>
        <xsl:with-param name="step" select="10"/>
        <xsl:with-param name="skip" select="10"/>
        <xsl:with-param name="id" select="'page2'"/>
        <xsl:with-param name="shadowoffset" select="5"/>
        <xsl:with-param name="thresh-red-hi" select="''"/>
        <xsl:with-param name="thresh-yellow-hi" select="''"/>
        <xsl:with-param name="start-visibility" select="'visible'"/>
        <xsl:with-param name="bright" select="0"/>
        <xsl:with-param name="sel_page" select="1"/>
        <xsl:with-param name="scaler_id" select="'batt_tmp_scaler_id'"/>
      </xsl:call-template>
    </xsl:if>

    <!-- Autonomy Time -->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="value[@name='AUTONOMTIME']/@val"/>
      <xsl:with-param name="headline" select="$lang-Autonomy-Time"/>
      <xsl:with-param name="font-size" select="11"/>
      <xsl:with-param name="unit" select="'Min'"/>
      <xsl:with-param name="x" select="590"/>
      <xsl:with-param name="y" select="180"/>
      <xsl:with-param name="h" select="80"/>
      <xsl:with-param name="barx" select="'49'"/>
      <xsl:with-param name="bary" select="70"/>
      <xsl:with-param name="barw" select="50"/>
      <xsl:with-param name="suby" select="240"/>
      <xsl:with-param name="startval" select="0"/>
      <xsl:with-param name="endval" select="100"/>
      <xsl:with-param name="decimal-places" select="0"/>
      <xsl:with-param name="step" select="20"/>
      <xsl:with-param name="skip" select="0"/>
      <xsl:with-param name="id" select="'page2'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-lo" select="4"/>
      <xsl:with-param name="thresh-yellow-hi" select="''"/>
      <xsl:with-param name="start-visibility" select="'visible'"/>
      <xsl:with-param name="bright" select="0"/>
      <xsl:with-param name="sel_page" select="1"/>
      <xsl:with-param name="scaler_id" select="'batt_autotime_scaler_id3'"/>
    </xsl:call-template>

    <!-- Log events pane -->
    <xsl:call-template name="events-pane">
    </xsl:call-template>
    <!--select pages -->
    <xsl:call-template name="select-page">
    </xsl:call-template>

  </xsl:template>

  <!-- EOS -->
</xsl:stylesheet>