/*
   rcn_panel.js - Astrid (rcn) screen.
   Copyright (c) 2016, Generex GmbH. All rights reserved.
   Said.
*/
var rcn_api = (function ($) {
  var oid = get_oid_from_url(),
    plattform = get_plattform(),
    cb = null,
    pannes_created = false,
    err_div = null,
    check_bowser = true,
    css_obj,
    valtable_obj, report_obj, unms_obj,
    inphases = null,
    outphases = null,
    x_pos = 5,
    y_pos = 5;

  var alarm_leds_txt_objs = [
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' }
    ],

    ctl_url = get_url("api/devices/ups/control"),
    usr_cnf_cmd_option = {
      data: {},
      data_type: 'text',
      success: usr_cnf_cmd_update,
      error: err_funct
    },
    usr_cnf_cmd_settings = { methode: "POST", xhttp_methode_override: 'PUT', req_payload_json: true };

  var req_params = null;

  /*public functions*/
  return {
    init: init
  };

  function init() {
    if (check_bowser && !utils_api.check_bowser()) {
      $('#loading_id').css('display', 'none');
      panes_api.create_br_check_panel(this, browser_check_ok);
      return true;
    }
    create_err_msg_panel();

    req_params = utils_api.get_req_params(utils_api.device_ups, oid);
    cb = jqmodule.subscribe(this, { update: update, error: err_funct }, req_params);
  }

  function browser_check_ok() {
    check_bowser = false;
    init();
  }

  function create_err_msg_panel() {
    css_obj = { position: 'absolute', top: y_pos, left: x_pos, width: 791, display: 'none', 'z-index': 22 };
    err_div = panes_api.create_err_panel({ id: 'error_div', 'class': 'alert alert-danger' }, css_obj);
  }

  function err_funct(response) {
    jqmodule.refresh(cb, 10 * 1000);
    panes_api.display_err({ response: response, oid: oid, err_div: err_div, err_msg_div_id: 'error_msg_div' });
  }

  function update(data) {
    if (data.ups == null) {
      return;
    }

    set_variable(data);
    jqmodule.refresh(cb, report_obj.refresh * 1000);
    if (err_div)
      err_div.css('display', 'none');

    if (window.menu_api != null)
      menu_api.update(data);

    unms_obj = get_unms_obj(data);
    if (unms_obj != null) {
      info_head_api.update(unms_obj);
    }

    if (!pannes_created) {
      pannes_created = true;
      create_panes();
      return false;
    }
    //set_configuration_color_txt();//set  Configuration color and text
    set_mimic_led_panel(); // set Mimic Led
    set_alarms_led_txt(); // set alarm led and text
    set_alarms_status_digit_inp(); // set alarms and status and  Digital Inputs
    set_measures();
    set_footer(); // set input output and rectifier measures
  }

  function create_footer_pane() {
    if (!oid || !unms_obj)
      return true;
    footer_api.create({ //Attr
        id: 'panel2'
        //'class':'unmsFooter'
      }, { //css
        position: 'absolute',
        top: '490px',
        left: '74px'
      },
      unms_obj
    );
  }

  function set_footer() {
    if (!oid || !unms_obj)
      return true;
    footer_api.set(unms_obj);
  }

  function set_variable(data) {
    valtable_obj = data.ups.valtable;
    report_obj = data.report;

    if (valtable_obj.INPHASES != null)
      inphases = valtable_obj.INPHASES;
    else
      inphases = valtable_obj.PHASES;

    if (valtable_obj.OUTPHASES != null)
      outphases = valtable_obj.OUTPHASES;
    else
      outphases = valtable_obj.PHASES;

    $.each(alarm_leds_txt_objs, function (index, alarm_led_txt_obj) {
      alarm_led_txt_obj.color = valtable_obj.RCN_PANELLED[index];

    });

    alarm_leds_txt_objs[0].txt = valtable_obj.RCN_PANEL0TXT;
    alarm_leds_txt_objs[1].txt = valtable_obj.RCN_PANEL1TXT;
    alarm_leds_txt_objs[2].txt = valtable_obj.RCN_PANEL2TXT;
    alarm_leds_txt_objs[3].txt = valtable_obj.RCN_PANEL3TXT;
    alarm_leds_txt_objs[4].txt = valtable_obj.RCN_PANEL4TXT;
    alarm_leds_txt_objs[5].txt = valtable_obj.RCN_PANEL5TXT;
    alarm_leds_txt_objs[6].txt = valtable_obj.RCN_PANEL6TXT;
    alarm_leds_txt_objs[7].txt = valtable_obj.RCN_PANEL7TXT;
    alarm_leds_txt_objs[8].txt = valtable_obj.RCN_PANEL8TXT;
    alarm_leds_txt_objs[9].txt = valtable_obj.RCN_PANEL9TXT;
  }

  function create_panes() {
    utils_api.setTitle(valtable_obj._platform);
    create_footer_pane();
    create_bg();
    create_alarms_led_txt_panel(); // Create alarm leds and text
    create_configuration_panel(); //Panel Configuration
    create_mimic_led_panel(); // Create Mimic Led
    create_alarms_status_digit_inp_panel(); //alarms and status and  Digital Inputs
    create_inp_outp_rec_info_measures(); // create input output and rectifier measures
  }

  function create_bg() {
    var fragment = document.createDocumentFragment(),
      img_div;
    css_obj = { position: 'absolute', top: y_pos, left: x_pos, width: 800, height: 564 };
    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'bg_img_id', 'class': 'img-rounded', width: 800, 'height': 563, src: './image/astrid/rcn_bg.png' }).appendTo(img_div);
    fragment.appendChild(img_div[0]);
    document.body.appendChild(fragment);
  }

  function create_mimic_led_panel() // Create Mimic Led
  {
    var fragment = document.createDocumentFragment(),
      img_div;

    css_obj = { position: 'absolute', top: y_pos + 129, left: x_pos + 205, width: 15, height: 15 };

    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'mimic_led1', 'class': 'img-rounded', width: 15, 'height': 15, src: get_mimic_img(0) }).appendTo(img_div);
    fragment.appendChild(img_div[0]);

    css_obj.left = x_pos + 305;
    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'mimic_led2', 'class': 'img-rounded', width: 15, 'height': 15, src: get_mimic_img(1) }).appendTo(img_div);
    fragment.appendChild(img_div[0]);

    css_obj.left = x_pos + 410;
    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'mimic_led3', 'class': 'img-rounded', width: 15, 'height': 15, src: get_mimic_img(2) }).appendTo(img_div);
    fragment.appendChild(img_div[0]);

    css_obj.top = x_pos + 193;
    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'mimic_led4', 'class': 'img-rounded', width: 15, 'height': 15, src: get_mimic_img(3) }).appendTo(img_div);
    fragment.appendChild(img_div[0]);

    css_obj.top = y_pos + 129;
    css_obj.left = x_pos + 587;
    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'mimic_led5', 'class': 'img-rounded', width: 15, 'height': 15, src: get_mimic_img(4) }).appendTo(img_div);
    fragment.appendChild(img_div[0]);

    document.body.appendChild(fragment);
  }

  function set_mimic_led_panel() // set Mimic Led
  {
    $('#mimic_led1').attr('src', get_mimic_img(0));
    $('#mimic_led2').attr('src', get_mimic_img(1));
    $('#mimic_led3').attr('src', get_mimic_img(2));
    $('#mimic_led4').attr('src', get_mimic_img(3));
    $('#mimic_led5').attr('src', get_mimic_img(4));
  }

  function create_alarms_led_txt_panel() // Create alarm leds and text
  {
    var fragment = document.createDocumentFragment(),
      div,
      css_obj_led = { position: 'absolute', top: y_pos + 285, left: x_pos + 30, width: 15, height: 15 },
      css_obj_txt = { position: 'absolute', top: y_pos + 285, left: x_pos + 50, width: 310, height: 15, 'text-align': 'left' };

    $.each(alarm_leds_txt_objs, function (index, alarm_led_txt_obj) {
      div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj_led); //.css('border', 'solid 2px #315284')
      $('<img />').attr({ 'id': 'alarm_led_' + index, 'class': 'img-rounded', width: 15, height: 15, src: get_alarm_img(index) }).appendTo(div);
      fragment.appendChild(div[0]);

      div = $('<div/>', { 'id': 'alarm_txt_' + index }).css(css_obj_txt).append(get_alarm_txt(index));
      fragment.appendChild(div[0]);

      css_obj_led.top += 45;
      css_obj_txt.top += 45;
      if (index == 4) {
        css_obj_led.top = y_pos + 285;
        css_obj_led.left = x_pos + 395;

        css_obj_txt.top = y_pos + 285;
        css_obj_txt.left = x_pos + 415;
      }
    });

    css_obj = { position: 'absolute', top: y_pos + 505, left: x_pos + 280, width: 190, height: 20 };
    div = $('<div/>').css(css_obj);
    button = $('<button>', { id: "butt_conf_id", 'class': "btn btn-default btn-sm" }).append('Panel Configuration').appendTo(div);
    button.click(function (event) {
      set_configuration_color_txt(); //set  Configuration color and text
      $('#configuration_panel_div_id').css('display', 'block');
      event.preventDefault();
    });
    fragment.appendChild(div[0]);

    document.body.appendChild(fragment);
  }

  function set_alarm_leds_txt_objs() //TODO from configuration panel
  {
    $.each(alarm_leds_txt_objs, function (index, alarm_led_txt_obj) {
      alarm_led_txt_obj.color = parseInt($('#conf_color_' + index).val());
      alarm_led_txt_obj.txt = $('#conf_txt_' + index).val();

    });
  }

  function set_alarms_led_txt() // set alarm led and text
  {
    $.each(alarm_leds_txt_objs, function (index, alarm_led_txt_obj) {
      $('#alarm_led_' + index).attr('src', get_alarm_img(index));
      $('#alarm_txt_' + index).html(get_alarm_txt(index));
    });
  }

  function create_configuration_panel() //create Panel Configuration
  {
    var fragment = document.createDocumentFragment(),
      tr, input, select, button, table, tbody, thead, panel_configuration_div, led_color;

    css_obj = {
      position: 'absolute',
      top: y_pos + 252,
      left: x_pos + 338,
      width: 422,
      height: 420,
      'display': 'none',
      border: 'solid 1px #808080',
      'z-index': '44',
      'background-color': '#E8E8F0',
      'margin-bottom': '40px'
    };

    panel_configuration_div = $('<div/>', { id: 'configuration_panel_div_id', 'class': 'img-rounded' }).css(css_obj);

    table = $('<table />', { id: 'configuration_panel_table', 'class': 'table table-condensed' }).appendTo(panel_configuration_div);
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<td />', { colspan: 3, align: 'center', 'text-align': 'center' }).css({ color: 'white', 'background-color': '#315284' }).append(i18n("Panel Configuration"))).appendTo(thead);

    $.each(alarm_leds_txt_objs, function (index, alarm_led_txt_obj) {
      tr = $('<tr />').appendTo(tbody);
      $('<td />', { align: 'left' }).css('vertical-align', 'middle').append(index).appendTo(tr);

      select = $('<select />', { id: 'conf_color_' + index });
      select.append('<option value="-1">' + i18n('White') + '</option>');
      select.append('<option value="0">' + i18n('Green') + '</option>');
      select.append('<option value="1">' + i18n('Red') + '</option>');
      select.append('<option value="2">' + i18n('Orange') + '</option>');
      led_color = get_selected_color(index);
      select.val(led_color);

      if (led_color == "-1") //led OFF
      {
        select.prop('disabled', true);
      }

      $('<td />', { align: 'left', width: 40 }).append(select).appendTo(tr);

      input = $('<input />', { id: 'conf_txt_' + index, type: 'text', 'text-align': 'left', size: 40, maxlength: '47' }).attr('value', (alarm_led_txt_obj.txt));
      $('<td />', { align: 'left', width: 310 }).append(input).appendTo(tr);
    });

    button = $('<button>', { id: "save_conf_id", 'class': "btn btn-default btn-sm" }).append(i18n('Ok')).appendTo(panel_configuration_div);
    button.css({ width: 80 });
    button.click(function (event) {
      $('#configuration_panel_div_id').css('display', 'none');
      set_alarm_leds_txt_objs();
      send_usr_cnf_cmd();
      event.preventDefault();
    });

    button = $('<button>', { id: "cancel_conf_id", 'class': "btn btn-default btn-sm" }).append(i18n('Cancel')).appendTo(panel_configuration_div);
    button.css({ width: 80 });
    button.click(function (event) {
      $('#configuration_panel_div_id').css('display', 'none');
      event.preventDefault();
    });

    fragment.appendChild(panel_configuration_div[0]);
    document.body.appendChild(fragment);

    new utils_api.draggable('configuration_panel_div_id');
  }

  function set_configuration_color_txt() //set Configuration color and text
  {
    var led_color;
    $.each(alarm_leds_txt_objs, function (index, alarm_led_txt_obj) {
      led_color = get_selected_color(index);
      if (led_color == "-1") //led OFF
      {
        $('#conf_color_' + index).prop('disabled', true);
      } else {
        $('#conf_color_' + index).prop('disabled', false);
      }
      $('#conf_color_' + index).val(led_color);
      $('#conf_txt_' + index).attr('value', (alarm_led_txt_obj.txt));
    });
  }

  function send_usr_cnf_cmd() {
    if (plattform == utils_api.plattform_cs121) {
      return send_cs121_usr_cnf_cmd();
    }

    usr_cnf_cmd_option.data = {
      code: 'writeUsrCnf',
      params: {
        cmdId: 2003,
        cmdParams: "",
        variables: [
          { varId: 31520, value: alarm_leds_txt_objs[0].txt }, //V_RCN_PANEL0TXT
          { varId: 31521, value: alarm_leds_txt_objs[1].txt }, //V_RCN_PANEL1TXT
          { varId: 31522, value: alarm_leds_txt_objs[2].txt }, //V_RCN_PANEL2TXT
          { varId: 31523, value: alarm_leds_txt_objs[3].txt }, //V_RCN_PANEL3TXT
          { varId: 31524, value: alarm_leds_txt_objs[4].txt }, //V_RCN_PANEL4TXT
          { varId: 31525, value: alarm_leds_txt_objs[5].txt }, //V_RCN_PANEL5TXT
          { varId: 31526, value: alarm_leds_txt_objs[6].txt }, //V_RCN_PANEL6TXT
          { varId: 31527, value: alarm_leds_txt_objs[7].txt }, //V_RCN_PANEL7TXT
          { varId: 31528, value: alarm_leds_txt_objs[8].txt }, //V_RCN_PANEL8TXT
          { varId: 31529, value: alarm_leds_txt_objs[9].txt }, //V_RCN_PANEL9TXT
          {
            varId: 31519, //V_RCN_PANELLED
            value: [
              alarm_leds_txt_objs[0].color,
              alarm_leds_txt_objs[1].color,
              alarm_leds_txt_objs[2].color,
              alarm_leds_txt_objs[3].color,
              alarm_leds_txt_objs[4].color,
              alarm_leds_txt_objs[5].color,
              alarm_leds_txt_objs[6].color,
              alarm_leds_txt_objs[7].color,
              alarm_leds_txt_objs[8].color,
              alarm_leds_txt_objs[9].color
            ]
          }
        ]
      }
    };

    jqmodule.ajax(ctl_url, usr_cnf_cmd_option, usr_cnf_cmd_settings);
    set_alarms_led_txt(); // set alarm led and text
  }

  function send_cs121_usr_cnf_cmd() {
    var url = get_url("rcnpanelapply.cgi"),
      cmd_settings = { methode: "POST" };

    usr_cnf_cmd_option.data = {
      p1: alarm_leds_txt_objs[0].txt,
      p2: alarm_leds_txt_objs[1].txt,
      p3: alarm_leds_txt_objs[2].txt,
      p4: alarm_leds_txt_objs[3].txt,
      p5: alarm_leds_txt_objs[4].txt,
      p6: alarm_leds_txt_objs[5].txt,
      p7: alarm_leds_txt_objs[6].txt,
      p8: alarm_leds_txt_objs[7].txt,
      p9: alarm_leds_txt_objs[8].txt,
      p10: alarm_leds_txt_objs[9].txt,

      l1: alarm_leds_txt_objs[0].color,
      l2: alarm_leds_txt_objs[1].color,
      l3: alarm_leds_txt_objs[2].color,
      l4: alarm_leds_txt_objs[3].color,
      l5: alarm_leds_txt_objs[4].color,
      l6: alarm_leds_txt_objs[5].color,
      l7: alarm_leds_txt_objs[6].color,
      l8: alarm_leds_txt_objs[7].color,
      l9: alarm_leds_txt_objs[8].color,
    };

    jqmodule.ajax(url, usr_cnf_cmd_option, cmd_settings);
    set_alarms_led_txt(); // set alarm led and text
  }

  function usr_cnf_cmd_update(response) {
    set_alarms_led_txt(); // set alarm led and text
  }

  function get_selected_color(index) {
    var color = alarm_leds_txt_objs[index].color;

    if (!(valtable_obj.RCN_PANEL & (1 << index))) {
      return "-1";
    }

    if (color == 0)
      return "0";
    if (color == 1)
      return "1";
    if (color == 2)
      return "2";

    return "-1";
  }

  function get_alarm_img(index) {
    var color = alarm_leds_txt_objs[index].color;

    if (!(valtable_obj.RCN_PANEL & (1 << index))) {
      return "./image/astrid/white14.gif";
    }


    if (color == 0)
      return "./image/astrid/green14.gif";
    if (color == 1)
      return "./image/astrid/red14.gif";
    if (color == 2)
      return "./image/astrid/orange14.gif";

    return "./image/astrid/white14.gif";
  }

  function get_alarm_txt(index) {
    return alarm_leds_txt_objs[index].txt;
  }

  function get_mimic_img(index) {
    var value = valtable_obj.RCN_MIMIC,
      tmp = (value >> (2 * index)) & 0x0003;

    if (tmp == 0)
      return "./image/astrid/014.gif";
    else if (tmp == 1)
      return "./image/astrid/red14.gif";
    else if (tmp == 2)
      return "./image/astrid/green14.gif";
    else if (tmp == 3)
      return "./image/astrid/orange14.gif";
    return "./image/astrid/014.gif";
  }

  function create_alarms_status_digit_inp_panel() //alarms and status and  Digital Inputs
  {
    var fragment = document.createDocumentFragment(),
      tr, table, tbody, thead, alarms_status_div;

    css_obj = { position: 'absolute', top: y_pos + 605, left: x_pos + 2, width: 800, border: 'solid 1px #808080' };

    alarms_status_div = $('<div/>', { id: 'alarms_status_digit_inp_div_id', 'class': 'img-rounded' }).css(css_obj);

    table = $('<table />', { id: 'alarms_status_table', 'class': 'table table-condensed' }).appendTo(alarms_status_div);
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<td />', { colspan: 3, align: 'center', 'text-align': 'center' }).css({ color: 'white', 'background-color': '#315284' }).append(i18n("Alarms, Status & Digital Inputs"))).appendTo(thead);

    tr = $('<tr />').appendTo(tbody);

    $('<td />', { id: 'alarms_id' }).css('vertical-align', 'top').append(get_alarms_table()).appendTo(tr);
    $('<td />', { id: 'status_id' }).css('vertical-align', 'top').append(get_status_table()).appendTo(tr);
    $('<td />', { id: 'digit_inp_id' }).css('vertical-align', 'top').append(get_digit_inp_table()).appendTo(tr);

    fragment.appendChild(alarms_status_div[0]);
    document.body.appendChild(fragment);
  }

  function set_alarms_status_digit_inp() // set alarms and status and  Digital Inputs
  {
    $('#alarms_id').empty();
    $('#alarms_id').append(get_alarms_table());

    $('#status_id').empty();
    $('#status_id').append(get_status_table());

    $('#digit_inp_id').empty();
    $('#digit_inp_id').append(get_digit_inp_table());
  }

  function create_inp_outp_rec_info_measures() // create input output and rectifier measures
  {
    var fragment = document.createDocumentFragment(),
      tr, table, tbody, thead, measures_div,
      top = $("#alarms_status_digit_inp_div_id").outerHeight(true) + 650;

    css_obj = { position: 'absolute', left: x_pos + 2, top: top, width: 800, border: 'solid 1px #808080' };

    measures_div = $('<div/>', { id: 'measures_div_id', 'class': 'img-rounded' }).css(css_obj);

    table = $('<table />', { id: 'measures_table', 'class': 'table table-condensed', 'table-layout': 'fixed', width: '100%' }).appendTo(measures_div);
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<td />', { colspan: 2, align: 'center', 'text-align': 'center' }).css({ color: 'white', 'background-color': '#315284' }).append(i18n("Measures"))).appendTo(thead);

    tr = $('<tr />').appendTo(tbody);

    $('<td />', { id: 'inp_outp_measures_id', width: '50%' }).css('vertical-align', 'top').append(get_inp_outp_measures_table()).appendTo(tr);
    $('<td />', { id: 'rect_info_measures_id', width: '50%' }).css('vertical-align', 'top').append(get_info_table()).appendTo(tr);

    fragment.appendChild(measures_div[0]);
    document.body.appendChild(fragment);
  }

  function get_inp_outp_measures_table() {
    var table, tbody;

    table = $('<table />', { id: 'inp_outp_measures_table', 'class': 'table table-condensed', width: '100%' });
    tbody = $('<tbody />').appendTo(table);

    $('<tr />').append($('<td />', { align: 'left', width: '50%' }).append(get_inp_measures_table())).appendTo(tbody);
    $('<tr />').append($('<td />', { align: 'left', width: '50%' }).append(get_output_measures_table())).appendTo(tbody);
    return table;
  }

  function get_inp_measures_table() // create input measures
  {
    var tr, td, table, tbody, thead;

    table = $('<table />', { id: 'mains_measures_table', 'class': 'table table-condensed table-hover', width: '100%' });
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<th />', { colspan: 2 }).css("text-decoration", "underline").append(i18n("Input Measures"))).appendTo(thead);

    //Input Voltage
    tr = $('<tr />').append($('<td />', { align: 'left', width: '240' }).append(i18n("Input Voltage Phase") + " R")).appendTo(tbody);
    $('<td />', { id: 'inp_volt1', align: 'left' }).append(get_value({ value: valtable_obj.INVOLT[0], unit: ' Vac', precision: 1 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Input Voltage Phase") + " S")).appendTo(tbody);
    $('<td />', { id: 'inp_volt2', align: 'left' }).append(get_value({ value: valtable_obj.INVOLT[1], unit: ' Vac', precision: 1 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Input Voltage Phase") + " T")).appendTo(tbody);
    $('<td />', { id: 'inp_volt3', align: 'left' }).append(get_value({ value: valtable_obj.INVOLT[2], unit: ' Vac', precision: 1 })).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append("")).appendTo(tbody);
    $('<td />', { align: 'left' }).append("").appendTo(tr);

    //input current
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Input Current Phase") + " R")).appendTo(tbody);
    $('<td />', { id: 'inp_cur1', align: 'left' }).append(get_value({ value: valtable_obj.RCN_INPUTCURRENT[0], unit: ' Iac', precision: 1 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Input Current Phase") + " S")).appendTo(tbody);
    $('<td />', { id: 'inp_cur2', align: 'left' }).append(get_value({ value: valtable_obj.RCN_INPUTCURRENT[1], unit: ' Iac', precision: 1 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Input Current Phase") + " T")).appendTo(tbody);
    $('<td />', { id: 'inp_cur3', align: 'left' }).append(get_value({ value: valtable_obj.RCN_INPUTCURRENT[2], unit: ' Iac', precision: 1 })).appendTo(tr);

    return table;
  }

  function get_output_measures_table() // create output measures
  {
    var tr, td, table, tbody, thead;

    table = $('<table />', { id: 'mains_measures_table', 'class': 'table table-condensed table-hover', width: '100%' });
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<th />', { colspan: 2 }).css("text-decoration", "underline").append(i18n("Output Measures"))).appendTo(thead);

    //Rectifier Output Voltage
    tr = $('<tr />').append($('<td />', { align: 'left', width: '240' }).append(i18n("Rectifier Output Voltage"))).appendTo(tbody);
    $('<td />', { id: 'rec_outp_volt', align: 'left' }).append(get_value({ value: valtable_obj.RCN_OUTPUTVOLT, unit: ' Vdc', precision: 1 })).appendTo(tr);

    //Battery Voltage
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Battery Voltage"))).appendTo(tbody);
    $('<td />', { id: 'batt_outp_volt', align: 'left' }).append(get_value({ value: valtable_obj.BATTVOLT, unit: ' Vdc', precision: 1 })).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append("")).appendTo(tbody);
    $('<td />', { align: 'left' }).append("").appendTo(tr);

    //Total Output Current
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Total Output Current"))).appendTo(tbody);
    $('<td />', { id: 'total_outp_cur', align: 'left' }).append(get_value({ value: valtable_obj.RCN_OUTPUTCURRENT, unit: ' Idc', precision: 1 })).appendTo(tr);

    //Battery Current
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Battery Current"))).appendTo(tbody);
    $('<td />', { id: 'batt_cur', align: 'left' }).append(get_value({ value: valtable_obj.RCN_BATTCURR[0], unit: ' Idc', precision: 1 })).appendTo(tr);

    //Second Battery Current
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Second Battery Current"))).appendTo(tbody);
    $('<td />', { id: 'batt_sec', align: 'left' }).append(get_value({ value: valtable_obj.RCN_BATTCURR[1], unit: ' Idc', precision: 1 })).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append("")).appendTo(tbody);
    $('<td />', { align: 'left' }).append("").appendTo(tr);

    //Battery Autonomy
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Battery Autonomy"))).appendTo(tbody);
    $('<td />', { id: 'batt_autonomy', align: 'left' }).append(get_value({ value: valtable_obj.AUTONOMTIME, unit: ' min', precision: 0 })).appendTo(tr);

    return table;
  }

  function get_info_table() // create info table
  {
    var tr, td, table, tbody, thead;

    table = $('<table />', { id: 'mains_measures_table', 'class': 'table table-condensed table-hover', width: '100%' });
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<th />', { colspan: 2 }).css("text-decoration", "underline").append(i18n("Rectifier Info"))).appendTo(thead);

    //Nominal Input Voltage
    tr = $('<tr />').append($('<td />', { align: 'left', width: '240' }).append(i18n("Nominal Input Voltage"))).appendTo(tbody);
    $('<td />', { id: 'rec_nominp_volt1', align: 'left' }).append(get_value({ value: valtable_obj.RCN_NOMINPVOLT, unit: ' Vac', precision: 1 })).appendTo(tr);

    //Nominal Input Frequency
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Nominal Input Frequency"))).appendTo(tbody);
    $('<td />', { id: 'rec_nominp_freq', align: 'left' }).append(get_value({ value: valtable_obj.INFREQ[0], unit: ' Hz', precision: 1 })).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append("")).appendTo(tbody);
    $('<td />', { align: 'left' }).append("").appendTo(tr);

    //Nominal Output Voltage
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Nominal Output Voltage"))).appendTo(tbody);
    $('<td />', { id: 'rec_nomoutp_volt', align: 'left' }).append(get_value({ value: valtable_obj.RCN_NOMOUTVOLT, unit: ' Vdc', precision: 1 })).appendTo(tr);

    //Nominal Diesel Mode Voltage
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Nominal Diesel Mode Voltage"))).appendTo(tbody);
    $('<td />', { id: 'rec_nomdiesel_volt', align: 'left' }).append(get_value({ value: valtable_obj.RCN_NOMDIESELVOLT, unit: ' Vdc', precision: 1 })).appendTo(tr);

    //Nominal Boost-charge Voltage
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Nominal Boost-charge Voltage"))).appendTo(tbody);
    $('<td />', { id: 'rec_nomboostcharger_volt', align: 'left' }).append(get_value({ value: valtable_obj.RCN_NOMBOOSTVOLT, unit: ' Vdc', precision: 1 })).appendTo(tr);

    //Nominal Equalization Voltage
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Nominal Equalization Voltage"))).appendTo(tbody);
    $('<td />', { id: 'rec_nomequalization_volt', align: 'left' }).append(get_value({ value: valtable_obj.RCN_NOMEQUVOLT, unit: ' Vdc', precision: 1 })).appendTo(tr);

    //Nominal Floating Voltage
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Nominal Floating Voltage"))).appendTo(tbody);
    $('<td />', { id: 'rec_nomfloating_volt', align: 'left' }).append(get_value({ value: valtable_obj.RCN_NOMFLOATVOLT, unit: ' Vdc', precision: 1 })).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append("")).appendTo(tbody);
    $('<td />', { align: 'left' }).append("").appendTo(tr);

    //Nominal Output Current
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Nominal Output Current"))).appendTo(tbody);
    $('<td />', { id: 'rec_nomoutp_cur', align: 'left' }).append(get_value({ value: valtable_obj.RCN_NOMOUTCURR, unit: ' Idc', precision: 1 })).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append("")).appendTo(tbody);
    $('<td />', { align: 'left' }).append("").appendTo(tr);

    //1° Battery Discharge Level
    tr = $('<tr />').append($('<td />', { align: 'left' }).append("1&deg; " + i18n("Battery Discharge Level"))).appendTo(tbody);
    $('<td />', { id: 'rec_batt_discharge_level_1', align: 'left' }).append(get_value({ value: valtable_obj.RCN_BATTDISCHLEVEL[0], unit: ' Vdc', precision: 1 })).appendTo(tr);

    //2° Battery Discharge Level
    tr = $('<tr />').append($('<td />', { align: 'left' }).append("2&deg; " + i18n("Battery Discharge Level"))).appendTo(tbody);
    $('<td />', { id: 'rec_batt_discharge_level_2', align: 'left' }).append(get_value({ value: valtable_obj.RCN_BATTDISCHLEVEL[1], unit: ' Vdc', precision: 1 })).appendTo(tr);

    //3° Battery Discharge Level
    tr = $('<tr />').append($('<td />', { align: 'left' }).append("3&deg; " + i18n("Battery Discharge Level"))).appendTo(tbody);
    $('<td />', { id: 'rec_batt_discharge_level_3', align: 'left' }).append(get_value({ value: valtable_obj.RCN_BATTDISCHLEVEL[2], unit: ' Vdc', precision: 1 })).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append("")).appendTo(tbody);
    $('<td />', { align: 'left' }).append("").appendTo(tr);

    //Battery Type
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Battery Type"))).appendTo(tbody);
    $('<td />', { id: 'rec_batt_type', align: 'left' }).append(get_value({ value: valtable_obj.RCN_BATTTYPE, unit: ' Ah', precision: 0 })).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append("")).appendTo(tbody);
    $('<td />', { align: 'left' }).append("").appendTo(tr);

    //Firmware
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Firmware"))).appendTo(tbody);
    $('<td />', { id: 'rec_firmware', align: 'left' }).append(get_value({ value: valtable_obj.RCN_FIRMWARE, unit: '', precision: 0 })).appendTo(tr);

    return table;
  }

  function set_measures() {
    var top = $("#alarms_status_digit_inp_div_id").outerHeight(true) + 650;
    $("#measures_div_id").css('top', top);

    //Input Voltage
    $('#inp_volt1').text(get_value({ value: valtable_obj.INVOLT[0], unit: ' Vac', precision: 1 }));
    $('#inp_volt2').text(get_value({ value: valtable_obj.INVOLT[1], unit: ' Vac', precision: 1 }));
    $('#inp_volt3').text(get_value({ value: valtable_obj.INVOLT[2], unit: ' Vac', precision: 1 }));

    //input current
    $('#inp_cur1').text(get_value({ value: valtable_obj.RCN_INPUTCURRENT[0], unit: ' Iac', precision: 1 }));
    $('#inp_cur2').text(get_value({ value: valtable_obj.RCN_INPUTCURRENT[1], unit: ' Iac', precision: 1 }));
    $('#inp_cur3').text(get_value({ value: valtable_obj.RCN_INPUTCURRENT[2], unit: ' Iac', precision: 1 }));

    //Rectifier Output Voltage
    $('#rec_outp_volt').text(get_value({ value: valtable_obj.RCN_OUTPUTVOLT, unit: ' Vdc', precision: 1 }));
    //Battery Voltage
    $('#batt_outp_volt').text(get_value({ value: valtable_obj.BATTVOLT, unit: ' Vdc', precision: 1 }));
    //Total Output Current
    $('#total_outp_cur').text(get_value({ value: valtable_obj.RCN_OUTPUTCURRENT, unit: ' Idc', precision: 1 }));
    //Battery Current
    $('#batt_cur').text(get_value({ value: valtable_obj.RCN_BATTCURR[0], unit: ' Idc', precision: 1 }));
    //Second Battery Current
    $('#batt_sec').text(get_value({ value: valtable_obj.RCN_BATTCURR[1], unit: ' Idc', precision: 1 }));
    //Battery Autonomy
    $('#batt_autonomy').text(get_value({ value: valtable_obj.AUTONOMTIME, unit: ' min', precision: 0 }));

    //Nominal Input Voltage
    $('#rec_nominp_volt1').text(get_value({ value: valtable_obj.RCN_NOMINPVOLT, unit: ' Vac', precision: 1 }));
    //Nominal Input Frequency
    $('#rec_nominp_freq').text(get_value({ value: valtable_obj.INFREQ[0], unit: ' Hhhz', precision: 1 }));
    //Nominal Output Voltage
    $('#rec_nomoutp_volt').text(get_value({ value: valtable_obj.RCN_NOMOUTVOLT, unit: ' Vdc', precision: 1 }));
    //Nominal Diesel Mode Voltage
    $('#rec_nomdiesel_volt').text(get_value({ value: valtable_obj.RCN_NOMDIESELVOLT, unit: ' Vdc', precision: 1 }));
    //Nominal Boost-charge Voltage
    $('#rec_nomboostcharger_volt').text(get_value({ value: valtable_obj.RCN_NOMBOOSTVOLT, unit: ' Vdc', precision: 1 }));
    //Nominal Equalization Voltage
    $('#rec_nomequalization_volt').text(get_value({ value: valtable_obj.RCN_NOMEQUVOLT, unit: ' Vdc', precision: 1 }));
    //Nominal Floating Voltage
    $('#rec_nomfloating_volt').text(get_value({ value: valtable_obj.RCN_NOMFLOATVOLT, unit: ' Vdc', precision: 1 }));
    //Nominal Output Current
    $('#rec_nomoutp_cur').text(get_value({ value: valtable_obj.RCN_NOMOUTCURR, unit: ' Idc', precision: 1 }));
    //1° Battery Discharge Level
    $('#rec_batt_discharge_level_1').text(get_value({ value: valtable_obj.RCN_BATTDISCHLEVEL[0], unit: ' Vdc', precision: 1 }));
    //2° Battery Discharge Level
    $('#rec_batt_discharge_level_2').text(get_value({ value: valtable_obj.RCN_BATTDISCHLEVEL[1], unit: ' Vdc', precision: 1 }));
    //3° Battery Discharge Level
    $('#rec_batt_discharge_level_3').text(get_value({ value: valtable_obj.RCN_BATTDISCHLEVEL[2], unit: ' Vdc', precision: 1 }));
    //Battery Type
    $('#rec_batt_type').text(get_value({ value: valtable_obj.RCN_BATTTYPE, unit: ' Ah', precision: 0 }));
    //Firmware
    $('#rec_firmware').text(get_value({ value: valtable_obj.RCN_FIRMWARE, unit: '', precision: 0 }));
  }

  function get_alarms_table() {
    var tr, table, tbody, thead;

    table = $('<table />', { id: 'alarms_table', 'class': 'table table-condensed  table-hover' });
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<th />', { colspan: 1 }).css("text-decoration", "underline").append(i18n("Alarms"))).appendTo(thead);

    if (valtable_obj.RCN_ALARMS & 0x0001)
      $('<tr />').append($('<td />', { align: 'left' }).append("A1 " + i18n("Mains Fault"))).appendTo(tbody);

    if (valtable_obj.RCN_ALARMS & 0x0001)
      $('<tr />').append($('<td />', { align: 'left' }).append("A1 " + i18n("Mains Fault"))).appendTo(tbody);
    if (valtable_obj.RCN_ALARMS & 0x0002)
      $('<tr />').append($('<td />', { align: 'left' }).append("A2 " + i18n("Blown fuses"))).appendTo(tbody);
    if (valtable_obj.RCN_ALARMS & 0x0004)
      $('<tr />').append($('<td />', { align: 'left' }).append("A3 " + i18n("High Temperature"))).appendTo(tbody);
    if (valtable_obj.RCN_ALARMS & 0x0008)
      $('<tr />').append($('<td />', { align: 'left' }).append("A4 " + i18n("Overload"))).appendTo(tbody);
    if (valtable_obj.RCN_ALARMS & 0x0010)
      $('<tr />').append($('<td />', { align: 'left' }).append("A5 " + i18n("Max. Output Voltage"))).appendTo(tbody);
    if (valtable_obj.RCN_ALARMS & 0x0020)
      $('<tr />').append($('<td />', { align: 'left' }).append("A6 " + i18n("Min. Output Voltage"))).appendTo(tbody);
    if (valtable_obj.RCN_ALARMS & 0x0040)
      $('<tr />').append($('<td />', { align: 'left' }).append("A7 " + i18n("Charging Fault"))).appendTo(tbody);
    if (valtable_obj.RCN_ALARMS & 0x0080)
      $('<tr />').append($('<td />', { align: 'left' }).append("A8 " + i18n("Fans Failure"))).appendTo(tbody);
    if (valtable_obj.RCN_ALARMS & 0x0100)
      $('<tr />').append($('<td />', { align: 'left' }).append("A9 " + i18n("Open Circuit Breaker"))).appendTo(tbody);
    if (valtable_obj.RCN_ALARMS & 0x0200)
      $('<tr />').append($('<td />', { align: 'left' }).append("A10 " + i18n("Earth Fault"))).appendTo(tbody);
    if (valtable_obj.RCN_ALARMS & 0x0400)
      $('<tr />').append($('<td />', { align: 'left' }).append("A11 " + i18n("Alarm Programmable") + " 1")).appendTo(tbody);
    if (valtable_obj.RCN_ALARMS & 0x0800)
      $('<tr />').append($('<td />', { align: 'left' }).append("A12 " + i18n("Alarm Programmable") + " 2")).appendTo(tbody);
    if (valtable_obj.RCN_ALARMS & 0x1000)
      $('<tr />').append($('<td />', { align: 'left' }).append("A13 " + i18n("Alarm Programmable") + " 3")).appendTo(tbody);
    if (valtable_obj.RCN_ALARMS & 0x2000)
      $('<tr />').append($('<td />', { align: 'left' }).append("A14 " + i18n("Alarm Programmable") + " 4")).appendTo(tbody);
    if (valtable_obj.RCN_ALARMS & 0x4000)
      $('<tr />').append($('<td />', { align: 'left' }).append("A15 " + i18n("EEPROM Fault"))).appendTo(tbody);
    if (valtable_obj.RCN_ALARMS & 0x8000)
      $('<tr />').append($('<td />', { align: 'left' }).append("A16 " + i18n("Emergency Voltage"))).appendTo(tbody);

    return table;
  }

  function get_status_table() {
    var tr, table, tbody, thead;

    table = $('<table />', { id: 'status_table', 'class': 'table table-condensed  table-hover' });
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<th />', { colspan: 1 }).css("text-decoration", "underline").append(i18n("Status"))).appendTo(thead);

    if (valtable_obj.RCN_STATES & 0x0001)
      $('<tr />').append($('<td />', { align: 'left' }).append("S1 " + i18n("Rectifier OK"))).appendTo(tbody);
    if (valtable_obj.RCN_STATES & 0x0002)
      $('<tr />').append($('<td />', { align: 'left' }).append("S2 " + i18n("Battery Discharge"))).appendTo(tbody);
    if (valtable_obj.RCN_STATES & 0x0010)
      $('<tr />').append($('<td />', { align: 'left' }).append("S2_1 1&deg; " + i18n("Battery Discharge Level"))).appendTo(tbody);
    if (valtable_obj.RCN_STATES & 0x0020)
      $('<tr />').append($('<td />', { align: 'left' }).append("S2_2 2&deg; " + i18n("Battery Discharge Level"))).appendTo(tbody);
    if (valtable_obj.RCN_STATES & 0x0040)
      $('<tr />').append($('<td />', { align: 'left' }).append("S2_3 3&deg; " + i18n("Battery Discharge Level"))).appendTo(tbody);
    if (valtable_obj.RCN_STATES & 0x0004)
      $('<tr />').append($('<td />', { align: 'left' }).append("S3 " + i18n("Battery on charge"))).appendTo(tbody);
    if (valtable_obj.RCN_STATES & 0x0080)
      $('<tr />').append($('<td />', { align: 'left' }).append("S3_1 " + i18n("Floating Charge"))).appendTo(tbody);
    if (valtable_obj.RCN_STATES & 0x0100)
      $('<tr />').append($('<td />', { align: 'left' }).append("S3_2 " + i18n("(Timed) Boost Charge"))).appendTo(tbody);
    if (valtable_obj.RCN_STATES & 0x0200)
      $('<tr />').append($('<td />', { align: 'left' }).append("S3_3 " + i18n("Manual Charge"))).appendTo(tbody);
    if (valtable_obj.RCN_STATES & 0x0400)
      $('<tr />').append($('<td />', { align: 'left' }).append("S3_4 " + i18n("Diesel Mode"))).appendTo(tbody);
    if (valtable_obj.RCN_STATES & 0x0008)
      $('<tr />').append($('<td />', { align: 'left' }).append("S4 " + i18n("Battery OK"))).appendTo(tbody);

    return table;
  }

  function get_digit_inp_table() {
    var tr, table, tbody, thead;

    table = $('<table />', { id: 'digit_inp_table', 'class': 'table table-condensed  table-hover' });
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<th />', { colspan: 1 }).css("text-decoration", "underline").append(i18n("Digital Input"))).appendTo(thead);

    if (valtable_obj.RCN_DIGINPUT & 0x0001)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Rectifier Input Circuit Breaker"))).appendTo(tbody);
    if (valtable_obj.RCN_DIGINPUT & 0x0002)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Battery Circuit Breaker"))).appendTo(tbody);
    if (valtable_obj.RCN_DIGINPUT & 0x0004)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Output Circuit Breaker"))).appendTo(tbody);
    if (valtable_obj.RCN_DIGINPUT & 0x0008)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Rectifier On/Off"))).appendTo(tbody);
    if (valtable_obj.RCN_DIGINPUT & 0x0020)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Fuse Bridge") + " 1")).appendTo(tbody);
    if (valtable_obj.RCN_DIGINPUT & 0x0010)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Fuse Bridge") + " 2")).appendTo(tbody);
    if (valtable_obj.RCN_DIGINPUT & 0x0080)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Thermal Switch Bridge") + " 1")).appendTo(tbody);
    if (valtable_obj.RCN_DIGINPUT & 0x0040)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Thermal Switch Bridge") + " 2")).appendTo(tbody);
    if (valtable_obj.RCN_DIGINPUT & 0x0100)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Fans"))).appendTo(tbody);
    if (valtable_obj.RCN_DIGINPUT & 0x0200)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Coupling Switch"))).appendTo(tbody);
    if (valtable_obj.RCN_DIGINPUT & 0x0400)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Earth Fault"))).appendTo(tbody);
    if (valtable_obj.RCN_DIGINPUT & 0x0800)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Reset Max Current"))).appendTo(tbody);
    if (valtable_obj.RCN_DIGINPUT & 0x8000)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Dip Switch 1 Off"))).appendTo(tbody);
    else
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Dip Switch 1 On"))).appendTo(tbody);
    if (valtable_obj.RCN_DIGINPUT & 0x4000)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Dip Switch 2 Off"))).appendTo(tbody);
    else
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Dip Switch 2 On"))).appendTo(tbody);
    if (valtable_obj.RCN_DIGINPUT & 0x2000)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Dip Switch 3 Off"))).appendTo(tbody);
    else
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Dip Switch 3 On"))).appendTo(tbody);
    if (valtable_obj.RCN_DIGINPUT & 0x1000)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Dip Switch 4 Off"))).appendTo(tbody);
    else
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Dip Switch 4 On"))).appendTo(tbody);

    return table;
  }

  function get_value(val_obj) {
    var val = null;
    if (val_obj.value == null || val_obj.value == -9999)
      return 'n/a';

    /*if(Math.round(val_obj.value) == val_obj.value)
       val = val.toString();
    else*/
    val = val_obj.value.toFixed(val_obj.precision);
    val += val_obj.unit;
    return val;
  }

}(jQuery));