/*
   rcnac_panel.js - Astrid (rcnac) screen.
   Copyright (c) 2016, Generex GmbH. All rights reserved.
   Said.
*/
var rcnac_api = (function ($) {
  var oid = get_oid_from_url(),
    cb = null,
    pannes_created = false,
    err_div = null,
    check_bowser = true,
    css_obj,
    valtable_obj, report_obj, unms_obj,
    plattform = get_plattform(),
    inphases = null,
    outphases = null,
    x_pos = 5,
    y_pos = 5;

  var alarm_leds_txt_objs = [
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' },
      { color: 0, txt: '' }
    ],

    ctl_url = get_url("api/devices/ups/control"),
    usr_cnf_cmd_option = {
      data: {},
      data_type: 'text',
      success: usr_cnf_cmd_update,
      error: err_funct
    },
    usr_cnf_cmd_settings = { methode: "POST", xhttp_methode_override: 'PUT', req_payload_json: true };

  var req_params = null;

  /*public functions*/
  return {
    init: init
  };

  function init() {
    if (check_bowser && !utils_api.check_bowser()) {
      $('#loading_id').css('display', 'none');
      panes_api.create_br_check_panel(this, browser_check_ok);
      return true;
    }
    create_err_msg_panel();

    req_params = utils_api.get_req_params(utils_api.device_ups, oid);
    cb = jqmodule.subscribe(this, { update: update, error: err_funct }, req_params);
  }

  function browser_check_ok() {
    check_bowser = false;
    init();
  }

  function create_err_msg_panel() {
    css_obj = { position: 'absolute', top: y_pos, left: x_pos, width: 791, display: 'none', 'z-index': 22 };
    err_div = panes_api.create_err_panel({ id: 'error_div', 'class': 'alert alert-danger' }, css_obj);
  }

  function err_funct(response) {
    jqmodule.refresh(cb, 10 * 1000);
    panes_api.display_err({ response: response, oid: oid, err_div: err_div, err_msg_div_id: 'error_msg_div' });
  }

  function update(data) {
    if (data.ups == null) {
      return;
    }

    set_variable(data);
    jqmodule.refresh(cb, report_obj.refresh * 1000);
    if (err_div)
      err_div.css('display', 'none');

    if (window.menu_api != null)
      menu_api.update(data);

    unms_obj = get_unms_obj(data);
    if (unms_obj != null) {
      info_head_api.update(unms_obj);
    }

    if (!pannes_created) {
      pannes_created = true;
      create_panes();
      return false;
    }
    //set_configuration_color_txt();//set  Configuration color and text
    set_alarms_led_txt(); // set alarm led and text
    set_mimic();
    set_alarms_status_digit_inp(); // set alarms and status and  Digital Inputs
    set_measures(); // set input output and rectifier measures
    set_statistics_panel(); // set statistics panel
    set_footer();
  }

  function create_footer_pane() {
    if (!oid || !unms_obj)
      return true;
    footer_api.create({ //Attr
        id: 'panel2'
        //'class':'unmsFooter'
      }, { //css
        position: 'absolute',
        top: '490px',
        left: '74px'
      },
      unms_obj
    );
  }

  function set_footer() {
    if (!oid || !unms_obj)
      return true;
    footer_api.set(unms_obj);
  }

  function set_variable(data) {
    valtable_obj = data.ups.valtable;
    report_obj = data.report;

    if (valtable_obj.INPHASES != null)
      inphases = valtable_obj.INPHASES;
    else
      inphases = valtable_obj.PHASES;

    if (valtable_obj.OUTPHASES != null)
      outphases = valtable_obj.OUTPHASES;
    else
      outphases = valtable_obj.PHASES;

    $.each(alarm_leds_txt_objs, function (index, alarm_led_txt_obj) {
      alarm_led_txt_obj.color = valtable_obj.RCN_PANELLED[index];

    });

    alarm_leds_txt_objs[0].txt = valtable_obj.RCN_PANEL0TXT;
    alarm_leds_txt_objs[1].txt = valtable_obj.RCN_PANEL1TXT;
    alarm_leds_txt_objs[2].txt = valtable_obj.RCN_PANEL2TXT;
    alarm_leds_txt_objs[3].txt = valtable_obj.RCN_PANEL3TXT;
    alarm_leds_txt_objs[4].txt = valtable_obj.RCN_PANEL4TXT;
    alarm_leds_txt_objs[5].txt = valtable_obj.RCN_PANEL5TXT;
    alarm_leds_txt_objs[6].txt = valtable_obj.RCN_PANEL6TXT;
    alarm_leds_txt_objs[7].txt = valtable_obj.RCN_PANEL7TXT;
    alarm_leds_txt_objs[8].txt = valtable_obj.RCN_PANEL8TXT;
    alarm_leds_txt_objs[9].txt = valtable_obj.RCN_PANEL9TXT;

    alarm_leds_txt_objs[10].txt = valtable_obj.RCN_PANEL10TXT;
    alarm_leds_txt_objs[11].txt = valtable_obj.RCN_PANEL11TXT;
    alarm_leds_txt_objs[12].txt = valtable_obj.RCN_PANEL12TXT;
    alarm_leds_txt_objs[13].txt = valtable_obj.RCN_PANEL13TXT;
    alarm_leds_txt_objs[14].txt = valtable_obj.RCN_PANEL14TXT;
    alarm_leds_txt_objs[15].txt = valtable_obj.RCN_PANEL15TXT;
    alarm_leds_txt_objs[16].txt = valtable_obj.RCN_PANEL16TXT;
    alarm_leds_txt_objs[17].txt = valtable_obj.RCN_PANEL17TXT;
    alarm_leds_txt_objs[18].txt = valtable_obj.RCN_PANEL18TXT;
    alarm_leds_txt_objs[19].txt = valtable_obj.RCN_PANEL19TXT;
  }

  function create_panes() {
    utils_api.setTitle(valtable_obj._platform);
    create_footer_pane();
    create_bg();
    create_mimic_panel();
    create_alarms_led_txt_panel(); // Create alarm leds and text
    create_configuration_panel(); //Panel Configuration
    create_alarms_status_digit_inp_panel(); //alarms and status and  Digital Inputs
    create_inp_outp_measures(); // create input output and info
    create_statistics_panel(); // create statistics panel
  }

  function create_bg() {
    var fragment = document.createDocumentFragment(),
      img_div;
    css_obj = { position: 'absolute', top: y_pos, left: x_pos, width: 722, height: 694 };
    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'bg_img_id', 'class': 'img-rounded', width: 720, 'height': 692, src: './image/astrid/rcnac_bg.png' }).appendTo(img_div);
    fragment.appendChild(img_div[0]);
    document.body.appendChild(fragment);
  }

  function create_mimic_panel() {
    var fragment = document.createDocumentFragment(),
      img_div;

    //Inverter
    css_obj = { position: 'absolute', top: y_pos + 87, left: x_pos + 367, width: 15, height: 15 };
    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'img_inv', 'class': 'img-rounded', width: 15, 'height': 15, src: get_inv_batt_ocb_rect_img(2) }).appendTo(img_div);
    fragment.appendChild(img_div[0]);

    //Battery
    css_obj.top = y_pos + 117;;
    css_obj.left = x_pos + 301;
    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'img_batt', 'class': 'img-rounded', width: 15, 'height': 15, src: get_inv_batt_ocb_rect_img(3) }).appendTo(img_div);
    fragment.appendChild(img_div[0]);

    //Output Breaker (OCB)
    css_obj.top = y_pos + 137;;
    css_obj.left = x_pos + 545;
    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'img_ocb', 'class': 'img-rounded', width: 15, 'height': 15, src: get_inv_batt_ocb_rect_img(6) }).appendTo(img_div);
    fragment.appendChild(img_div[0]);

    //Rectifier
    css_obj.top = y_pos + 87;;
    css_obj.left = x_pos + 235;
    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'img_rect', 'class': 'img-rounded', width: 15, 'height': 15, src: get_inv_batt_ocb_rect_img(9) }).appendTo(img_div);
    fragment.appendChild(img_div[0]);

    //Input
    css_obj.top = y_pos + 87;;
    css_obj.left = x_pos + 123;
    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'img_inp', 'class': 'img-rounded', width: 15, 'height': 15, src: get_inp_byp_ssi_img(0) }).appendTo(img_div);
    fragment.appendChild(img_div[0]);

    //Bypass
    css_obj.top = y_pos + 187;;
    css_obj.left = x_pos + 121;
    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'img_byp', 'class': 'img-rounded', width: 15, 'height': 15, src: get_inp_byp_ssi_img(1) }).appendTo(img_div);
    fragment.appendChild(img_div[0]);

    //Inverter static switch status
    css_obj.top = y_pos + 87;;
    css_obj.left = x_pos + 462;
    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'img_ssi', 'class': 'img-rounded', width: 15, 'height': 15, src: get_inp_byp_ssi_img(4) }).appendTo(img_div);
    fragment.appendChild(img_div[0]);

    //Bypass static switch status
    css_obj.top = y_pos + 188;;
    css_obj.left = x_pos + 462;
    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'img_ssb', 'class': 'img-rounded', width: 15, 'height': 15, src: get_ssb_mbcb_img(5) }).appendTo(img_div);
    fragment.appendChild(img_div[0]);

    //Manual bypass status
    css_obj.top = y_pos + 250;;
    css_obj.left = x_pos + 121;
    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'img_mbcb', 'class': 'img-rounded', width: 15, 'height': 15, src: get_ssb_mbcb_img(7) }).appendTo(img_div);
    fragment.appendChild(img_div[0]);

    //Emergency power off status
    css_obj.top = y_pos + 271;;
    css_obj.left = x_pos + 545;
    img_div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj);
    $('<img />').attr({ 'id': 'img_epo', 'class': 'img-rounded', width: 15, 'height': 15, src: get_epo_img(8) }).appendTo(img_div);
    fragment.appendChild(img_div[0]);

    document.body.appendChild(fragment);
  }

  function set_mimic() {
    $('#img_inv').attr('src', get_inv_batt_ocb_rect_img(2));
    $('#img_batt').attr('src', get_inv_batt_ocb_rect_img(3));
    $('#img_ocb').attr('src', get_inv_batt_ocb_rect_img(6));
    $('#img_rect').attr('src', get_inv_batt_ocb_rect_img(9));

    $('#img_inp').attr('src', get_inp_byp_ssi_img(0));
    $('#img_byp').attr('src', get_inp_byp_ssi_img(1));
    $('#img_ssi').attr('src', get_inp_byp_ssi_img(4));

    $('#img_ssb').attr('src', get_ssb_mbcb_img(5));
    $('#img_mbcb').attr('src', get_ssb_mbcb_img(7));

    $('#img_epo').attr('src', get_epo_img(8));
  }

  function get_epo_img(index) {
    var img_base = './image/astrid/',
      value = valtable_obj.RCNAC_MIMIC[index];

    switch (value) {
      case 0:
        return img_base += 'r.gif';
      case 1:
        return img_base += '0.gif';
      case 2:
        return img_base += 'r1000.gif';
      case 3:
        return img_base += 'r0500.gif';
    }

    return './image/astrid/0.gif';
  }

  function get_ssb_mbcb_img(index) {
    var img_base = './image/astrid/',
      value = valtable_obj.RCNAC_MIMIC[index];

    switch (value) {
      case 0:
        return img_base += 'o.gif';
      case 1:
        return img_base += '0.gif';
      case 2:
        return img_base += 'o1000.gif';
      case 3:
        return img_base += 'o0500.gif';
    }

    return './image/astrid/0.gif';
  }

  function get_inp_byp_ssi_img(index) {
    var img_base = './image/astrid/',
      value = valtable_obj.RCNAC_MIMIC[index];

    switch (value) {
      case 0:
        return img_base += 'g.gif';
      case 1:
        return img_base += '0.gif';
      case 2:
        return img_base += 'g1000.gif';
      case 3:
        return img_base += 'g0500.gif';
    }

    return './image/astrid/0.gif';
  }

  function get_inv_batt_ocb_rect_img(index) {
    var img_base = './image/astrid/',
      value = valtable_obj.RCNAC_MIMIC[index];

    switch (value) {
      case 1:
        return img_base += '0.gif';
      case 2:
        return img_base += 'o1000.gif';
      case 3:
        return img_base += 'o0500.gif';
      case 10:
        return img_base += 'g.gif';
      case 11:
        return img_base += 'g1000.gif';
      case 12:
        return img_base += 'g0500.gif';
      case 20:
        return img_base += 'r.gif';
      case 21:
        return img_base += 'r1000.gif';
      case 22:
        return img_base += 'r0500.gif';
      case 30:
        return img_base += 'o.gif';
    }

    return './image/astrid/0.gif';
  }



  function create_alarms_led_txt_panel() // Create alarm leds and text
  {
    var fragment = document.createDocumentFragment(),
      div,
      css_obj_led = { position: 'absolute', top: y_pos + 305, left: x_pos + 30, width: 15, height: 15 },
      css_obj_txt = { position: 'absolute', top: y_pos + 305, left: x_pos + 50, width: 310, height: 15, 'text-align': 'left' };

    $.each(alarm_leds_txt_objs, function (index, alarm_led_txt_obj) {
      div = $('<div/>', { 'class': 'img-rounded' }).css(css_obj_led); //.css('border', 'solid 2px #315284')
      $('<img />').attr({ 'id': 'alarm_led_' + index, 'class': 'img-rounded', width: 15, height: 15, src: get_alarm_img(index) }).appendTo(div);
      fragment.appendChild(div[0]);

      div = $('<div/>', { 'id': 'alarm_txt_' + index }).css(css_obj_txt).append(get_alarm_txt(index));
      fragment.appendChild(div[0]);

      css_obj_led.top += 34;
      css_obj_txt.top += 34;
      if (index == 9) {
        css_obj_led.top = y_pos + 305;
        css_obj_led.left = x_pos + 395;

        css_obj_txt.top = y_pos + 305;
        css_obj_txt.left = x_pos + 415;
      }
    });

    css_obj = { position: 'absolute', top: y_pos + 636, left: x_pos + 280, width: 190, height: 20 };
    div = $('<div/>').css(css_obj);
    button = $('<button>', { id: "butt_conf_id", 'class': "btn btn-default btn-sm" }).append('Panel Configuration').appendTo(div);
    button.click(function (event) {
      set_configuration_color_txt() //set  Configuration color and text
      $('#configuration_panel_div_id').css('display', 'block');
      event.preventDefault();
    });
    fragment.appendChild(div[0]);

    document.body.appendChild(fragment);
  }

  function set_alarm_leds_txt_objs() {
    $.each(alarm_leds_txt_objs, function (index, alarm_led_txt_obj) {
      alarm_led_txt_obj.color = parseInt($('#conf_color_' + index).val());
      alarm_led_txt_obj.txt = $('#conf_txt_' + index).val();

    });
  }

  function set_alarms_led_txt() // set alarm led and text
  {
    $.each(alarm_leds_txt_objs, function (index, alarm_led_txt_obj) {
      $('#alarm_led_' + index).attr('src', get_alarm_img(index));
      $('#alarm_txt_' + index).html(get_alarm_txt(index));
    });
  }

  function create_configuration_panel() //create Panel Configuration
  {
    var fragment = document.createDocumentFragment(),
      tr, input, select, button, table, tbody, thead, panel_configuration_div;

    css_obj = {
      position: 'absolute',
      top: y_pos + 202,
      left: x_pos + 338,
      width: 442,
      height: 740,
      'display': 'none',
      border: 'solid 1px #808080',
      'z-index': '44',
      'background-color': '#E8E8F0',
      'margin-bottom': '40px'
    };

    panel_configuration_div = $('<div/>', { id: 'configuration_panel_div_id', 'class': 'img-rounded' }).css(css_obj);

    table = $('<table />', { id: 'configuration_panel_table', 'class': 'table table-condensed' }).appendTo(panel_configuration_div);
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<td />', { colspan: 3, align: 'center', 'text-align': 'center' }).css({ color: 'white', 'background-color': '#315284' }).append(i18n("Panel Configuration"))).appendTo(thead);

    $.each(alarm_leds_txt_objs, function (index, alarm_led_txt_obj) {
      tr = $('<tr />').appendTo(tbody);
      $('<td />', { align: 'left' }).css('vertical-align', 'middle').append(index).appendTo(tr);

      select = $('<select />', { id: 'conf_color_' + index });
      select.append('<option value="0">' + i18n('Green') + '</option>');
      select.append('<option value="1">' + i18n('Red') + '</option>');
      select.append('<option value="2">' + i18n('Orange') + '</option>');
      select.val(get_selcted_color(index));
      $('<td />', { align: 'left', width: 40 }).append(select).appendTo(tr);

      input = $('<input />', { id: 'conf_txt_' + index, type: 'text', 'text-align': 'left', size: 40, maxlength: '47' }).attr('value', (alarm_led_txt_obj.txt));
      $('<td />', { align: 'left', width: 310 }).append(input).appendTo(tr);
    });

    button = $('<button>', { id: "save_conf_id", 'class': "btn btn-default btn-sm" }).append(i18n('Ok')).appendTo(panel_configuration_div);
    button.css({ width: 80 });
    button.click(function (event) {
      $('#configuration_panel_div_id').css('display', 'none');
      set_alarm_leds_txt_objs();
      send_usr_cnf_cmd();
      event.preventDefault();
    });

    button = $('<button>', { id: "cancel_conf_id", 'class': "btn btn-default btn-sm" }).append(i18n('Cancel')).appendTo(panel_configuration_div);
    button.css({ width: 80 });
    button.click(function (event) {
      $('#configuration_panel_div_id').css('display', 'none');
      event.preventDefault();
    });

    fragment.appendChild(panel_configuration_div[0]);
    document.body.appendChild(fragment);

    new utils_api.draggable('configuration_panel_div_id');
  }

  function set_configuration_color_txt() //set  Configuration color and text
  {
    var select = null;

    $.each(alarm_leds_txt_objs, function (index, alarm_led_txt_obj) {
      select = $('#conf_color_' + index).val(get_selcted_color(index));
      valtable_obj.RCNAC_PANEL[index] == 1 ? select.attr('disabled', true) : select.removeAttr('disabled');

      select = $('#conf_txt_' + index).attr('value', (alarm_led_txt_obj.txt));
      valtable_obj.RCNAC_PANEL[index] == 1 ? select.attr('disabled', true) : select.removeAttr('disabled');
    });
  }

  function send_usr_cnf_cmd() {
    if (plattform == utils_api.plattform_cs121) {
      return send_cs121_usr_cnf_cmd();
    }

    usr_cnf_cmd_option.data = {
      code: 'writeUsrCnf',
      params: {
        cmdId: 2003,
        cmdParams: "",
        variables: [
          { varId: 31520, value: alarm_leds_txt_objs[0].txt }, //V_RCN_PANEL0TXT
          { varId: 31521, value: alarm_leds_txt_objs[1].txt }, //V_RCN_PANEL1TXT
          { varId: 31522, value: alarm_leds_txt_objs[2].txt }, //V_RCN_PANEL2TXT
          { varId: 31523, value: alarm_leds_txt_objs[3].txt }, //V_RCN_PANEL3TXT
          { varId: 31524, value: alarm_leds_txt_objs[4].txt }, //V_RCN_PANEL4TXT
          { varId: 31525, value: alarm_leds_txt_objs[5].txt }, //V_RCN_PANEL5TXT
          { varId: 31526, value: alarm_leds_txt_objs[6].txt }, //V_RCN_PANEL6TXT
          { varId: 31527, value: alarm_leds_txt_objs[7].txt }, //V_RCN_PANEL7TXT
          { varId: 31528, value: alarm_leds_txt_objs[8].txt }, //V_RCN_PANEL8TXT
          { varId: 31529, value: alarm_leds_txt_objs[9].txt }, //V_RCN_PANEL9TXT

          { varId: 31570, value: alarm_leds_txt_objs[10].txt }, //V_RCN_PANEL10TXT
          { varId: 31571, value: alarm_leds_txt_objs[11].txt }, //V_RCN_PANEL11TXT
          { varId: 31572, value: alarm_leds_txt_objs[12].txt }, //V_RCN_PANEL12TXT
          { varId: 31573, value: alarm_leds_txt_objs[13].txt }, //V_RCN_PANEL13TXT
          { varId: 31574, value: alarm_leds_txt_objs[14].txt }, //V_RCN_PANEL14TXT
          { varId: 31575, value: alarm_leds_txt_objs[15].txt }, //V_RCN_PANEL15TXT
          { varId: 31576, value: alarm_leds_txt_objs[16].txt }, //V_RCN_PANEL16TXT
          { varId: 31577, value: alarm_leds_txt_objs[17].txt }, //V_RCN_PANEL17TXT
          { varId: 31578, value: alarm_leds_txt_objs[18].txt }, //V_RCN_PANEL18TXT
          { varId: 31579, value: alarm_leds_txt_objs[19].txt }, //V_RCN_PANEL19TXT
          {
            varId: 31519, //V_RCN_PANELLED
            value: [
              alarm_leds_txt_objs[0].color,
              alarm_leds_txt_objs[1].color,
              alarm_leds_txt_objs[2].color,
              alarm_leds_txt_objs[3].color,
              alarm_leds_txt_objs[4].color,
              alarm_leds_txt_objs[5].color,
              alarm_leds_txt_objs[6].color,
              alarm_leds_txt_objs[7].color,
              alarm_leds_txt_objs[8].color,
              alarm_leds_txt_objs[9].color,
              alarm_leds_txt_objs[10].color,
              alarm_leds_txt_objs[11].color,
              alarm_leds_txt_objs[12].color,
              alarm_leds_txt_objs[13].color,
              alarm_leds_txt_objs[14].color,
              alarm_leds_txt_objs[15].color,
              alarm_leds_txt_objs[16].color,
              alarm_leds_txt_objs[17].color,
              alarm_leds_txt_objs[18].color,
              alarm_leds_txt_objs[19].color,
            ]
          }
        ]
      }
    };

    jqmodule.ajax(ctl_url, usr_cnf_cmd_option, usr_cnf_cmd_settings);
    set_alarms_led_txt(); // set alarm led and text
  }

  function send_cs121_usr_cnf_cmd() {
    var url = get_url("rcnpanelapply.cgi"),
      cmd_settings = { methode: "POST" };

    usr_cnf_cmd_option.data = {
      p1: alarm_leds_txt_objs[0].txt,
      p2: alarm_leds_txt_objs[1].txt,
      p3: alarm_leds_txt_objs[2].txt,
      p4: alarm_leds_txt_objs[3].txt,
      p5: alarm_leds_txt_objs[4].txt,
      p6: alarm_leds_txt_objs[5].txt,
      p7: alarm_leds_txt_objs[6].txt,
      p8: alarm_leds_txt_objs[7].txt,
      p9: alarm_leds_txt_objs[8].txt,
      p10: alarm_leds_txt_objs[9].txt,

      p11: alarm_leds_txt_objs[10].txt,
      p12: alarm_leds_txt_objs[11].txt,
      p13: alarm_leds_txt_objs[12].txt,
      p14: alarm_leds_txt_objs[13].txt,
      p15: alarm_leds_txt_objs[14].txt,
      p16: alarm_leds_txt_objs[15].txt,
      p17: alarm_leds_txt_objs[16].txt,
      p18: alarm_leds_txt_objs[17].txt,
      p19: alarm_leds_txt_objs[18].txt,
      p20: alarm_leds_txt_objs[19].txt,

      l1: alarm_leds_txt_objs[0].color,
      l2: alarm_leds_txt_objs[1].color,
      l3: alarm_leds_txt_objs[2].color,
      l4: alarm_leds_txt_objs[3].color,
      l5: alarm_leds_txt_objs[4].color,
      l6: alarm_leds_txt_objs[5].color,
      l7: alarm_leds_txt_objs[6].color,
      l8: alarm_leds_txt_objs[7].color,
      l9: alarm_leds_txt_objs[8].color,
      l10: alarm_leds_txt_objs[9].color,
      l11: alarm_leds_txt_objs[10].color,
      l12: alarm_leds_txt_objs[11].color,
      l13: alarm_leds_txt_objs[12].color,
      l14: alarm_leds_txt_objs[13].color,
      l15: alarm_leds_txt_objs[14].color,
      l16: alarm_leds_txt_objs[15].color,
      l17: alarm_leds_txt_objs[16].color,
      l18: alarm_leds_txt_objs[17].color,
      l19: alarm_leds_txt_objs[18].color,
      l20: alarm_leds_txt_objs[19].color,
    };

    jqmodule.ajax(url, usr_cnf_cmd_option, cmd_settings);
    set_alarms_led_txt(); // set alarm led and text
  }

  function usr_cnf_cmd_update(response) {
    set_alarms_led_txt(); // set alarm led and text
  }


  function get_selcted_color(index) {
    var color = alarm_leds_txt_objs[index].color;
    if (color == 0)
      return "0";
    if (color == 1)
      return "1";
    if (color == 2)
      return "2";

    return "0";
  }

  function get_alarm_img(index) {
    var color = alarm_leds_txt_objs[index].color;

    if (valtable_obj.RCNAC_PANEL[index] == 1) {
      return "./image/astrid/white14.gif";
    }

    if (color == 0)
      return "./image/astrid/green14.gif";
    if (color == 1)
      return "./image/astrid/red14.gif";
    if (color == 2)
      return "./image/astrid/orange14.gif";

    return "./image/astrid/white14.gif";
  }

  function get_alarm_txt(index) {
    return alarm_leds_txt_objs[index].txt;
  }

  function get_mimic_img(index) {
    var value = valtable_obj.RCN_MIMIC,
      tmp = (value >> (2 * index)) & 0x0003;

    if (tmp == 0)
      return "./image/astrid/014.gif";
    else if (tmp == 1)
      return "./image/astrid/red14.gif";
    else if (tmp == 2)
      return "./image/astrid/green14.gif";
    else if (tmp == 3)
      return "./image/astrid/orange14.gif";
    return "./image/astrid/014.gif";
  }

  function create_alarms_status_digit_inp_panel() //alarms and status and  Digital Inputs
  {
    var fragment = document.createDocumentFragment(),
      tr, table, tbody, thead, alarms_status_div;

    css_obj = { position: 'absolute', top: y_pos + 725, left: x_pos + 2, width: 800, border: 'solid 1px #808080' };

    alarms_status_div = $('<div/>', { id: 'alarms_status_digit_inp_div_id', 'class': 'img-rounded' }).css(css_obj);

    table = $('<table />', { id: 'alarms_status_table', 'class': 'table table-condensed' }).appendTo(alarms_status_div);
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<td />', { colspan: 3, align: 'center', 'text-align': 'center' }).css({ color: 'white', 'background-color': '#315284' }).append(i18n("Alarms, Status & Digital Inputs"))).appendTo(thead);

    tr = $('<tr />').appendTo(tbody);

    $('<td />', { id: 'alarms_id' }).css('vertical-align', 'top').append(get_alarms_table()).appendTo(tr);
    $('<td />', { id: 'status_id' }).css('vertical-align', 'top').append(get_status_table()).appendTo(tr);
    $('<td />', { id: 'digit_inp_id' }).css('vertical-align', 'top').append(get_digit_inp_table()).appendTo(tr);

    fragment.appendChild(alarms_status_div[0]);
    document.body.appendChild(fragment);
  }

  function set_alarms_status_digit_inp() // set alarms and status and  Digital Inputs
  {
    $('#alarms_id').empty();
    $('#alarms_id').append(get_alarms_table());

    $('#status_id').empty();
    $('#status_id').append(get_status_table());

    $('#digit_inp_id').empty();
    $('#digit_inp_id').append(get_digit_inp_table());
  }

  function create_inp_outp_measures() // create input output and info
  {
    var fragment = document.createDocumentFragment(),
      tr, table, tbody, thead, measures_div,
      top = $("#alarms_status_digit_inp_div_id").outerHeight(true) + 760;

    css_obj = { position: 'absolute', left: x_pos + 2, top: top, width: 800, border: 'solid 1px #808080' };

    measures_div = $('<div/>', { id: 'measures_div_id', 'class': 'img-rounded' }).css(css_obj);

    table = $('<table />', { id: 'measures_table', 'class': 'table table-condensed', 'table-layout': 'fixed', width: '100%' }).appendTo(measures_div);
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<td />', { colspan: 2, align: 'center', 'text-align': 'center' }).css({ color: 'white', 'background-color': '#315284' }).append(i18n("Measures"))).appendTo(thead);

    tr = $('<tr />').appendTo(tbody);

    $('<td />', { id: 'inp_outp_measures_id', width: '50%' }).css('vertical-align', 'top').append(get_inp_measures_table()).appendTo(tr);
    $('<td />', { id: 'rect_info_measures_id', width: '50%' }).css('vertical-align', 'top').append(get_output_measures_table()).appendTo(tr);

    fragment.appendChild(measures_div[0]);
    document.body.appendChild(fragment);
  }

  function get_inp_measures_table() {
    var table, tbody;

    table = $('<table />', { id: 'inp_outp_measures_table', 'class': 'table table-condensed', width: '100%' });
    tbody = $('<tbody />').appendTo(table);

    $('<tr />').append($('<td />', { align: 'left' }).append(get_mains_measures_table())).appendTo(tbody);
    $('<tr />').append($('<td />', { align: 'left' }).append(get_battery_measures_table())).appendTo(tbody);
    $('<tr />').append($('<td />', { align: 'left' }).append(get_bypass_measures_table())).appendTo(tbody);
    $('<tr />').append($('<td />', { align: 'left' }).append(get_inverter_measures_table())).appendTo(tbody);

    return table;
  }

  function get_mains_measures_table() // create mains measures
  {
    var tr, td, table, tbody, thead;

    table = $('<table />', { id: 'mains_measures_table', 'class': 'table table-condensed table-hover', width: '100%' });
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<th />', { colspan: 2 }).css("text-decoration", "underline").append(i18n("Input Measures"))).appendTo(thead);

    //Input Voltage
    tr = $('<tr />').append($('<td />', { align: 'left', width: '240' }).append(i18n("Mains Voltage Phase") + " R")).appendTo(tbody);
    $('<td />', { id: 'inp_volt1', align: 'left' }).append(get_value({ value: valtable_obj.INVOLT[0], unit: ' Vac', precision: 1 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Mains Voltage Phase") + " S")).appendTo(tbody);
    $('<td />', { id: 'inp_volt2', align: 'left' }).append(get_value({ value: valtable_obj.INVOLT[1], unit: ' Vac', precision: 1 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Mains Voltage Phase") + " T")).appendTo(tbody);
    $('<td />', { id: 'inp_volt3', align: 'left' }).append(get_value({ value: valtable_obj.INVOLT[2], unit: ' Vac', precision: 1 })).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append("")).appendTo(tbody);
    $('<td />', { align: 'left' }).append("").appendTo(tr);
    //input current
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Mains Current Phase") + " R")).appendTo(tbody);
    $('<td />', { id: 'inp_cur1', align: 'left' }).append(get_value({ value: valtable_obj.RCN_INPUTCURRENT[0], unit: ' Iac', precision: 1 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Mains Current Phase") + " S")).appendTo(tbody);
    $('<td />', { id: 'inp_cur2', align: 'left' }).append(get_value({ value: valtable_obj.RCN_INPUTCURRENT[1], unit: ' Iac', precision: 1 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Mains Current Phase") + " T")).appendTo(tbody);
    $('<td />', { id: 'inp_cur3', align: 'left' }).append(get_value({ value: valtable_obj.RCN_INPUTCURRENT[2], unit: ' Iac', precision: 1 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append("")).appendTo(tbody);
    $('<td />', { align: 'left' }).append("").appendTo(tr);
    //Mains Frequency
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Mains Frequency"))).appendTo(tbody);
    $('<td />', { id: 'inp_freq', align: 'left' }).append(get_value({ value: valtable_obj.INFREQ[0], unit: ' Hz', precision: 1 })).appendTo(tr);

    return table;
  }

  function get_battery_measures_table() // create battery measures
  {
    var tr, td, table, tbody, thead;

    table = $('<table />', { id: 'mains_batt_measures_table', 'class': 'table table-condensed table-hover', width: '100%' });
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<th />', { colspan: 2 }).css("text-decoration", "underline").append(i18n("Battery Measures"))).appendTo(thead);

    //Battery Voltage
    tr = $('<tr />').append($('<td />', { align: 'left', width: '240' }).append(i18n("Battery Voltage"))).appendTo(tbody);
    $('<td />', { id: 'batt_inp_volt', align: 'left' }).append(get_value({ value: valtable_obj.BATTVOLT, unit: ' Vac', precision: 1 })).appendTo(tr);
    //Battery Current
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Battery Current"))).appendTo(tbody);
    $('<td />', { id: 'batt_inp_curr', align: 'left' }).append(get_value({ value: valtable_obj.RCN_BATTCURR, unit: ' Iac', precision: 1 })).appendTo(tr);
    //Battery Temperature
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Battery Temperature"))).appendTo(tbody);
    $('<td />', { id: 'batt_temp', align: 'left' }).append(get_value({ value: valtable_obj.TEMPDEG, unit: ' &deg;C', precision: 1 })).appendTo(tr);
    //Battery Autonomy
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Battery Autonomy"))).appendTo(tbody);
    $('<td />', { id: 'batt_autotime', align: 'left' }).append(get_value({ value: valtable_obj.AUTONOMTIME, unit: ' min', precision: 0 })).appendTo(tr);

    return table;
  }

  function get_bypass_measures_table() // create Bypass measures
  {
    var tr, td, table, tbody, thead;

    table = $('<table />', { id: 'mains_measures_table', 'class': 'table table-condensed table-hover', width: '100%' });
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<th />', { colspan: 2 }).css("text-decoration", "underline").append(i18n("Bypass Measures"))).appendTo(thead);

    //Bypass Voltage
    tr = $('<tr />').append($('<td />', { align: 'left', width: '240' }).append(i18n("Bypass Voltage Phase") + " R")).appendTo(tbody);
    $('<td />', { id: 'byp_inp_volt1', align: 'left' }).append(get_value({ value: valtable_obj.RCN_BYPASSVOLT[0], unit: ' Vdc', precision: 1 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Bypass Voltage Phase") + " S")).appendTo(tbody);
    $('<td />', { id: 'byp_inp_volt2', align: 'left' }).append(get_value({ value: valtable_obj.RCN_BYPASSVOLT[1], unit: ' Vdc', precision: 1 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Bypass Voltage Phase") + " T")).appendTo(tbody);
    $('<td />', { id: 'byp_inp_volt3', align: 'left' }).append(get_value({ value: valtable_obj.RCN_BYPASSVOLT[2], unit: ' Vdc', precision: 1 })).appendTo(tr);
    //Bypass Frequency
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Bypass Frequency"))).appendTo(tbody);
    $('<td />', { id: 'byp_inp_freq', align: 'left' }).append(get_value({ value: valtable_obj.RCN_BYPASSFREQ, unit: ' Hz', precision: 1 })).appendTo(tr);


    return table;
  }

  function get_inverter_measures_table() // create Inverter measures
  {
    var tr, td, table, tbody, thead;

    table = $('<table />', { id: 'mains_measures_table', 'class': 'table table-condensed table-hover', width: '100%' });
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<th />', { colspan: 2 }).css("text-decoration", "underline").append(i18n("Inverter Measures"))).appendTo(thead);

    //Bypass Voltage
    tr = $('<tr />').append($('<td />', { align: 'left', width: '240' }).append(i18n("Inverter Voltage Phase") + " R")).appendTo(tbody);
    $('<td />', { id: 'inv_inp_volt1', align: 'left' }).append(get_value({ value: valtable_obj.RCN_INVERTERVOLT[0], unit: ' Vdc', precision: 1 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Inverter Voltage Phase") + " S")).appendTo(tbody);
    $('<td />', { id: 'inv_inp_volt2', align: 'left' }).append(get_value({ value: valtable_obj.RCN_INVERTERVOLT[1], unit: ' Vdc', precision: 1 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Inverter Voltage Phase") + " T")).appendTo(tbody);
    $('<td />', { id: 'inv_inp_volt3', align: 'left' }).append(get_value({ value: valtable_obj.RCN_INVERTERVOLT[2], unit: ' Vdc', precision: 1 })).appendTo(tr);

    //Bypass Frequency
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Inverter Frequency"))).appendTo(tbody);
    $('<td />', { id: 'inv_inp_freq', align: 'left' }).append(get_value({ value: valtable_obj.RCN_INVERTERFREQ, unit: ' Hz', precision: 1 })).appendTo(tr);


    return table;
  }


  function get_output_measures_table() // create output measures and info
  {
    var table, tbody;

    table = $('<table />', { id: 'inp_outp_measures_table', 'class': 'table table-condensed', width: '100%' });
    tbody = $('<tbody />').appendTo(table);

    $('<tr />').append($('<td />', { align: 'left' }).append(get_output_m_table())).appendTo(tbody);
    $('<tr />').append($('<td />', { align: 'left' }).append(get_info_panel())).appendTo(tbody);

    return table;
  }

  function get_output_m_table() // create output measures
  {
    var tr, td, table, tbody, thead;

    table = $('<table />', { id: 'mains_measures_table', 'class': 'table table-condensed table-hover', width: '100%' });
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<th />', { colspan: 2 }).css("text-decoration", "underline").append(i18n("Output Measures"))).appendTo(thead);

    //Output Voltage
    tr = $('<tr />').append($('<td />', { align: 'left', width: '240' }).append(i18n("Output Voltage Phase") + " R")).appendTo(tbody);
    $('<td />', { id: 'outp_volt1', align: 'left' }).append(get_value({ value: valtable_obj.RCN_OUTPUTVOLT[0], unit: ' Vac', precision: 1 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Output Voltage Phase") + " R")).appendTo(tbody);
    $('<td />', { id: 'outp_volt2', align: 'left' }).append(get_value({ value: valtable_obj.RCN_OUTPUTVOLT[1], unit: ' Vac', precision: 1 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Output Voltage Phase") + " R")).appendTo(tbody);
    $('<td />', { id: 'outp_volt3', align: 'left' }).append(get_value({ value: valtable_obj.RCN_OUTPUTVOLT[2], unit: ' Vac', precision: 1 })).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append("")).appendTo(tbody);
    $('<td />', { align: 'left' }).append("").appendTo(tr);

    //Output Current
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Output Current Phase") + " R")).appendTo(tbody);
    $('<td />', { id: 'outp_cur1', align: 'left' }).append(get_value({ value: valtable_obj.RCN_OUTPUTCURRENT[0], unit: ' Iac', precision: 1 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Output Current Phase") + " R")).appendTo(tbody);
    $('<td />', { id: 'outp_cur2', align: 'left' }).append(get_value({ value: valtable_obj.RCN_OUTPUTCURRENT[1], unit: ' Iac', precision: 1 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Output Current Phase") + " R")).appendTo(tbody);
    $('<td />', { id: 'outp_cur3', align: 'left' }).append(get_value({ value: valtable_obj.RCN_OUTPUTCURRENT[2], unit: ' Iac', precision: 1 })).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append("")).appendTo(tbody);
    $('<td />', { align: 'left' }).append("").appendTo(tr);

    //Output Load
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Output Load Phase") + " R")).appendTo(tbody);
    $('<td />', { id: 'outp_load1', align: 'left' }).append(get_value({ value: valtable_obj.OUTPOWER[0], unit: ' %', precision: 0 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Output Load Phase") + " R")).appendTo(tbody);
    $('<td />', { id: 'outp_load2', align: 'left' }).append(get_value({ value: valtable_obj.OUTPOWER[1], unit: ' %', precision: 0 })).appendTo(tr);
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Output Load Phase") + " R")).appendTo(tbody);
    $('<td />', { id: 'outp_load3', align: 'left' }).append(get_value({ value: valtable_obj.OUTPOWER[2], unit: ' %', precision: 0 })).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append("")).appendTo(tbody);
    $('<td />', { align: 'left' }).append("").appendTo(tr);

    //Output Frequency
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Output Frequency"))).appendTo(tbody);
    $('<td />', { id: 'outp_freq', align: 'left' }).append(get_value({ value: valtable_obj.RCN_OUTPUTFREQ, unit: ' Hz', precision: 1 })).appendTo(tr);

    return table;
  }

  function get_info_panel() // create UPs info
  {
    var tr, td, table, tbody, thead;

    table = $('<table />', { id: 'mains_measures_table', 'class': 'table table-condensed table-hover', width: '100%' });
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<th />', { colspan: 2 }).css("text-decoration", "underline").append("AC-UPS " + i18n("Panel Info"))).appendTo(thead);

    //UPS Name
    tr = $('<tr />').append($('<td />', { align: 'left', width: '240' }).append(i18n("UPS Name"))).appendTo(tbody);
    $('<td />', { id: 'ups_name', align: 'left' }).append(valtable_obj.RCN_UPSNAME).appendTo(tr);
    //UPS Size
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("UPS Size"))).appendTo(tbody);
    $('<td />', { id: 'ups_size', align: 'left' }).append(get_value({ value: valtable_obj.RCN_NOMOUTCURR, unit: ' kVA', precision: 0 })).appendTo(tr);
    //UPS Serial Number
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("UPS Serial Number"))).appendTo(tbody);
    $('<td />', { id: 'ups_srnum', align: 'left' }).append(valtable_obj.RCN_UPSSERNO).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append("")).appendTo(tbody);
    $('<td />', { align: 'left' }).append("").appendTo(tr);

    //Battery Size
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Battery Size"))).appendTo(tbody);
    $('<td />', { id: 'batt_size', align: 'left' }).append(get_value({ value: valtable_obj.RCN_BATTSIZE, unit: ' Ah', precision: 0 })).appendTo(tr);

    //Nominal Output Voltage
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Nominal Output Voltage"))).appendTo(tbody);
    $('<td />', { id: 'nom_outp_volt', align: 'left' }).append(get_value({ value: valtable_obj.RCN_NOMOUTVOLT, unit: ' Vac', precision: 0 })).appendTo(tr);
    //Nominal Frequency
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Nominal Frequency"))).appendTo(tbody);
    $('<td />', { id: 'nom_outp_freq', align: 'left' }).append(get_value({ value: valtable_obj.RCN_NOMFREQ, unit: ' Hz', precision: 0 })).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append("")).appendTo(tbody);
    $('<td />', { align: 'left' }).append("").appendTo(tr);
    //ModBus Address
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("ModBus Address"))).appendTo(tbody);
    $('<td />', { id: 'ups_mdbusaddr', align: 'left' }).append(valtable_obj.RCN_MODBUSADDR).appendTo(tr);

    return table;
  }

  function set_measures() {
    var top = $("#alarms_status_digit_inp_div_id").outerHeight(true) + 760;
    $("#measures_div_id").css('top', top);

    //Input Voltage
    $('#inp_volt1').text(get_value({ value: valtable_obj.INVOLT[0], unit: ' Vac', precision: 1 }));
    $('#inp_volt2').text(get_value({ value: valtable_obj.INVOLT[1], unit: ' Vac', precision: 1 }));
    $('#inp_volt3').text(get_value({ value: valtable_obj.INVOLT[2], unit: ' Vac', precision: 1 }));
    //input current
    $('#inp_cur1').text(get_value({ value: valtable_obj.RCN_INPUTCURRENT[0], unit: ' Iac', precision: 1 }));
    $('#inp_cur2').text(get_value({ value: valtable_obj.RCN_INPUTCURRENT[1], unit: ' Iac', precision: 1 }));
    $('#inp_cur3').text(get_value({ value: valtable_obj.RCN_INPUTCURRENT[2], unit: ' Iac', precision: 1 }));
    //input Frequency
    $('#inp_freq').text(get_value({ value: valtable_obj.INFREQ[0], unit: ' Hz', precision: 1 }));

    //Battery Voltage
    $('#batt_inp_volt').text(get_value({ value: valtable_obj.BATTVOLT, unit: ' Vac', precision: 1 }));
    //Battery Current
    $('#batt_inp_curr').text(get_value({ value: valtable_obj.RCN_BATTCURR, unit: ' Iac', precision: 1 }));
    //Battery Temperature
    $('#batt_temp').html(get_value({ value: valtable_obj.TEMPDEG, unit: ' &deg;C', precision: 1 }));
    //Battery Autonomy
    $('#batt_autotime').text(get_value({ value: valtable_obj.AUTONOMTIME, unit: ' min', precision: 0 }));
    //Bypass Voltage
    $('#byp_inp_volt1').text(get_value({ value: valtable_obj.RCN_BYPASSVOLT[0], unit: ' Vdc', precision: 1 }));
    $('#byp_inp_volt2').text(get_value({ value: valtable_obj.RCN_BYPASSVOLT[1], unit: ' Vdc', precision: 1 }));
    $('#byp_inp_volt3').text(get_value({ value: valtable_obj.RCN_BYPASSVOLT[2], unit: ' Vdc', precision: 1 }));
    //Bypass Freq
    $('#byp_inp_freq').text(get_value({ value: valtable_obj.RCN_BYPASSFREQ, unit: ' Hz', precision: 1 }));
    //Inverter Voltage
    $('#inv_inp_volt1').text(get_value({ value: valtable_obj.RCN_INVERTERVOLT[0], unit: ' Vdc', precision: 1 }));
    $('#inv_inp_volt2').text(get_value({ value: valtable_obj.RCN_INVERTERVOLT[1], unit: ' Vdc', precision: 1 }));
    $('#inv_inp_volt3').text(get_value({ value: valtable_obj.RCN_INVERTERVOLT[2], unit: ' Vdc', precision: 1 }));
    //Inverter Freq
    $('#inv_inp_freq').text(get_value({ value: valtable_obj.RCN_INVERTERFREQ, unit: ' Hz', precision: 1 }));
    //Output Voltage
    $('#outp_volt1').text(get_value({ value: valtable_obj.RCN_OUTPUTVOLT[0], unit: ' Vac', precision: 1 }));
    $('#outp_volt2').text(get_value({ value: valtable_obj.RCN_OUTPUTVOLT[1], unit: ' Vac', precision: 1 }));
    $('#outp_volt3').text(get_value({ value: valtable_obj.RCN_OUTPUTVOLT[2], unit: ' Vac', precision: 1 }));
    //Output Current
    $('#outp_cur1').text(get_value({ value: valtable_obj.RCN_OUTPUTCURRENT[0], unit: ' Iac', precision: 1 }));
    $('#outp_cur2').text(get_value({ value: valtable_obj.RCN_OUTPUTCURRENT[1], unit: ' Iac', precision: 1 }));
    $('#outp_cur3').text(get_value({ value: valtable_obj.RCN_OUTPUTCURRENT[2], unit: ' Iac', precision: 1 }));
    //Output Load
    $('#outp_load1').text(get_value({ value: valtable_obj.OUTPOWER[0], unit: ' %', precision: 0 }));
    $('#outp_load2').text(get_value({ value: valtable_obj.OUTPOWER[1], unit: ' %', precision: 0 }));
    $('#outp_load3').text(get_value({ value: valtable_obj.OUTPOWER[2], unit: ' %', precision: 0 }));
    //Output Frequency
    $('#outp_freq').text(get_value({ value: valtable_obj.RCN_OUTPUTFREQ, unit: ' Hz', precision: 1 }));
    //UPS Name
    $('#ups_name').text(valtable_obj.RCN_UPSNAME);
    //UPS Size
    $('#ups_size').text(get_value({ value: valtable_obj.RCN_NOMOUTCURR, unit: ' kVA', precision: 0 }));

    //UPS Serial Number
    $('#ups_srnum').text(valtable_obj.RCN_UPSSERNO);
    //Battery Size
    $('#batt_size').text(get_value({ value: valtable_obj.RCN_BATTSIZE, unit: ' Ah', precision: 0 }));
    //Nominal Output Voltage
    $('#nom_outp_volt').text(get_value({ value: valtable_obj.RCN_NOMOUTVOLT, unit: ' Vac', precision: 0 }));
    //Nominal Frequency
    $('#nom_outp_freq').text(get_value({ value: valtable_obj.RCN_NOMFREQ, unit: ' Hz', precision: 0 }));
    //ModBus Address
    $('#ups_mdbusaddr').text(valtable_obj.RCN_MODBUSADDR);
  }

  function create_statistics_panel() // create statistics panel
  {
    var fragment = document.createDocumentFragment(),
      top = $("#alarms_status_digit_inp_div_id").outerHeight(true) + 1540,
      statistics_div, tr, td, table, tbody, thead;

    css_obj = { position: 'absolute', left: x_pos + 2, top: top, width: 800, border: 'solid 1px #808080' };

    statistics_div = $('<div/>', { id: 'statistics_div_id', 'class': 'img-rounded' }).css(css_obj);

    table = $('<table />', { id: 'measures_table', 'class': 'table table-condensed', 'table-layout': 'fixed', width: '100%' }).appendTo(statistics_div);
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<td />', { colspan: 2, align: 'center', 'text-align': 'center' }).css({ color: 'white', 'background-color': '#315284' }).append(i18n("Statistics"))).appendTo(thead);

    //Minimum Battery Voltage since first start of the UPS
    tr = $('<tr />').append($('<td />', { align: 'left', width: '540' }).append(i18n("Minimum Battery Voltage since first start of the UPS"))).appendTo(tbody);
    $('<td />', { id: 'min_batt_volt', align: 'left' }).append(get_value({ value: valtable_obj.RCN_MINBATTVOLT, unit: ' Vdc', precision: 0 })).appendTo(tr);
    //Maximum Battery Voltage since first start of the UPS
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Maximum Battery Voltage since first start of the UPS"))).appendTo(tbody);
    $('<td />', { id: 'max_batt_volt', align: 'left' }).append(get_value({ value: valtable_obj.RCN_MAXBATTVOLT, unit: ' Vdc', precision: 0 })).appendTo(tr);
    //Number of discharging battery cycles since first start of the UPS
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Number of discharging battery cycles since first start of the UPS"))).appendTo(tbody);
    $('<td />', { id: 'num_batt_disch', align: 'left' }).append(get_value({ value: valtable_obj.RCN_NUMDISCH, unit: ' ', precision: 0 })).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append("")).appendTo(tbody);
    $('<td />', { align: 'left' }).append("").appendTo(tr);

    //UPS working in Normal Mode Time
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("UPS working in Normal Mode Time"))).appendTo(tbody);
    $('<td />', { id: 'ups_normal_mode_time', align: 'left' }).append(valtable_obj.RCN_NORMALTIME).appendTo(tr);
    //UPS working in Battery Backup Mode Time
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("UPS working in Battery Backup Mode Time"))).appendTo(tbody);
    $('<td />', { id: 'ups_batt_backups_mode_time', align: 'left' }).append(valtable_obj.RCN_BACKUPTIME).appendTo(tr);
    //UPS working in Bypass Mode Time
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("UPS working in Bypass Mode Time"))).appendTo(tbody);
    $('<td />', { id: 'ups_byp_mode_time', align: 'left' }).append(valtable_obj.RCN_BYPASSTIME).appendTo(tr);

    tr = $('<tr />').append($('<td />', { align: 'left' }).append("")).appendTo(tbody);
    $('<td />', { align: 'left' }).append("").appendTo(tr);
    //Minimum Battery Voltage since last reset of the UPS
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Minimum Battery Voltage since last reset of the UPS"))).appendTo(tbody);
    $('<td />', { id: 'min_batt_volt_reset', align: 'left' }).append(get_value({ value: valtable_obj.RCN_MINBATTVOLTRES, unit: ' Vdc', precision: 0 })).appendTo(tr);
    //Maximum Battery Voltage since last reset of the UPS
    tr = $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Maximum Battery Voltage since last reset of the UPS"))).appendTo(tbody);
    $('<td />', { id: 'max_batt_volt_reset', align: 'left' }).append(get_value({ value: valtable_obj.RCN_MAXBATTVOLTRES, unit: ' Vdc', precision: 0 })).appendTo(tr);

    fragment.appendChild(statistics_div[0]);
    document.body.appendChild(fragment);
  }


  function set_statistics_panel() // set statistics panel
  {
    var top = $("#alarms_status_digit_inp_div_id").outerHeight(true) + 1540;
    $('#statistics_div_id').css('top', top);

    //Minimum Battery Voltage since first start of the UPS
    $('#min_batt_volt').text(get_value({ value: valtable_obj.RCN_MINBATTVOLT, unit: ' Vdc', precision: 0 }));
    //Maximum Battery Voltage since first start of the UPS
    $('#max_batt_volt').text(get_value({ value: valtable_obj.RCN_MAXBATTVOLT, unit: ' Vdc', precision: 0 }));
    //Number of discharging battery cycles since first start of the UPS
    $('#num_batt_disch').text(get_value({ value: valtable_obj.RCN_NUMDISCH, unit: ' ', precision: 0 }));
    //UPS working in Normal Mode Time
    $('#ups_normal_mode_time').text(valtable_obj.RCN_NORMALTIME);
    //UPS working in Battery Backup Mode Time
    $('#ups_batt_backups_mode_time').text(valtable_obj.RCN_BACKUPTIME);
    //UPS working in Bypass Mode Time
    $('#ups_byp_mode_time').text(valtable_obj.RCN_BYPASSTIME);
    //Minimum Battery Voltage since last reset of the UPS
    $('#min_batt_volt_reset').text(get_value({ value: valtable_obj.RCN_MINBATTVOLTRES, unit: ' Vdc', precision: 0 }));
    //Maximum Battery Voltage since last reset of the UPS
    $('#max_batt_volt_reset').text(get_value({ value: valtable_obj.RCN_MAXBATTVOLTRES, unit: ' Vdc', precision: 0 }));
  }

  function get_alarms_table() {
    var a210 = valtable_obj.RCNAC_ALARMS[0],
      a211 = valtable_obj.RCNAC_ALARMS[1],
      a212 = valtable_obj.RCNAC_ALARMS[2],
      a213 = valtable_obj.RCNAC_ALARMS[3],
      a214 = valtable_obj.RCNAC_ALARMS[4],
      a215 = valtable_obj.RCNAC_ALARMS[5],
      a216 = valtable_obj.RCNAC_ALARMS[6],
      a217 = valtable_obj.RCNAC_ALARMS[7],
      tr, table, tbody, thead;

    table = $('<table />', { id: 'alarms_table', 'class': 'table table-condensed  table-hover' });
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<th />', { colspan: 1 }).css("text-decoration", "underline").append(i18n("Alarms"))).appendTo(thead);

    if (a213 & 0x01)
      $('<tr />').append($('<td />', { align: 'left' }).append("A1 " + i18n("Mains Fault"))).appendTo(tbody);
    if (a213 & 0x02)
      $('<tr />').append($('<td />', { align: 'left' }).append("A2 " + i18n("Rectifier Fuses Blown"))).appendTo(tbody);
    if (a213 & 0x04)
      $('<tr />').append($('<td />', { align: 'left' }).append("A3 " + i18n("Rectifier High Temperature"))).appendTo(tbody);
    if (a213 & 0x08)
      $('<tr />').append($('<td />', { align: 'left' }).append("A4 " + i18n("Rectifier Overload"))).appendTo(tbody);
    if (a213 & 0x10)
      $('<tr />').append($('<td />', { align: 'left' }).append("A5 " + i18n("Max. DC Voltage"))).appendTo(tbody);
    if (a213 & 0x20)
      $('<tr />').append($('<td />', { align: 'left' }).append("A6 " + i18n("Min. DC Voltage"))).appendTo(tbody);
    if (a213 & 0x40)
      $('<tr />').append($('<td />', { align: 'left' }).append("A7 " + i18n("Charging Fault"))).appendTo(tbody);
    if (a213 & 0x80)
      $('<tr />').append($('<td />', { align: 'left' }).append("A8 RICB " + i18n("Open"))).appendTo(tbody);
    if (a212 & 0x01)
      $('<tr />').append($('<td />', { align: 'left' }).append("A9 BCB " + i18n("Open"))).appendTo(tbody);
    if (a212 & 0x02)
      $('<tr />').append($('<td />', { align: 'left' }).append("A10 " + i18n("Battery Discharge"))).appendTo(tbody);
    if (a212 & 0x04)
      $('<tr />').append($('<td />', { align: 'left' }).append("A11 " + i18n("Battery Low"))).appendTo(tbody);
    if (a212 & 0x08)
      $('<tr />').append($('<td />', { align: 'left' }).append("A12 " + i18n("Battery In Test"))).appendTo(tbody);
    if (a212 & 0x10)
      $('<tr />').append($('<td />', { align: 'left' }).append("A13 " + i18n("Battery Fault"))).appendTo(tbody);
    if (a212 & 0x20)
      $('<tr />').append($('<td />', { align: 'left' }).append("A14 " + i18n("Inverter VDC Fault"))).appendTo(tbody);
    if (a212 & 0x40)
      $('<tr />').append($('<td />', { align: 'left' }).append("A15 " + i18n("Inverter High Temperature"))).appendTo(tbody);
    if (a212 & 0x80)
      $('<tr />').append($('<td />', { align: 'left' }).append("A16 " + i18n("Inverter Out Of Tolerance"))).appendTo(tbody);
    if (a211 & 0x01)
      $('<tr />').append($('<td />', { align: 'left' }).append("A17 " + i18n("Current Stop"))).appendTo(tbody);
    if (a211 & 0x02)
      $('<tr />').append($('<td />', { align: 'left' }).append("A18 " + i18n("Inverter Not Synchronized"))).appendTo(tbody);
    if (a211 & 0x04)
      $('<tr />').append($('<td />', { align: 'left' }).append("A19 " + i18n("Inverter Overload"))).appendTo(tbody);
    if (a211 & 0x08)
      $('<tr />').append($('<td />', { align: 'left' }).append("A20 " + i18n("Bypass Fault"))).appendTo(tbody);
    if (a211 & 0x10)
      $('<tr />').append($('<td />', { align: 'left' }).append("A21 " + i18n("Bypass Feed Load"))).appendTo(tbody);
    if (a211 & 0x20)
      $('<tr />').append($('<td />', { align: 'left' }).append("A22 " + i18n("Bypass Switch"))).appendTo(tbody);
    if (a211 & 0x40)
      $('<tr />').append($('<td />', { align: 'left' }).append("A23 " + i18n("Retransfer Blocked"))).appendTo(tbody);
    if (a211 & 0x80)
      $('<tr />').append($('<td />', { align: 'left' }).append("A24 " + i18n("Fans Failure"))).appendTo(tbody);
    if (a210 & 0x01)
      $('<tr />').append($('<td />', { align: 'left' }).append("A25 " + i18n("UPS") + " OCB " + i18n("Open"))).appendTo(tbody);
    if (a210 & 0x02)
      $('<tr />').append($('<td />', { align: 'left' }).append("A26 MBCB " + i18n("Closed"))).appendTo(tbody);
    if (a210 & 0x04)
      $('<tr />').append($('<td />', { align: 'left' }).append("A27 EPO " + i18n("Pressed"))).appendTo(tbody);
    if (a210 & 0x08)
      $('<tr />').append($('<td />', { align: 'left' }).append("A28 " + i18n("Thermal Image"))).appendTo(tbody);
    if (a210 & 0x10)
      $('<tr />').append($('<td />', { align: 'left' }).append("A29 " + i18n("Short Circuit"))).appendTo(tbody);
    if (a210 & 0x20)
      $('<tr />').append($('<td />', { align: 'left' }).append("A30 " + i18n("Rectifier Error Loop"))).appendTo(tbody);
    if (a210 & 0x40)
      $('<tr />').append($('<td />', { align: 'left' }).append("A31 " + i18n("Output Voltage out of tol."))).appendTo(tbody);
    if (a210 & 0x80)
      $('<tr />').append($('<td />', { align: 'left' }).append("A32 ")).appendTo(tbody);
    if (a217 & 0x01)
      $('<tr />').append($('<td />', { align: 'left' }).append("A33 ")).appendTo(tbody);
    if (a217 & 0x02)
      $('<tr />').append($('<td />', { align: 'left' }).append("A34 ")).appendTo(tbody);
    if (a217 & 0x04)
      $('<tr />').append($('<td />', { align: 'left' }).append("A35 ")).appendTo(tbody);
    if (a217 & 0x08)
      $('<tr />').append($('<td />', { align: 'left' }).append("A36 ")).appendTo(tbody);
    if (a217 & 0x10)
      $('<tr />').append($('<td />', { align: 'left' }).append("A37 ")).appendTo(tbody);
    if (a217 & 0x20)
      $('<tr />').append($('<td />', { align: 'left' }).append("A38 ")).appendTo(tbody);
    if (a217 & 0x40)
      $('<tr />').append($('<td />', { align: 'left' }).append("A39 ")).appendTo(tbody);
    if (a217 & 0x80)
      $('<tr />').append($('<td />', { align: 'left' }).append("A40 DC " + i18n("Earth Fault"))).appendTo(tbody);
    if (a216 & 0x01)
      $('<tr />').append($('<td />', { align: 'left' }).append("A41 " + i18n("Rectifier") + " OCB " + i18n("Open"))).appendTo(tbody);
    if (a216 & 0x02)
      $('<tr />').append($('<td />', { align: 'left' }).append("A42 " + i18n("Inverter") + " ICB " + i18n("Open"))).appendTo(tbody);
    if (a216 & 0x04)
      $('<tr />').append($('<td />', { align: 'left' }).append("A43 " + "SBCB " + i18n("Open"))).appendTo(tbody);
    if (a216 & 0x08)
      $('<tr />').append($('<td />', { align: 'left' }).append("A44 " + "ELCB " + i18n("Open"))).appendTo(tbody);
    if (a216 & 0x10)
      $('<tr />').append($('<td />', { align: 'left' }).append("A45 ")).appendTo(tbody);
    if (a216 & 0x20)
      $('<tr />').append($('<td />', { align: 'left' }).append("A46 ")).appendTo(tbody);
    if (a216 & 0x40)
      $('<tr />').append($('<td />', { align: 'left' }).append("A47 ")).appendTo(tbody);
    if (a216 & 0x80)
      $('<tr />').append($('<td />', { align: 'left' }).append("A48 ")).appendTo(tbody);
    if (a215 & 0x01)
      $('<tr />').append($('<td />', { align: 'left' }).append("A49 ")).appendTo(tbody);
    if (a215 & 0x02)
      $('<tr />').append($('<td />', { align: 'left' }).append("A50 " + i18n("Configurable Alarm") + " #1")).appendTo(tbody);
    if (a215 & 0x04)
      $('<tr />').append($('<td />', { align: 'left' }).append("A51" + i18n("Configurable Alarm") + "#2")).appendTo(tbody);
    if (a215 & 0x08)
      $('<tr />').append($('<td />', { align: 'left' }).append("A52" + i18n("Configurable Alarm") + "#3")).appendTo(tbody);
    if (a215 & 0x10)
      $('<tr />').append($('<td />', { align: 'left' }).append("A53" + i18n("Configurable Alarm") + "#4")).appendTo(tbody);
    if (a215 & 0x20)
      $('<tr />').append($('<td />', { align: 'left' }).append("A54" + i18n("Configurable Alarm") + "#5")).appendTo(tbody);
    if (a215 & 0x40)
      $('<tr />').append($('<td />', { align: 'left' }).append("A55" + i18n("Configurable Alarm") + "#6")).appendTo(tbody);
    if (a215 & 0x80)
      $('<tr />').append($('<td />', { align: 'left' }).append("A56" + i18n("Configurable Alarm") + "#7")).appendTo(tbody);
    if (a214 & 0x01)
      $('<tr />').append($('<td />', { align: 'left' }).append("A57" + i18n("Configurable Alarm") + "#8")).appendTo(tbody);
    if (a214 & 0x02)
      $('<tr />').append($('<td />', { align: 'left' }).append("A58" + i18n("Configurable Alarm") + "#9")).appendTo(tbody);
    if (a214 & 0x04)
      $('<tr />').append($('<td />', { align: 'left' }).append("A59" + i18n("Configurable Alarm") + "#10")).appendTo(tbody);
    if (a214 & 0x08)
      $('<tr />').append($('<td />', { align: 'left' }).append("A60 ")).appendTo(tbody);
    if (a214 & 0x10)
      $('<tr />').append($('<td />', { align: 'left' }).append("A61 " + i18n("Communication Fault"))).appendTo(tbody);
    if (a214 & 0x20)
      $('<tr />').append($('<td />', { align: 'left' }).append("A62 " + i18n("Rectifier Critical Fault"))).appendTo(tbody);
    if (a214 & 0x40)
      $('<tr />').append($('<td />', { align: 'left' }).append("A63 " + i18n("Inverter Critical Fault"))).appendTo(tbody);
    if (a214 & 0x80)
      $('<tr />').append($('<td />', { align: 'left' }).append("A64 " + i18n("Common Alarm"))).appendTo(tbody);

    return table;
  }

  function get_status_table() {
    var tr, table, tbody, thead;

    table = $('<table />', { id: 'status_table', 'class': 'table table-condensed  table-hover' });
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<th />', { colspan: 1 }).css("text-decoration", "underline").append(i18n("Status"))).appendTo(thead);

    // byte 221
    if (valtable_obj.RCNAC_STATES & 0x0001)
      $('<tr />').append($('<td />', { align: 'left' }).append("S1 " + i18n("Rectifier OK"))).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES & 0x0002)
      $('<tr />').append($('<td />', { align: 'left' }).append("S2 " + i18n("Rectifier On"))).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES & 0x0004)
      $('<tr />').append($('<td />', { align: 'left' }).append("S2_1 " + i18n("Floating Charge"))).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES & 0x0008)
      $('<tr />').append($('<td />', { align: 'left' }).append("S2_2 " + i18n("Boost Charge"))).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES & 0x0010)
      $('<tr />').append($('<td />', { align: 'left' }).append("S2_3 " + i18n("Manual Charge"))).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES & 0x0020)
      $('<tr />').append($('<td />', { align: 'left' }).append("S3 " + i18n("Battery OK"))).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES & 0x0040)
      $('<tr />').append($('<td />', { align: 'left' }).append("S4 " + i18n("Inverter OK"))).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES & 0x0080)
      $('<tr />').append($('<td />', { align: 'left' }).append("S5 " + i18n("Bypass OK"))).appendTo(tbody);
    // byte 220
    if (valtable_obj.RCNAC_STATES & 0x0100)
      $('<tr />').append($('<td />', { align: 'left' }).append("S6 " + i18n("Inverter Synchronized"))).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES & 0x0200)
      $('<tr />').append($('<td />', { align: 'left' }).append("S7 " + i18n("Inverter Feed Load"))).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES & 0x0400)
      $('<tr />').append($('<td />', { align: 'left' }).append("S8 " + i18n("Inverter On"))).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES & 0x0800)
      $('<tr />').append($('<td />', { align: 'left' }).append("S9 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES & 0x1000)
      $('<tr />').append($('<td />', { align: 'left' }).append("S10 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES & 0x2000)
      $('<tr />').append($('<td />', { align: 'left' }).append("S11 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES & 0x4000)
      $('<tr />').append($('<td />', { align: 'left' }).append("S12 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES & 0x8000)
      $('<tr />').append($('<td />', { align: 'left' }).append("S13 ")).appendTo(tbody);
    // byte 219
    if (valtable_obj.RCNAC_STATES2 & 0x0001)
      $('<tr />').append($('<td />', { align: 'left' }).append("S14 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES2 & 0x0002)
      $('<tr />').append($('<td />', { align: 'left' }).append("S15 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES2 & 0x0004)
      $('<tr />').append($('<td />', { align: 'left' }).append("S16 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES2 & 0x0008)
      $('<tr />').append($('<td />', { align: 'left' }).append("S17 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES2 & 0x0010)
      $('<tr />').append($('<td />', { align: 'left' }).append("S18 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES2 & 0x0020)
      $('<tr />').append($('<td />', { align: 'left' }).append("S19 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES2 & 0x0040)
      $('<tr />').append($('<td />', { align: 'left' }).append("S20 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES2 & 0x0080)
      $('<tr />').append($('<td />', { align: 'left' }).append("S21 ")).appendTo(tbody);
    // byte 218
    if (valtable_obj.RCNAC_STATES2 & 0x0100)
      $('<tr />').append($('<td />', { align: 'left' }).append("S22 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES2 & 0x0200)
      $('<tr />').append($('<td />', { align: 'left' }).append("S23 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES2 & 0x0400)
      $('<tr />').append($('<td />', { align: 'left' }).append("S24 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES2 & 0x0800)
      $('<tr />').append($('<td />', { align: 'left' }).append("S25 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES2 & 0x1000)
      $('<tr />').append($('<td />', { align: 'left' }).append("S26 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES2 & 0x2000)
      $('<tr />').append($('<td />', { align: 'left' }).append("S27 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES2 & 0x4000)
      $('<tr />').append($('<td />', { align: 'left' }).append("S28 ")).appendTo(tbody);
    if (valtable_obj.RCNAC_STATES2 & 0x8000)
      $('<tr />').append($('<td />', { align: 'left' }).append("S29 ")).appendTo(tbody);

    return table;
  }

  function get_digit_inp_table() {
    var a125 = valtable_obj.RCNAC_DIGINPUT[0],
      a126 = valtable_obj.RCNAC_DIGINPUT[1],
      a127 = valtable_obj.RCNAC_DIGINPUT[2],
      a128 = valtable_obj.RCNAC_DIGINPUT[3],
      a129 = valtable_obj.RCNAC_DIGINPUT[4],
      a130 = valtable_obj.RCNAC_DIGINPUT[5],
      a131 = valtable_obj.RCNAC_DIGINPUT[6],
      a132 = valtable_obj.RCNAC_DIGINPUT[7],

      tr, table, tbody, thead;

    table = $('<table />', { id: 'digit_inp_table', 'class': 'table table-condensed  table-hover' });
    tbody = $('<tbody />').appendTo(table);
    thead = $('<thead />').appendTo(table);

    tr = $('<tr />').append($('<th />', { colspan: 1 }).css("text-decoration", "underline").append(i18n("Digital Input"))).appendTo(thead);

    if (a125 == 1)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Digital Input") + " #1")).appendTo(tbody);
    if (a126 == 1)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Digital Input") + " #2")).appendTo(tbody);
    if (a127 == 1)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Digital Input") + " #3")).appendTo(tbody);
    if (a128 == 1)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Digital Input") + " #4")).appendTo(tbody);
    if (a129 == 1)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Dip Switch 1 ON"))).appendTo(tbody);
    else
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Dip Switch 1 OFF"))).appendTo(tbody);
    if (a130 == 1)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Dip Switch 2 ON"))).appendTo(tbody);
    else
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Dip Switch 2 OFF"))).appendTo(tbody);
    if (a131 == 1)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Dip Switch 3 ON"))).appendTo(tbody);
    else
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Dip Switch 3 OFF"))).appendTo(tbody);
    if (a132 == 1)
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Dip Switch 4 ON"))).appendTo(tbody);
    else
      $('<tr />').append($('<td />', { align: 'left' }).append(i18n("Dip Switch 4 OFF"))).appendTo(tbody);

    return table;
  }

  function get_value(val_obj) {
    var val = null;
    if (val_obj.value == null || val_obj.value == -9999)
      return 'n/a';

    if (val_obj.unit == ' &deg;C') //Temperature?
    {
      return panes_api.get_temperature(val_obj.value, valtable_obj._tempUnit, val_obj.precision);
    }

    /*if(Math.round(val_obj.value) == val_obj.value)
       val = val.toString();
    else*/
    val = val_obj.value.toFixed(val_obj.precision);
    val += val_obj.unit;
    return val;
  }

}(jQuery));