<?xml version="1.0"?>
<!--
   sfp_panel.xsl - UPS screen for Borri SFP 2.x.x models @UNMS-II.
   Copyright (c) 2005, Generex GmbH. All rights reserved.
   klaus
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!-- Methods -->
  <!--Header-->
  <xsl:template name="sfp_panel-header">
    <xsl:call-template name="app-header">
      <xsl:with-param name="top" select="3"/>
    </xsl:call-template>
  </xsl:template>

  <!--Footer-->
  <xsl:template name="sfp_panel-footer" >
    <xsl:call-template name="app-footer" >
      <xsl:with-param name="left" select="36"/>
      <xsl:with-param name="top" select="440"/>
      <xsl:with-param name="width" select="720"/>
      <xsl:with-param name="height" select="62"/>
    </xsl:call-template>
  </xsl:template>
  <!--Menu-->
  <xsl:template name="sfp_panel-menu">
    <xsl:call-template name="app-menu">
      <xsl:with-param name="top" select="428"/>
      <xsl:with-param name="left" select="0"/>
      <xsl:with-param name="width" select="0"/>
      <xsl:with-param name="height" select="0"/>
      <xsl:with-param name="class" select="'XBold_black'"/>
    </xsl:call-template>
  </xsl:template>

  <!--Body-->
  <xsl:template name="sfp_panel-body">
    <xsl:call-template name="background">
      <xsl:with-param name="imagepath" select="'./lib/ups/image/sfp/backu_b.png'"/>
      <xsl:with-param name="x" select="'0'"/>
      <xsl:with-param name="y" select="'0'"/>
      <xsl:with-param name="w" select="'791'"/>
      <xsl:with-param name="h" select="'488'"/>
      <xsl:with-param name="border" select="'0'"/>
      <xsl:with-param name="id" select="'background'"/>
    </xsl:call-template>

    <div style="position: absolute; left:551px; top:172px; width:96px; height:20px; z-index:1;">
      <a href="javascript:onChangeSelectionUp()">
        <img border="0" alt="" src="./lib/ups/image/sfp/select.jpg" width="96" height="20"/>
      </a>
    </div>
    <xsl:apply-templates />
    <xsl:call-template name="IEpixelBugfixCall"/>
    <script type="text/javascript">
      init();
    </script>
    <xsl:call-template name="js_refresh_call">
      <xsl:with-param	 name="timeout" select="1000*//report/@refresh"/>
    </xsl:call-template>
  </xsl:template>
  <!-- Implementation -->

  <xsl:template match="values">
    <!-- MODEL -->
    <div class="LargeBold" style="position: absolute; left: 505px; top: 381px; height: 20px; color:#ffffff;text-align:center">
      <xsl:value-of select="value[@name='MODEL']/@val" />
    </div>
    <!-- SOLASTATUS -->
    <xsl:variable name="sstate">
      <xsl:call-template name="hexoct2dec">
        <xsl:with-param name="value">
          <xsl:value-of select="value[@name='SOLASTATUS']/@val"/>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:variable>
    <!-- ACTSOLASTATUS -->
    <xsl:variable name="asstate">
      <xsl:call-template name="hexoct2dec">
        <xsl:with-param name="value">
          <xsl:value-of select="value[@name='ACTSOLASTATUS']/@val"/>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:variable>
    <!-- Bits masked -->
    <xsl:variable name="asstateBit7">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$asstate"/>
        <xsl:with-param name="bit" select="$bit7"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit0">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit0"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit1">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit2">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit2"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit3">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit3"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit4">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit4"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit5">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit5"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit6">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit6"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit7">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit7"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit8">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit8"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit9">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit9"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit10">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit10"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit11">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit11"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit12">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit12"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit13">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit13"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit14">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit14"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit15">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit15"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit16">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit16"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit17">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit17"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit18">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit18"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit19">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit19"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit20">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit20"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit21">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit21"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit22">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit22"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit23">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit23"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit24">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit24"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit25">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit25"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit26">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit26"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit27">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit27"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit28">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit28"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit29">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit29"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit30">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit30"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="sstateBit31">
      <xsl:call-template name="bit">
        <xsl:with-param name="val" select="$sstate"/>
        <xsl:with-param name="bit" select="$bit31"/>
      </xsl:call-template>
    </xsl:variable>
    <!-- BATTERY-->
    <div style="position: absolute; left: 96px; top: 215px; width: 50px; height: 50px">
      <xsl:choose>
        <xsl:when test="1=$sstateBit16">
          <img src="./lib/ups/image/sfp/Battw.gif" />
        </xsl:when>
        <xsl:when test="1=$sstateBit31">
          <img src="./lib/ups/image/sfp/Battr.gif" />
        </xsl:when>
        <xsl:when test="1=$sstateBit9 or 0=$sstateBit8">
          <img src="./lib/ups/image/sfp/Battge.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/Battgr.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- RECTIFIER-->
    <div style="position: absolute; left: 206px; top: 142px; width: 50px; height: 50px">
      <xsl:choose>
        <xsl:when test="1=$sstateBit9">
          <img src="./lib/ups/image/sfp/grr.gif" />
        </xsl:when>
        <xsl:when test="1=$sstateBit10 or 1=$sstateBit11">
          <img src="./lib/ups/image/sfp/grge.gif" />
        </xsl:when>
        <xsl:when test="1=$sstateBit8 and 0=$asstateBit7">
          <img src="./lib/ups/image/sfp/grgr.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/grw.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>
    <!-- INVERTER-->
    <div style="position: absolute; left: 281px; top: 142px; width: 50px; height: 50px">
      <xsl:choose>
        <xsl:when test="0=$sstateBit30">
          <img src="./lib/ups/image/sfp/wrr.gif" />
        </xsl:when>
        <xsl:when test="1=$sstateBit29 or 1=$sstateBit28 or 0=$sstateBit26 ">
          <img src="./lib/ups/image/sfp/wrge.gif" />
        </xsl:when>
        <xsl:when test="0=$sstateBit1">
          <img src="./lib/ups/image/sfp/wrgr.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/wrw.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- SSI-->
    <div style="position: absolute; left: 340px; top: 142px; width: 50px; height: 50px">
      <xsl:choose>
        <xsl:when test="1=$sstateBit25">
          <img src="./lib/ups/image/sfp/sswgr.gif" />
        </xsl:when>
        <xsl:when test="0=$sstateBit25">
          <img src="./lib/ups/image/sfp/ssww.gif" />
        </xsl:when>
        <xsl:when test="1=$sstateBit22">
          <img src="./lib/ups/image/sfp/sswr.gif" />
        </xsl:when>
      </xsl:choose>
    </div>

    <!-- SSB -->
    <div style="position: absolute; left: 340px; top: 287px; width: 50px; height: 50px">
      <xsl:choose>
        <xsl:when test="1=$sstateBit21">
          <img src="./lib/ups/image/sfp/sswge.gif" />
        </xsl:when>
        <xsl:when test="0=$sstateBit21">
          <img src="./lib/ups/image/sfp/ssww.gif" />
        </xsl:when>
      </xsl:choose>
    </div>

    <!-- IUG -->
    <div style="position: absolute; left: 457px; top: 223px; width: 35px; height: 35px">
      <xsl:choose>
        <xsl:when test="1=$sstateBit5">
          <img src="./lib/ups/image/sfp/sow.gif" />
        </xsl:when>
        <xsl:when test="0=$sstateBit25 and 0=$sstateBit21">
          <img src="./lib/ups/image/sfp/sgw.gif" />
        </xsl:when>
        <xsl:when test="0=$sstateBit5">
          <img src="./lib/ups/image/sfp/sggr.gif" />
        </xsl:when>
      </xsl:choose>
    </div>

    <!-- IB -->
    <div style="position: absolute; left: 219px; top: 222px; width: 35px; height: 35px">
      <xsl:choose>
        <xsl:when test="1=$sstateBit16">
          <img src="./lib/ups/image/sfp/sor.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/sggr.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- IRE -->
    <div style="position: absolute; left: 169px; top: 307px; width: 22px; height: 8px">
      <xsl:choose>
        <xsl:when test="1=$sstateBit23">
          <img src="./lib/ups/image/sfp/led22x8gr.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led22x8red.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- IBY -->
    <div style="position: absolute; left: 169px; top: 362px; width: 22px; height: 8px">
      <xsl:choose>
        <xsl:when test="1=$sstateBit6">
          <img src="./lib/ups/image/sfp/led22x8red.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led22x8grau.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- IRP -->
    <div style="position: absolute; left: 170px; top: 164px; width: 22px; height: 8px">
      <xsl:choose>
        <xsl:when test="1=$sstateBit8">
          <img src="./lib/ups/image/sfp/led22x8gr.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led22x8red.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- PSSB -->
    <div style="position: absolute; left: 301px; top: 307px; width: 22px; height: 8px">
      <xsl:choose>
        <xsl:when test="0=$sstateBit4 and 1=$sstateBit23">
          <img src="./lib/ups/image/sfp/led22x8gr.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led22x8grau.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- PBAT1 -->
    <div style="position: absolute; left: 160px; top: 235px; width: 22px; height: 8px">
      <xsl:choose>
        <xsl:when test="1=$sstateBit17 and 0=$sstateBit9 and 0=$sstateBit16">
          <img src="./lib/ups/image/sfp/led22x8gr.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led22x8grau.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>


    <!-- PBAT2 -->
    <div style="position: absolute; left: 182px; top: 235px; width: 22px; height: 8px">
      <xsl:choose>
        <xsl:when test="(1=$sstateBit17 and 0=$sstateBit9) or 1=$sstateBit16">
          <img src="./lib/ups/image/sfp/led22x8grau.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led22x8gelb.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- COMMON ALARM -->
    <div style="position: absolute; left: 439px; top: 148px; width: 33px; height: 12px">
      <xsl:choose>
        <xsl:when test="1201537280!=$sstate">
          <img src="./lib/ups/image/sfp/led33x12red.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led33x12gr.gif" />
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- LOAD BAR -->
    <xsl:variable name="solatopp" select="value[@name='SOLATOPP']/@val"/>
    <xsl:call-template name="Loadbar">
      <xsl:with-param name="load" select="$solatopp"/>
      <xsl:with-param name="x" select="'588'"/>
      <xsl:with-param name="y" select="'275'"/>
    </xsl:call-template>


    <!-- AUTONOM BAR -->
    <xsl:variable name="solacbam" select="value[@name='SOLACBAM']/@val"/>
    <xsl:variable name="outpower" select="value[@name='OUTPOWER']/@val"/>

    <!-- AUTO 1 -->
    <div style="position: absolute; left: 664px; top: 275px; width: 20px; height: 4px; font-color:#ffffff">
      <xsl:choose>
        <xsl:when test="$outpower>110">
          <img src="./lib/ups/image/sfp/led20x4red.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led20x4trans.gif"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- AUTO 2 -->
    <div style="position: absolute; left: 664px; top: 281px; width: 20px; height: 4px">
      <xsl:choose>
        <xsl:when test="$outpower>100">
          <img src="./lib/ups/image/sfp/led20x4red.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led20x4trans.gif"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- AUTO 3 -->
    <div style="position: absolute; left: 664px; top: 287px; width: 20px; height: 4px">
      <xsl:choose>
        <xsl:when test="$solacbam>90">
          <img src="./lib/ups/image/sfp/led20x4gr.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led20x4trans.gif"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- AUTO 4 -->
    <div style="position: absolute; left: 664px; top: 293px; width: 20px; height: 4px">
      <xsl:choose>
        <xsl:when test="$solacbam>80">
          <img src="./lib/ups/image/sfp/led20x4gr.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led20x4trans.gif"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- AUTO 5 -->
    <div style="position: absolute; left: 664px; top: 299px; width: 20px; height: 4px">
      <xsl:choose>
        <xsl:when test="$solacbam>70">
          <img src="./lib/ups/image/sfp/led20x4gr.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led20x4trans.gif"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- AUTO 6 -->
    <div style="position: absolute; left: 664px; top: 305px; width: 20px; height: 4px">
      <xsl:choose>
        <xsl:when test="$solacbam>60">
          <img src="./lib/ups/image/sfp/led20x4gr.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led20x4trans.gif"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- AUTO 7 -->
    <div style="position: absolute; left: 664px; top: 311px; width: 20px; height: 4px">
      <xsl:choose>
        <xsl:when test="$solacbam>50">
          <img src="./lib/ups/image/sfp/led20x4gr.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led20x4trans.gif"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- AUTO 8 -->
    <div style="position: absolute; left: 664px; top: 317px; width: 20px; height: 4px">
      <xsl:choose>
        <xsl:when test="$solacbam>40">
          <img src="./lib/ups/image/sfp/led20x4gr.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led20x4trans.gif"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- AUTO 9 -->
    <div style="position: absolute; left: 664px; top: 323px; width: 20px; height: 4px">
      <xsl:choose>
        <xsl:when test="$solacbam>30">
          <img src="./lib/ups/image/sfp/led20x4gr.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led20x4trans.gif"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- AUTO 10 -->
    <div style="position: absolute; left: 664px; top: 329px; width: 20px; height: 4px">
      <xsl:choose>
        <xsl:when test="$solacbam>30">
          <img src="./lib/ups/image/sfp/led20x4gr.gif" />
        </xsl:when>
        <xsl:when test="$solacbam>20">
          <img src="./lib/ups/image/sfp/led20x4gelb.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led20x4trans.gif"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- AUTO 11 -->
    <div style="position: absolute; left: 664px; top: 335px; width: 20px; height: 4px">
      <xsl:choose>
        <xsl:when test="$solacbam>20">
          <img src="./lib/ups/image/sfp/led20x4gr.gif" />
        </xsl:when>
        <xsl:when test="$solacbam>10">
          <img src="./lib/ups/image/sfp/led20x4red.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led20x4trans.gif"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>

    <!-- AUTO 12 -->
    <div style="position: absolute; left: 664px; top: 341px; width: 20px; height: 4px">
      <xsl:choose>
        <xsl:when test="$solacbam>10">
          <img src="./lib/ups/image/sfp/led20x4gr.gif" />
        </xsl:when>
        <xsl:when test="$solacbam>1">
          <img src="./lib/ups/image/sfp/led20x4red.gif" />
        </xsl:when>
        <xsl:otherwise>
          <img src="./lib/ups/image/sfp/led20x4trans.gif"/>
        </xsl:otherwise>
      </xsl:choose>
    </div>
    <xsl:variable name="y" select="113"/>
    <!--OUTPOWER TEXT -->
    <div class="MediumBold">
      <xsl:call-template name="paneText">
        <xsl:with-param name="x" select="563" />
        <xsl:with-param name="y" select="358" />
        <xsl:with-param name="w" select="66" />
        <xsl:with-param name="h" select="15" />
        <xsl:with-param name="value" select="value[@name='SOLATOP']/@val" />
        <xsl:with-param name="unit" select="'VA'" />
        <xsl:with-param name="align" select="'center'" />
      </xsl:call-template>
    </div>
    <!--AUTONOMY TEXT -->
    <div class="MediumBold">
      <xsl:call-template name="paneText">
        <xsl:with-param name="x" select="647" />
        <xsl:with-param name="y" select="358" />
        <xsl:with-param name="w" select="52" />
        <xsl:with-param name="h" select="15" />
        <xsl:with-param name="value" select="$solacbam" />
        <xsl:with-param name="unit" select="'min'" />
        <xsl:with-param name="align" select="'center'" />
      </xsl:call-template>
    </div>
    <!-- OUTPUT-->
    <xsl:call-template name="paneTab3r3c">
      <xsl:with-param name="xT" select="509"/>
      <xsl:with-param name="yT" select="$y"/>
      <xsl:with-param name="wT" select="50"/>
      <xsl:with-param name="hT" select="11"/>
      <xsl:with-param name="xOff" select="0"/>
      <xsl:with-param name="xOff2" select="2"/>
      <xsl:with-param name="w" select="40"/>
      <xsl:with-param name="h" select="11"/>
      <xsl:with-param name="text" select="'Output L'" />
      <xsl:with-param name="value"  select="value[@name='SOLAWROV']" />
      <xsl:with-param name="unit" select="'V'"/>
      <xsl:with-param name="precision" select="0"/>
      <xsl:with-param name="value2" select="value[@name='SOLAWROC']" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision2" select="1"/>
      <xsl:with-param name="value3" select="value[@name='OUTFREQ']" />
      <xsl:with-param name="unit3" select="'Hz'"/>
      <xsl:with-param name="precision3" select="1"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page0_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page0_100', ['Output', ' L1:']);</script>
    <script type="text/javascript"> translate_text('page0_110', ['Output', ' L2:']);</script>
    <script type="text/javascript"> translate_text('page0_120', ['Output', ' L3:']);</script>

    <!-- LOAD-->
    <xsl:call-template name="paneTab3r2c">
      <xsl:with-param name="xT" select="513"/>
      <xsl:with-param name="yT" select="$y"/>
      <xsl:with-param name="wT" select="48"/>
      <xsl:with-param name="hT" select="11"/>
      <xsl:with-param name="xOff" select="0"/>
      <xsl:with-param name="xOff2" select="0"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="11"/>
      <xsl:with-param name="text" select="'Load L'" />
      <xsl:with-param name="value"  select="value[@name='SOLAOPL']" />
      <xsl:with-param name="unit" select="'VA'"/>
      <xsl:with-param name="value2" select="value[@name='SOLAOPLP']" />
      <xsl:with-param name="unit2" select="'%'"/>
      <xsl:with-param name="precision2" select="1"/>
      <xsl:with-param name="visibility" select="'visible'"/>
      <xsl:with-param name="name" select="'page1_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page1_100', ['Load', ' L1:']);</script>
    <script type="text/javascript"> translate_text('page1_110', ['Load', ' L2:']);</script>
    <script type="text/javascript"> translate_text('page1_120', ['Load', ' L:']);</script>

    <!-- INVERTER -->
    <xsl:call-template name="paneRow2">
      <xsl:with-param name="xT" select="513"/>
      <xsl:with-param name="yT" select="$y + 11"/>
      <xsl:with-param name="wT" select="48"/>
      <xsl:with-param name="hT" select="11"/>
      <xsl:with-param name="xOff" select="0"/>
      <xsl:with-param name="xOff2" select="0"/>
      <xsl:with-param name="w" select="40"/>
      <xsl:with-param name="h" select="11"/>
      <xsl:with-param name="text" select="'Inverter'" />
      <xsl:with-param name="value"  select="value[@name='SOLAIOMV']/@val" />
      <xsl:with-param name="unit" select="'V'"/>
      <xsl:with-param name="value2"  select="value[@name='INFREQ']/@val" />
      <xsl:with-param name="unit2" select="'Hz'"/>
      <xsl:with-param name="precision"  select="0"/>
      <xsl:with-param name="precision2" select="1"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page2_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page2_10', ['Inverter', ':']);</script>

    <!-- BATTERY-->
    <xsl:call-template name="paneRow2">
      <xsl:with-param name="xT" select="509"/>
      <xsl:with-param name="yT" select="$y "/>
      <xsl:with-param name="wT" select="78"/>
      <xsl:with-param name="hT" select="11"/>
      <xsl:with-param name="xOff" select="0"/>
      <xsl:with-param name="xOff2" select="0"/>
      <xsl:with-param name="w" select="45"/>
      <xsl:with-param name="h" select="11"/>
      <xsl:with-param name="alignT" select="'left'"/>
      <xsl:with-param name="text" select="'Battery'" />
      <xsl:with-param name="value"  select="value[@name='BATTVOLT']/@val" />
      <xsl:with-param name="unit" select="'V'"/>
      <xsl:with-param name="value2"  select="value[@name='SOLABATTC']/@val" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision"  select="0"/>
      <xsl:with-param name="precision2" select="1"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page3_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page3_10', ['Battery', ':']);</script>

    <xsl:call-template name="paneRow2">
      <xsl:with-param name="xT" select="509"/>
      <xsl:with-param name="yT" select="$y + 12"/>
      <xsl:with-param name="wT" select="78"/>
      <xsl:with-param name="hT" select="11"/>
      <xsl:with-param name="xOff" select="0"/>
      <xsl:with-param name="xOff2" select="0"/>
      <xsl:with-param name="w" select="45"/>
      <xsl:with-param name="h" select="11"/>
      <xsl:with-param name="alignT" select="'left'"/>
      <xsl:with-param name="text" select="'Autonomy time'" />
      <xsl:with-param name="value"  select="value[@name='SOLACBAM']/@val" />
      <xsl:with-param name="unit" select="'min'"/>
      <xsl:with-param name="value2"  select="value[@name='SOLACBAP']/@val" />
      <xsl:with-param name="unit2" select="'%'"/>
      <xsl:with-param name="precision"  select="0"/>
      <xsl:with-param name="precision2" select="1"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page3_2'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page3_20', ['Autonomy time', ':']);</script>

    <xsl:call-template name="paneRow">
      <xsl:with-param name="xT" select="509"/>
      <xsl:with-param name="yT" select="$y + 24"/>
      <xsl:with-param name="wT" select="78"/>
      <xsl:with-param name="hT" select="11"/>
      <xsl:with-param name="xOff" select="0"/>
      <xsl:with-param name="xOff2" select="0"/>
      <xsl:with-param name="w" select="45"/>
      <xsl:with-param name="h" select="11"/>
      <xsl:with-param name="alignT" select="'left'"/>
      <xsl:with-param name="text" select="'Rectifier'" />
      <xsl:with-param name="value"  select="value[@name='SOLARECC']/@val" />
      <xsl:with-param name="unit" select="'A'"/>
      <xsl:with-param name="precision"  select="1"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page3_3'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page3_30', ['Rectifier', ':']);</script>

    <!--BYPASS-->
    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="1"/>
      <xsl:with-param name="x" select="509"/>
      <xsl:with-param name="y" select="$y"/>
      <xsl:with-param name="w" select="28"/>
      <xsl:with-param name="h" select="11"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'BYP:'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page4_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page4_11', ['BYP', ':']);</script>

    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="539"/>
      <xsl:with-param name="y" select="$y"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="11"/>
      <xsl:with-param name="value1"  select="value[@name='INVOLT']/@val" />
      <xsl:with-param name="unit1" select="'V'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="value[@name='INVOLT']/@val2" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='INVOLT']/@val3" />
      <xsl:with-param name="unit3" select="'V'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page4'"/>
    </xsl:call-template>

    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="583"/>
      <xsl:with-param name="y" select="$y"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="11"/>
      <xsl:with-param name="value1" select="value[@name='SOLAMAINC']/@val" />
      <xsl:with-param name="unit1" select="'A'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2"  select="value[@name='SOLAMCPS']/@val" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='SOLAMCPT']/@val" />
      <xsl:with-param name="unit3" select="'A'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page4'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="620"/>
      <xsl:with-param name="y" select="$y"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="11"/>
      <xsl:with-param name="value1" select="value[@name='SOLAMFREQ']/@val" />
      <xsl:with-param name="unit1" select="'Hz'"/>
      <xsl:with-param name="precision1" select="1"/>
      <xsl:with-param name="value2"  select="value[@name='SOLAMFREQ']/@val" />
      <xsl:with-param name="unit2" select="'Hz'"/>
      <xsl:with-param name="precision2" select="1"/>
      <xsl:with-param name="value3" select="value[@name='SOLAMFREQ']/@val" />
      <xsl:with-param name="unit3" select="'Hz'"/>
      <xsl:with-param name="precision3" select="1"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page4'"/>
    </xsl:call-template>

    <!--RECTIFIER-->
    <xsl:call-template name="paneTextColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="509"/>
      <xsl:with-param name="y" select="$y"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="11"/>
      <xsl:with-param name="align" select="'left'" />
      <xsl:with-param name="text1"  select="'INP L1:'" />
      <xsl:with-param name="text2"  select="'    L2:'" />
      <xsl:with-param name="text3" select="'    L3:'" />
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page5_1'"/>
    </xsl:call-template>
    <script type="text/javascript"> translate_text('page5_11', ['INP', ' L1:']);</script>

    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="539"/>
      <xsl:with-param name="y" select="$y"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="11"/>
      <xsl:with-param name="value1"  select="value[@name='SOLAWRIV']/@val" />
      <xsl:with-param name="unit1" select="'V'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2" select="value[@name='SOLAWRIV']/@val2" />
      <xsl:with-param name="unit2" select="'V'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='SOLAWRIV']/@val3" />
      <xsl:with-param name="unit3" select="'V'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page5'"/>

    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="583"/>
      <xsl:with-param name="y" select="$y"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="11"/>
      <xsl:with-param name="value1" select="value[@name='SOLACPI']/@val" />
      <xsl:with-param name="unit1" select="'A'"/>
      <xsl:with-param name="precision1" select="0"/>
      <xsl:with-param name="value2"  select="value[@name='SOLACPI']/@val2" />
      <xsl:with-param name="unit2" select="'A'"/>
      <xsl:with-param name="precision2" select="0"/>
      <xsl:with-param name="value3" select="value[@name='SOLACPI']/@val3" />
      <xsl:with-param name="unit3" select="'A'"/>
      <xsl:with-param name="precision3" select="0"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page5'"/>
    </xsl:call-template>
    <xsl:call-template name="paneColumn">
      <xsl:with-param name="rows" select="3"/>
      <xsl:with-param name="x" select="620"/>
      <xsl:with-param name="y" select="$y"/>
      <xsl:with-param name="w" select="48"/>
      <xsl:with-param name="h" select="11"/>
      <xsl:with-param name="value1" select="value[@name='SOLAINFREQ']/@val" />
      <xsl:with-param name="unit1" select="'Hz'"/>
      <xsl:with-param name="precision1" select="1"/>
      <xsl:with-param name="value2"  select="value[@name='SOLAINFREQ']/@val" />
      <xsl:with-param name="unit2" select="'Hz'"/>
      <xsl:with-param name="precision2" select="1"/>
      <xsl:with-param name="value3" select="value[@name='SOLAINFREQ']/@val" />
      <xsl:with-param name="unit3" select="'Hz'"/>
      <xsl:with-param name="precision3" select="1"/>
      <xsl:with-param name="visibility" select="'hidden'"/>
      <xsl:with-param name="name" select="'page5'"/>

    </xsl:call-template>


  </xsl:template>


  <!-- EOS -->
</xsl:stylesheet>