<?xml version="1.0"?>
<!--
   siteman.xsl - OEM UPS screen for BREKOM@UNMS-II.
   Copyright (c) 2005, Generex GmbH. All rights reserved.
   klaus
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!-- Methods -->
  <!--Header-->
  <xsl:template name="siteman_panel-header">
    <xsl:call-template name="app-header">
      <xsl:with-param name="top" select="3"/>
    </xsl:call-template>
  </xsl:template>

  <!--Footer-->
  <xsl:template name="siteman_panel-footer" >
    <xsl:call-template name="app-footer" >
      <xsl:with-param name="left" select="24"/>
      <xsl:with-param name="top" select="490"/>
      <xsl:with-param name="width" select="752"/>
      <xsl:with-param name="height" select="62"/>
    </xsl:call-template>
  </xsl:template>
  <!--Menu-->
  <xsl:template name="siteman_panel-menu">
    <xsl:call-template name="app-menu">
      <xsl:with-param name="top" select="428"/>
      <xsl:with-param name="left" select="0"/>
      <xsl:with-param name="width" select="0"/>
      <xsl:with-param name="height" select="0"/>
      <xsl:with-param name="class" select="'XBold_black'"/>
    </xsl:call-template>
  </xsl:template>

  <!--Body-->
  <xsl:template name="siteman_panel-body">
    <xsl:call-template name="background">
      <xsl:with-param name="imagepath" select="'./lib/ups/image/ups/empty.png'"/>
      <xsl:with-param name="x" select="'0'"/>
      <xsl:with-param name="y" select="'0'"/>
      <xsl:with-param name="w" select="'792'"/>
      <xsl:with-param name="h" select="'485'"/>
      <xsl:with-param name="border" select="0"/>
      <xsl:with-param name="id" select="'background'"/>
    </xsl:call-template>
    <xsl:apply-templates />
    <xsl:call-template name="IEpixelBugfixCall"/>
    <script type="text/javascript">
      init();
      setBrekomSelection(selection);
    </script>
    <xsl:call-template name="js_refresh_call">
      <xsl:with-param	 name="timeout" select="1000*//report/@refresh"/>
    </xsl:call-template>
  </xsl:template>
  <!-- Implementation -->
  <xsl:template match="values">
    <xsl:variable name="analog1" select="value[@name='SM_A1NAME']/@val"/>
    <xsl:variable name="analog2" select="value[@name='SM_A2NAME']/@val"/>
    <xsl:variable name="analog3" select="value[@name='SM_A3NAME']/@val"/>
    <xsl:variable name="analog4" select="value[@name='SM_A4NAME']/@val"/>
    <xsl:variable name="analog5" select="value[@name='SM_A5NAME']/@val"/>
    <xsl:variable name="analog6" select="value[@name='SM_A6NAME']/@val"/>
    <xsl:variable name="analog7" select="value[@name='SM_A7NAME']/@val"/>
    <xsl:variable name="analog8" select="value[@name='SM_A8NAME']/@val"/>

    <!-- VALUES-->
    <xsl:variable name="anaval1">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='SM2_ANALOG']/@val"/>
        <xsl:with-param name="unit" select="value[@name='SM2_UNIT1x']/@val"/>
        <xsl:with-param name="precision" select="1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="anaval2">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='SM2_ANALOG']/@val2"/>
        <xsl:with-param name="unit" select="value[@name='SM2_UNIT2x']/@val"/>
        <xsl:with-param name="precision" select="1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="anaval3">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='SM2_ANALOG']/@val3"/>
        <xsl:with-param name="unit" select="value[@name='SM2_UNIT3x']/@val"/>
        <xsl:with-param name="precision" select="1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="anaval4">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='SM2_ANALOG']/@val4"/>
        <xsl:with-param name="unit" select="value[@name='SM2_UNIT4x']/@val"/>
        <xsl:with-param name="precision" select="1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="anaval5">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='SM2_ANALOG']/@val5"/>
        <xsl:with-param name="unit" select="value[@name='SM2_UNIT5x']/@val"/>
        <xsl:with-param name="precision" select="1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="anaval6">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='SM2_ANALOG']/@val6"/>
        <xsl:with-param name="unit" select="value[@name='SM2_UNIT6x']/@val"/>
        <xsl:with-param name="precision" select="1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="anaval7">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='SM2_ANALOG']/@val7"/>
        <xsl:with-param name="unit" select="value[@name='SM2_UNIT7x']/@val"/>
        <xsl:with-param name="precision" select="1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="anaval8">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='SM2_ANALOG']/@val8"/>
        <xsl:with-param name="unit" select="value[@name='SM2_UNIT8x']/@val"/>
        <xsl:with-param name="precision" select="1"/>
      </xsl:call-template>
    </xsl:variable>


    <!-- MODEL -->
    <div class="LargeBold" style="position: absolute; left: 35px; top: 75px; width: 714px; height: 17px; text-align:center">
      <xsl:value-of select="value[@name='MODEL']/@val" />
    </div>


    <!-- STATUS LEDs-->
    <xsl:variable name="xOffset" select="40"/>
    <xsl:variable name="xGroupOffset" select="230"/>
    <xsl:variable name="yOffset" select="42"/>
    <xsl:variable name="firstRowY"  select="135"/>
    <xsl:variable name="secondRowY" select="$firstRowY + $yOffset"/>
    <xsl:variable name="firstGroupX" select="90"/>
    <xsl:variable name="secondGroupX" select="$firstGroupX + $xGroupOffset"/>
    <xsl:variable name="thirdGroupX" select="$secondGroupX + $xGroupOffset"/>

    <xsl:call-template name="siteman-led-group">
      <xsl:with-param name="x" select="$firstGroupX"/>
      <xsl:with-param name="y" select="$firstRowY"/>
      <xsl:with-param name="val" select="value[@name='SM2_DIGITAL_OUT']/@val"/>
      <xsl:with-param name="count" select="0"/>
      <xsl:with-param name="maxcount" select="8"/>
      <xsl:with-param name="rowcount" select="4"/>
      <xsl:with-param name="xOffset" select="$xOffset"/>
      <xsl:with-param name="yOffset" select="$yOffset"/>
      <xsl:with-param name="headline" select="'Digitale Ausg&#228;nge'"/>
      <xsl:with-param name="logic" select="0"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="id"   select="'digiout_id'"/>
    </xsl:call-template>

    <xsl:call-template name="siteman-led-group">
      <xsl:with-param name="x" select="$secondGroupX"/>
      <xsl:with-param name="y" select="$firstRowY"/>
      <xsl:with-param name="val" select="value[@name='SM2_DIGITAL_ALARMS']/@val"/>
      <xsl:with-param name="count" select="0"/>
      <xsl:with-param name="maxcount" select="8"/>
      <xsl:with-param name="rowcount" select="4"/>
      <xsl:with-param name="xOffset" select="$xOffset"/>
      <xsl:with-param name="yOffset" select="$yOffset"/>
      <xsl:with-param name="use" select="value[@name='SM2_USE_DIGITAL_ALARM']/@val"/>
      <xsl:with-param name="headline" select="'Digitale Eing&#228;nge'"/>
      <xsl:with-param name="logic" select="1"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="id"   select="'digiin_id'"/>
    </xsl:call-template>
    <xsl:variable name="use-analog-alarms">
      <xsl:call-template name="bit-or">
        <xsl:with-param name="val1" select="value[@name='SM2_USE_ANALOG_ALARM_HI']/@val"/>
        <xsl:with-param name="val2" select="value[@name='SM2_USE_ANALOG_ALARM_LO']/@val"/>
        <xsl:with-param name="places" select="8"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:call-template name="siteman-led-group">
      <xsl:with-param name="x" select="$thirdGroupX"/>
      <xsl:with-param name="y" select="$firstRowY"/>
      <xsl:with-param name="val" select="value[@name='SM2_ANALOG_ALARMS']/@val"/>
      <xsl:with-param name="count" select="0"/>
      <xsl:with-param name="maxcount" select="8"/>
      <xsl:with-param name="rowcount" select="4"/>
      <xsl:with-param name="xOffset" select="$xOffset"/>
      <xsl:with-param name="yOffset" select="$yOffset"/>
      <xsl:with-param name="use" select="$use-analog-alarms"/>
      <xsl:with-param name="headline" select="'Analoge Alarme'"/>
      <xsl:with-param name="logic" select="1"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="id"   select="'analogalarm_id'"/>
    </xsl:call-template>

    <!--	<div id="valueshead" style="position:absolute; top:{$firstRowY+135}px; left: {$secondGroupX - 35}px; width:220px;height:15px; clip:rect(0 220 18 0);background-color:#3F5987; color:#ffffff;text-align:left;padding:1px;" class="MediumBold"><xsl:value-of select="$lang-Values"/></div>
-->
    <div id="values" style="position:absolute; left: 30px; top:{$firstRowY+130}px; width:728px">
      <div align="center" >
        <table cellspacing="1" border="0" cellpadding="1">
          <tr>
            <td colspan="2" style="background-color:#3F5987; color:#ffffff;text-align:left;height:18px;" class="MediumBold">
              <xsl:value-of select="$lang-SM2-Values"/>
            </td>
          </tr>
          <tr>
            <td class="tdMediumSmallBoldGrey" style="text-align:left;padding-left:3px;padding-right:3px;padding-top:1px;padding-bottom:1px;" onMouseOver="TTshow('analogthres1')" onMouseOut="TThide()">
              <xsl:value-of select="$analog1"/>
            </td>
            <td class="tdMediumSmallBoldGrey" style="text-align:right;padding-left:3px;padding-right:3px;padding-top:1px;padding-bottom:1px;" onMouseOver="TTshow('analogthres1')" onMouseOut="TThide()">
              <xsl:value-of select="$anaval1"/>
            </td>
          </tr>
          <tr >
            <td class="tdMediumSmallBold" style="text-align:left;padding-left:3px;padding-right:3px;padding-top:1px;padding-bottom:1px;" onMouseOver="TTshow('analogthres2')" onMouseOut="TThide()">
              <xsl:value-of select="$analog2"/>
            </td>
            <td class="tdMediumSmallBold" style="text-align:right;padding-left:3px;padding-right:3px;padding-top:1px;padding-bottom:1px;" onMouseOver="TTshow('analogthres2')" onMouseOut="TThide()">
              <xsl:value-of select="$anaval2"/>
            </td>
          </tr>
          <tr>
            <td class="tdMediumSmallBoldGrey" style="text-align:left;padding-left:3px;padding-right:3px;padding-top:1px;padding-bottom:1px" onMouseOver="TTshow('analogthres3')" onMouseOut="TThide()">
              <xsl:value-of select="$analog3"/>
            </td>
            <td class="tdMediumSmallBoldGrey" style="text-align:right;padding-left:3px;padding-right:3px;padding-top:1px;padding-bottom:1px" onMouseOver="TTshow('analogthres3')" onMouseOut="TThide()">
              <xsl:value-of select="$anaval3"/>
            </td>
          </tr>
          <tr>
            <td class="tdMediumSmallBold" style="text-align:left;padding-left:3px;padding-right:3px;padding-top:1px;padding-bottom:1px" onMouseOver="TTshow('analogthres4')" onMouseOut="TThide()">
              <xsl:value-of select="$analog4"/>
            </td>
            <td class="tdMediumSmallBold" style="text-align:right;padding-left:3px;padding-right:3px;padding-top:1px;padding-bottom:1px" onMouseOver="TTshow('analogthres4')" onMouseOut="TThide()">
              <xsl:value-of select="$anaval4"/>
            </td>
          </tr>
          <tr>
            <td class="tdMediumSmallBoldGrey" style="text-align:left;padding-left:3px;padding-right:3px;padding-top:1px;padding-bottom:1px" onMouseOver="TTshow('analogthres5')" onMouseOut="TThide()">
              <xsl:value-of select="$analog5"/>
            </td>
            <td class="tdMediumSmallBoldGrey" style="text-align:right;padding-left:3px;padding-right:3px;padding-top:1px;padding-bottom:1px" onMouseOver="TTshow('analogthres5')" onMouseOut="TThide()">
              <xsl:value-of select="$anaval5"/>
            </td>
          </tr>
          <tr>
            <td class="tdMediumSmallBold" style="text-align:left;padding-left:3px;padding-right:3px;padding-top:1px;padding-bottom:1px" onMouseOver="TTshow('analogthres6')" onMouseOut="TThide()">
              <xsl:value-of select="$analog6"/>
            </td>
            <td class="tdMediumSmallBold" style="text-align:right;padding-left:3px;padding-right:3px;padding-top:1px;padding-bottom:1px" onMouseOver="TTshow('analogthres6')" onMouseOut="TThide()">
              <xsl:value-of select="$anaval6"/>
            </td>
          </tr>
          <tr>
            <td class="tdMediumSmallBoldGrey" style="text-align:left;padding-left:3px;padding-right:3px;padding-top:1px;padding-bottom:1px" onMouseOver="TTshow('analogthres7')" onMouseOut="TThide()">
              <xsl:value-of select="$analog7"/>
            </td>
            <td class="tdMediumSmallBoldGrey" style="text-align:right;padding-left:3px;padding-right:3px;padding-top:1px;padding-bottom:1px" onMouseOver="TTshow('analogthres7')" onMouseOut="TThide()">
              <xsl:value-of select="$anaval7"/>
            </td>
          </tr>
          <tr>
            <td class="tdMediumSmallBold" style="text-align:left;padding-left:3px;padding-right:3px;padding-top:1px;padding-bottom:1px" onMouseOver="TTshow('analogthres8')" onMouseOut="TThide()">
              <xsl:value-of select="$analog8"/>
            </td>
            <td class="tdMediumSmallBold" style="text-align:right;padding-left:3px;padding-right:3px;padding-top:1px;padding-bottom:1px" onMouseOver="TTshow('analogthres8')" onMouseOut="TThide()">
              <xsl:value-of select="$anaval8"/>
            </td>
          </tr>
        </table>
      </div>
    </div>

    <!-- TESTVAL-->
    <!--
	<div class="LargeBold" style="position: absolute; left: 60px; top: 310px; width: 163px; height: 17px; text-align:center">
		<xsl:value-of select="$overtemp1" />
	</div>
	-->

    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="1"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="name" select="value[@name='SM_O1NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="2"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="name" select="value[@name='SM_O2NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="3"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="name" select="value[@name='SM_O3NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="4"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="name" select="value[@name='SM_O4NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="5"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="name" select="value[@name='SM_O5NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="6"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="name" select="value[@name='SM_O6NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="7"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="name" select="value[@name='SM_O7NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="8"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="name" select="value[@name='SM_O8NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="1"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="name" select="value[@name='SM_D1NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="2"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="name" select="value[@name='SM_D2NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="3"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="name" select="value[@name='SM_D3NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="4"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="name" select="value[@name='SM_D4NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="5"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="name" select="value[@name='SM_D5NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="6"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="name" select="value[@name='SM_D6NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="7"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="name" select="value[@name='SM_D7NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="8"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="name" select="value[@name='SM_D8NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="1"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="name" select="$analog1"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="2"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="name" select="$analog2"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="3"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="name" select="$analog3"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="4"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="name" select="$analog4"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="5"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="name" select="$analog5"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="6"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="name" select="$analog6"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="7"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="name" select="$analog7"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="8"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="name" select="$analog8"/>
    </xsl:call-template>
    <xsl:call-template name="analogthres">
      <xsl:with-param name="id" select="1"/>
      <xsl:with-param name="lo" select="value[@name='SM2_ANALOG_LO_THRES']/@val"/>
      <xsl:with-param name="hi" select="value[@name='SM2_ANALOG_HI_THRES']/@val"/>
      <xsl:with-param name="name" select="$analog1"/>
      <xsl:with-param name="val" select="$anaval1"/>
    </xsl:call-template>
    <xsl:call-template name="analogthres">
      <xsl:with-param name="id" select="2"/>
      <xsl:with-param name="lo" select="value[@name='SM2_ANALOG_LO_THRES']/@val2"/>
      <xsl:with-param name="hi" select="value[@name='SM2_ANALOG_HI_THRES']/@val2"/>
      <xsl:with-param name="name" select="$analog2"/>
      <xsl:with-param name="val" select="$anaval2"/>
    </xsl:call-template>
    <xsl:call-template name="analogthres">
      <xsl:with-param name="id" select="3"/>
      <xsl:with-param name="lo" select="value[@name='SM2_ANALOG_LO_THRES']/@val3"/>
      <xsl:with-param name="hi" select="value[@name='SM2_ANALOG_HI_THRES']/@val3"/>
      <xsl:with-param name="name" select="$analog3"/>
      <xsl:with-param name="val" select="$anaval3"/>
    </xsl:call-template>
    <xsl:call-template name="analogthres">
      <xsl:with-param name="id" select="4"/>
      <xsl:with-param name="lo" select="value[@name='SM2_ANALOG_LO_THRES']/@val4"/>
      <xsl:with-param name="hi" select="value[@name='SM2_ANALOG_HI_THRES']/@val4"/>
      <xsl:with-param name="name" select="$analog4"/>
      <xsl:with-param name="val" select="$anaval4"/>
    </xsl:call-template>
    <xsl:call-template name="analogthres">
      <xsl:with-param name="id" select="5"/>
      <xsl:with-param name="lo" select="value[@name='SM2_ANALOG_LO_THRES']/@val5"/>
      <xsl:with-param name="hi" select="value[@name='SM2_ANALOG_HI_THRES']/@val5"/>
      <xsl:with-param name="name" select="$analog5"/>
      <xsl:with-param name="val" select="$anaval5"/>
    </xsl:call-template>
    <xsl:call-template name="analogthres">
      <xsl:with-param name="id" select="6"/>
      <xsl:with-param name="lo" select="value[@name='SM2_ANALOG_LO_THRES']/@val6"/>
      <xsl:with-param name="hi" select="value[@name='SM2_ANALOG_HI_THRES']/@val6"/>
      <xsl:with-param name="name" select="$analog6"/>
      <xsl:with-param name="val" select="$anaval6"/>
    </xsl:call-template>
    <xsl:call-template name="analogthres">
      <xsl:with-param name="id" select="7"/>
      <xsl:with-param name="lo" select="value[@name='SM2_ANALOG_LO_THRES']/@val7"/>
      <xsl:with-param name="hi" select="value[@name='SM2_ANALOG_HI_THRES']/@val7"/>
      <xsl:with-param name="name" select="$analog7"/>
      <xsl:with-param name="val" select="$anaval7"/>
    </xsl:call-template>
    <xsl:call-template name="analogthres">
      <xsl:with-param name="id" select="8"/>
      <xsl:with-param name="lo" select="value[@name='SM2_ANALOG_LO_THRES']/@val8"/>
      <xsl:with-param name="hi" select="value[@name='SM2_ANALOG_HI_THRES']/@val8"/>
      <xsl:with-param name="name" select="$analog8"/>
      <xsl:with-param name="val" select="$anaval8"/>
    </xsl:call-template>


  </xsl:template>


  <!-- LOCAL TEMPLATE DEFINITIONS-->


  <!-- EOS -->
</xsl:stylesheet>
