<?xml version="1.0"?>
<!--
   sitemon_panel.xsl - AUX-Device (former DIESEL) UPS screen @UNMS-II.
   Copyright (c) 2005, Generex GmbH. All rights reserved.
   klaus
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!-- Methods -->
  <!--Header-->
  <xsl:template name="sitemon_panel-header">
    <xsl:call-template name="app-header">
      <xsl:with-param name="top" select="3"/>
    </xsl:call-template>
  </xsl:template>

  <!--Footer-->
  <xsl:template name="sitemon_panel-footer" >
    <xsl:call-template name="app-footer" >
      <xsl:with-param name="left" select="24"/>
      <xsl:with-param name="top" select="490"/>
      <xsl:with-param name="width" select="752"/>
      <xsl:with-param name="height" select="62"/>
    </xsl:call-template>
  </xsl:template>
  <!--Menu-->
  <xsl:template name="sitemon_panel-menu">
    <xsl:call-template name="app-menu">
      <xsl:with-param name="top" select="428"/>
      <xsl:with-param name="left" select="0"/>
      <xsl:with-param name="width" select="0"/>
      <xsl:with-param name="height" select="0"/>
      <xsl:with-param name="class" select="'XBold_black'"/>
    </xsl:call-template>
  </xsl:template>

  <!--Body-->
  <xsl:template name="sitemon_panel-body">
    <xsl:call-template name="background">
      <xsl:with-param name="imagepath" select="'./lib/ups/image/ups/empty.png'"/>
      <xsl:with-param name="x" select="'0'"/>
      <xsl:with-param name="y" select="'0'"/>
      <xsl:with-param name="w" select="'792'"/>
      <xsl:with-param name="h" select="'485'"/>
      <xsl:with-param name="border" select="0"/>
      <xsl:with-param name="id" select="'background'"/>
    </xsl:call-template>
    <xsl:apply-templates />
    <xsl:call-template name="IEpixelBugfixCall"/>
    <xsl:call-template name="js_refresh_call">
      <xsl:with-param	 name="timeout" select="1000*//report/@refresh"/>
    </xsl:call-template>
  </xsl:template>

  <!-- Implementation -->
  <xsl:template match="values">
    <!-- MODEL -->
    <div class="LargeBold" style="position: absolute; left: 35px; top: 75px; width: 714px; height: 17px; text-align:center">
      <xsl:value-of select="value[@name='MODEL']/@val" />
    </div>
    <!-- STATUS -->
    <xsl:variable name="state" select="value[@name='SMON2_STATUS']/@val"/>

    <!-- Bits masked -->
    <xsl:variable name="bitlogic">
      <xsl:value-of select="'green,red'"/>
    </xsl:variable>


    <div id="manual_switch" style="position:absolute; left:271px; top:200px;width:32px;" class="SmallBold">
      <xsl:call-template name="auxdev-led">
        <xsl:with-param name="color-scheme" select="$bitlogic"/>
        <xsl:with-param name="state" select="$state"/>
        <xsl:with-param name="start-bit" select="0"/>
        <xsl:with-param name="count-bits" select="1"/>
      </xsl:call-template>
    </div>
    <script type="text/javascript"> translate_text('manual_switch', 'Manual Switch');</script>

    <div id="magnetic_contact" style="position:absolute; left:350px; top:178px;width:32px" class="SmallBold">
      <xsl:call-template name="auxdev-led">
        <xsl:with-param name="color-scheme" select="$bitlogic"/>
        <xsl:with-param name="state" select="$state"/>
        <xsl:with-param name="start-bit" select="1"/>
        <xsl:with-param name="count-bits" select="1"/>
      </xsl:call-template>
    </div>
    <script type="text/javascript"> translate_text('magnetic_contact', 'Magnetic Contact');</script>

    <div style="position:absolute; left:504px; top:131px;width:32px" class="SmallBold">
      <xsl:call-template name="auxdev-led">
        <xsl:with-param name="color-scheme" select="$bitlogic"/>
        <xsl:with-param name="state" select="$state"/>
        <xsl:with-param name="start-bit" select="2"/>
        <xsl:with-param name="count-bits" select="1"/>
      </xsl:call-template>
    </div>
    <script type="text/javascript"> translate_text('motion_sensor', 'Motion Sensor');</script>

  </xsl:template>

  <xsl:template name="auxdev-led">
    <xsl:param name="state" select="0"/>
    <xsl:param name="start-bit" select="1"/>
    <xsl:param name="count-bits" select="1"/>
    <xsl:param name="color-scheme" select="'gray,gray'"/>
    <xsl:call-template name="generic-led">
      <xsl:with-param name="color-scheme" select="$color-scheme"/>
      <xsl:with-param name="state" select="$state"/>
      <xsl:with-param name="start-bit" select="$start-bit"/>
      <xsl:with-param name="count-bits" select="$count-bits"/>
      <xsl:with-param name="path" select="'../img/'"/>
      <xsl:with-param name="prefix" select="'zone2_'"/>
      <xsl:with-param name="extension" select="'.gif'"/>
      <xsl:with-param name="width" select="12"/>
      <xsl:with-param name="height" select="12"/>
    </xsl:call-template>

  </xsl:template>

  <!-- EOS -->
</xsl:stylesheet>



