<?xml version="1.0"?>
<!--
   nrekom.xsl - OEM UPS screen for BREKOM@UNMS-II.
   Copyright (c) 2005, Generex GmbH. All rights reserved.
   klaus
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:import href="./../language.xsl"/>
  <xsl:import href="./../xsl_util.xsl"/>
  <xsl:import href="./../js_util.xsl"/>
  <xsl:import href="./../web_common.xsl"/>
  <xsl:import href="./../panes.xsl"/>
  <xsl:import href="./../valuebar.xsl"/>
  <xsl:import href="../app/common.xsl"/>
  <xsl:import href="./../ups/xseriescommon.xsl"/>


  <xsl:output method="xml" indent="yes" omit-xml-declaration="yes" encoding="ISO-8859-1"/>

  <xsl:variable name="headerY" select="227"/>


  <xsl:template match="/">

    <html>
      <head>
        <meta http-equiv="content-type" contEnt="text/html; charset=ISO-8859-1" />
        <meta http-equiv="expires" content="0" />
        <meta name="robots" content="noindex" />
        <meta name="generator" content="GENEREX Network Management System" />
        <link rel="stylesheet" type="text/css" href="./lib/css.css" />
        <script type="text/javascript" src="./lib/app/app_utils.js"></script>
        <title>NMS Web Client</title>
        <xsl:call-template name="set_css"/>

        <xsl:call-template name="IEpixelBugfixDef">
          <xsl:with-param name="pixels" select="0"/>
        </xsl:call-template>
        <xsl:call-template name="popup"/>
        <xsl:call-template name="js_refresh_def"/>
        <xsl:call-template name="js_tooltips_def"/>
        <xsl:call-template name="js_selection">
          <xsl:with-param name="pageCount" select="3"/>
        </xsl:call-template>
        <script type="text/javascript">
          <xsl:comment>
            <![CDATA[ 
      function setBrekomSelection(newSelection)
      {
        setSelection(newSelection);
        
        for(i = 0; i<3; ++i){
          panel = document.getElementById("screen" + eval(i + 1));
          if(panel){
          
            if(i == newSelection){
             panel.style.backgroundColor = "#ffffff";             
            }
            else{
             panel.style.backgroundColor = "#3F5987";
            }
          }
         }
        
        for(i = 0; ;++i){					
          a = document.getElementsByTagName("a")[i];
          if(!a) break;
          hr = a.getAttribute("id");
          if(hr && hr.indexOf("sel") == 0 && hr.length == 4){
            idx = hr.substr(3,1);
            if(idx == newSelection){
              a.style.color = "#3F5987";             
            }
            else{
              a.style.color = "#ffffff";
            }
            
          }
        }
        
      }
      function escapeQuestionMark(str)
      {
        var ret = ""        
        for (i = 0; i< str.length; ++i){
          if(str.charAt(i) == '?'){
            ret += "%3F";
          }
          else{
            ret += str.charAt(i);
          }
        }
        return ret;
      }
      function sm2cmd(cmd, num, val, refoid, cmdmsg, bWithComment)
      {
      	cmdmsg =escape(cmdmsg);
        var href= "nmsView.dll?upscmd=UPS_EXE_COMMAND%20[" + cmd + "][" + num + "," + val + "]&refoid="+ refoid+"&cmdmsg="+cmdmsg;
        //alert(href);
				if(!bWithComment){
	        href= "nmsView.dll?upscmd=UPS_EXE_COMMAND%20[" + cmd + "][" + num + "," + val + "]&refoid="+ refoid+"&cmdmsg="+cmdmsg;
				}
				else{
	        href= "nmsView.dll?atxt&type=cmd&upscmd=UPS_EXE_COMMAND%20[" + cmd + "][" + num + "," + val + "]&refoid="+ refoid+"&cmdmsg="+cmdmsg;
				
				}
				location.replace(href);
      }
      /*
      function sm2cmd(cmd, num, val, ip)
      {
        var href= "cmd=" + cmd + "&num=" + num + "&val=" + val + "&ip="+ ip;
        //alert(dummy);
        //location.href = href;
        sm2cmdPopup(href);    
      } 
      */
      var fenster = 0;
			function sm2cmdPopup(query)
			{
				fenster=window.open("sm2cmd.htm?"+query,"sm2cmd","width=280,height=230,status=no,resizable=no");
			  fenster.focus();
			}
    	]]>
          </xsl:comment>
        </script>

      </head>
      <body leftmargin="0" topmargin="0" marginheight="0" marginwidth="0">

        <xsl:call-template name="app-notifier">
          <xsl:with-param name="popup" select="//popup"/>
        </xsl:call-template>

        <xsl:call-template name="background">
          <xsl:with-param name="imagepath" select="'./lib/ups/image/ups/empty.png'"/>
          <xsl:with-param name="x" select="'0'"/>
          <xsl:with-param name="y" select="'0'"/>
          <xsl:with-param name="w" select="'792'"/>
          <xsl:with-param name="h" select="'485'"/>
          <xsl:with-param name="border" select="0"/>
          <xsl:with-param name="id" select="'background'"/>
        </xsl:call-template>

        <xsl:call-template name="headline">
          <xsl:with-param name="top" select="3"/>
          <xsl:with-param name="zonename" select="//zone/@name"/>
          <xsl:with-param name="servicename" select="//service/@name"/>
          <xsl:with-param name="ip-address" select="//host/@address"/>
        </xsl:call-template>

        <xsl:call-template name="app-footer">
          <xsl:with-param name="top" select="480"/>
        </xsl:call-template>

        <div id="valueshead1" style="position:absolute; top:{$headerY}px; left:60px;width:180px;height:26; clip:rect(0 180 23 0);background-color:#3F5987; color:#ffffff;text-align:left;padding:3px;" class="MediumBold">
         <script type="text/javascript"> translate_text("valueshead1", '<xsl:value-of select="$lang-UPS-Values"/>');</script>
        </div>
        <div id="valueshead2" style="position:absolute; top:{$headerY}px; left:240px;width:160px;height:26; clip:rect(0 140 23 0);background-color:#3F5987; color:#ffffff;text-align:left;padding:3px;" class="MediumBold">
         <script type="text/javascript"> translate_text("valueshead2", '<xsl:value-of select="$lang-SM2-Values"/>');</script>
        </div>
        <div id="screenhead" style="position:absolute; top:{$headerY}px; left:409px;width:320px;height:26; clip:rect(0 320 23 0);background-color:#3F5987; color:#ffffff;text-align:left;padding:3px;" class="MediumBold">
          <script type="text/javascript"> translate_text("screenhead", '<xsl:value-of select="$lang-Selection"/>');</script>
        </div>
        <div id="screen1"    style="position:absolute; top:{$headerY + 3}px; left:480px;width:13px;height:16px;clip:rect(0 16 16 0);background-color:#3F5987; text-align:center;">
          <a id="sel0" href="javascript:setBrekomSelection(0)" class="MediumBold" style="color:#ffffff;text-decoration:none;">1</a>
        </div>
        <div id="screen2"    style="position:absolute; top:{$headerY + 3}px; left:500px;width:13px;clip:rect(0 16 16 0);background-color:#3F5987; text-align:center;">
          <a id="sel1" href="javascript:setBrekomSelection(1)" class="MediumBold" style="color:#ffffff;text-decoration:none;">2</a>
        </div>
        <div id="screen3"    style="position:absolute; top:{$headerY + 3}px; left:520px;width:13px;clip:rect(0 16 16 0);background-color:#3F5987; text-align:center;">
          <a id="sel2" href="javascript:setBrekomSelection(2)" class="MediumBold" style="color:#ffffff;text-decoration:none;">3</a>
        </div>
        <xsl:apply-templates />

        <xsl:call-template name="IEpixelBugfixCall"/>
        <script type="text/javascript">
          init();
          setBrekomSelection(selection);
        </script>
        <xsl:call-template name="js_refresh_call">
          <xsl:with-param	 name="timeout" select="1000*//report/@refresh"/>
        </xsl:call-template>

      </body>
    </html>
  </xsl:template>

  <xsl:template match="values">

    <!-- VALUES-->
    <!-- <xsl:variable name="analog1" select="value[@name='SM_A1NAME']/@val"/>-->
    <xsl:variable name="analog1">
      <xsl:call-template name="cut-string">
        <xsl:with-param name="input-string" select="value[@name='SM_A1NAME']/@val"/>
        <xsl:with-param name="length" select="20"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="analog2">
      <xsl:call-template name="cut-string">
        <xsl:with-param name="input-string" select="value[@name='SM_A2NAME']/@val"/>
        <xsl:with-param name="length" select="20"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="analog3">
      <xsl:call-template name="cut-string">
        <xsl:with-param name="input-string" select="value[@name='SM_A3NAME']/@val"/>
        <xsl:with-param name="length" select="20"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="analog4">
      <xsl:call-template name="cut-string">
        <xsl:with-param name="input-string" select="value[@name='SM_A4NAME']/@val"/>
        <xsl:with-param name="length" select="20"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="analog5">
      <xsl:call-template name="cut-string">
        <xsl:with-param name="input-string" select="value[@name='SM_A5NAME']/@val"/>
        <xsl:with-param name="length" select="20"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="analog6">
      <xsl:call-template name="cut-string">
        <xsl:with-param name="input-string" select="value[@name='SM_A6NAME']/@val"/>
        <xsl:with-param name="length" select="20"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="analog7">
      <xsl:call-template name="cut-string">
        <xsl:with-param name="input-string" select="value[@name='SM_A7NAME']/@val"/>
        <xsl:with-param name="length" select="20"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="analog8">
      <xsl:call-template name="cut-string">
        <xsl:with-param name="input-string" select="value[@name='SM_A8NAME']/@val"/>
        <xsl:with-param name="length" select="20"/>
      </xsl:call-template>
    </xsl:variable>

    <div id="config" style="position:absolute; top:76px; left:658px; " >
      <a id="config_1" class="SmallBoldLink" href="http://{//host/@address}/admin/sman2.shtml" border="0"  target="_blank">
        <script type="text/javascript"> translate_text("config_1", '<xsl:value-of select="$lang-Configuration"/>');</script>
      </a>
    </div>

    <!-- MODEL -->
    <div class="LargeBold" style="position: absolute; left: 35px; top: 75px; width: 714px; height: 17px; text-align:center">
      <xsl:value-of select="value[@name='MODEL']/@val" />
    </div>


    <!-- STATUS LEDs-->
    <xsl:variable name="xOffset" select="40"/>
    <xsl:variable name="xGroupOffset" select="230"/>
    <xsl:variable name="yOffset" select="42"/>
    <xsl:variable name="firstRowY"  select="105"/>
    <xsl:variable name="secondRowY" select="$firstRowY + $yOffset"/>
    <xsl:variable name="firstGroupX" select="90"/>
    <xsl:variable name="secondGroupX" select="$firstGroupX + $xGroupOffset"/>
    <xsl:variable name="thirdGroupX" select="$secondGroupX + $xGroupOffset"/>

    <xsl:call-template name="siteman-led-group">
      <xsl:with-param name="x" select="$firstGroupX"/>
      <xsl:with-param name="y" select="$firstRowY"/>
      <xsl:with-param name="val" select="value[@name='SM2_DIGITAL_OUT']/@val"/>
      <xsl:with-param name="count" select="0"/>
      <xsl:with-param name="maxcount" select="8"/>
      <xsl:with-param name="rowcount" select="4"/>
      <xsl:with-param name="xOffset" select="$xOffset"/>
      <xsl:with-param name="yOffset" select="$yOffset"/>
      <xsl:with-param name="headline" select="$lang-digital-Out"/>
      <xsl:with-param name="logic" select="0"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="id"   select="'digiout_1'"/>
    </xsl:call-template>

    <xsl:call-template name="siteman-led-group">
      <xsl:with-param name="x" select="$secondGroupX"/>
      <xsl:with-param name="y" select="$firstRowY"/>
      <xsl:with-param name="val" select="value[@name='SM2_DIGITAL_ALARMS']/@val"/>
      <xsl:with-param name="count" select="0"/>
      <xsl:with-param name="maxcount" select="8"/>
      <xsl:with-param name="rowcount" select="4"/>
      <xsl:with-param name="xOffset" select="$xOffset"/>
      <xsl:with-param name="yOffset" select="$yOffset"/>
      <xsl:with-param name="use" select="value[@name='SM2_USE_DIGITAL_ALARM']/@val"/>
      <xsl:with-param name="headline" select="$lang-digital-In"/>
      <xsl:with-param name="logic" select="1"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="id"   select="'digiin_1'"/>
    </xsl:call-template>
    <xsl:variable name="use-analog-alarms">
      <xsl:call-template name="bit-or">
        <xsl:with-param name="val1" select="value[@name='SM2_USE_ANALOG_ALARM_HI']/@val"/>
        <xsl:with-param name="val2" select="value[@name='SM2_USE_ANALOG_ALARM_LO']/@val"/>
        <xsl:with-param name="places" select="8"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:call-template name="siteman-led-group">
      <xsl:with-param name="x" select="$thirdGroupX"/>
      <xsl:with-param name="y" select="$firstRowY"/>
      <xsl:with-param name="val" select="value[@name='SM2_ANALOG_ALARMS']/@val"/>
      <xsl:with-param name="count" select="0"/>
      <xsl:with-param name="maxcount" select="8"/>
      <xsl:with-param name="rowcount" select="4"/>
      <xsl:with-param name="xOffset" select="$xOffset"/>
      <xsl:with-param name="yOffset" select="$yOffset"/>
      <xsl:with-param name="use" select="$use-analog-alarms"/>
      <xsl:with-param name="headline" select="$lang-Analog-Alarms"/>
      <xsl:with-param name="logic" select="1"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="id"   select="'analogalarm_1'"/>
    </xsl:call-template>

    <!-- TESTVAL-->
    <!--
	<div class="LargeBold" style="position: absolute; left: 60px; top: 310px; width: 163px; height: 17px; text-align:center">
		<xsl:value-of select="$overtemp1" />
	</div>
	-->
    <xsl:variable name="involt">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='INVOLT']/@val"/>
        <xsl:with-param name="unit" select="'V'"/>
        <xsl:with-param name="precision" select="0"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="outputvolt">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='OUTPUT_VOLT']/@val"/>
        <xsl:with-param name="unit" select="'V'"/>
        <xsl:with-param name="precision" select="0"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="infreq">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='INFREQ']/@val"/>
        <xsl:with-param name="unit" select="'Hz'"/>
        <xsl:with-param name="precision" select="0"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="outfreq">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='OUTFREQ']/@val"/>
        <xsl:with-param name="unit" select="'Hz'"/>
        <xsl:with-param name="precision" select="0"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="outpower">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='OUTPOWER']/@val"/>
        <xsl:with-param name="unit" select="'%'"/>
        <xsl:with-param name="precision" select="0"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="battvolt">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='BATTVOLT']/@val"/>
        <xsl:with-param name="unit" select="'V'"/>
        <xsl:with-param name="precision" select="0"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="battcap">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='BATTCAP']/@val"/>
        <xsl:with-param name="unit" select="'%'"/>
        <xsl:with-param name="decimal-places" select="0"/>
        <xsl:with-param name="precision" select="0"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="tempdeg">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='TEMPDEG']/@val"/>
        <xsl:with-param name="unit" select="'&#176;C'"/>
        <xsl:with-param name="precision" select="0"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="avgbattemp">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='AVGBATTEMP']/@val"/>
        <xsl:with-param name="unit" select="'&#176;C'"/>
        <xsl:with-param name="precision" select="0"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="avgdays">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='AVGDAYS']/@val"/>
        <xsl:with-param name="unit" select="$lang-Days"/>
        <xsl:with-param name="precision" select="0"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="autonomtime">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='AUTONOMTIME']/@val"/>
        <xsl:with-param name="unit" select="'min'"/>
        <xsl:with-param name="precision" select="0"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="batterylife">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='BATERYLIFE']/@val"/>
        <xsl:with-param name="unit" select="'Mon.'"/>
        <xsl:with-param name="precision" select="0"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="anaval1">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='SM2_ANALOG']/@val"/>
        <xsl:with-param name="unit" select="value[@name='SM2_UNIT1x']/@val"/>
        <xsl:with-param name="precision" select="1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="anaval2">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='SM2_ANALOG']/@val2"/>
        <xsl:with-param name="unit" select="value[@name='SM2_UNIT2x']/@val"/>
        <xsl:with-param name="precision" select="1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="anaval3">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='SM2_ANALOG']/@val3"/>
        <xsl:with-param name="unit" select="value[@name='SM2_UNIT3x']/@val"/>
        <xsl:with-param name="precision" select="1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="anaval4">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='SM2_ANALOG']/@val4"/>
        <xsl:with-param name="unit" select="value[@name='SM2_UNIT4x']/@val"/>
        <xsl:with-param name="precision" select="1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="anaval5">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='SM2_ANALOG']/@val5"/>
        <xsl:with-param name="unit" select="value[@name='SM2_UNIT5x']/@val"/>
        <xsl:with-param name="precision" select="1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="anaval6">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='SM2_ANALOG']/@val6"/>
        <xsl:with-param name="unit" select="value[@name='SM2_UNIT6x']/@val"/>
        <xsl:with-param name="precision" select="1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="anaval7">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='SM2_ANALOG']/@val7"/>
        <xsl:with-param name="unit" select="value[@name='SM2_UNIT7x']/@val"/>
        <xsl:with-param name="precision" select="1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="anaval8">
      <xsl:call-template name="get-value">
        <xsl:with-param name="value" select="value[@name='SM2_ANALOG']/@val8"/>
        <xsl:with-param name="unit" select="value[@name='SM2_UNIT8x']/@val"/>
        <xsl:with-param name="precision" select="1"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="anaunit1" select="value[@name='SM2_UNIT1x']/@val"/>
    <xsl:variable name="anaunit2" select="value[@name='SM2_UNIT2x']/@val"/>
    <xsl:variable name="anaunit3" select="value[@name='SM2_UNIT3x']/@val"/>
    <xsl:variable name="anaunit4" select="value[@name='SM2_UNIT4x']/@val"/>
    <xsl:variable name="anaunit5" select="value[@name='SM2_UNIT5x']/@val"/>
    <xsl:variable name="anaunit6" select="value[@name='SM2_UNIT6x']/@val"/>
    <xsl:variable name="anaunit7" select="value[@name='SM2_UNIT7x']/@val"/>
    <xsl:variable name="anaunit8" select="value[@name='SM2_UNIT8x']/@val"/>
    <div id="values" style="position:absolute; left: 60px; top:{$headerY+23}px; width:320px; height:200px;Overflow:auto;">
      <table width="320" cellspacing="1" border="0" cellpadding="1">
        <tr>
          <td id="inp_volt_1" class="tdMediumSmallBoldGrey" style="text-align:left;width:120px;">
            <script type="text/javascript"> translate_text("inp_volt_1", '<xsl:value-of select="$lang-Input-voltage"/>');</script>
          </td>
          <td class="tdMediumSmallBoldGrey" style="text-align:left;width:50px">
            <xsl:value-of select="$involt"/>
          </td>
          <td class="tdMediumSmallBoldGrey" style="text-align:left;width:110px" onMouseOver="TTshow('analogthres1')" onMouseOut="TThide()">
            <xsl:value-of select="$analog1"/>
          </td>
          <td class="tdMediumSmallBoldGrey" style="text-align:right;width:40px" onMouseOver="TTshow('analogthres1')" onMouseOut="TThide()">
            <xsl:value-of select="$anaval1"/>
          </td>
        </tr>
        <tr >
          <td class="tdMediumSmallBold" style="text-align:left;">
            <script type="text/javascript"> translate_text("outp_volt_1", '<xsl:value-of select="$lang-Output-voltage"/>');</script>
          </td>
          <td class="tdMediumSmallBold" style="text-align:left">
            <xsl:value-of select="$outputvolt"/>
          </td>
          <td class="tdMediumSmallBold" style="text-align:left" onMouseOver="TTshow('analogthres2')" onMouseOut="TThide()">
            <xsl:value-of select="$analog2"/>
          </td>
          <td class="tdMediumSmallBold" style="text-align:right" onMouseOver="TTshow('analogthres2')" onMouseOut="TThide()">
            <xsl:value-of select="$anaval2"/>
          </td>
        </tr>
        <tr>
          <td id="inp_freq_1" class="tdMediumSmallBoldGrey" style="text-align:left">
            <script type="text/javascript"> translate_text("inp_freq_1", '<xsl:value-of select="$lang-Input-frequency"/>');</script>
          </td>
          <td class="tdMediumSmallBoldGrey" style="text-align:left">
            <xsl:value-of select="$infreq"/>
          </td>
          <td class="tdMediumSmallBoldGrey" style="text-align:left" onMouseOver="TTshow('analogthres3')" onMouseOut="TThide()">
            <xsl:value-of select="$analog3"/>
          </td>
          <td class="tdMediumSmallBoldGrey" style="text-align:right" onMouseOver="TTshow('analogthres3')" onMouseOut="TThide()">
            <xsl:value-of select="$anaval3"/>
          </td>
        </tr>
        <tr>
          <td id="outp_freq_1" class="tdMediumSmallBold" style="text-align:left">
            <script type="text/javascript"> translate_text("outp_freq_1", '<xsl:value-of select="$lang-Output-frequency"/>');</script>
          </td>
          <td class="tdMediumSmallBold" style="text-align:left">
            <xsl:value-of select="$outfreq"/>
          </td>
          <td class="tdMediumSmallBold" style="text-align:left" onMouseOver="TTshow('analogthres4')" onMouseOut="TThide()">
            <xsl:value-of select="$analog4"/>
          </td>
          <td class="tdMediumSmallBold" style="text-align:right" onMouseOver="TTshow('analogthres4')" onMouseOut="TThide()">
            <xsl:value-of select="$anaval4"/>
          </td>
        </tr>
        <tr>
          <td id="load_cur_1" class="tdMediumSmallBoldGrey" style="text-align:left">
            <script type="text/javascript"> translate_text("load_cur_1", ['<xsl:value-of select="$lang-Load"/>', '<xsl:value-of select="$lang-Current"/>']);</script>
          </td>
          <td class="tdMediumSmallBoldGrey" style="text-align:left">
            <xsl:value-of select="$outpower"/>
          </td>
          <td class="tdMediumSmallBoldGrey" style="text-align:left" onMouseOver="TTshow('analogthres5')" onMouseOut="TThide()">
            <xsl:value-of select="$analog5"/>
          </td>
          <td class="tdMediumSmallBoldGrey" style="text-align:right" onMouseOver="TTshow('analogthres5')" onMouseOut="TThide()">
            <xsl:value-of select="$anaval5"/>
          </td>
        </tr>
        <tr>
          <td class="tdMediumSmallBold" style="text-align:left">
            <xsl:value-of select="$lang-Battery-voltage"/>
          </td>
          <td class="tdMediumSmallBold" style="text-align:left">
            <xsl:value-of select="$battvolt"/>
          </td>
          <td class="tdMediumSmallBold" style="text-align:left" onMouseOver="TTshow('analogthres6')" onMouseOut="TThide()">
            <xsl:value-of select="$analog6"/>
          </td>
          <td class="tdMediumSmallBold" style="text-align:right" onMouseOver="TTshow('analogthres6')" onMouseOut="TThide()">
            <xsl:value-of select="$anaval6"/>
          </td>
        </tr>
        <tr>
          <td class="tdMediumSmallBoldGrey" style="text-align:left">
            <xsl:value-of select="$lang-Battery-capacity"/>
          </td>
          <td class="tdMediumSmallBoldGrey" style="text-align:left">
            <xsl:value-of select="$battcap"/>
          </td>
          <td class="tdMediumSmallBoldGrey" style="text-align:left" onMouseOver="TTshow('analogthres7')" onMouseOut="TThide()">
            <xsl:value-of select="$analog7"/>
          </td>
          <td class="tdMediumSmallBoldGrey" style="text-align:right" onMouseOver="TTshow('analogthres7')" onMouseOut="TThide()">
            <xsl:value-of select="$anaval7"/>
          </td>
        </tr>
        <tr>
          <td class="tdMediumSmallBold" style="text-align:left">
            <xsl:value-of select="$lang-Temperature"/>
          </td>
          <td class="tdMediumSmallBold" style="text-align:left">
            <xsl:value-of select="$tempdeg"/>
          </td>
          <td class="tdMediumSmallBold" style="text-align:left" onMouseOver="TTshow('analogthres8')" onMouseOut="TThide()">
            <xsl:value-of select="$analog8"/>
          </td>
          <td class="tdMediumSmallBold" style="text-align:right" onMouseOver="TTshow('analogthres8')" onMouseOut="TThide()">
            <xsl:value-of select="$anaval8"/>
          </td>
        </tr>
        <tr>
          <td id="avg_tmp_1" class="tdMediumSmallBoldGrey" style="text-align:left">
            <script type="text/javascript"> translate_text("avg_tmp_1", '<xsl:value-of select="$lang-Avg-temperature"/>');</script>
          </td>
          <td class="tdMediumSmallBoldGrey" style="text-align:left">
            <xsl:value-of select="$avgbattemp"/>
          </td>
          <td class="tdMediumSmallBoldGrey" style="text-align:left">&#160;</td>
          <td class="tdMediumSmallBoldGrey" style="text-align:left">&#160;</td>
        </tr>
        <tr>
          <td class="tdMediumSmallBold" style="text-align:left">
            <xsl:value-of select="$lang-UPS-uptime"/>
          </td>
          <td class="tdMediumSmallBold" style="text-align:left">
            <xsl:value-of select="$avgdays"/>
          </td>
          <td class="tdMediumSmallBold" style="text-align:left">&#160;</td>
          <td class="tdMediumSmallBold" style="text-align:left">&#160;</td>
        </tr>
        <tr>
          <td class="tdMediumSmallBoldGrey" style="text-align:left">
            <xsl:value-of select="$lang-Autonomy-time"/>
          </td>
          <td class="tdMediumSmallBoldGrey" style="text-align:left">
            <xsl:value-of select="$autonomtime"/>
          </td>
          <td class="tdMediumSmallBoldGrey" style="text-align:left">&#160;</td>
          <td class="tdMediumSmallBoldGrey" style="text-align:left">&#160;</td>
        </tr>
        <tr>
          <td class="tdMediumSmallBold" style="text-align:left">
            <xsl:value-of select="$lang-Battery-lifetime"/>
          </td>
          <td class="tdMediumSmallBold" style="text-align:left">
            <xsl:value-of select="$batterylife"/>
          </td>
          <td class="tdMediumSmallBold" style="text-align:left">&#160;</td>
          <td class="tdMediumSmallBold" style="text-align:left">&#160;</td>
        </tr>
      </table>
    </div>
    <!-- BAR CHARTS-->
    <xsl:variable name="barchartx" select="400"/>
    <xsl:variable name="barcharty" select="$headerY+28"/>
    <xsl:variable name="barh" select="180"/>
    <xsl:variable name="barw" select="50"/>
    <xsl:variable name="suby" select="150"/>

    <!--page0 bar1-->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="value[@name='INVOLT']/@val"/>
      <xsl:with-param name="headline" select="$lang-Input-voltage-sep"/>
      <xsl:with-param name="unit" select="' V'"/>
      <xsl:with-param name="x" select="$barchartx"/>
      <xsl:with-param name="y" select="$barcharty"/>
      <xsl:with-param name="h" select="$barh"/>
      <xsl:with-param name="barx" select="$scalewidth + $scalegapwidth"/>
      <xsl:with-param name="bary" select="20"/>
      <xsl:with-param name="barw" select="$barw"/>
      <xsl:with-param name="suby" select="$suby"/>
      <xsl:with-param name="startval" select="180"/>
      <xsl:with-param name="endval" select="260"/>
      <xsl:with-param name="step" select="20"/>
      <xsl:with-param name="skip" select="0"/>
      <xsl:with-param name="id" select="'page0-'"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="thresh-red-hi" select="250"/>
      <xsl:with-param name="thresh-red-lo" select="210"/>
      <xsl:with-param name="thresh-yellow-hi" select="240"/>
      <xsl:with-param name="thresh-yellow-lo" select="220"/>
      <xsl:with-param name="bright" select="1"/>
    </xsl:call-template>

    <!--page0 bar2-->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="value[@name='INFREQ']/@val"/>
      <xsl:with-param name="headline" select="$lang-Input-frequency-sep"/>
      <xsl:with-param name="unit" select="' Hz'"/>
      <xsl:with-param name="x" select="$barchartx + 100"/>
      <xsl:with-param name="y" select="$barcharty"/>
      <xsl:with-param name="h" select="$barh"/>
      <xsl:with-param name="barx" select="$scalewidth + $scalegapwidth"/>
      <xsl:with-param name="bary" select="20"/>
      <xsl:with-param name="barw" select="$barw"/>
      <xsl:with-param name="suby" select="$suby"/>
      <xsl:with-param name="startval" select="30"/>
      <xsl:with-param name="endval" select="60"/>
      <xsl:with-param name="decimal-places" select="1"/>
      <xsl:with-param name="step" select="10"/>
      <xsl:with-param name="skip" select="0"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="id" select="'page0-'"/>
      <xsl:with-param name="thresh-red-hi" select="55"/>
      <xsl:with-param name="thresh-red-lo" select="35"/>
    </xsl:call-template>

    <!--page0 bar3-->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="value[@name='OUTPOWER']/@val"/>
      <xsl:with-param name="headline" select="$lang-Load"/>
      <xsl:with-param name="unit" select="'%'"/>
      <xsl:with-param name="x" select="$barchartx + 200"/>
      <xsl:with-param name="y" select="$barcharty"/>
      <xsl:with-param name="h" select="$barh"/>
      <xsl:with-param name="barx" select="$scalewidth + $scalegapwidth"/>
      <xsl:with-param name="bary" select="20"/>
      <xsl:with-param name="barw" select="$barw"/>
      <xsl:with-param name="suby" select="$suby"/>
      <xsl:with-param name="startval" select="0"/>
      <xsl:with-param name="endval" select="100"/>
      <xsl:with-param name="decimal-places" select="0"/>
      <xsl:with-param name="step" select="20"/>
      <xsl:with-param name="skip" select="0"/>
      <xsl:with-param name="shadowoffset" select="5"/>
      <xsl:with-param name="id" select="'page0-'"/>
      <xsl:with-param name="thresh-red-hi" select="100"/>
      <xsl:with-param name="thresh-yellow-hi" select="80"/>
    </xsl:call-template>

    <!--page1 bar1-->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="value[@name='TEMPDEG']/@val"/>
      <xsl:with-param name="headline" select="$lang-Temperature"/>
      <xsl:with-param name="unit" select="' &#176;C'"/>
      <xsl:with-param name="x" select="$barchartx"/>
      <xsl:with-param name="y" select="$barcharty"/>
      <xsl:with-param name="h" select="$barh"/>
      <xsl:with-param name="barx" select="$scalewidth + $scalegapwidth"/>
      <xsl:with-param name="bary" select="20"/>
      <xsl:with-param name="barw" select="$barw"/>
      <xsl:with-param name="suby" select="$suby"/>
      <xsl:with-param name="startval" select="0"/>
      <xsl:with-param name="endval" select="75"/>
      <xsl:with-param name="step" select="25"/>
      <xsl:with-param name="skip" select="0"/>
      <xsl:with-param name="id" select="'page1-'"/>
      <xsl:with-param name="thresh-red-hi" select="60"/>
    </xsl:call-template>

    <!--page1 bar2-->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="value[@name='BATTCAP']/@val"/>
      <xsl:with-param name="headline" select="$lang-Battery-capacity-sep"/>
      <xsl:with-param name="unit" select="'%'"/>
      <xsl:with-param name="x" select="$barchartx + 100"/>
      <xsl:with-param name="y" select="$barcharty"/>
      <xsl:with-param name="h" select="$barh"/>
      <xsl:with-param name="barx" select="$scalewidth + $scalegapwidth"/>
      <xsl:with-param name="bary" select="20"/>
      <xsl:with-param name="barw" select="$barw"/>
      <xsl:with-param name="suby" select="$suby"/>
      <xsl:with-param name="startval" select="0"/>
      <xsl:with-param name="endval" select="100"/>
      <xsl:with-param name="decimal-places" select="0"/>
      <xsl:with-param name="step" select="20"/>
      <xsl:with-param name="skip" select="0"/>
      <xsl:with-param name="id" select="'page1-'"/>
      <xsl:with-param name="thresh-red-lo" select="50"/>
      <xsl:with-param name="thresh-yellow-lo" select="80"/>
    </xsl:call-template>

    <!--page1 bar3-->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="value[@name='AUTONOMTIME']/@val"/>
      <xsl:with-param name="headline" select="$lang-Autonomy-time-sep"/>
      <xsl:with-param name="unit" select="' min'"/>
      <xsl:with-param name="x" select="$barchartx + 200"/>
      <xsl:with-param name="y" select="$barcharty"/>
      <xsl:with-param name="h" select="$barh"/>
      <xsl:with-param name="barx" select="$scalewidth + $scalegapwidth"/>
      <xsl:with-param name="bary" select="20"/>
      <xsl:with-param name="barw" select="$barw"/>
      <xsl:with-param name="suby" select="$suby"/>
      <xsl:with-param name="startval" select="0"/>
      <xsl:with-param name="endval" select="100"/>
      <xsl:with-param name="decimal-places" select="0"/>
      <xsl:with-param name="step" select="20"/>
      <xsl:with-param name="skip" select="0"/>
      <xsl:with-param name="id" select="'page1-'"/>
      <xsl:with-param name="thresh-red-lo" select="3"/>
    </xsl:call-template>

    <!--page2 bar1-->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="value[@name='OUTPUT_VOLT']/@val"/>
      <xsl:with-param name="headline" select="$lang-Output-voltage-sep"/>
      <xsl:with-param name="unit" select="' V'"/>
      <xsl:with-param name="x" select="$barchartx"/>
      <xsl:with-param name="y" select="$barcharty"/>
      <xsl:with-param name="h" select="$barh"/>
      <xsl:with-param name="barx" select="$scalewidth + $scalegapwidth"/>
      <xsl:with-param name="bary" select="20"/>
      <xsl:with-param name="barw" select="$barw"/>
      <xsl:with-param name="suby" select="$suby"/>
      <xsl:with-param name="startval" select="180"/>
      <xsl:with-param name="endval" select="260"/>
      <xsl:with-param name="step" select="20"/>
      <xsl:with-param name="skip" select="0"/>
      <xsl:with-param name="id" select="'page2-'"/>
      <xsl:with-param name="thresh-red-hi" select="240"/>
      <xsl:with-param name="thresh-red-lo" select="200"/>
    </xsl:call-template>

    <!--page2 bar2-->
    <xsl:call-template name="valuebar">
      <xsl:with-param name="value" select="value[@name='OUTFREQ']/@val"/>
      <xsl:with-param name="headline" select="$lang-Output-frequency-sep"/>
      <xsl:with-param name="unit" select="' Hz'"/>
      <xsl:with-param name="x" select="$barchartx + 100"/>
      <xsl:with-param name="y" select="$barcharty"/>
      <xsl:with-param name="h" select="$barh"/>
      <xsl:with-param name="barx" select="$scalewidth + $scalegapwidth"/>
      <xsl:with-param name="bary" select="20"/>
      <xsl:with-param name="barw" select="$barw"/>
      <xsl:with-param name="suby" select="$suby"/>
      <xsl:with-param name="startval" select="30"/>
      <xsl:with-param name="endval" select="60"/>
      <xsl:with-param name="decimal-places" select="1"/>
      <xsl:with-param name="step" select="10"/>
      <xsl:with-param name="skip" select="0"/>
      <xsl:with-param name="id" select="'page2-'"/>
      <xsl:with-param name="thresh-red-hi" select="55"/>
      <xsl:with-param name="thresh-red-lo" select="35"/>
    </xsl:call-template>

    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="1"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="name" select="value[@name='SM_O1NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="2"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="name" select="value[@name='SM_O2NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="3"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="name" select="value[@name='SM_O3NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="4"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="name" select="value[@name='SM_O4NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="5"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="name" select="value[@name='SM_O5NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="6"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="name" select="value[@name='SM_O6NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="7"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="name" select="value[@name='SM_O7NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="8"/>
      <xsl:with-param name="type" select="'digiout'"/>
      <xsl:with-param name="name" select="value[@name='SM_O8NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="1"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="name" select="value[@name='SM_D1NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="2"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="name" select="value[@name='SM_D2NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="3"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="name" select="value[@name='SM_D3NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="4"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="name" select="value[@name='SM_D4NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="5"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="name" select="value[@name='SM_D5NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="6"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="name" select="value[@name='SM_D6NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="7"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="name" select="value[@name='SM_D7NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="8"/>
      <xsl:with-param name="type" select="'digiin'"/>
      <xsl:with-param name="name" select="value[@name='SM_D8NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="1"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="name" select="value[@name='SM_A1NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="2"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="name" select="value[@name='SM_A2NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="3"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="name" select="value[@name='SM_A3NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="4"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="name" select="value[@name='SM_A4NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="5"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="name" select="value[@name='SM_A5NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="6"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="name" select="value[@name='SM_A6NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="7"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="name" select="value[@name='SM_A7NAME']/@val"/>
    </xsl:call-template>
    <xsl:call-template name="tooltip">
      <xsl:with-param name="id" select="8"/>
      <xsl:with-param name="type" select="'analogalarm'"/>
      <xsl:with-param name="name" select="value[@name='SM_A8NAME']/@val"/>
    </xsl:call-template>

    <xsl:call-template name="analogthres">
      <xsl:with-param name="id" select="1"/>
      <xsl:with-param name="lo" select="value[@name='SM2_ANALOG_LO_THRES']/@val"/>
      <xsl:with-param name="hi" select="value[@name='SM2_ANALOG_HI_THRES']/@val"/>
      <xsl:with-param name="name" select="value[@name='SM_A1NAME']/@val"/>
      <xsl:with-param name="val" select="$anaval1"/>
    </xsl:call-template>
    <xsl:call-template name="analogthres">
      <xsl:with-param name="id" select="2"/>
      <xsl:with-param name="lo" select="value[@name='SM2_ANALOG_LO_THRES']/@val2"/>
      <xsl:with-param name="hi" select="value[@name='SM2_ANALOG_HI_THRES']/@val2"/>
      <xsl:with-param name="name" select="value[@name='SM_A2NAME']/@val"/>
      <xsl:with-param name="val" select="$anaval2"/>
    </xsl:call-template>
    <xsl:call-template name="analogthres">
      <xsl:with-param name="id" select="3"/>
      <xsl:with-param name="lo" select="value[@name='SM2_ANALOG_LO_THRES']/@val3"/>
      <xsl:with-param name="hi" select="value[@name='SM2_ANALOG_HI_THRES']/@val3"/>
      <xsl:with-param name="name" select="value[@name='SM_A3NAME']/@val"/>
      <xsl:with-param name="val" select="$anaval3"/>
    </xsl:call-template>
    <xsl:call-template name="analogthres">
      <xsl:with-param name="id" select="4"/>
      <xsl:with-param name="lo" select="value[@name='SM2_ANALOG_LO_THRES']/@val4"/>
      <xsl:with-param name="hi" select="value[@name='SM2_ANALOG_HI_THRES']/@val4"/>
      <xsl:with-param name="name" select="value[@name='SM_A4NAME']/@val"/>
      <xsl:with-param name="val" select="$anaval4"/>
    </xsl:call-template>
    <xsl:call-template name="analogthres">
      <xsl:with-param name="id" select="5"/>
      <xsl:with-param name="lo" select="value[@name='SM2_ANALOG_LO_THRES']/@val5"/>
      <xsl:with-param name="hi" select="value[@name='SM2_ANALOG_HI_THRES']/@val5"/>
      <xsl:with-param name="name" select="value[@name='SM_A5NAME']/@val"/>
      <xsl:with-param name="val" select="$anaval5"/>
    </xsl:call-template>
    <xsl:call-template name="analogthres">
      <xsl:with-param name="id" select="6"/>
      <xsl:with-param name="lo" select="value[@name='SM2_ANALOG_LO_THRES']/@val6"/>
      <xsl:with-param name="hi" select="value[@name='SM2_ANALOG_HI_THRES']/@val6"/>
      <xsl:with-param name="name" select="value[@name='SM_A6NAME']/@val"/>
      <xsl:with-param name="val" select="$anaval6"/>
    </xsl:call-template>
    <xsl:call-template name="analogthres">
      <xsl:with-param name="id" select="7"/>
      <xsl:with-param name="lo" select="value[@name='SM2_ANALOG_LO_THRES']/@val7"/>
      <xsl:with-param name="hi" select="value[@name='SM2_ANALOG_HI_THRES']/@val7"/>
      <xsl:with-param name="name" select="value[@name='SM_A7NAME']/@val"/>
      <xsl:with-param name="val" select="$anaval7"/>
    </xsl:call-template>
    <xsl:call-template name="analogthres">
      <xsl:with-param name="id" select="8"/>
      <xsl:with-param name="lo" select="value[@name='SM2_ANALOG_LO_THRES']/@val8"/>
      <xsl:with-param name="hi" select="value[@name='SM2_ANALOG_HI_THRES']/@val8"/>
      <xsl:with-param name="name" select="value[@name='SM_A8NAME']/@val"/>
      <xsl:with-param name="val" select="$anaval8"/>
    </xsl:call-template>

  </xsl:template>


  <!-- LOCAL TEMPLATE DEFINITIONS-->


  <!-- EOS -->
</xsl:stylesheet>